Unit BMP_U;
Interface
Uses DOS,GRAPH,GFA,GR256;
var erro:integer;

{Procedure GetEgaPal(cor:byte;var pal:byte);
Procedure SetEgaPal(cor:byte;pal:byte);
Procedure SetPal16(Cor,r,g,b:byte);
Procedure GetPal16(Cor:byte;Var r,g,b:byte);
Procedure SetAllPal16(var pal;cor,n:integer);
Procedure EgaDefault;}
Procedure Load_BMP(X,Y:integer;file_name:string{;var erro:integer});
Procedure Save_BMP(file_name:string;x1,y1,x2,y2:word);



Implementation
Procedure GetEgaPal(cor:byte;var pal:byte);assembler;
asm
 mov bl,cor
 mov ah,$10
 mov al,$07
 int $10
 les DI,pal
 mov ES:[DI],BH
end;

Procedure SetEgaPal(cor:byte;pal:byte);assembler;
asm
 mov bl,cor
 mov bh,pal
 mov ah,$10
 mov al,$00
 int $10
end;

Procedure SetPal16(Cor,r,g,b:byte);assembler;
asm
 mov AH,$10
 mov AL,$10
 xor BH,BH
 mov BL,cor
 mov DH,r
 mov CH,g
 mov CL,b
 int $10
end;
{===================================================}
Procedure GetPal16(Cor:byte;Var r,g,b:byte);assembler;
asm
 mov AH,$10
 mov AL,$15
 xor BH,BH
 mov BL,cor
 int $10
 les DI,r
 mov ES:[DI],DH
 les DI,g
 mov ES:[DI],CH
 les DI,b
 mov ES:[DI],CL
end;
Procedure SetAllPal16(var pal;cor,n:integer);assembler;
asm
 mov AH,$10
 mov AL,$12
 mov BX,cor
 mov CX,n
 les DX,pal
 int $10
end;

Procedure EgaDefault;
var i,reg:byte;
    r,g,b:byte;
begin
 for i:=0 to 15 do begin;
  GetEgaPal(i,reg);
  SetEgaPal(i,i);
  GetPal16(reg,r,g,b);
  SetPal16(i,r,g,b);
 end;
end;


Procedure Load_BMP(X,Y:integer;file_name:string{;var erro:integer});
var header:array [1..27] of word;
    rgb_struct:array[0..255] of record
                                 b,g,r,cor:byte;
                                end;
    rgb_triple:array[0..255] of record
                                 b,g,r:byte;
                                end absolute rgb_struct;
    pal:array[0..255] of record
                          red,green,blue:byte;
                         end;
    F:File;
    i,j:integer;
    locer:integer;
    Xp,Yp,lido,larg,larg1,alt,cores,bufsize,desloc,reloc,grupo:word;
    buf:array[1..10000] of byte;
    pic_point_1,pic_point_2:byte;
    sign:array[1..2] of char absolute header;
    maxX,maxY:word;
begin;
 maxX:=GetmaxX+1;
 maxY:=GetMaxY+1;
 assign(f,file_name);
 {$I-}
 reset(f,1);
 {$I+}
 erro:=IoResult;
 if erro<>0 then exit;
 {$I-}
 blockread(f,header,18,lido);
 erro:=IoResult;
 if erro=0 then if sign<>'BM' then erro:=-100;
 if erro=0 then begin;
  desloc:=header[8]-4;
  if desloc>36 then desloc:=36;
  blockread(f,header[10],desloc,lido);
  erro:=IoResult;
 end;
 if erro=0 then begin;
  reloc:=ord(desloc<>8);
  larg:=header[10];
  alt:=header[11+reloc];
  cores:=1 shl header[13+2*reloc];
  if (alt>maxY) or (larg>maxX) then erro:=-101;
 end;
 if erro=0 then begin;
  if (X<0) or (Y<0) then begin;
   X:=(maxX-larg) div 2;
   Y:=(maxY-alt) div 2;
  end;
  blockread(f,rgb_struct,header[6]-18-desloc,lido);
  erro:=IoResult;
 end;
 if erro=0 then begin;
  if cores=16 then begin;
   larg1:=8*(larg div 8)+8*ord(larg mod 8<>0);
   LARG1:=LARG1 div 2;
  end else begin;
   larg1:=4*(larg div 4)+4*ord(larg mod 4<>0);
  end;
  if reloc=1 then for i:=0 to cores-1 do begin;
   pal[i].red:=rgb_struct[i].r div 4;
   pal[i].green:=rgb_struct[i].g div 4;
   pal[i].blue:=rgb_struct[i].b div 4;
  end else for i:=0 to cores-1 do begin;
   pal[i].red:=rgb_triple[i].r div 4;
   pal[i].green:=rgb_triple[i].g div 4;
   pal[i].blue:=rgb_triple[i].b div 4;
  end;
  EgaDefault;
  setallpal16(Pal,0,cores);
  bufsize:=larg1*(10000 div larg1);
  lido:=bufsize;
  While (lido=bufsize) and (erro=0) do begin
   blockread(f,buf,bufsize,lido);
   erro:=IoResult;
   if erro=0 then if Cores=16 then
    for j:=1 to lido div larg1 do for i:=0 to larg-1 do begin;
     XP:=X+i;
     YP:=Y+alt-j;
     pic_point_1:=buf[(j-1)*larg1+1+i div 2];
     pic_point_2:=(pic_point_1 shr 4)*((i+1) mod 2)+(pic_point_1 and 15)*((i+2) mod 2);
     if (pic_point_2 <> 8) then putpixel(XP,YP,pic_point_2)
    end
    else for j:=1 to lido div larg1 do for i:=1 to larg do begin;
     XP:=X+(i-1);
     YP:=Y+alt-j;
     pic_point_1:=buf[(j-1)*larg1+i];
     if (pic_point_1 <> 8) then putpixel(XP,YP,pic_point_1);
    end;
   Y := Y - lido DIV larg1;
  end; { while }
 end; { erro = 0 }
 close(f);
 {$I+}
 locer:=Ioresult;
 if erro=0 then erro:=locer;
end;



Procedure save_bmp;
var f:file;
    w,w0,i,j:word;
    by,b0:byte;
    pale:paleta;
begin;
 w0:=0;
 b0:=0;
 assign(f,file_name);
 rewrite(f,1);
 w:=77*256+66;
 blockwrite(f,w,2); {1-2 sign}
 w:=254*256+54;
 blockwrite(f,w,2); {3-4 ??}
 for i:=0 to 2 do blockwrite(f,w0,2); {5-6,7-8,9-10 reserved}
 w:=1078;
 blockwrite(f,w,2); {11-12 #bytes for palette + 18 + desloc = 1078}
 blockwrite(f,w0,2); {13-14 reserved}
 w:=40;
 blockwrite(f,w,2); {15-16 desloc + 4 = 40}
 blockwrite(f,w0,2); {17-18 reserved}
 w:=320;
 blockwrite(f,w,2); {19-20 x size}
 blockwrite(f,w0,2); {20-21 reserved}
 w:=200;
 blockwrite(f,w,2); {21-22 y size}
 blockwrite(f,w0,2); {23-24 reserved}
 w:=1;
 blockwrite(f,w,2); {25-26 ??}
 w:=8;
 blockwrite(f,w,2); {27-28 shove for # of colors (2^8=256)}
 for i:=0 to 11 do blockwrite(f,w0,2); {29-54 reserved}
 getpal(pale);
 for i:=0 to 255 do begin;
  by:=pale.b[i]*4;
  blockwrite(f,by,1);
  by:=pale.g[i]*4;
  blockwrite(f,by,1);
  by:=pale.r[i]*4;
  blockwrite(f,by,1);
  blockwrite(f,b0,1);
 end;
 for j:=199 downto 0 do for i:=0 to 319 do begin;
  by:=getpixel(i,j);
  blockwrite(f,by,1);
 end;
 close(f);
end;



begin
end.