{$g+,i-,d-,l-,b-,r-,o-,f-,s-,a+,e-,p-,q-,t+,v-,x+,i-,n-}

uses MegaGraf,Keyboard,SinCos;

(*                  BEST GAME SDK FOR TURBO/BORLAND PASCAL                 *)
(*                ͻ         ͻ ͻ               *)
(*                ͼ    ͻ ͻ  ͻ   ͼ                  *)
(*                   ͼͼ  ͼ͹ ͼ  ͼ                  *)
(*                        ͻ   ͼ                                *)
(*                 :     ͹˻ ͻ  .Ĵ               *)
(*               | |  .    ͼ              *                   *)
(*               -+-    . ʼ       ʼ     ʼ   .  +                 *)
(*                |   .        version 2.0       .      :                 *)
(*                 Copyright (c) 1996-98 by Vadim Bodrov  |               *)

(* Author of original fractal demo program: Ryan Jones (Dios@Rworld.com)   *)

{$IFDEF WINDOWS}
 THIS PROGRAM CAN`T BE COMPILED FOR MS WINDOWS
{$ENDIF}

 const
  ZInc=25;
  ZOfs=256;
  ZScale=230;
  Sc=0.7;

 type
  ABType=Record LSide,RSide: Integer; end;
  Triangle=Record
   X1,Y1,Z1,X2,Y2,Z2,X3,Y3,Z3: Real;
   Color: Byte;
 end;

 var
  Tris: Array[0..100] Of Triangle; { Triangle info }
  Trin,                            { # of triangles }
  l,i,hn: Word;                    { fractal stuff }
  Ch: Char;
  Page: Boolean;

 procedure ChangePage;
 begin
  if Page then begin
   SetActivePage(0);
   SetVisualPage(1,true);
   Page:=false;
  end else begin
   SetActivePage(1);
   SetVisualPage(0,true);
   Page:=true;
  end;
  ClearPage;
 end;

 procedure AddTris(i: Word);
 var
  OX1,OY1,OZ1,OX2,OY2,OZ2,OX3,OY3,OZ3: Real;
  OC: Byte;
 begin
  with Tris[i] do begin
   OX1:=X1;
   OY1:=Y1;
   OZ1:=Z1;
   OX2:=X2;
   OY2:=Y2;
   OZ2:=Z2;
   OX3:=X3;
   OY3:=Y3;
   OZ3:=Z3;
   OC:=Color + 24;
  end;
  with Tris[Trin] do begin
   X1:=OX1;
   Y1:=OY1;
   Z1:=OZ1+ZInc;
   X2:=OX1*2/3+OX2/3;
   Y2:=OY1*2/3+OY2/3;
   Z2:=OZ2+ZInc;
   X3:=OX1*2/3+OX3/3;
   Y3:=OY1*2/3+OY3/3;
   Z3:=OZ3+ZInc;
   Color:=OC;
  end;
  with Tris[Trin+1] do begin
   X1:=OX2*2/3+OX1/3;
   Y1:=OY2*2/3+OY1/3;
   Z1:=OZ1+ZInc;
   X2:=OX2;
   Y2:=OY2;
   Z2:=OZ2+ZInc;
   X3:=OX2*2/3+OX3/3;
   Y3:=OY2*2/3+OY3/3;
   Z3:=OZ3+ZInc;
   Color:=OC;
  end;
  with Tris[Trin+2] do begin
   X1:=OX3*2/3+OX1/3;
   Y1:=OY3*2/3+OY1/3;
   Z1:=OZ1+ZInc;
   X2:=OX3*2/3+OX2/3;
   Y2:=OY3*2/3+OY2/3;
   Z2:=OZ2+ZInc;
   X3:=OX3;
   Y3:=OY3;
   Z3:=OZ3+ZInc;
   Color:=OC;
  end;
  Inc(Trin,3);
 end;

 procedure DrawTris;
 var SX1,SY1,SX2,SY2,SX3,SY3,i: Word;
 begin
  i:=0;
  repeat
   with Tris[i] do begin
    SX1:=Round((ZScale*X1)/(Z1-ZOfs));
    SY1:=Round((ZScale*Y1)/(Z1-ZOfs));
    SX2:=Round((ZScale*X2)/(Z2-ZOfs));
    SY2:=Round((ZScale*Y2)/(Z2-ZOfs));
    SX3:=Round((ZScale*X3)/(Z3-ZOfs));
    SY3:=Round((ZScale*Y3)/(Z3-ZOfs));
    FilledTriangle(160+SX1,100+SY1,160+SX2,100+SY2,160+SX3,100+SY3,RGBColor(Color+40,10,Color+40));
   end;
   inc(i);
  until i=Trin;
  ChangePage;
 end;

 procedure Rotate(var X,Y: Real; Ang: Word);
 var XX,YY: Real;
 begin
  XX:=X*xCos(Ang)+Y*xSin(Ang);
  YY:=Y*xCos(Ang)-X*xSin(Ang);
  X:=XX;
  Y:=YY;
 end;

 procedure RotateTris(Ang: Word);
 var i: Word;
 begin
  i:=0;
  repeat
  with Tris[i] do begin
   Rotate(X1,Z1,Ang);
   Rotate(X2,Z2,Ang);
   Rotate(X3,Z3,Ang);
  end;
  inc(i);
 until i=Trin;
 end;

 procedure RotateTrisb(Ang: Word);
 var i: Word;
 begin
  i:=0;
  repeat
  with Tris[i] do begin
   Rotate(X1,Y1,Ang);
   Rotate(X2,Y2,Ang);
   Rotate(X3,Y3,Ang);
  end;
  inc(i);
  until i=Trin;
 end;

 procedure RotateTrisc(Ang: Word);
 var i: Word;
 begin
  i:=0;
  repeat
   with Tris[i] do begin
    Rotate(Y1,Z1,Ang);
    Rotate(Y2,Z2,Ang);
    Rotate(Y3,Z3,Ang);
   end;
   inc(i);
  until i=Trin;
 end;

 procedure ExpandTris;
 const Scd=0.95;
 var i: Word;
 begin
  i:=0;
  repeat
   with Tris[i] do begin
    X1:=X1*Scd;
    Y1:=Y1*Scd;
    X2:=X2*Scd;
    Y2:=Y2*Scd;
    X3:=X3*Scd;
    Y3:=Y3*Scd;
   end;
   inc(i);
  until i=Trin;
 end;

 begin
  InitVBE;
  if not SetSVGAMode(320,200,grSVGA4G) then begin
   if not SetSVGAMode(320,200,grSVGA16M) then begin
    SetTextMode;
    Writeln;
    Writeln(' Sorry, but I can`t set SVGA Mode 320x200 (16M/16M+A colors)...');
    exit;
   end;
  end;
  with Tris[0] do begin
   X1:=0;
   Y1:=86;
   Z1:=0;
   X2:=100;
   Y2:=-86;
   Z2:=0;
   X3:=-100;
   Y3:=-86;
   Z3:=0;
   X1:=X1*Sc;
   Y1:=Y1*Sc;
   Z1:=Z1*Sc;
   X2:=X2*Sc;
   Y2:=Y2*Sc;
   Z2:=Z2*Sc;
   X3:=X3*Sc;
   Y3:=Y3*Sc;
   Z3:=Z3*Sc;
   Color:=24;
  end;
  Trin:=1;
  l:=3;
  repeat
   i:=hn;
   hn:=Trin;
   repeat
    AddTris(i);
    inc(i);
   until i=hn;
   dec(l);
  until l=0;
  Tris[0].Color:=24;
  repeat { main loop }
   i:=0;
   repeat
    DrawTris;
    RotateTris(2);
    inc(i);
   until xKeyPressed or (i=90);
   i:=0;
   repeat
    DrawTris;
    RotateTrisb(2);
    inc(i);
   until xKeyPressed or (i=90);
   i:=0;
   repeat
    DrawTris;
    RotateTrisc(2);
    inc(i);
   until xKeyPressed or (i=90);
  until xKeyPressed;
  repeat Ch:=xReadKey until not xKeyPressed;
  i:=200;
  repeat { outro }
   DrawTris;
   ExpandTris;
   RotateTris(2);
   RotateTrisb(2);
   RotateTrisc(2);
   dec(i);
  until (i=0) or xKeyPressed;
  if xKeyPressed then repeat Ch:=xReadKey until not xKeyPressed;
  SetTextMode;
 end.