{$g+,n-,d-,l-,b-,r-,o-,f-,s-,a+,e-,p-,q-,t+,v-,X+,i-}

uses Keyboard,MegaGraf,SinCos,MemPlus;

(*                  BEST GAME SDK FOR TURBO/BORLAND PASCAL                 *)
(*                ͻ         ͻ ͻ               *)
(*                ͼ    ͻ ͻ  ͻ   ͼ                  *)
(*                   ͼͼ  ͼ͹ ͼ  ͼ                  *)
(*                        ͻ   ͼ                                *)
(*                 :     ͹˻ ͻ  .Ĵ               *)
(*               | |  .    ͼ              *                   *)
(*               -+-    . ʼ       ʼ     ʼ   .  +                 *)
(*                |   .        version 2.0       .      :                 *)
(*                 Copyright (c) 1996-98 by Vadim Bodrov  |               *)

{$IFDEF WINDOWS}
 THIS PROGRAM CAN`T BE COMPILED FOR MS WINDOWS
{$ENDIF}

 const
  DivOne=       128;
  DivTwo=       DivOne div 2;
  MainStep=     6;
  XStep=        3;
  YStep=        4;

 var
  SinuSinTablele: array [0..449] of     Integer;
  SinTable, CosTable: array [0..255] of Integer;
  PalBuffer:                            Pointer;
  X,Y,i,j:                              Word;
  ColStep,Color,APage,VPage:            Byte;

 procedure FlipPage;
 begin
  if APage=1 then begin
   APage:=0;
   VPage:=1;
  end else begin
   APage:=1;
   VPage:=0;
  end;
  SetActivePage(APage);
  SetVisualPage(VPage,true);
 end;

 procedure DrawPolar(xo,yo,r,a: Word; Color: Byte);
 var X,Y: Word;
 begin
  X:=320+xo+(r*SinuSinTablele[90+a]) div (DivTwo); if X>639 then exit;
  Y:=200+yo+(r*SinuSinTablele[a]) div (DivTwo); if Y>399 then exit;
  PutPixelSVGA256(X,Y,Color);
 end;

 function WormHole_Init: Boolean;
 begin
  for i:=0 to 255 do begin
   CosTable[i]:=round(cos(pi*i/DivOne)*90);
   SinTable[i]:=round(sin(pi*i/DivOne)*80);
  end;
  for i:=0 to 449 do SinuSinTablele[i]:=round(xsin(i)*DivOne);
  if not InitVBE then WormHole_Init:=false;
  Retrace;
  SetVBEMode($100);
  ClearVideoMem;
  PalBuffer:=LoadFile('fire.pal');
  if PalBuffer=nil then begin
   Writeln(' Can`t load fire.pal');
   Halt(0);
  end;
  GetVGAPalette(mgBufferPtr,0,256);
  repeat until not FadePalette(mgBufferPtr,0,256,0);
  X:=30; Y:=90;
  WormHole_Init:=true;
 end;

 procedure WormHole_Show;
 begin
  ClearPage;
  ColStep:=2;
  Color:=250; j:=10;
  while j<220 do begin
   i:=0;
   while i<360 do begin
    DrawPolar(CosTable[(X+(200-j)) mod 255],SinTable[(Y+(200-j)) mod 255],j,i,Color);
    inc(i,MainStep);
   end;
   inc(j,ColStep);
   if (j mod 5)=0 then begin
    inc(ColStep);
   end;
   dec(Color,ColStep);
  end;
   X:=XStep+X mod 255;
   Y:=YStep+Y mod 255;
   FlipPage;
 end;

 procedure WormHole_Done;
 begin
  FreeBuffer(PalBuffer,768);
  SetTextMode;
 end;

 begin
  if not WormHole_Init then begin
   SetTextMode;
   Writeln;
   Writeln(' VESA mode 640x400x256 (100h) not supported!');
   exit;
  end;
  GetVGAPalette(mgBufferPtr,0,256);
  repeat
   WormHole_Show;
  until not EvenPalette(mgBufferPtr,PalBuffer,0,256);
  repeat
   WormHole_Show;
  until xKeyPressed;
  GetVGAPalette(mgBufferPtr,0,256);
  repeat
   WormHole_Show;
  until not FadePalette(mgBufferPtr,0,256,0);
  FlushKeyboard;
  WormHole_Done;
 end.

