{$g+,n-,d-,l-,b-,r-,o+,f+,s-,a+,e-,p-,q-,t+,v-,x+,i-}

(*  MOUSE FUNCTIONS SUPPORT /I80386 AND HIGHER, REAL MODE, PROTECTED MODE  *)
(*                                                                         *)
(*                  BEST GAME SDK FOR TURBO/BORLAND PASCAL                 *)
(*                ͻ         ͻ ͻ               *)
(*                ͼ    ͻ ͻ  ͻ   ͼ                  *)
(*                   ͼͼ  ͼ͹ ͼ  ͼ                  *)
(*                        ͻ   ͼ                                *)
(*                 :     ͹˻ ͻ  .Ĵ               *)
(*               | |  .    ͼ              *                   *)
(*               -+-    . ʼ       ʼ     ʼ   .  +                 *)
(*                |   .        version 2.0       .      :                 *)
(*                 BY VADIM BODROV, RUSSIA  (c) 1996-98   |               *)

{$IFDEF WINDOWS}
 THIS UNIT CAN NOT BE COMPILED FOR MS WINDOWS!!!
 ONLY DOS REAL MODE AND PROTECTED MODE SUPPORTED
{$ENDIF}

 unit AddMouse;

 interface

 const LeftBtn=0;
       RightBtn=1;
       MiddleBtn=2;

 var NoButtons: Byte;
     MouseXShr,MouseYShr: Byte;

 function  InitMouse: Boolean;
 procedure ShowMouse;
 procedure HideMouse;
 function  LeftButtonPressed: Boolean;
 function  MiddleButtonPressed: Boolean;
 function  RightButtonPressed: Boolean;
 function  ButtonPressed (Button: Byte): Boolean;
 procedure GetMouseXY (var X, Y: Word);
 function  GetMouseX: Word;
 function  GetMouseY: Word;
 procedure SetMouseXY (NewX, NewY: Word);
 procedure PressOnStatus (Button: Byte; var X, Y, No: Word);
 procedure PressOffStatus (Button: Byte; var X, Y, No: Word);
 procedure SetMouseXYRange (MinX, MinY, MaxX, MaxY: Word);
 procedure SetMouseXRange (MinX, MaxX: Word);
 procedure SetMouseYRange (MinY, MaxY: Word);
 procedure GetLastPos (var LDX, LDY: Word);
 procedure LPEmulationOn;
 procedure LPEmulationOff;
 procedure SetCorrelationXY (X, Y: Word);             (* Default X=8, Y=16 *)
 procedure SetHiddenZone (X1, Y1, X2, Y2: Word);
 procedure MaxMouseSpeed (Speed: Word);               (* Default Speed=64  *)
 procedure SetMouseSensitive (XSpeed, YSpeed, SpeedBorder: Word);
 procedure GetMouseSensitive (var XSpeed, YSpeed, SpeedBorder: Word);
 procedure SetMouseVisualPage (Page: Word);
 function  GetMouseVisualPage: Word;
 function  DisableMouse: Boolean;
 procedure EnableMouse;
 function  ResetMouse: Boolean;
 procedure GetMouseInfo (var Ver: Word; var MouseType, IRQ: Byte);
 procedure SetUserProc (Mask: Word; ProcAddr: Pointer);
 procedure FreeUserProc;

 implementation

{$IFDEF DPMI}
 uses Version,DOSUtil,i80386;
 var
  UserAddr: LongInt;
  RealRegs: TRealRegs;
{$ELSE}
 uses Version;
{$ENDIF}

 function InitMouse: Boolean; assembler;
      asm
        xor     ax,ax
        int     $33
        cmp     ax,0
        jnz     @Cont
        mov     [NoButtons],al
        jmp     @Exit
@Cont:  mov     [NoButtons],bl
@Exit:
 end;

 procedure ShowMouse; assembler;
      asm
        mov     ax,1
        int     $33
 end;

 procedure HideMouse; assembler;
      asm
        mov     ax,2
        int     $33
 end;

 procedure GetStatus; near; assembler; {Internal}
      asm
        mov     ax,3
        int     $33
        mov     ax,bx
 end;

 function LeftButtonPressed: Boolean; assembler;
      asm
        call    near ptr GetStatus
        and     ax,$01
 end;

 function MiddleButtonPressed: Boolean; assembler;
      asm
        call    near ptr GetStatus
        and     ax,$04
 end;

 function RightButtonPressed: Boolean; assembler;
      asm
        call    near ptr GetStatus
        and     ax,$02
 end;

  function  ButtonPressed(Button: Byte): Boolean; assembler;
     asm
       xor      ax,ax
       mov      bl,[Button]
       cmp      bl,0
       jnz      @Pass1
       push     cs
       call     near ptr LeftButtonPressed
       jmp      @Ok
@Pass1:
       cmp      bl,1
       jnz      @Pass2
       push     cs
       call     near ptr RightButtonPressed
       jmp      @Ok
@Pass2:
       cmp      bl,2
       jnz      @Ok
       push     cs
       call     near ptr MiddleButtonPressed
       jmp      @Ok
@Ok: end;

 procedure GetMouseXY(var X,Y: Word); assembler;
      asm
        call    near ptr GetStatus
        mov     ax,cx
        mov     cl,[MouseXShr]
        shr     ax,cl
        mov     cl,[MouseYShr]
        shr     dx,cl
        les     di,X
        mov     es:[di],ax
        les     di,Y
        mov     es:[di],dx
 end;

 function GetMouseX: Word; assembler;
      asm
        call    near ptr GetStatus
        mov     ax,cx
        mov     cl,[MouseXShr]
        shr     ax,cl
 end;

 function GetMouseY: Word; assembler;
      asm
        call    near ptr GetStatus
        mov     ax,dx
        mov     cl,[MouseYShr]
        shr     ax,cl
 end;

 procedure SetMouseXY (NewX,NewY: Word); assembler;
      asm
        mov     ax,[NewX]
        mov     cl,[MouseXShr]
        shl     ax,cl
        mov     dx,[NewY]
        mov     cl,[MouseYShr]
        shl     dx,cl
        mov     cx,ax
        mov     ax,4
        int     $33
 end;

 procedure PressOnStatus(Button: Byte; var X,Y,No: Word); assembler;
      asm
        xor     bx,bx
        mov     bl,[Button]
        mov     ax,5
        int     $33
        les     di,No
        mov     es:[di],bx
        les     di,X
        mov     es:[di],cx
        les     di,Y
        mov     es:[di],dx
 end;

 procedure PressOffStatus(Button: Byte; var X,Y,No: Word); assembler;
      asm
        xor     bx,bx
        mov     bl,[Button]
        mov     ax,6
        int     $33
        les     di,No
        mov     es:[di],bx
        les     di,X
        mov     es:[di],cx
        les     di,Y
        mov     es:[di],dx
 end;

 procedure SetMouseXYRange(MinX,MinY,MaxX,MaxY: Word); assembler;
      asm
        mov     ax,[MinX]
        mov     dx,[MaxX]
        mov     cl,[MouseXShr]
        shl     ax,cl
        shl     dx,cl
        mov     cx,ax
        mov     ax,7
        int     $33
        mov     ax,[MinY]
        mov     dx,[MaxY]
        mov     cl,[MouseYShr]
        shl     ax,cl
        shl     dx,cl
        mov     cx,ax
        mov     ax,8
        int     $33
 end;

 procedure SetMouseXRange(MinX,MaxX: Word); assembler;
      asm
        mov     ax,[MinX]
        mov     dx,[MaxX]
        mov     cl,[MouseXShr]
        shl     ax,cl
        shl     dx,cl
        mov     cx,ax
        mov     ax,7
        int     $33
 end;

 procedure SetMouseYRange(MinY,MaxY: Word); assembler;
      asm
        mov     ax,[MinY]
        mov     dx,[MaxY]
        mov     cl,[MouseYShr]
        shl     ax,cl
        shl     dx,cl
        mov     cx,ax
        mov     ax,8
        int     $33
 end;

 procedure GetLastPos(var LDX,LDY: Word); assembler;
      asm
        mov     ax,11
        int     $33
        mov     ax,cx
        mov     cl,[MouseXShr]
        shr     ax,cl
        mov     cl,[MouseYShr]
        shr     dx,cl
        les     di,LDX
        mov     es:[di],ax
        les     di,LDY
        mov     es:[di],dx
 end;

 procedure LPEmulationOn; assembler;
      asm
        mov     ax,13
        int     $33
 end;

 procedure LPEmulationOff; assembler;
      asm
        mov     ax,14
        int     $33
 end;

 procedure SetCorrelationXY(X,Y: Word); assembler;
      asm
        mov     cx,[X]
        mov     dx,[Y]
        mov     ax,15
        int     $33
 end;

 procedure SetHiddenZone(X1,Y1,X2,Y2: Word); assembler;
      asm
        push    si
        mov     cx,[X1]
        mov     dx,[Y1]
        mov     si,[X2]
        mov     di,[Y2]
        mov     ax,16
        int     $33
        pop     si
 end;

 procedure MaxMouseSpeed(Speed: Word); assembler;
      asm
        mov     dx,[Speed]
        mov     ax,17
        int     $33
 end;

 procedure SetMouseSensitive(XSpeed,YSpeed,SpeedBorder: Word); assembler;
      asm
        mov     bx,[XSpeed]
        mov     cx,[YSpeed]
        mov     dx,[SpeedBorder]
        mov     ax,26
        int     $33
 end;

 procedure GetMouseSensitive(var XSpeed,YSpeed,SpeedBorder: Word); assembler;
      asm
        mov     ax,27
        int     $33
        les     di,XSpeed
        mov     es:[di],bx
        les     di,YSpeed
        mov     es:[di],cx
        les     di,SpeedBorder
        mov     es:[di],dx
 end;

 procedure SetMouseVisualPage(Page: Word); assembler;
      asm
        mov     bx,[Page]
        mov     ax,29
        int     $33
 end;

 function  GetMouseVisualPage: Word; assembler;
       asm
        mov     ax,30
        int     $33
        mov     ax,bx
 end;

 function  DisableMouse: Boolean; assembler;
      asm
        mov     ax,31
        int     $33
        xor     ax,$ffff
 end;

 procedure EnableMouse; assembler;
      asm
        mov     ax,32
        int     $33
 end;

 function ResetMouse: Boolean; assembler;
      asm
        mov     ax,33
        int     $33
 end;

 procedure GetMouseInfo(var Ver: Word; var MouseType, IRQ: Byte); assembler;
      asm
        mov     ax,34
        int     $33
        les     di,Ver
        mov     es:[di],bx
        les     di,MouseType
        mov     es:[di],ch
        les     di,IRQ
        mov     es:[di],cl
 end;

 procedure SetUserProc(Mask: Word; ProcAddr: Pointer);
{$IFDEF MSDOS}
 begin
      asm
        les     dx,[ProcAddr]
        mov     cx,[Mask]
        mov     ax,12
        int     $33
 end;
{$ELSE}
 begin
  ClearRegs(RealRegs);
  UserAddr:=AllocateRealModeCallBack(ProcAddr,RealRegs);
  ClearRegs(RealRegs);
  RealRegs.ES:=HiWord(UserAddr);
  RealRegs.DX:=Word(UserAddr);
  RealRegs.CX:=Mask;
  RealRegs.AX:=12;
  RealModeInt($33,RealRegs);
{$ENDIF}
 end;

 procedure FreeUserProc;
 begin
  ResetMouse;
{$IFDEF DPMI}
  FreeRealModeCallBack(UserAddr);
{$ENDIF}
 end;

 end.