{$g+,n-,d-,l-,b-,r-,o+,f+,s-,a+,e-,p-,q-,t+,v-,x+,i-}

(*     DIGPAK SUPPORT /I80386 AND HIGHER, REAL MODE, PROTECTED MODE        *)
(*                                                                         *)
(*                  BEST GAME SDK FOR TURBO/BORLAND PASCAL                 *)
(*                ͻ         ͻ ͻ               *)
(*                ͼ    ͻ ͻ  ͻ   ͼ                  *)
(*                   ͼͼ  ͼ͹ ͼ  ͼ                  *)
(*                        ͻ   ͼ                                *)
(*                 :     ͹˻ ͻ  .Ĵ               *)
(*               | |  .    ͼ              *                   *)
(*               -+-    . ʼ       ʼ     ʼ   .  +                 *)
(*                |   .        version 2.0       .      :                 *)
(*                 BY VADIM BODROV, RUSSIA  (c) 1996-98   |               *)

{---------------------------------------------------------------------------
 Used materials:
 'TRICKS OF THE GAME-PROGRAMMING GURUS' by Andre LaMothe, John Ratcliff,
 Mark Seminatore, Denise Tyler, Copyright (C) 1994 Sams Publishing
---------------------------------------------------------------------------}

{$IFDEF WINDOWS}
 THIS UNIT CAN NOT BE COMPILED FOR MS WINDOWS!!!
 ONLY DOS REAL MODE AND PROTECTED MODE SUPPORTED
{$ENDIF}

{****************************************************************************
    A  $500  per  product  license  fee  applies  to  all commercial software
 products  distributed  with  ANY DIGPAK and another $500 for MIDPAK drivers.
 That's  a  total  of  $1,000  if  your  product  uses BOTH DIGPAK and MIDPAK
 drivers.  If  you  distribute any commercial title with DIGPAK and/or MIDPAK
 drivers  resident  then  this  license fee applies. To pay a license, simply
 write  a  check for $500 for just DIGPAK $500 for just MIDPAK, or $1,000 for
 both  DIGPAK  and MIDPAK single product distribution license payable to: The
 Audio  Solution,  747  Napa  Lane, St. Charles, MO 63304 with a copy of your
 commerical  product.  You  will  receive a signed license agreement from The
 Audio  Solution shortly thereafter. This license fee applies specifically to
 the  inclusion  with  your distribution disk any of the DIGPAK and/or MIDPAK
 drivers.  These drivers are copyrighted works, created by me, to enhance the
 use  of  sound  and music in DOS based commercial software. The license fees
 collected  are  used  to  maintain  the  drivers  and  keep the BBS running.

 WARNING!!!!!!  You  would  be ill-advised to distribute a commercial product
 containing  either  DIGPAK  and/or  MIDPAK  drivers  without having paid the
 distribution  license  fee.  Since  your  product  would  contain unlicensed
 copyrighted software from The Audio Solution, your product could be required
 to be immediately removed from retail distribution. I doubt this is going to
 be  a  problem.  Clearly  if  your  product  is enhanced by the use of these
 drivers,  your  company can easily afford a nominal license fee of $1,000 in
 exchange  for  getting  the use of several man-years of software engineering
 resources.
*****************************************************************************}

 unit DigPak;

 interface

 const

(* Sound Mode *)

  PCM_8_MONO=    0000;
  PCM_8_STEREO=  0001;
  PCM_16_MONO=   0002;
  PCM_16_STEREO= 0003;

(* Audio Capabilities *)

  PLAYBACK=      0001;
  MASSAGE=       0002;
  FIXEDFREQ=     0004;
  USESTIMER=     0008;
  SHARESTIMER=   0016;
  LOOPEND=       0032;
  STEREOPAN=     0064;
  STEREOPLAY=    0128;
  AUDIORECORD=   0256;
  DMABACKFILL=   0512;
  PCM16=         1024;
  PCM16STEREO=   2048;

 Type TSndStruct=record
      Sound:     Pointer;
      SndLen:    Word;
      IsPlaying: Pointer;
      Frequency: Word;
      Addr:      Pointer;
 end;

 function  SoundStatus: Boolean;
 function  AudioCapabilities: Word;
 procedure StopSound;
 procedure SetAudioHardware (IRQ, BaseAddr, Other: Word);
 procedure WaitSound;
 function  AudioPendingStatus: Byte;
 function  SetStereoPan (Pan: Word): Boolean;
 function  SetPlayMode (Mode: Word): Boolean;
 function  SetAudioVolume (LVolume, RVolume: Word): Boolean;
 function  CheckDMABuffer (Address: Pointer; Size: Word): Boolean;
 function  ReportPendingAddress: Pointer;
 function  ReportSemaphoreAddress: Pointer;
 function  ReportVersionNumber: Word;
 procedure StopNextLoop;
 procedure SetTimerDivisorRate (Rate: Word);
 procedure SetRecordMode (Mode: Word);
 function  SetBackFillMode (Mode: Word): Boolean;
 function  ReportDMAC: Word;
 function  LoadDigPak (fName: String): Boolean;
 function  InitDigPak: Boolean;
 function  DeInitDigPak: Boolean;
 procedure UnLoadDigPak;
 function  SndLoad (Name: String; var SndFile: TSndStruct): Boolean;
 procedure SndFree (var SndFile: TSndStruct);
 procedure DigPlay (var SndPlay: TSndStruct);
 procedure MassageAudio (var SndPlay: TSndStruct);
 procedure DigPlay2 (var SndPlay: TSndStruct);
 function  PostAudioPending (var SndPlay: TSndStruct): Byte;

 implementation

{$IFDEF MSDOS}
 uses MemPlus,DOSUtil,i80386;
{$ELSE}
 uses MemPlus,WinAPI,DOSUtil,i80386;
{$ENDIF}

 var HaveDigPak: Boolean;
     DigPakLoad: Pointer;
     DigPakSize: LongInt;
     DigPakOn:   Boolean;
     DigPakPara: Word;

{$IFDEF DPMI}
     DPMIAddr1:  Pointer;
     RealSEG1:   Word;
     DPMIAddr2:  Pointer;
     RealSEG2:   Word;
     DigPakExit: Pointer;
     Pending:    Word;
     Semaphore:  Word;
{$ENDIF}

 function SoundStatus: Boolean; assembler;
      asm
        mov     ax,$689
        int     $66
 end;

 function AudioCapabilities: Word; assembler;
      asm
        mov     ax,$68C
        int     $66
 end;

 procedure StopSound; assembler;
      asm
        mov     ax,$68F
        int     $66
 end;

 procedure SetAudioHardware(IRQ,BaseAddr,Other: Word); assembler;
      asm
        mov     ax,$690
        mov     bx,[IRQ]
        mov     cx,[BaseAddr]
        mov     dx,[Other]
        int     $66
 end;

 procedure WaitSound; assembler;
      asm
@WS:    mov     ax,$689
        int     $66
        or      ax,ax
        jnz     @WS
 end;

 function AudioPendingStatus: Byte; assembler;
      asm
        mov     ax,$696
        int     $66
 end;

 function SetStereoPan(Pan: Word): Boolean; assembler;
      asm
        mov     dx,[Pan]
        mov     ax,$697
        int     $66
 end;

 function SetPlayMode(Mode: Word): Boolean; assembler;
      asm
        mov     dx,[Mode]
        mov     ax,$698
        int     $66
 end;

 function  SetAudioVolume(LVolume, RVolume: Word): Boolean; assembler;
      asm
        mov     bx,[LVolume]
        mov     cx,[RVolume]
        mov     ax,$69F
        int     $66
 end;

 function  CheckDMABuffer(Address: Pointer; Size: Word): Boolean; assembler;
{$IFDEF MSDOS}
      asm
        mov     ax,$69E
        les     bx,[Address]
        mov     cx,[Size]
        int     $66
 end;
{$ELSE}
      asm
        mov     ax,$69E
        xor     bx,bx
        mov     es,[RealSEG1]
        mov     cx,[Size]
        int     $66
 end;
{$ENDIF}

 function ReportPendingAddress: Pointer;
{$IFDEF MSDOS}
 assembler;
      asm
        mov     ax,$699
        int     $66
 end;
{$ELSE}
 var Regs: TRealRegs;
 begin
  if Pending=0 then begin
   ClearRegs(Regs);
   Regs.AX:=$699;
   RealModeInt($66,Regs);
   AllocSelector(Pending);
   Pending:=SetSelectorBase(Pending,LongAdd(LongMul(Regs.DX,16),Regs.AX));
   SetSelectorLimit(Pending,4);
  end;
  ReportPendingAddress:=Ptr(Pending,0);
 end;
{$ENDIF}

 function ReportSemaphoreAddress: Pointer;
{$IFDEF MSDOS}
 assembler;
      asm
        mov     ax,$699
        int     $66
        mov     ax,bx
 end;
{$ELSE}
 var Regs: TRealRegs;
 begin
  if Semaphore=0 then begin
   ClearRegs(Regs);
   Regs.AX:=$699;
   RealModeInt($66,Regs);
   AllocSelector(Semaphore);
   Semaphore:=SetSelectorBase(Semaphore,LongAdd(LongMul(Regs.DX,16),Regs.BX));
   SetSelectorLimit(Semaphore,4);
  end;
  ReportSemaphoreAddress:=Ptr(Semaphore,0);
 end;
{$ENDIF}

 function ReportVersionNumber: Word; assembler;
      asm
        xor     bx,bx
        mov     ax,$689
        int     $66
        mov     ax,bx
 end;

 procedure StopNextLoop; assembler;
      asm
        mov     ax,$69B
        int     $66
 end;

 procedure SetTimerDivisorRate(Rate: Word); assembler;
      asm
        mov     ax,$693
        mov     dx,[Rate]
        int     $66
 end;

 procedure SetRecordMode(Mode: Word); assembler;
      asm
        mov     dx,[Mode]
        mov     ax,$69A
        int     $66
 end;

 function SetBackFillMode(Mode: Word): Boolean; assembler;
      asm
        mov     dx,[Mode]
        mov     ax,$69C
        int     $66
 end;

 function ReportDMAC: Word; assembler;
      asm
        mov     ax,$69D
        int     $66
 end;

 function LoadDigPak(fName: String): Boolean;
 begin
  if HaveDigPak then begin
   LoadDigPak:=false; exit;
  end;
  DigPakSize:=SizeOfFile(fName);
{$IFDEF MSDOS}
  GetBuffer(DigPakLoad,DigPakSize+$110);
  DigPakPara:=Seg(DigPakLoad^)+1;
{$ELSE}
  DigPakPara:=xGlobalDosAlloc(DigPakLoad,DigPakSize+$100);
{$ENDIF}
  if DigPakLoad=nil then begin
   LoadDigPak:=false;
   exit;
  end;
{$IFDEF MSDOS}
  if ReadFromFile(fName,Ptr(DigPakPara,$100),0,DigPakSize)
{$ELSE}
  if ReadFromFile(fName,GetPtr(DigPakLoad,$100),0,DigPakSize)
{$ENDIF}
  then HaveDigPak:=true else begin
   HaveDigPak:=false;
{$IFDEF MSDOS}
   FreeBuffer(DigPakLoad,DigPakSize+$110);
   DigPakPara:=0;
{$ELSE}
   DigPakPara:=0;
   xGlobalDosFree(DigPakLoad);
{$ENDIF}
  end;
 end;

 function InitDigPak: Boolean;
{$IFDEF DPMI}
 var Regs: TRealRegs;
 begin
  if (HaveDigPak) and (xGetStr(DigPakLoad,$103,6)='DIGPAK') then begin
   ClearRegs(Regs);
   Regs.CS:=DigPakPara;
   Regs.IP:=$200;
   RealCallF(Regs);
   DigPakOn:=Regs.AX=0;
  end;
{$ELSE}
 begin
  if (HaveDigPak) and (xGetStr(Ptr(DigPakPara,0),$103,6)='DIGPAK') then begin
   DigPakOn:=Word(FarCall(Ptr(DigPakPara,$200)))=0;
  end;
{$ENDIF}
  InitDigPak:=DigPakOn;
 end;

 function DeInitDigPak: Boolean;
{$IFDEF DPMI}
 var Regs: TRealRegs;
{$ENDIF}
 begin
  if DigPakOn then begin
{$IFDEF DPMI}
   ClearRegs(Regs);
   Regs.CS:=DigPakPara;
   Regs.IP:=$203;
   RealCallF(Regs);
{$ELSE}
   FarCall(Ptr(DigPakPara,$203));
{$ENDIF}
   DigPakOn:=false;
   DeInitDigPak:=true;
  end else DeInitDigPak:=false;
 end;

 procedure UnLoadDigPak;
 begin
   if HaveDigPak then begin
   if DigPakOn then DeInitDigPak;
{$IFDEF MSDOS}
   FreeBuffer(DigPakLoad,DigPakSize+$110);
   DigPakPara:=0;
{$ELSE}
   DigPakPara:=0;
   xGlobalDosFree(DigPakLoad);
{$ENDIF}
   DigPakLoad:=nil;
   HaveDigPak:=false;
  end;
 end;

 function SndLoad(Name: String; var SndFile: TSndStruct): Boolean;
 begin
  SndFile.Sound:=nil;
  if TestFile(Name) then begin
   SndFile.SndLen:=SizeOfFile(Name);
{$IFDEF MSDOS}
   GetBuffer(SndFile.Sound,SndFile.SndLen);
   SndFile.Addr:=SndFile.Sound;
{$ELSE}
   SndFile.Sound:=Ptr(xGlobalDosAlloc(SndFile.Addr,1+SndFile.SndLen),0);
{$ENDIF}
   if SndFile.Sound=nil then begin
    SndLoad:=false;
    exit;
   end;
{$IFDEF MSDOS}
   if not ReadFromFile(Name,SndFile.Sound,0,SndFile.SndLen)
   then begin
    FreeBuffer(SndFile.Sound,SndFile.SndLen);
    SndFile.Sound:=nil;
   end;
{$ELSE}
   if not ReadFromFile(Name,SndFile.Addr,0,SndFile.SndLen)
   then begin
    xGlobalDOSFree(SndFile.Addr);
    SndFile.Sound:=nil;
   end;
{$ENDIF}
  end;
  SndFile.Frequency:=11025;
  SndLoad:=SndFile.Sound<>nil;
 end;

 procedure SndFree(var SndFile: TSndStruct);
 begin
  if SndFile.Sound<>nil then begin
{$IFDEF MSDOS}
   FreeBuffer(SndFile.Sound,SndFile.SndLen);
{$ELSE}
   xGlobalDosFree(SndFile.Addr);
{$ENDIF}
   SndFile.Sound:=nil;
   SndFile.Addr:=nil;
   SndFile.SndLen:=0;
   SndFile.Frequency:=0;
  end;
 end;

 procedure DigPlay(var SndPlay: TSndStruct);
{$IFDEF DPMI}
 var Reg: TRealRegs;
 begin
  if not DigPakOn then Exit;
  Move(SndPlay,DPMIAddr1^,SizeOf(SndPlay));
  ClearRegs(Reg);
  Reg.AX:=$688;
  Reg.DS:=RealSEG1;
  Reg.SI:=0;
  RealModeInt($66,Reg);
{$ELSE}
  assembler;
      asm
        push    ds
        cmp     [DigPakOn],1
        jnz     @Exit
        mov     ax,$688
        lds     si,[SndPlay]
        int     $66
@Exit:  pop     ds
{$ENDIF}
 end;

 procedure MassageAudio(var SndPlay: TSndStruct);
{$IFDEF DPMI}
 var Reg: TRealRegs;
 begin
  if not DigPakOn then Exit;
  Move(SndPlay,DPMIAddr1^,SizeOf(SndPlay));
  ClearRegs(Reg);
  Reg.AX:=$68A;
  Reg.DS:=RealSEG1;
  Reg.SI:=0;
  RealModeInt($66,Reg);
{$ELSE}
  assembler;
      asm
        push    ds
        cmp     [DigPakOn],1
        jnz     @Exit
        mov     ax,$68A
        lds     si,[SndPlay]
        int     $66
@Exit:  pop     ds
{$ENDIF}
 end;

 procedure DigPlay2(var SndPlay: TSndStruct);
{$IFDEF DPMI}
 var Reg: TRealRegs;
 begin
  if not DigPakOn then Exit;
  Move(SndPlay,DPMIAddr1^,SizeOf(SndPlay));
  ClearRegs(Reg);
  Reg.AX:=$68B;
  Reg.DS:=RealSEG1;
  Reg.SI:=0;
  RealModeInt($66,Reg);
{$ELSE}
  assembler;
      asm
        push    ds
        cmp     [DigPakOn],1
        jnz     @Exit
        mov     ax,$68B
        lds     si,[SndPlay]
        int     $66
@Exit:  pop     ds
{$ENDIF}
 end;

 function PostAudioPending(var SndPlay: TSndStruct): Byte;
{$IFDEF DPMI}
 var Regs: TRealRegs;
 begin
  if not DigPakOn then Exit;
  Move(SndPlay,DPMIAddr2^,SizeOf(SndPlay));
  ClearRegs(Regs);
  Regs.AX:=$695;
  Regs.DS:=RealSEG2;
  Regs.SI:=0;
  RealModeInt($66,Regs);
  PostAudioPending:=Regs.AX;
{$ELSE}
  assembler;
      asm
        push    ds
        cmp     [DigPakOn],1
        jnz     @Exit
        mov     ax,$695
        lds     si,[SndPlay]
        int     $66
@Exit:  pop     ds
{$ENDIF}
 end;

{$IFDEF DPMI}
 procedure ExitDigPak;
 begin
  ExitProc:=DigPakExit;
  xGlobalDOSFree(DPMIAddr1);
  xGlobalDOSFree(DPMIAddr2);
  if Pending<>0 then FreeSelector(Pending);
  if Semaphore<>0 then FreeSelector(Semaphore);
 end;
{$ENDIF}

begin
{$IFDEF DPMI}
  RealSEG1:=xGlobalDOSAlloc(DPMIAddr1,SizeOf(TSndStruct));
  RealSEG2:=xGlobalDOSAlloc(DPMIAddr2,SizeOf(TSndStruct));
  DigPakExit:=ExitProc;
  ExitProc:=@ExitDigPak;
{$ENDIF}
 end.

