{$g+,n-,d-,l-,b-,r-,o+,f+,s-,a+,e-,p-,q-,t+,v-,x+,i-}

(*     USEFULL UTILITY /I80386 AND HIGHER, REAL MODE, PROTECTED MODE       *)
(*                                                                         *)
(*                  BEST GAME SDK FOR TURBO/BORLAND PASCAL                 *)
(*                ͻ         ͻ ͻ               *)
(*                ͼ    ͻ ͻ  ͻ   ͼ                  *)
(*                   ͼͼ  ͼ͹ ͼ  ͼ                  *)
(*                        ͻ   ͼ                                *)
(*                 :     ͹˻ ͻ  .Ĵ               *)
(*               | |  .    ͼ              *                   *)
(*               -+-    . ʼ       ʼ     ʼ   .  +                 *)
(*                |   .        version 2.0       .      :                 *)
(*                 BY VADIM BODROV, RUSSIA  (c) 1996-98   |               *)

{$IFDEF WINDOWS}
 THIS UNIT CAN NOT BE COMPILED FOR MS WINDOWS!!!
 ONLY DOS REAL MODE AND PROTECTED MODE SUPPORTED
{$ENDIF}

 unit DOSUtil;

 interface

{$IFDEF DPMI}
 type TRealRegs=Record
  Case Word Of
  0: (EDI,ESI,EBP,EXX,EBX,EDX,ECX,EAX: LongInt;
      FLAGS,ES,DS,FS,GS,IP,CS,SP,SS: Word) ;
  1: (DI,DIH,SI,SIH,BP,BPH,XX,XXH: Word;
  Case Word of
  0: (BX,BXH,DX,DXH,CX,CXH,AX,AXH: Word);
  1: (BL,BH,BLH,BHH,DL,DH,DLH,DHH,
     CL,CH,CLH,CHH,AL,AH,ALH,AHH: Byte));
 end;

 function  NewSelector (Base, Limit: LongInt): Word;
 procedure ClearRegs (var Regs: TRealRegs);
 function  RealModeInt (IntNum: Word; var Regs: TRealRegs): Word;
 function  AllocateRealModeCallBack (DPMIProc: Pointer; var Regs: TRealRegs): LongInt;
 procedure FreeRealModeCallBack (CallBack: LongInt);
 procedure RealCallF (var Regs: TRealRegs);
 procedure RealCallI (var Regs: TRealRegs);
 procedure SetDPMIIntVec (IONo: Byte; Addr: Pointer);
 procedure GetDPMIIntVec (IONo: Byte; var Addr: Pointer);
{$ELSE}
 procedure SetRealIntVec (IONo: Byte; Addr: Pointer);
 procedure GetRealIntVec (IONo: Byte; var Addr: Pointer);
{$ENDIF}

{COMMON}
 function  toASCIIZ (Dest: PChar; Sr: String): PChar;
 function  IntToStr (L: LongInt): String;
 function  StrToInt (S: String): LongInt;
 function  ByteToHEX (B: Byte): String;
 function  WordToHEX (W: Word): String;

 function  ReadFromFile(fName: String; Buf: Pointer; fPos, Num: Longint): Boolean;
 function  WritetoFile (fName: String; Buf: Pointer; fPos, Num: Longint): Boolean;
 function  TestFile (Name: String): Boolean;
 function  SizeOfFile (Name: String): Longint;
 function  ExeSize (fName: String): LongInt;
 function  GetCtrlBreakState: Boolean;
 procedure SetCtrlBreakState (State: Boolean);

 procedure xGotoXY (X, Y: Byte);
 procedure HideCursor;
 procedure ShowCursor;
 procedure FillScr (Chr: Char; Attr: Byte);
 procedure BIOSText (S: String; Color: Byte);
 procedure CallOld (Sub: Pointer);

 implementation

{$IFDEF DPMI}
 uses WinApi,i80386,MemPlus;
{$ELSE}
 uses i80386,MemPlus;
{$ENDIF}

{$IFDEF DPMI}
 var UserProc: Pointer;

 function  NewSelector(Base, Limit: LongInt): Word;
 var Sel: Word;
 begin
  Sel:=AllocSelector(0);
  If (Sel<>0) and (SetSelectorBase(Sel,Base)=Sel) and (SetSelectorLimit(Sel,
      Limit)=0) then NewSelector:=Sel else NewSelector:=0;
 end;

 procedure ClearRegs(var Regs: TRealRegs);
 begin
  FillChar(Regs,SizeOf(Regs),0);
 end;

 function  RealModeInt(IntNum: Word; var Regs: TRealRegs): Word; assembler;
      asm
        push    bp
        mov     bx,[IntNum]
        xor     cx,cx
        les     di,Regs
        mov     ax,$300
        int     $31
        jc      @exit
        mov     ax,0
@exit:  pop     bp
 end;

 procedure UserInt; assembler;
      asm
        cld
        lodsw
        mov     es:[di.$2A],ax
        lodsw
        mov     es:[di.$2C],ax
        lodsw
        or      ax, 1
        mov     es:[di.$20],ax
        mov     ax,6
        add     es:[di.$2E],ax
        mov     ax,seg @Data
        mov     ds,ax
        push    ds
        push    es
        pusha
        call    dword ptr [UserProc]
        popa
        pop     es
        pop     ds
        iret
 end;

 function AllocateRealModeCallBack(DPMIProc: Pointer; var Regs: TRealRegs): LongInt; assembler;
      asm
        db      $66
        mov     ax,word ptr [DPMIProc]
        db      $66
        mov     word ptr [UserProc],ax
        push    ds
        les     di,Regs
        mov     si,offset UserInt
        mov     ax,seg UserInt
        mov     ds,ax
        mov     ax,$303
        int     $31
        pop     ds
        mov     ax,dx
        mov     dx,cx
 end;

 procedure FreeRealModeCallBack(CallBack: LongInt); assembler;
      asm
        mov     cx,word ptr [CallBack+2]
        mov     dx,word ptr [CallBack]
        mov     ax,$304
        int     $31
 end;

 procedure RealCallF(var Regs: TRealRegs); assembler;
      asm
        push    bp
        les     di,Regs
        xor     cx,cx
        xor     bx,bx
        mov     ax,$301
        int     $31
        pop     bp
 end;

 procedure RealCallI(var Regs: TRealRegs); assembler;
      asm
        push    bp
        les     di,Regs
        xor     cx,cx
        xor     bx,bx
        mov     ax,$302
        int     $31
        pop     bp
 end;

 procedure SetDPMIIntVec(IONo: Byte; Addr: Pointer); assembler;
      asm
        mov     ax,$0205
        mov     bl,[IONo]
        mov     cx,TLong[Addr].Hi
        mov     dx,TLong[Addr].Lo
        int     $31
 end;

 procedure GetDPMIIntVec(IONo: Byte ; var Addr: Pointer); assembler;
      asm
        mov     ax,$0204
        mov     bl,[IONo]
        int     $31
        les     di,Addr
        mov     es:[di],dx
        mov     es:[di+2],cx
 end;

 procedure SetRealModeIntVec(IONo: Byte; Addr: Pointer); assembler;
      asm
        mov     ax,$0201
        mov     bl,[IONo]
        mov     cx,TLong[Addr].Hi
        mov     dx,TLong[Addr].Lo
        int     $31
 end;

 procedure GetRealModeIntVec(IONo: Byte ; var Addr: Pointer); assembler;
      asm
        mov     ax,$0200
        mov     bl,[IONo]
        int     $31
        les     di,Addr
        mov     es:[di],dx
        mov     es:[di+2],cx
 end;
{$ELSE}

 procedure SetRealIntVec(IONo: Byte; Addr: Pointer); assembler;
      asm
        push    ds
        mov     al,[IONo]
        mov     ah,$25
        lds     dx,Addr
        int     $21
        pop     ds
 end;

 procedure GetRealIntVec(IONo: Byte; var Addr: Pointer); assembler;
      asm
        mov     al,[IONo]
        mov     ah,$35
        int     $21
        mov     ax,es
        les     di,Addr
        mov     es:[di],bx
        mov     es:[di+2],ax
 end;
{$ENDIF}

 function toASCIIZ (Dest: PChar; Sr: String): PChar;
 var Spos,Slen: Integer;
 begin
  Spos:=0;
  Slen:=Ord(Sr[0]);
  while Spos<Slen do begin
   Dest[Spos]:=Sr[Spos+1];
   inc(Spos);
  end;
  Dest[Spos]:=Chr(0);
  toASCIIZ:=Dest;
 end;

 function IntToStr(L: Longint): String;
 var
  S:string[11];
 begin
  Str(L,S);
  IntToStr:=S;
 end;

 function StrToInt(S: String): LongInt;
 var
  Result:  LongInt;
  ErrCode: Integer;
 begin
  Val(S,Result,ErrCode);
  StrToInt:=Result;
 end;

 function ByteToHex(B: Byte): String;
 const HexTable: array [0..15] of Char=('0','1','2','3','4','5','6','7',
                                        '8','9','A','B','C','D','E','F');
 var HexStr: String;
 begin
  HexStr[2]:=HexTable[B and $0F];
  HexStr[1]:=HexTable[B and $F0 div 16];
  HexStr[0]:=#2;
  ByteToHex:=HexStr;
 end;

 function WordToHEX(W: Word): String;
 begin
  WordToHEX:=ByteToHEX(Hi(W))+ByteToHEX(Lo(W));
 end;

 function ReadFromFile(fName: String; Buf: Pointer; fPos,Num: Longint): Boolean;
 var Offset, Count: Longint;
     F: file;
 begin
  Assign(F,fName);
  Reset(F,1);
{$I+}
  if IOResult<>0 then begin ReadFromFile:=false; exit; end;
{$I-}
  Seek(F,fPos);
  if Buf<>nil then begin
   Offset:=0;
   while Offset<Num do begin
    Count:=Num-Offset;
    if Count>2048 then Count:=2048;
    BlockRead(F,GetPtr(Buf,Offset)^,Count);
{$I+}
  if IOResult<>0 then begin ReadFromFile:=false; exit; end;
{$I-}
    Inc(Offset,Count);
   end;
  end;
  Close(F);
{$I+}
  if IOResult<>0 then ReadFromFile:=false else ReadFromFile:=true;
{$I-}
 end;

 function WritetoFile(fName: String; Buf: Pointer; fPos,Num: Longint): Boolean;
 var Offset, Count: Longint;
     F: file;
 begin
  Assign(F,fName);
  Reset(F,1);
{$I+}
  if IOResult<>0 then begin WriteToFile:=false; exit; end;
{$I-}
  Seek(F,fPos);
  if Buf<>nil then begin
   Offset:=0;
   while Offset<Num do begin
    Count:=Num-Offset;
    if Count>2048 then Count:=2048;
    BlockWrite(F,GetPtr(Buf,Offset)^,Count);
{$I+}
  if IOResult<>0 then begin WriteToFile:=false; exit; end;
{$I-}
    Inc(Offset,Count);
   end;
  end;
  Close(F);
{$I+}
  if IOResult<>0 then WriteToFile:=false else WriteToFile:=true;
{$I-}
 end;

 function  TestFile(Name: String): Boolean;
 var f: File;
 begin
{$i-}
  Assign(f,Name);
  Reset(f,1);
{$i+}
  if IOResult=0 then begin
   TestFile:=true; Close(f);
  end else TestFile:=false;
 end;

 function  SizeOfFile(Name: String): Longint;
 var f: File;
 begin
{$i-}
  Assign(f,Name);
  Reset(f,1);
{i+}
  if IOResult=0 then begin
   SizeOfFile:=FileSize(f); Close(f); end else SizeOfFile:=0;
{$i-}
 end;

 function ExeSize(fName: String): LongInt;
 var ExeHeader: Array[1..3] of Word;
     ReadIn: Word;
     f: File;
 begin
{$i-}
  Assign(f,fName);
  Reset(f,1);
{$i+}
  If IOResult=0 then begin
{$i-}
   BlockRead(F,ExeHeader[1],6,ReadIn);
{$i+}
   If (ReadIn=SizeOf(ExeHeader)) and (ExeHeader[1]=ord('M')) and
    (IOResult=0) then ExeSize:=LongInt(ExeHeader[3]-1)*512+ExeHeader[2];
   Close(f);
  end;
 end;

 function  GetCtrlBreakState: Boolean; assembler;
      asm
        mov     ax,$3300
        int     $21
        mov     ax,dx
 end;

 procedure SetCtrlBreakState(State: Boolean); assembler;
      asm
        mov     ax,$3301
        mov     dl,[State]
        int     $21
 end;

 procedure xGotoXY(X,Y: Byte); assembler;
      asm
        mov     es,SEG0040
        mov     bh,es:[$62]
        mov     dl,[X]
        dec     dl
        mov     dh,[Y]
        dec     dh
        mov     ax,$0200
        int     $10
@Skip:
 end;

 procedure SetCursor(Cursor: Word); assembler;
      asm
        mov     ax,$0100
        xor     bx,bx
        mov     cx,[Cursor]
        int     $10
 end;

 function GetCursor: Word; assembler;
      asm
        mov     ah,3
        xor     bx,bx
        int     $10
        mov     ax,cx
 end;

 procedure HideCursor;
 begin
  SetCursor($2000);
 end;

 procedure ShowCursor;
 begin
  SetCursor($0607);
 end;

 procedure FillScr(Chr: Char; Attr: Byte); assembler;
      asm
        mov     es,SEGB800
        xor     di,di
        mov     cx,4000
        mov     ah,[Attr]
        mov     al,[Chr]
        push    ax
        db      $66
        shl     ax,16
        pop     ax
        db      $66
        rep     stosw
        mov     ax,$0F00
        int     $10
        mov     ax,$0200
        xor     dx,dx
        int     $10
 end;

 procedure BIOSText(S: String; Color: Byte); assembler;
      asm
        les     di,S
        xor     cx,cx
        mov     cl,es:[di]
        mov     ax,$0E00
        mov     bl,[Color]
@Loop:  mov     al,es:[di]
        inc     di
        int     $10
        loop    @Loop
 end;

 procedure CallOld(Sub: Pointer);
 begin
  Inline($9C/$FF/$5E/$06);
 end;

 end.
