
{$g+,i-,d-,l-,b-,r-,o-,f-,s-,a+,e-,p-,q-,t+,v-,x+,i-,n-}

(* FIXED POINT LIBRARY 32 BIT VRESION REVISION #22 BY MICHAEL ABRASH, 1994 *)
(*               BORLAND PASCAL VERSION BY VADIM BODROV, 1997              *)
(*                                                                         *)
(*                  BEST GAME SDK FOR TURBO/BORLAND PASCAL                 *)
(*                ͻ         ͻ ͻ               *)
(*                ͼ    ͻ ͻ  ͻ   ͼ                  *)
(*                   ͼͼ  ͼ͹ ͼ  ͼ                  *)
(*                        ͻ   ͼ                                *)
(*                 :     ͹˻ ͻ  .Ĵ               *)
(*               | |  .    ͼ              *                   *)
(*               -+-    . ʼ       ʼ     ʼ   .  +                 *)
(*                |   .        version 2.0       .      :                 *)
(*                 BY VADIM BODROV, RUSSIA  (c) 1996-98   |               *)

{---------------------------------------------------------------------------
 Used materials:
 - 'Zen Of Graphic Programming', Copyright (C) 1995 by Michael Abrash
----------------------------------------------------------------------------}

{$IFDEF WINDOWS}
 THIS UNIT CAN NOT BE COMPILED FOR MS WINDOWS!!!
 ONLY DOS REAL MODE AND PROTECTED MODE SUPPORTED
{$ENDIF}

 unit FixedLib;

 interface

 type

  FixedPoint = LongInt;
  TAngle = Word;
  Xform = array [0..2,0..3] of FixedPoint;
  TVect = array [0..2] of FixedPoint;

  Point3 = record
   X: FixedPoint;
   Y: FixedPoint;
   Z: FixedPoint;
  end;

  Point = record
   X: Word;
   Y: Word;
  end;

  Rect = record
   Left:   Word;
   Top:    Word;
   Right:  Word;
   Bottom: Word;
  end;

  THLine = record
   XStart: Word;
   XEnd:   Word;
  end;

 function  FixedMul (M1, M2: FixedPoint): FixedPoint;
 function  FixedDiv (Divided, Divisor: FixedPoint): FixedPoint;
 function  FixedAdd (A1, A2: FixedPoint): FixedPoint;
 function  FixedSub (A1, A2: FixedPoint): FixedPoint;
 function  IntToFixed (IVal: Integer): FixedPoint;
 function  RealToFixed (RVal: Real): FixedPoint;
 function  FixedToReal (FVal: FixedPoint): Real;
 function  RoundFixedToInt (FVal: FixedPoint): Integer;
 procedure CosSin (Angle: TAngle; var VCos, VSin: FixedPoint);
 function  RandomF: FixedPoint;

 procedure XformVec (WorkingXform: Xform; SourceVec, DestVec: TVect);
 procedure ConcatXforms (SourceXform1, SourceXform2, DestXform: Xform);
 procedure AppendRotationX (var XformToChange: Xform; Angle: TAngle);
 procedure AppendRotationY (var XformToChange: Xform; Angle: TAngle);
 procedure AppendRotationZ (var XformToChange: Xform; Angle: TAngle);
 procedure ScanEdge (X1, Y1, X2, Y2, SetXStart, SkipFirst: Word; var EdgePointPtr: Pointer);

 implementation

 uses Version;

 const CosTable: array [0..900] of LongInt =
 ($10000,$10000,$10000,$FFFF,$FFFE,$FFFE,$FFFC,$FFFB,$FFFA,$FFF8,
  $FFF6,$FFF4,$FFF2,$FFEF,$FFEC,$FFEA,$FFE6,$FFE3,$FFE0,$FFDC,
  $FFD8,$FFD4,$FFD0,$FFCB,$FFC7,$FFC2,$FFBD,$FFB7,$FFB2,$FFAC,
  $FFA6,$FFA0,$FF9A,$FF93,$FF8D,$FF86,$FF7F,$FF77,$FF70,$FF68,
  $FF60,$FF58,$FF50,$FF48,$FF3F,$FF36,$FF2D,$FF24,$FF1A,$FF10,
  $FF07,$FEFD,$FEF2,$FEE8,$FEDD,$FED2,$FEC7,$FEBC,$FEB1,$FEA5,
  $FE99,$FE8D,$FE81,$FE74,$FE68,$FE5B,$FE4E,$FE40,$FE33,$FE25,
  $FE18,$FE09,$FDFB,$FDED,$FDDE,$FDCF,$FDC0,$FDB1,$FDA2,$FD92,
  $FD82,$FD72,$FD62,$FD52,$FD41,$FD30,$FD1F,$FD0E,$FCFD,$FCEB,
  $FCD9,$FCC7,$FCB5,$FCA3,$FC90,$FC7D,$FC6A,$FC57,$FC44,$FC30,
  $FC1C,$FC08,$FBF4,$FBE0,$FBCB,$FBB7,$FBA2,$FB8D,$FB77,$FB62,
  $FB4C,$FB36,$FB20,$FB0A,$FAF3,$FADC,$FAC5,$FAAE,$FA97,$FA80,
  $FA68,$FA50,$FA38,$FA20,$FA07,$F9EF,$F9D6,$F9BD,$F9A3,$F98A,
  $F970,$F956,$F93C,$F922,$F908,$F8ED,$F8D2,$F8B7,$F89C,$F881,
  $F865,$F84A,$F82E,$F811,$F7F5,$F7D9,$F7BC,$F79F,$F782,$F764,
  $F747,$F729,$F70B,$F6ED,$F6CF,$F6B0,$F692,$F673,$F654,$F635,
  $F615,$F5F6,$F5D6,$F5B6,$F596,$F575,$F555,$F534,$F513,$F4F2,
  $F4D0,$F4AF,$F48D,$F46B,$F449,$F427,$F404,$F3E2,$F3BF,$F39C,
  $F378,$F355,$F331,$F30E,$F2EA,$F2C5,$F2A1,$F27C,$F258,$F233,
  $F20E,$F1E8,$F1C3,$F19D,$F177,$F151,$F12B,$F104,$F0DE,$F0B7,
  $F090,$F068,$F041,$F019,$EFF2,$EFCA,$EFA2,$EF79,$EF51,$EF28,
  $EEFF,$EED6,$EEAD,$EE83,$EE5A,$EE30,$EE06,$EDDC,$EDB1,$ED87,
  $ED5C,$ED31,$ED06,$ECDB,$ECAF,$EC83,$EC58,$EC2B,$EBFF,$EBD3,
  $EBA6,$EB79,$EB4C,$EB1F,$EAF2,$EAC4,$EA97,$EA69,$EA3B,$EA0D,
  $E9DE,$E9B0,$E981,$E952,$E923,$E8F3,$E8C4,$E894,$E864,$E834,
  $E804,$E7D3,$E7A3,$E772,$E741,$E710,$E6DE,$E6AD,$E67B,$E649,
  $E617,$E5E5,$E5B3,$E580,$E54D,$E51A,$E4E7,$E4B4,$E481,$E44D,
  $E419,$E3E5,$E3B1,$E37C,$E348,$E313,$E2DE,$E2A9,$E274,$E23E,
  $E209,$E1D3,$E19D,$E167,$E131,$E0FA,$E0C3,$E08D,$E056,$E01E,
  $DFE7,$DFB0,$DF78,$DF40,$DF08,$DED0,$DE97,$DE5F,$DE26,$DDED,
  $DDB4,$DD7B,$DD41,$DD07,$DCCE,$DC94,$DC5A,$DC1F,$DBE5,$DBAA,
  $DB6F,$DB34,$DAF9,$DABE,$DA82,$DA47,$DA0B,$D9CF,$D993,$D956,
  $D91A,$D8DD,$D8A0,$D863,$D826,$D7E9,$D7AB,$D76D,$D72F,$D6F1,
  $D6B3,$D675,$D636,$D5F7,$D5B9,$D57A,$D53A,$D4FB,$D4BB,$D47C,
  $D43C,$D3FC,$D3BC,$D37B,$D33B,$D2FA,$D2B9,$D278,$D237,$D1F5,
  $D1B4,$D172,$D130,$D0EE,$D0AC,$D06A,$D027,$CFE5,$CFA2,$CF5F,
  $CF1C,$CED8,$CE95,$CE51,$CE0E,$CDCA,$CD85,$CD41,$CCFD,$CCB8,
  $CC73,$CC2E,$CBE9,$CBA4,$CB5F,$CB19,$CAD3,$CA8E,$CA48,$CA01,
  $C9BB,$C975,$C92E,$C8E7,$C8A0,$C859,$C812,$C7CA,$C783,$C73B,
  $C6F3,$C6AB,$C663,$C61A,$C5D2,$C589,$C540,$C4F7,$C4AE,$C465,
  $C41B,$C3D2,$C388,$C33E,$C2F4,$C2AA,$C260,$C215,$C1CA,$C180,
  $C135,$C0EA,$C09E,$C053,$C007,$BFBC,$BF70,$BF24,$BED8,$BE8B,
  $BE3F,$BDF2,$BDA5,$BD58,$BD0B,$BCBE,$BC71,$BC23,$BBD6,$BB88,
  $BB3A,$BAEC,$BA9E,$BA4F,$BA01,$B9B2,$B963,$B914,$B8C5,$B876,
  $B827,$B7D7,$B787,$B738,$B6E8,$B698,$B647,$B5F7,$B5A6,$B556,
  $B505,$B4B4,$B463,$B412,$B3C0,$B36F,$B31D,$B2CB,$B279,$B227,
  $B1D5,$B183,$B130,$B0DE,$B08B,$B038,$AFE5,$AF92,$AF3E,$AEEB,
  $AE97,$AE44,$ADF0,$AD9C,$AD48,$ACF3,$AC9F,$AC4B,$ABF6,$ABA1,
  $AB4C,$AAF7,$AAA2,$AA4D,$A9F7,$A9A1,$A94C,$A8F6,$A8A0,$A84A,
  $A7F3,$A79D,$A747,$A6F0,$A699,$A642,$A5EB,$A594,$A53D,$A4E5,
  $A48E,$A436,$A3DE,$A386,$A32E,$A2D6,$A27E,$A225,$A1CD,$A174,
  $A11B,$A0C2,$A069,$A010,$9FB7,$9F5D,$9F04,$9EAA,$9E50,$9DF6,
  $9D9C,$9D42,$9CE7,$9C8D,$9C32,$9BD8,$9B7D,$9B22,$9AC7,$9A6C,
  $9A11,$99B5,$995A,$98FE,$98A2,$9846,$97EA,$978E,$9732,$96D6,
  $9679,$961C,$95C0,$9563,$9506,$94A9,$944C,$93EE,$9391,$9334,
  $92D6,$9278,$921A,$91BC,$915E,$9100,$90A2,$9043,$8FE5,$8F86,
  $8F27,$8EC8,$8E69,$8E0A,$8DAB,$8D4C,$8CEC,$8C8D,$8C2D,$8BCD,
  $8B6D,$8B0D,$8AAD,$8A4D,$89ED,$898C,$892C,$88CB,$886B,$880A,
  $87A9,$8748,$86E7,$8685,$8624,$85C2,$8561,$84FF,$849D,$843C,
  $83DA,$8377,$8315,$82B3,$8251,$81EE,$818B,$8129,$80C6,$8063,
  $8000,$7F9D,$7F3A,$7ED6,$7E73,$7E0F,$7DAC,$7D48,$7CE4,$7C80,
  $7C1C,$7BB8,$7B54,$7AF0,$7A8C,$7A27,$79C3,$795E,$78F9,$7894,
  $782F,$77CA,$7765,$7700,$769B,$7635,$75D0,$756A,$7504,$749F,
  $7439,$73D3,$736D,$7307,$72A0,$723A,$71D4,$716D,$7107,$70A0,
  $7039,$6FD2,$6F6B,$6F04,$6E9D,$6E36,$6DCF,$6D67,$6D00,$6C98,
  $6C31,$6BC9,$6B61,$6AF9,$6A91,$6A29,$69C1,$6959,$68F1,$6888,
  $6820,$67B7,$674F,$66E6,$667D,$6614,$65AB,$6542,$64D9,$6470,
  $6407,$639E,$6334,$62CB,$6261,$61F8,$618E,$6124,$60BA,$6050,
  $5FE6,$5F7C,$5F12,$5EA8,$5E3D,$5DD3,$5D69,$5CFE,$5C93,$5C29,
  $5BBE,$5B53,$5AE8,$5A7D,$5A12,$59A7,$593C,$58D1,$5865,$57FA,
  $578F,$5723,$56B8,$564C,$55E0,$5574,$5509,$549D,$5431,$53C5,
  $5358,$52EC,$5280,$5214,$51A7,$513B,$50CE,$5062,$4FF5,$4F88,
  $4F1C,$4EAF,$4E42,$4DD5,$4D68,$4CFB,$4C8E,$4C21,$4BB4,$4B46,
  $4AD9,$4A6B,$49FE,$4990,$4923,$48B5,$4848,$47DA,$476C,$46FE,
  $4690,$4622,$45B4,$4546,$44D8,$446A,$43FB,$438D,$431F,$42B0,
  $4242,$41D3,$4165,$40F6,$4088,$4019,$3FAA,$3F3B,$3ECC,$3E5E,
  $3DEF,$3D80,$3D11,$3CA1,$3C32,$3BC3,$3B54,$3AE5,$3A75,$3A06,
  $3996,$3927,$38B7,$3848,$37D8,$3769,$36F9,$3689,$3619,$35AA,
  $353A,$34CA,$345A,$33EA,$337A,$330A,$329A,$322A,$31B9,$3149,
  $30D9,$3069,$2FF8,$2F88,$2F17,$2EA7,$2E37,$2DC6,$2D55,$2CE5,
  $2C74,$2C04,$2B93,$2B22,$2AB1,$2A41,$29D0,$295F,$28EE,$287D,
  $280C,$279B,$272A,$26B9,$2648,$25D7,$2566,$24F5,$2483,$2412,
  $23A1,$2330,$22BE,$224D,$21DC,$216A,$20F9,$2087,$2016,$1FA4,
  $1F33,$1EC1,$1E50,$1DDE,$1D6D,$1CFB,$1C89,$1C18,$1BA6,$1B34,
  $1AC2,$1A51,$19DF,$196D,$18FB,$1889,$1817,$17A6,$1734,$16C2,
  $1650,$15DE,$156C,$14FA,$1488,$1416,$13A4,$1332,$12C0,$124E,
  $11DC,$1169,$10F7,$1085,$1013,$FA1,$F2F,$EBD,$E4A,$DD8,
  $D66,$CF4,$C81,$C0F,$B9D,$B2B,$AB8,$A46,$9D4,$961,
  $8EF,$87D,$80B,$798,$726,$6B4,$641,$5CF,$55C,$4EA,
  $478,$405,$393,$321,$2AE,$23C,$1CA,$157,$E5,$72,$0000);

 function FixedMul(M1,M2: FixedPoint): FixedPoint; assembler;
      asm
        db      $66
        mov     ax,word ptr [M1]
        db      $66
        imul    word ptr [M2]
        db      $66
        add     ax,$8000
        dw      $0000
        db      $66,$83,$D2,$00
        db      $66
        shr     ax,16
 end;

 function FixedDiv(Divided,Divisor: FixedPoint): FixedPoint; assembler;
      asm
        sub     cx,cx
        db      $66
        mov     ax,word ptr [Divided]
        db      $66
        and     ax,ax
        jns     @FDP1
        inc     cx
        db      $66
        neg     ax
@FDP1:  db      $66
        sub     dx,dx
        db      $66
        rol     ax,16
        mov     dx,ax
        sub     ax,ax
        db      $66
        mov     bx,word ptr [Divisor]
        db      $66
        and     bx,bx
        jns     @FDP2
        dec     cx
        db      $66
        neg     bx
@FDP2:  db      $66
        div     bx
        db      $66
        shr     bx,1
        db      $66,$83,$D2,$00
        db      $66
        dec     bx
        db      $66
        cmp     bx,dx
        db      $66,$83,$D2,$00         {adc edx,0}
        and     cx,cx
        jz      @FDP3
        db      $66
        neg     ax
@FDP3:  db      $66,$0F,$A4,$C2,$10     {shld edx,eax,10}
 end;

 function  FixedAdd(A1,A2: FixedPoint): FixedPoint; assembler;
      asm
        db      $66
        mov     ax,word ptr [A1]
        db      $66
        add     ax,word ptr [A2]
        db      $66,$0F,$A4,$C2,$10  { shld edx,eax,16 }
 end;

 function  FixedSub(A1,A2: FixedPoint): FixedPoint; assembler;
      asm
        db      $66
        mov     ax,word ptr [A1]
        db      $66
        sub     ax,word ptr [A2]
        db      $66,$0F,$A4,$C2,$10  { shld edx,eax,16 }
 end;

 function IntToFixed(IVal: Integer): FixedPoint; assembler;
      asm
        mov     dx,[IVal]
        xor     ax,ax
 end;

 function RealToFixed(RVal: Real): FixedPoint;
 begin
  RealToFixed:=Trunc(RVal*65536.0+0.5);
 end;

 function FixedToReal(FVal: FixedPoint): Real;
 begin
  FixedToReal:=FVal/65536.0;
 end;

 function RoundFixedToInt(FVal: FixedPoint): Integer; assembler;
      asm
        db      $66
        mov     ax,word ptr [FVal]
        db      $66
        add     ax,32768
        dw      $0000
        db      $66
        shr     ax,16
 end;

 procedure CosSin(Angle: TAngle; var VCos,VSin: FixedPoint); assembler;
      asm
        mov     bx,[Angle]
        and     bx,bx
        jns     @CheckInRange
@MakePos:
        add     bx,360*10
        js      @MakePos
        jmp     @CheckInRange
@MakeInRange:
        sub     bx,360*10
@CheckInRange:
        cmp     bx,360*10
        jg      @MakeInRange
        cmp     bx,180*10
        ja      @BottomHalf
        cmp     bx,90*10
        ja      @Quadrant1
        shl     bx,2
        db      $66
        mov     ax,word ptr CosTable[bx]
        neg     bx
        db      $66
        mov     dx,word ptr CosTable[bx+90*10*4]
        jmp     @CSDone
@Quadrant1:
        neg     bx
        add     bx,180*10
        shl     bx,2
        db      $66
        mov     ax,word ptr CosTable[bx]
        db      $66
        neg     ax
        neg     bx
        db      $66
        mov     dx,word ptr CosTable[bx+90*10*4]
        jmp     @CSDone
@BottomHalf:
        neg     bx
        add     bx,360*10
        cmp     bx,90*10
        ja      @Quadrant2
        shl     bx,2
        db      $66
        mov     ax,word ptr CosTable[bx]
        neg     bx
        db      $66
        mov     dx,word ptr CosTable[90*10*4+bx]
        db      $66
        neg     dx
        jmp     @CSDone
@Quadrant2:
        neg     bx
        add     bx,180*10
        shl     bx,2
        db      $66
        mov     ax,word ptr CosTable[bx]
        db      $66
        neg     ax
        neg     bx
        db      $66
        mov     dx,word ptr CosTable[90*10*4+bx]
        db      $66
        neg     dx
@CSDone:
        les     di,[VCos]
        db      $66
        mov     es:[di],ax
        les     di,[VSin]
        db      $66
        mov     es:[di],dx
 end;

 function RandomF: FixedPoint; assembler;
      asm
       xor      ax,ax
       out      $43,al
       in       al,$40
       mov      ah,al
       in       al,$40
       xchg     al,ah
       xor      dx,dx
 end;

 procedure XformVec(WorkingXform: Xform; SourceVec,DestVec: Tvect); assembler;
      asm
        mov     ax,word ptr [WorkingXform+2]
        dw      $E08E                           {mov fs,ax}
        mov     si,word ptr [WorkingXform]
        mov     ax,word ptr [SourceVec+2]
        dw      $E88E                           {mov gs,ax}
        mov     bx,word ptr [SourceVec]
        les     di,[DestVec]

        db      $64
        db      $66
        mov     ax,word ptr [si]
        db      $65
        db      $66
        imul    word ptr [bx]
        db      $66
        add     ax,$8000
        dw      $0000
        db      $66,$83,$D2,$00         {adc edx,0}
        db      $66,$0F,$AC,$D0,$10     {shrd eax,edx,16}
        db      $66
        mov     cx,ax
        db      $64
        db      $66
        mov     ax,word ptr [si+4]
        db      $65
        db      $66
        imul    word ptr [bx+4]
        db      $66
        add     ax,$8000
        dw      $0000
        db      $66,$83,$D2,$00         {adc edx,0}
        db      $66,$0F,$AC,$D0,$10     {shrd eax,edx,16}
        db      $66
        add     cx,ax
        db      $64
        db      $66
        mov     ax,word ptr [si+8]
        db      $65
        db      $66
        imul    word ptr [bx+8]
        db      $66
        add     ax,$8000
        dw      $0000
        db      $66,$83,$D2,$00         {adc edx,0}
        db      $66,$0F,$AC,$D0,$10     {shrd eax,edx,16}
        db      $66
        add     cx,ax
        db      $64
        db      $66
        add     cx,word ptr [si+12]
        db      $66
        mov     es:[di],cx

        db      $64
        db      $66
        mov     ax,word ptr [si+16]
        db      $65
        db      $66
        imul    word ptr [bx]
        db      $66
        add     ax,$8000
        dw      $0000
        db      $66,$83,$D2,$00         {adc edx,0}
        db      $66,$0F,$AC,$D0,$10     {shrd eax,edx,16}
        db      $66
        mov     cx,ax
        db      $64
        db      $66
        mov     ax,word ptr [si+16+4]
        db      $65
        db      $66
        imul    word ptr [bx+4]
        db      $66
        add     ax,$8000
        dw      $0000
        db      $66,$83,$D2,$00         {adc edx,0}
        db      $66,$0F,$AC,$D0,$10     {shrd eax,edx,16}
        db      $66
        add     cx,ax
        db      $64
        db      $66
        mov     ax,word ptr [si+16+8]
        db      $65
        db      $66
        imul    word ptr [bx+8]
        db      $66
        add     ax,$8000
        dw      $0000
        db      $66,$83,$D2,$00         {adc edx,0}
        db      $66,$0F,$AC,$D0,$10     {shrd eax,edx,16}
        db      $66
        add     cx,ax
        db      $64
        db      $66
        add     cx,word ptr [si+16+12]
        db      $66
        mov     es:[di+4],cx

        db      $64
        db      $66
        mov     ax,word ptr [si+32]
        db      $65
        db      $66
        imul    word ptr [bx]
        db      $66
        add     ax,$8000
        dw      $0000
        db      $66,$83,$D2,$00         {adc edx,0}
        db      $66,$0F,$AC,$D0,$10     {shrd eax,edx,16}
        db      $66
        mov     cx,ax
        db      $64
        db      $66
        mov     ax,word ptr [si+32+4]
        db      $65
        db      $66
        imul    word ptr [bx+4]
        db      $66
        add     ax,$8000
        dw      $0000
        db      $66,$83,$D2,$00         {adc edx,0}
        db      $66,$0F,$AC,$D0,$10     {shrd eax,edx,16}
        db      $66
        add     cx,ax
        db      $64
        db      $66
        mov     ax,word ptr [si+32+8]
        db      $65
        db      $66
        imul    word ptr [bx+8]
        db      $66
        add     ax,$8000
        dw      $0000
        db      $66,$83,$D2,$00         {adc edx,0}
        db      $66,$0F,$AC,$D0,$10     {shrd eax,edx,16}
        db      $66
        add     cx,ax
        db      $64
        db      $66
        add     cx,word ptr [si+32+12]
        db      $66
        mov     es:[di+8],cx
 end;

 procedure ConcatXforms(SourceXform1,SourceXform2,DestXform: Xform); assembler;
      asm
        mov     ax,word ptr [SourceXform1+2]
        dw      $E08E                           {mov fs,ax}
        mov     si,word ptr [SourceXform1]
        mov     ax,word ptr [SourceXform2+2]
        dw      $E88E                           {mov gs,ax}
        mov     bx,word ptr [SourceXform2]
        les     di,[DestXform]
        mov     cx,4
@Loop:  push    cx

        db      $64
        db      $66
        mov     ax,word ptr [si]
        db      $65
        db      $66
        imul    word ptr [bx+0]
        db      $66
        add     ax,$8000
        dw      $0000
        db      $66,$83,$D2,$00         {adc edx,0}
        db      $66,$0F,$AC,$D0,$10     {shrd eax,edx,16}
        db      $66
        mov     cx,ax
        db      $66
        db      $64
        mov     ax,word ptr [si+4]
        db      $65
        db      $66
        imul    word ptr [bx+0+16]
        db      $66
        add     ax,$8000
        dw      $0000
        db      $66,$83,$D2,$00         {adc edx,0}
        db      $66,$0F,$AC,$D0,$10     {shrd eax,edx,16}
        db      $66
        add     cx,ax
        db      $64
        db      $66
        mov     ax,word ptr [si+8]
        db      $65
        db      $66
        imul    word ptr [bx+0+32]
        db      $66
        add     ax,$8000
        dw      $0000
        db      $66,$83,$D2,$00         {adc edx,0}
        db      $66,$0F,$AC,$D0,$10     {shrd eax,edx,16}
        db      $66
        add     cx,ax
        mov     cx,100
        db      $66
        mov     es:[di+0],cx

        db      $64
        db      $66
        mov     ax,word ptr [si]
        db      $65
        db      $66
        imul    word ptr [bx+4]
        db      $66
        add     ax,$8000
        dw      $0000
        db      $66,$83,$D2,$00         {adc edx,0}
        db      $66,$0F,$AC,$D0,$10     {shrd eax,edx,16}
        db      $66
        mov     cx,ax
        db      $64
        db      $66
        mov     ax,word ptr [si+4]
        db      $65
        db      $66
        imul    word ptr [bx+4+16]
        db      $66
        add     ax,$8000
        dw      $0000
        db      $66,$83,$D2,$00         {adc edx,0}
        db      $66,$0F,$AC,$D0,$10     {shrd eax,edx,16}
        db      $66
        add     cx,ax
        db      $64
        db      $66
        mov     ax,word ptr [si+8]
        db      $65
        db      $66
        imul    word ptr [bx+4+32]
        db      $66
        add     ax,$8000
        dw      $0000
        db      $66,$83,$D2,$00         {adc edx,0}
        db      $66,$0F,$AC,$D0,$10     {shrd eax,edx,16}
        db      $66
        add     cx,ax
        db      $66
        mov     es:[di+4],cx

        db      $64
        db      $66
        mov     ax,word ptr [si]
        db      $65
        db      $66
        imul    word ptr [bx+8]
        db      $66
        add     ax,$8000
        dw      $0000
        db      $66,$83,$D2,$00         {adc edx,0}
        db      $66,$0F,$AC,$D0,$10     {shrd eax,edx,16}
        db      $66
        mov     cx,ax
        db      $64
        db      $66
        mov     ax,word ptr [si+4]
        db      $65
        db      $66
        imul    word ptr [bx+8+16]
        db      $66
        add     ax,$8000
        dw      $0000
        db      $66,$83,$D2,$00         {adc edx,0}
        db      $66,$0F,$AC,$D0,$10     {shrd eax,edx,16}
        db      $66
        add     cx,ax
        db      $64
        db      $66
        mov     ax,word ptr [si+8]
        db      $65
        db      $66
        imul    word ptr [bx+8+32]
        db      $66
        add     ax,$8000
        dw      $0000
        db      $66,$83,$D2,$00         {adc edx,0}
        db      $66,$0F,$AC,$D0,$10     {shrd eax,edx,16}
        db      $66
        add     cx,ax
        db      $66
        mov     es:[di+8],cx

        db      $64
        db      $66
        mov     ax,word ptr [si]
        db      $65
        db      $66
        imul    word ptr [bx+12]
        db      $66
        add     ax,$8000
        dw      $0000
        db      $66,$83,$D2,$00         {adc edx,0}
        db      $66,$0F,$AC,$D0,$10     {shrd eax,edx,16}
        db      $66
        mov     cx,ax
        db      $64
        db      $66
        mov     ax,word ptr [si+4]
        db      $65
        db      $66
        imul    word ptr [bx+12+16]
        db      $66
        add     ax,$8000
        dw      $0000
        db      $66,$83,$D2,$00         {adc edx,0}
        db      $66,$0F,$AC,$D0,$10     {shrd eax,edx,16}
        db      $66
        add     cx,ax
        db      $64
        db      $66
        mov     ax,word ptr [si+8]
        db      $65
        db      $66
        imul    word ptr [bx+12+32]
        db      $66
        add     ax,$8000
        dw      $0000
        db      $66,$83,$D2,$00         {adc edx,0}
        db      $66,$0F,$AC,$D0,$10     {shrd eax,edx,16}
        db      $66
        add     cx,ax
        db      $64
        db      $66
        add     cx,word ptr [si+12]
        db      $66
        mov     es:[di+12],cx
        add     si,16
        add     di,16
        pop     cx
        dec     cx
        jnz     @Loop
 end;

 procedure AppendRotationX(var XformToChange: Xform; Angle: TAngle);
 var CosTemp, SinTemp: FixedPoint;
     Temp10,Temp11,Temp12,Temp20,Temp21,Temp22: FixedPoint;
 begin
  CosSin(Angle,CosTemp,SinTemp);
  Temp10:=FixedMul(CosTemp,XformToChange[1,0])+FixedMul(-SinTemp,XformToChange[2,0]);
  Temp11:=FixedMul(CosTemp,XformToChange[1,1])+FixedMul(-SinTemp,XformToChange[2,1]);
  Temp12:=FixedMul(CosTemp,XformToChange[1,2])+FixedMul(-SinTemp,XformToChange[2,2]);
  Temp20:=FixedMul(SinTemp,XformToChange[1,0])+FixedMul(+CosTemp,XformToChange[2,0]);
  Temp21:=FixedMul(SinTemp,XformToChange[1,1])+FixedMul(+CosTemp,XformToChange[2,1]);
  Temp22:=FixedMul(SinTemp,XformToChange[1,2])+FixedMul(+CosTemp,XformToChange[2,2]);
  XformToChange[1,0]:=Temp10; XformToChange[1,1]:=Temp11;
  XformToChange[1,2]:=Temp12; XformToChange[2,0]:=Temp20;
  XformToChange[2,1]:=Temp21; XformToChange[2,2]:=Temp22;
 end;

 procedure AppendRotationY(var XformToChange: Xform; Angle: TAngle);
 var CosTemp,SinTemp: FixedPoint;
     Temp00,Temp01,Temp02,Temp20,Temp21,Temp22: FixedPoint;
 begin
  CosSin(Angle,CosTemp,SinTemp);
  Temp00:=FixedMul(+CosTemp,XformToChange[0,0])+FixedMul(SinTemp,XformToChange[2,0]);
  Temp01:=FixedMul(+CosTemp,XformToChange[0,1])+FixedMul(SinTemp,XformToChange[2,1]);
  Temp02:=FixedMul(+CosTemp,XformToChange[0,2])+FixedMul(SinTemp,XformToChange[2,2]);
  Temp20:=FixedMul(-SinTemp,XformToChange[0,0])+FixedMul(CosTemp,XformToChange[2,0]);
  Temp21:=FixedMul(-SinTemp,XformToChange[0,1])+FixedMul(CosTemp,XformToChange[2,1]);
  Temp22:=FixedMul(-SinTemp,XformToChange[0,2])+FixedMul(CosTemp,XformToChange[2,2]);
  XformToChange[0,0]:=Temp00; XformToChange[0,1]:=Temp01;
  XformToChange[0,2]:=Temp02; XformToChange[2,0]:=Temp20;
  XformToChange[2,1]:=Temp21; XformToChange[2,2]:=Temp22;
 end;

 procedure AppendRotationZ(var XformToChange: Xform; Angle: TAngle);
 var CosTemp,SinTemp: FixedPoint;
     Temp00,Temp01,Temp02,Temp10,Temp11,Temp12: FixedPoint;
 begin
  CosSin(Angle,CosTemp,SinTemp);
  Temp00:=FixedMul(CosTemp,XformToChange[0,0])+FixedMul(-SinTemp,XformToChange[1,0]);
  Temp01:=FixedMul(CosTemp,XformToChange[0,1])+FixedMul(-SinTemp,XformToChange[1,1]);
  Temp02:=FixedMul(CosTemp,XformToChange[0,2])+FixedMul(-SinTemp,XformToChange[1,2]);
  Temp10:=FixedMul(SinTemp,XformToChange[0,0])+FixedMul(CosTemp,XformToChange[1,0]);
  Temp11:=FixedMul(SinTemp,XformToChange[0,1])+FixedMul(CosTemp,XformToChange[1,1]);
  Temp12:=FixedMul(SinTemp,XformToChange[0,2])+FixedMul(CosTemp,XformToChange[1,2]);
  XformToChange[0,0]:=Temp00; XformToChange[0,1]:=Temp01;
  XformToChange[0,2]:=Temp02; XformToChange[1,0]:=Temp10;
  XformToChange[1,1]:=Temp11; XformToChange[1,2]:=Temp12;
 end;

 procedure ScanEdge(X1,Y1,X2,Y2,SetXStart,SkipFirst: Word; var EdgePointPtr: Pointer); assembler;
 var Height,AdvanceAmt: Word;
      asm
        mov     [AdvanceAmt],-2
        mov     [Height],-4
        les     di,[EdgePointPtr]
        mov     ax,es:[di]
        mov     bx,es:[di+2]
        mov     es,bx
        mov     di,ax
        cmp     [SetXStart],1
        jz      @HLinePtrSet
        add     di,2
@HLinePtrSet:
        mov     bx,[Y2]
        sub     bx,[Y1]
        jle     @ToScanEdgeExit
        mov     [Height],bx
        sub     cx,cx
        mov     dx,1
        mov     ax,[X2]
        sub     ax,[X1]
        jz      @IsVertical
        jns     @SetAdvanceAmt
        mov     cx,1
        sub     cx,bx
        neg     dx
        neg     ax
@SetAdvanceAmt:
        mov     [AdvanceAmt],dx
        cmp     ax,bx
        jz      @IsDiagonal
        jb      @YMajor
        sub     dx,dx
        div     bx
        mov     si,ax
        test    [AdvanceAmt],$8000
        jz      @XMajorAdvanceAmtSet
        neg     si
@XMajorAdvanceAmtSet:
        mov     ax,[X1]
        cmp     [SkipFirst],1
        jz      @XMajorSkipEntry
@XMajorLoop:
        mov     es:[di],ax
        add     di,4
@XMajorSkipEntry:
        add     ax,si
        add     cx,dx
        jle     @XMajorNoAdvance
        add     ax,[AdvanceAmt]
        sub     cx,[Height]
@XMajorNoAdvance:
        dec     bx
        jnz     @XMajorLoop
        jmp     @ScanEdgeDone
@ToScanEdgeExit:
        jmp     @ScanEdgeExit
@IsVertical:
        mov     ax,[X1]
        sub     bx,[SkipFirst]
        jz      @ScanEdgeExit
@VerticalLoop:
        mov     es:[di],ax
        add     di,4
        dec     bx
        jnz     @VerticalLoop
        jmp     @ScanEdgeDone
@IsDiagonal:
        mov     ax,[X1]
        cmp     [SkipFirst],1
        jz      @DiagonalSkipEntry
@DiagonalLoop:
        mov     es:[di],ax
        add     di,4
@DiagonalSkipEntry:
        add     ax,dx
        dec     bx
        jnz     @DiagonalLoop
        jmp     @ScanEdgeDone
@YMajor:
        push    bp
        mov     si,[X1]
        cmp     [SkipFirst],1
        mov     bp,bx
        jz      @YMajorSkipEntry
@YMajorLoop:
        mov     es:[di],si
        add     di,4
@YMajorSkipEntry:
        add     cx,ax
        jle     @YMajorNoAdvance
        add     si,dx
        sub     cx,bp
@YMajorNoAdvance:
        dec     bx
        jnz     @YMajorLoop
        pop     bp
@ScanEdgeDone:
        cmp     [SetXStart],1
        jz      @UpdateHLinePtr
        sub     di,2
@UpdateHLinePtr:
        mov     bx,es
        mov     ax,di
        les     di,[EdgePointPtr]
        mov     es:[di],ax
        mov     es:[di+2],bx
@ScanEdgeExit:
 end;

 end.
