{$g+,n-,d-,l-,b-,r-,o+,f+,s-,a+,e-,p-,q-,t+,v-,x+,i-}

(*  FLI ANIMATION PLAYER/I80386 AND HIGHER, REAL MODE, PROTECTED MODE      *)
(*                                                                         *)
(*                  BEST GAME SDK FOR TURBO/BORLAND PASCAL                 *)
(*                ͻ         ͻ ͻ               *)
(*                ͼ    ͻ ͻ  ͻ   ͼ                  *)
(*                   ͼͼ  ͼ͹ ͼ  ͼ                  *)
(*                        ͻ   ͼ                                *)
(*                 :     ͹˻ ͻ  .Ĵ               *)
(*               | |  .    ͼ              *                   *)
(*               -+-    . ʼ       ʼ     ʼ   .  +                 *)
(*                |   .        version 2.0       .      :                 *)
(*                 BY VADIM BODROV, RUSSIA  (c) 1996-98   |               *)

{$IFDEF WINDOWS}
 THIS UNIT CAN NOT BE COMPILED FOR MS WINDOWS!!!
 ONLY DOS REAL MODE AND PROTECTED MODE SUPPORTED
{$ENDIF}

 unit FLI;

 interface

 var FLIAbortKey: Byte;

 function FLIInit (FileName: String): Boolean;
 function FLIGetFrames: Word;
 function FLIPlay (X,Y: Integer; Loop: LongInt): Boolean;
 function FLIShowNextFrame (X,Y: Integer): Boolean;
 function FLIDone: Boolean;

 implementation

 uses MEGAGraf,ZenTimer,DOSUtil,MemPlus,GfxUtil;

 Type
  tHeadFLI = record
   longFile: Longint;
   H_magic:  Word;
   frames:   Word;
   width:    Word;
   height:   Word;
   planes:   Word;
   speed:    Word;
   dummy:    array [1..112] of Byte;
 end;

 tHeadFrame = record
  longframe: Longint;
  F_magic:   Word;
  Blocks:    Word;
  dummy:     array [1..8] of Byte;
 end;

 tHeadBlock = record
  longBlock: Longint;
  BlockType: Word;
 end;

 tHeadBlockInf = record
  y1:     Word;
  height: Word;
 end;

 tPalette = array [0..255,1..3] of Byte;

 var
  FLIfile:        file;
  Palette:        tPalette;
  HeadFLI:        tHeadFLI;
  buffer,buffer2: Pointer;
  frame:          Integer;
  FLIReady:       Boolean;
  Times:          LongInt;
  LastTimer:      LongInt;

 Function CheckKey: Boolean; near;
 begin
  if FLIAbortKey <> 0 then
   CheckKey:=Port[$60]=FLIAbortKey
  else
   CheckKey:=false;
 end;

 procedure ReadFrame; near;
 var
  HeadFrame: tHeadFrame;
  HeadBlock: tHeadBlock;
  Block:     Word;
  x1,data2:  Byte;
  data:      ShortInt;
  fnt,dst:   Pointer;

 procedure Read (dst: Pointer; ValueX:word);
 begin
  xMove(fnt,dst,ValueX);
  IncPointer(fnt,ValueX);
 end;

 procedure NormalizePal (Addr: Pointer; Count: Word); assembler;
      asm
        mov     cx,word ptr [Count]
        les     di,[Addr]
@Loop:  mov     al,es:[di]
        shl     al,2
        stosb
        loop    @Loop
 end;

 procedure FLI_COLOR;
 var
  count,first,Size,ValueB: Byte;
  packets:                 Word;
  ValueA:                  Word;
  Sz:                      Word;

 begin
  Read(@packets,2);
  first:=0;
  ValueA:=0;
  for count:=1 to packets do begin
   Read(@ValueB,1);
   Read(@Size,1);
   Size:=Size and $FF;
   inc(ValueA,Size);
   inc(first,ValueB);
   Sz:=(Size+256*ord(Size=0))*3;
   Read(@Palette[first],Sz);
   if mgBytesPerPixel>1 then
    NormalizePal(@Palette[0],Sz)
   else
    SetVGAPalette(@Palette[0],0,256);
   inc(first,Size);
  end;
  if (ValueA*3) mod 2 > 0 then Read(@ValueB,1);
 end;

 procedure FLI_LC;
 var
  BlockToDo:              tHeadBlockInf;
  numpackets,packet,line: Byte;
 begin
  Read(@BlockToDo,SizeOf(tHeadBlockInf));
  for line:=0 to BlockToDo.height-1 do begin
   Read(@Numpackets,1);
   dst:=GetPtr(buffer2,(BlockToDo.y1+line)*320);
   for packet:=1 to numpackets do begin
    Read(@x1,1);
    dst:=GetPtr(dst,x1);
    Read(@data,1);
    if (data<0) then begin
     Read(@data2,1);
     xFill(dst,-data,data2);
     dst:=GetPtr(dst,-data);
    end else begin
     Read(dst,data);
     dst:=GetPtr(dst,data);
    end;
   end;
  end;
 end;

 procedure FLI_BLACK;
 begin
   xFill(dst,HeadFLI.width*HeadFLI.height,0);
 end;

 procedure FLI_BRUN;
 var numpackets, packet, line: Byte;
 begin
  for line:=0 to HeadFLI.height-1 do begin
   Read(@Numpackets,1);
   for packet:=1 to numpackets do begin
    Read(@data,1);
    if (data>0) then begin
     Read(@data2,1);
     xFill(dst,data,data2);
     dst:=GetPtr(dst,data);
    end else begin
     data:=-data;
     Read(dst,data);
     dst:=GetPtr(dst,data);
    end;
   end;
  end;
 end;

 procedure FLI_COPY;
 begin
   Read(dst,HeadFLI.width*HeadFLI.height);
 end;

 begin
  BlockRead(FLIFile,HeadFrame,SizeOf(tHeadFrame));
  BlockRead(FLIFile,buffer^,HeadFrame.longframe-SizeOf(tHeadFrame));
  fnt:=buffer;
  for Block:=1 to HeadFrame.Blocks do begin
   dst:=buffer2;
   Read(@HeadBlock,SizeOf(tHeadBlock));
   case (HeadBlock.BlockType) of
    11: FLI_COLOR;
    12: FLI_LC;
    13: FLI_BLACK;
    15: FLI_BRUN;
    16: FLI_COPY;
   end;
  end;
 end;

 function FLIInit (FileName: String): Boolean;
 begin
  FLIReady:=false;
 {$I-}
  if not TestFile(FileName) then begin
   FLIInit:=false;
   exit;
  end;
  Assign(FLIfile,FileName);
  Reset(FLIfile,1);
 {$I+}
  If IOResult<>0 then begin
   FLIInit:=false;
   exit;
  end;
 {$I-}
  BlockRead(FLIfile,HeadFLI,SizeOf(tHeadFLI));
 {$I+}
  If HeadFLI.H_magic<>$AF11 then begin
   FLIInit:=false;
   exit;
  end;
  GetBuffer(buffer,$FFFF);
  if Buffer<>nil then begin
   GetBuffer(buffer2,$FFFF);
   if Buffer2<>nil then FLIReady:=true;
  end;
  FLIInit:=FLIReady;
 end;

 function FLIShowNextFrame (X,Y: Integer): Boolean;
 begin
  if not FLIReady then begin
   FLIShowNextFrame:=false;
   exit;
  end;
  FLIShowNextFrame:=true;
  ReadFrame;
  GfxPalAddr:=@Palette[0];
  Retrace;
  case mgBytesPerPixel of
   1: PutSprite(X,Y,X+319,Y+199,false,Buffer2);
   2: PutSprite256to32K(X,Y,X+319,Y+199,false,Buffer2);
   3: PutSprite256to16M(X,Y,X+319,Y+199,false,Buffer2);
   4: PutSprite256to4G(X,Y,X+319,Y+199,false,Buffer2);
  end;
  Inc(frame);
  if frame=HeadFLI.frames+1 then begin
   frame:=1;
   Seek(FLIFile,SizeOf(tHeadFLI));
   inc(Times);
  end;
 end;

 function FLIPlay (X,Y: Integer; Loop: LongInt): Boolean;
 begin
  if not FLIReady then begin
   FLIPlay:=false;
   exit;
  end;
  FLIPlay:=true;
  Times:=0;
  LastTimer:=LongInt(ptr(SEG0040,$6C)^);
  repeat
   frame:=1;
   repeat
    FLIShowNextFrame(X,Y);
    repeat until LongInt(ptr(SEG0040,$6C)^) > LastTimer+(HeadFLI.Speed shr 2);
    LastTimer:=LongInt(ptr(SEG0040,$6C)^);
    if CheckKey then exit;
   until frame=HeadFLI.frames+1;
   if Loop=0 then Times:=$FFFFFF;
  until Times=Loop;
 end;

 function FLIDone: Boolean;
 begin
  if not FLIReady then
   FLIDone:=false
  else begin
   FreeMem(buffer2,$FFFF);
   FreeMem(buffer,$FFFF);
   Close(FLIfile);
   FliDone:=true;
  end;
 end;

 function FLIGetFrames: Word;
 begin
  FLIGetFrames:=HeadFLI.frames
 end;

 begin
  FLIAbortKey:=1;
 end.