{$g+,n-,d-,l-,b-,r-,o+,f+,s-,a+,e-,p-,q-,t+,v-,x+,i-}

(* 256-COLORED FONTS SUPPORT /I80386 AND HIGHER, REAL MODE, PROTECTED MODE *)
(*                                                                         *)
(*                  BEST GAME SDK FOR TURBO/BORLAND PASCAL                 *)
(*                ͻ         ͻ ͻ               *)
(*                ͼ    ͻ ͻ  ͻ   ͼ                  *)
(*                   ͼͼ  ͼ͹ ͼ  ͼ                  *)
(*                        ͻ   ͼ                                *)
(*                 :     ͹˻ ͻ  .Ĵ               *)
(*               | |  .    ͼ              *                   *)
(*               -+-    . ʼ       ʼ     ʼ   .  +                 *)
(*                |   .        version 2.0       .      :                 *)
(*                 BY VADIM BODROV, RUSSIA  (c) 1996-98   |               *)

{$IFDEF WINDOWS}
 THIS UNIT CAN NOT BE COMPILED FOR MS WINDOWS!!!
 ONLY DOS REAL MODE AND PROTECTED MODE SUPPORTED
{$ENDIF}

 unit GfxFont;

 interface

 var FontSpacing:    Integer;
     FirstCh,LastCh: Byte;   {for RAW}
     NumOfChar:      Byte;   {for TED}

 function  SetTEDFont (Addr, Pal: Pointer): Boolean;
 procedure SetRAWFont (Addr, Pal: Pointer; Length, Height: Byte);
 procedure PutSymXY (X, Y: Integer; C: Char);
 procedure WriteXY (X, Y: Integer; S: String);

 implementation

 uses MegaGraf,MemPlus,GfxUtil;

 var TX,TY:    Byte;
     ChSet:    Pointer;
     FontInit: Byte;
     NormPal:  array [0..768] of Byte;

 function GetID(Addr: Pointer; Num: Byte): String;
 var i: Byte;
     s: String;
 begin
  s:='';
  for i:=0 to Num-1 do s:=s+chr(xGetByte(Addr,i));
  GetID:=s;
 end;

 function FindTEDCh(Addr: Pointer; Ch: Char): Pointer;
 var i: Byte;
 begin
  if FontInit<>1 then begin
   FindTEDCh:=nil; exit;
  end;
  i:=0;
  repeat
   if GetByte(Addr)<>Byte(Ch) then
    IncPointer(Addr,3+Word(xGetByte(Addr,1))*Word(xGetByte(Addr,2)))
   else begin
    if (xGetByte(Addr,1)=0) or (xGetByte(Addr,2)=0) then begin
     FindTEDCh:=nil;
     exit;
    end;
    FindTEDCh:=Addr;
    exit;
   end;
   inc(i);
  until i=NumOfChar;
  FindTEDCh:=nil;
 end;

 function SetTEDFont(Addr,Pal: Pointer): Boolean;
 begin
  if GetID(Addr,17)<>'TED94PARADiSE' then begin
   SetTEDFont:=false;
   exit;
  end;
  ChSet:=GetPtr(Addr,20);
  if Pal<>nil then begin
   xMove(Pal,@NormPal,768);
   PAL6to8(@NormPal);
  end;
  FontInit:=1;
 end;

 procedure SetRAWFont(Addr,Pal: Pointer; Length, Height: Byte);
 begin
  TX:=Length;
  TY:=Height;
  ChSet:=Addr;
  if Pal<>nil then begin
   xMove(Pal,@NormPal,768);
   PAL6to8(@NormPal);
  end;
  FontInit:=2;
 end;

 procedure PutSymXY(X,Y: Integer; C: Char);
 var cAddr: Pointer;
 begin
  GfxPalAddr:=@NormPal;
  case FontInit of
   1: begin
       if C=' ' then exit;
       cAddr:=FindTEDCh(ChSet,C);
       if cAddr=nil then exit;
       TX:=xGetByte(cAddr,1);
       TY:=xGetByte(cAddr,2);
       IncPointer(cAddr,3);
       case mgBitsPerPixel of
        8:     PutSprite(X,Y,X+TX-1,Y+TY-1,false,cAddr);
        15,16: PutSprite256to32K(X,Y,X+TX-1,Y+TY-1,false,cAddr);
        24:    PutSprite256to16M(X,Y,X+TX-1,Y+TY-1,false,cAddr);
        32:    PutSprite256to4G(X,Y,X+TX-1,Y+TY-1,false,cAddr);
       end;
      end;
   2: begin
       if (FirstCh>Byte(C)) or (LastCh<Byte(C)) then Exit;
       cAddr:=GetPtr(ChSet,TX*TY*(Word(C)-FirstCh));
       case mgColorMode of
        8:     PutSprite(X,Y,X+TX-1,Y+TY-1,false,cAddr);
        15,16: PutSprite256to32K(X,Y,X+TX-1,Y+TY-1,false,cAddr);
        24:    PutSprite256to16M(X,Y,X+TX-1,Y+TY-1,false,cAddr);
        32:    PutSprite256to4G(X,Y,X+TX-1,Y+TY-1,false,cAddr);
       end;
      end;
  end;
 end;

 procedure WriteXY(X,Y: Integer; S: String);
 var Nr: Byte;
 begin
  for Nr:=1 to Length(S) do begin
   PutSymXY(X,Y,S[Nr]);
   inc(X,TX+FontSpacing);
  end;
 end;

 begin
  FirstCh:=32;
  LastCh:=90;
  NumOfChar:=90;
 end.