{$g+,n-,d-,l-,b-,r-,f+,s-,a+,e-,p-,q-,t+,v-,x+,i-}

(* GFX MOUSE POINTERS SUPPORT/I80386 AND HIGHER, REAL MODE, PROTECTED MODE *)
(*                                                                         *)
(*                  BEST GAME SDK FOR TURBO/BORLAND PASCAL                 *)
(*                ͻ         ͻ ͻ               *)
(*                ͼ    ͻ ͻ  ͻ   ͼ                  *)
(*                   ͼͼ  ͼ͹ ͼ  ͼ                  *)
(*                        ͻ   ͼ                                *)
(*                 :     ͹˻ ͻ  .Ĵ               *)
(*               | |  .    ͼ              *                   *)
(*               -+-    . ʼ       ʼ     ʼ   .  +                 *)
(*                |   .        version 2.0       .      :                 *)
(*                 BY VADIM BODROV, RUSSIA  (c) 1996-98   |               *)

{$IFDEF WINDOWS}
 THIS UNIT CAN NOT BE COMPILED FOR MS WINDOWS!!!
 ONLY DOS REAL MODE AND PROTECTED MODE SUPPORTED
{$ENDIF}

 unit GfxMouse;

 interface

 var GfxMouseFreq:        Word;
     GfxMousePage:        Word;
     AnimationFreq:       Word;
     ResetMouseOnStart:   Boolean;
     GfxMouseX,GfxMouseY: Word;
     UseTimer:            Boolean;

 procedure ShowGfxMouse;
 procedure HideGfxMouse;
 function  SetGfxCursor (Addr: Pointer): Boolean;
 function  EnableGfxMouse: Boolean;
 procedure DisableGfxMouse;
 procedure CursorAnimationOn;
 procedure CursorAnimationOff;
 procedure GetCursorSize (var HSize, VSize: Byte);

 procedure DrawGfxCursor (X, Y: Word);
 procedure RestoreCursorBG (X, Y: Word);
 procedure ReDrawCursor (XNew, YNew: Word);

 implementation

{$IFDEF MSDOS}
 uses MemPlus,MegaGraf,AddMouse,i80386,DOSUtil;
{$ELSE}
 uses MemPlus,MegaGraf,AddMouse,i80386,DOSUtil,Version,WinAPI;
{$ENDIF}

 var C0,C1,C2:          Pointer;
     CurP,OldInt:       Pointer;
     Size:              Word;
     Block:             Word;
     DX,DY:             Byte;
     NumFrames:         Word;
     FrameCount:        Word;
     SetUpCur:          Boolean;
     Init:              Boolean;
     Flag:              Byte;
     DrawFlag:          Word;
     mux,muy:           Word;
     AnimationFlag:     Word;
     Animation:         Boolean;
     AnimDrawFlag:      Boolean;
     ShowOn:            Boolean;
     ProcAddr:          Word;
     TmpPage:           Word;

{$IFDEF DPMI}
 var MSEL:              Word;
     GfxMouseExit:      Pointer;
{$ENDIF}

 procedure CurToFone256; near; assembler;
      asm
        cld
        les     di,C2
        mov     ax,word ptr [C1+2]
        dw      $E08E   {<- mov FS,AX}
        mov     si,word ptr [C1]
        mov     cx,[Size]
@Loop1: db      $64
        rep     movsb
        mov     cx,[Block]
        les     di,C2
        mov     ax,word ptr [C0+2]
        dw      $E08E   {<- mov FS,AX}
        mov     si,word ptr [C0]
@Loop:  db      $64
        lodsb
        or      al,0
        jz      @Cont
        mov     es:[di],al
@Cont:  inc     di
        loop    @Loop
 end;

 procedure CurToFone32K; near; assembler;
      asm
        cld
        les     di,C2
        mov     ax,word ptr [C1+2]
        dw      $E08E   {<- mov FS,AX}
        mov     si,word ptr [C1]
        mov     cx,[Size]
        shr     cx,1
@Loop1: db      $64
        rep     movsw
        mov     cx,[Block]
        les     di,C2
        mov     ax,word ptr [C0+2]
        dw      $E08E   {<- mov FS,AX}
        mov     si,word ptr [C0]
@Loop:  db      $64
        lodsw
        or      ax,0
        jz      @Cont
        mov     es:[di],ax
@Cont:  add     di,2
        loop    @Loop
 end;

 procedure CurToFone16M; near; assembler;
      asm
        cld
        les     di,C2
        mov     ax,word ptr [C1+2]
        dw      $E08E   {<- mov FS,AX}
        mov     si,word ptr [C1]
        mov     cx,[Size]
@Loop1: db      $64
        rep     movsb
        mov     cx,[Block]
        les     di,C2
        mov     ax,word ptr [C0+2]
        dw      $E08E   {<- mov FS,AX}
        mov     si,word ptr [C0]
        xor     bx,bx
@Loop:  db      $64
        lodsw
        db      $64
        mov     bl,[si]
        inc     si
        or      ax,0
        jz      @Cont
        or      bx,0
        jz      @Cont
        mov     es:[di],ax
        mov     es:[di+2],bl
@Cont:  add     di,3
        loop    @Loop
 end;

 procedure CurToFone4G; near; assembler;
      asm
        cld
        les     di,C2
        mov     bx,[Size]
        shr     bx,2
        mov     ax,word ptr [C1+2]
        dw      $E08E   {<- mov FS,AX}
        mov     si,word ptr [C1]
        mov     cx,bx
@Loop1: db      $66
        db      $64
        rep     movsw
        mov     cx,bx
        les     di,C2
        mov     ax,word ptr [C0+2]
        dw      $E08E   {<- mov FS,AX}
        mov     si,word ptr [C0]
@Loop:  db      $66
        db      $64
        lodsw
        db      $66
        or      ax,0
        dw      $0
        jz      @Cont
        db      $66
        mov     es:[di],ax
@Cont:  add     di,4
        loop    @Loop
 end;

 procedure ShowGfxMouse; assembler;
      asm
        cmp     [ShowOn],1
        jnz     @ShowIt
        retf
@ShowIt:mov     ax,[MuX]
        mov     [GfxMouseX],ax
        mov     ax,[MuY]
        mov     [GfxMouseY],ax
        push    [GfxMouseX]
        push    [GfxMouseY]
        call    DrawGfxCursor
        mov     ax,1
        mov     [ShowOn],al
 end;

 procedure DrawGfxCursor(X,Y: Word); assembler;
      asm
        mov     ax,[mgActivePage]
        cmp     ax,[GfxMousePage]
        jz      @Go
        mov     [TmpPage],ax
        push    word ptr [GfxMousePage]
        call    far ptr SetActivePage
@Go:    push    [X]
        push    [Y]
        xor     ax,ax
        mov     al,[&DX]
        add     ax,[X]
        dec     ax
        push    ax
        xor     ax,ax
        mov     al,[DY]
        add     ax,[Y]
        dec     ax
        push    ax
        push    0
        db      $66
        push    word ptr [C1]
        call    GetSprite
        call    word ptr [ProcAddr]
        push    [X]
        push    [Y]
        xor     ax,ax
        mov     al,[&DX]
        add     ax,[X]
        dec     ax
        push    ax
        xor     ax,ax
        mov     al,[DY]
        add     ax,[Y]
        dec     ax
        push    ax
        push    0
        db      $66
        push    word ptr [C2]
        call    PutSprite
        mov     ax,[TmpPage]
        cmp     ax,[mgActivePage]
        jz      @Quit
        push    ax
        call    far ptr SetActivePage
@Quit:
 end;

 procedure RestoreCursorBG(X,Y: Word); assembler;
      asm
        mov     ax,[mgActivePage]
        cmp     ax,[GfxMousePage]
        jz      @Go
        mov     [TmpPage],ax
        push    word ptr [GfxMousePage]
        call    far ptr SetActivePage
@Go:    push    [X]
        push    [Y]
        xor     ax,ax
        mov     al,[&DX]
        add     ax,[X]
        dec     ax
        push    ax
        xor     ax,ax
        mov     al,[DY]
        add     ax,[Y]
        dec     ax
        push    ax
        push    0
        db      $66
        push    word ptr [C1]
        call    PutSprite
        xor     ax,ax
        mov     [Flag],al
        mov     ax,[TmpPage]
        cmp     ax,[mgActivePage]
        jz      @Quit
        push    ax
        call    far ptr SetActivePage
@Quit:
 end;

 procedure ReDrawCursor(XNew,YNew: Word); assembler;
      asm
        mov     ax,[GfxMouseX]
        mov     bx,[GfxMouseY]
        cmp     ax,[XNew]
        jnz     @DoIt
        cmp     bx,[YNew]
        jnz     @DoIt
        jmp     @Opps
@DoIt:  push    ax
        push    bx
        call    RestoreCursorBG
        mov     cx,[XNew]
        mov     dx,[YNew]
        mov     [GfxMouseX],cx
        mov     [GfxMouseY],dx
        push    cx
        push    dx
        call    DrawGfxCursor
        leave
        retf    4
@Opps:  call    word ptr [ProcAddr]
        mov     ax,[mgActivePage]
        cmp     ax,[GfxMousePage]
        jz      @Go
        mov     [TmpPage],ax
        push    word ptr [GfxMousePage]
        call    far ptr SetActivePage
@Go:    push    [GfxMouseX]
        push    [GfxMouseY]
        xor     ax,ax
        mov     al,[&DX]
        add     ax,[GfxMouseX]
        dec     ax
        push    ax
        xor     ax,ax
        mov     al,[DY]
        add     ax,[GfxMouseY]
        dec     ax
        push    ax
        push    0
        db      $66
        push    word ptr [C2]
        call    PutSprite
        mov     ax,[TmpPage]
        cmp     ax,[mgActivePage]
        jz      @Quit
        push    ax
        call    far ptr SetActivePage
@Quit:
 end;

 procedure MouseInt1; interrupt;
 begin
  if ShowOn then begin
   if (Animation) and (AnimationFlag=AnimationFreq) then begin
    AnimationFlag:=0;
    if FrameCount=NumFrames-1 then begin c0:=CurP; FrameCount:=0; end else begin
     inc(FrameCount); IncPointer(c0,Size);
     AnimDrawFlag:=true;
    end;
   end else inc(AnimationFlag);
   if DrawFlag=0 then begin
    GetMouseXY(mux,muy);
   end;
   if DrawFlag=GfxMouseFreq then begin
    ReDrawCursor(mux,muy);
    AnimDrawFlag:=false;
    DrawFlag:=0;
   end else Inc(DrawFlag);
  end;
  CallOld(OldInt);
 end;

 procedure MouseInt2;
{$IFDEF MSDOS}
 interrupt;
{$ENDIF}
 begin
  if ShowOn then begin
   if (Animation) and (AnimationFlag=AnimationFreq) then begin
    AnimationFlag:=0;
    if FrameCount=NumFrames-1 then begin c0:=CurP; FrameCount:=0; end else begin
     inc(FrameCount); IncPointer(c0,Size);
     AnimDrawFlag:=true;
    end;
   end else inc(AnimationFlag);
   if DrawFlag=0 then begin
    GetMouseXY(mux,muy);
   end;
   if DrawFlag=GfxMouseFreq then begin
    ReDrawCursor(mux,muy);
    AnimDrawFlag:=false;
    DrawFlag:=0;
   end else Inc(DrawFlag);
  end;
 end;

 function SetGfxCursor(Addr: Pointer): Boolean;
 var c: Byte;
 begin
  Addr:=Normalize(Addr);
{$IFDEF DPMI}
  MSEL:=NormalSel;
  Addr:=Ptr(MSEL,0);
{$ENDIF}
  NumFrames:=xGetByte(Addr,7);
  if (GetStr(Addr,6)<>'GFXCUR') or (NumFrames=0) then begin
   SetGfxCursor:=false; exit;
  end;
  c:=xGetByte(Addr,6);
  case c of
   0: ProcAddr:=Ofs(CurToFone256);
   1: ProcAddr:=Ofs(CurToFone32K);
   2: ProcAddr:=Ofs(CurToFone16M);
   3: ProcAddr:=Ofs(CurToFone4G);
  end;
  if SetUpCur then begin
   FreeBuffer(c1,Size);
   FreeBuffer(c2,Size);
  end;
  if NumFrames<2 then Animation:=false else Animation:=true;
  AnimationFlag:=0;
  FrameCount:=0;
  DX:=XGetByte(Addr,8);
  DY:=XGetByte(Addr,9);
  Block:=Word(DX)*Word(DY);
  Size:=Block*Word(C+1);
  IncPointer(Addr,10);
  CurP:=Addr;
  GetBuffer(c1,Size);
  GetBuffer(c2,Size);
  xFill(c1,Size,0);
  xFill(c2,Size,0);
  SetUpCur:=true;
  C0:=CurP;
 end;

 procedure HideGfxMouse;
 begin
  if not ShowOn then exit;
  ShowOn:=false;
  RestoreCursorBG(GfxMouseX,GfxMouseY);
 end;

 function EnableGfxMouse: Boolean;
 begin
  EnableGfxMouse:=false;
  if not SetUpCur then exit;
  if ShowOn then exit;
  AnimDrawFlag:=false;
  FrameCount:=0;
  AnimationFlag:=0;
  EnableGfxMouse:=true;
  if not Init then Init:=true;
  if ResetMouseOnStart then begin
   GfxMouseX:=0;
   GfxMouseY:=0;
   SetMouseXRange(0,mgXRes);
   SetMouseYRange(0,mgYRes);
   SetMouseXY(GfxMouseX,GfxMouseY);
  end;
  ShowGfxMouse;
  if UseTimer then begin
{$IFDEF MSDOS}
   GetRealIntVec($08,OldInt);
   SetRealIntVec($08,@MouseInt1);
{$ELSE}
   GetDPMIIntVec($08,OldInt);
   SetDPMIIntVec($08,@MouseInt1);
{$ENDIF}
  end else SetUserProc($FFFF,@MouseInt2);
 end;

 procedure DisableGfxMouse;
 begin
  if not ShowOn then exit;
  if UseTimer then begin
{$IFDEF MSDOS}
   SetRealIntVec($08,OldInt);
{$ELSE}
   SetDPMIIntVec($08,OldInt);
{$ENDIF}
  end else FreeUserProc;
  HideGfxMouse;
 end;

 procedure CursorAnimationOn; assembler;
      asm
        cmp     [NumFrames],1
        jle     @Exit
        mov     [Animation],1
@Exit:
 end;

 procedure CursorAnimationOff; assembler;
      asm
        mov     [Animation],0
 end;

 procedure GetCursorSize(var HSize,VSize: Byte); assembler;
      asm
        les     di,[HSize]
        mov     al,[&DX]
        mov     es:[di],ax
        les     di,[VSize]
        mov     al,[DY]
        mov     es:[di],ax
 end;

{$IFDEF DPMI}
 procedure ExitGfxMouse;
 begin
  FreeSelector(MSEL);
  ExitProc:=GfxMouseExit;
 end;
{$ENDIF}

 begin
  ResetMouseOnStart:=true;
  UseTimer:=true;
{$IFDEF DPMI}
  MSEL:=AllocSelector(0);
  MSEL:=SetSelectorBase(MSEL,0);
  SetSelectorLimit(MSEL,$FFFF);
  GfxMouseExit:=ExitProc;
  ExitProc:=@ExitGfxMouse;
{$ENDIF}
 end.
