{$g+,n-,d-,l-,b-,r-,o+,f+,s-,a+,e-,p-,q-,t+,v-,x+,i-}

(*  GRAPHIC FORMATS SUPPORT /I80386 AND HIGHER, REAL MODE, PROTECTED MODE  *)
(*                                                                         *)
(*                  BEST GAME SDK FOR TURBO/BORLAND PASCAL                 *)
(*                ͻ         ͻ ͻ               *)
(*                ͼ    ͻ ͻ  ͻ   ͼ                  *)
(*                   ͼͼ  ͼ͹ ͼ  ͼ                  *)
(*                        ͻ   ͼ                                *)
(*                 :     ͹˻ ͻ  .Ĵ               *)
(*               | |  .    ͼ              *                   *)
(*               -+-    . ʼ       ʼ     ʼ   .  +                 *)
(*                |   .        version 2.0       .      :                 *)
(*                 BY VADIM BODROV, RUSSIA  (c) 1996-98   |               *)

{$IFDEF WINDOWS}
 THIS UNIT CAN NOT BE COMPILED FOR MS WINDOWS!!!
 ONLY DOS REAL MODE AND PROTECTED MODE SUPPORTED
{$ENDIF}

 unit Images;

 interface

 function GetPCXWH (var DX, DY: Word; Addr: Pointer): Boolean;
 function GetPCXSize (Addr: Pointer): Longint;
 function PutPCX (X, Y: Integer; Addr: Pointer; Pal: Boolean): Boolean;

 function GetCELWH (var DX, DY: Word; Addr: Pointer): Boolean;
 function GetCELSize (Addr: Pointer): Longint;
 function PutCEL (X, Y: Integer; Addr: Pointer; Pal: Boolean): Boolean;

 function GetGIFWH (var DX, DY: Word; Addr: Pointer): Boolean;
 function PutGIF (X, Y: Integer; Addr: Pointer; Pal: Boolean): Boolean;

 function GetBMPWH (var DX, DY: Word; Addr: Pointer): Boolean;
 function GetBMPSize (Addr: Pointer): Longint;
 function PutBMP (X, Y: Integer; Addr: Pointer; Pal: Boolean): Boolean;

 function GetTGAWH (var DX, DY: Word; Addr: Pointer): Boolean;
 function GetTGASize (Buffer: Pointer): Longint;
 function PutTGA (X, Y: Integer; Addr: Pointer; Pal: Boolean): Boolean;

 function GetLBMWH (var DX, DY: Word; Addr: Pointer): Boolean;
 function GetLBMSize (Addr: Pointer): Longint;
 function PutLBM (X, Y: Integer; Addr: Pointer; Pal: Boolean): Boolean;

 implementation

 uses MemPlus,MegaGraf,GfxUtil,i80386,DOSUtil;

 const
  MAXSCREENWIDTH=4096;
  MAXCODES=4096;

 type
    TDataSubBlock =              record
     Size:                        Byte;
     Data:                        array[1..255] of Byte;
  end;

    THeader =                    record
     Signature:                   array[0..2] of Char;
     Version:                     array[0..2] of Char;
  end;

    TLogicalScreenDescriptor =   record
     ScreenWidth:                 Word;
     ScreenHeight:                Word;
     PackedFields:                Byte;
     BackGroundColorIndex:        Byte;
     AspectRatio:                 Byte;
   end;

    TImageDescriptor =           record
     Seperator:                   Byte;
     ImageLeftPos:                Word;
     ImageTopPos:                 Word;
     ImageWidth:                  Word;
     ImageHeight:                 Word;
     PackedFields:                Byte;
  end;

  var
     GIFError:                    Boolean;
     Header:                      THeader;
     LogicalScreen:               TLogicalScreenDescriptor;
     IPtr,Skip:                   Pointer;
     UseGIFPal:                   Boolean;
     TableSize:                   Word;
     ImageDescriptor:             TImageDescriptor;
     Interlaced:                  Boolean;
     InterlacePass:               Byte;
     LZWCodeSize:                 Byte;
     BitsLeft,BytesLeft:          Integer;
     CurrCodeSize:                Integer;
     ClearCode:                   Integer;
     EndingCode:                  Integer;
     Slot:                        Word;
     TopSlot:                     Word;
     HighCode:                    Word;
     NextByte:                    Integer;
     CurrByte:                    Byte;
     CurX,CurY:                   Integer;
     ImageData:                   TDataSubBlock;
     DecodeStack:                 array [0..MAXCODES] of Byte;
     Prefix:                      array [0..MAXCODES] of Word;
     Suffix:                      array [0..MAXCODES] of Byte;
     LineBuffer:                  array [0..MAXSCREENWIDTH] of Byte;
     IndiceSP:                    Integer;
     BMPpalNum:                   Word;
     LBMSize:                     Word;

 function ShlOne(N: Integer): Integer; near; assembler;
      asm
        mov     cx,[N]
        mov     ax,1
        shl     ax,cl
 end;

 function SkipPCXLine(Source: Pointer; DX: Word): Word; near; assembler;
      asm
        cld
        les     di,[Source]
        xor     cx,cx
        xor     bx,bx
        xor     dx,dx
@NextByte:
        cmp     bx,[&DX]
        jge     @Exit
        mov     al,es:[di]
        inc     dx
        inc     di
        jnz     @Cont
        push    ax
        mov     ax,es
        add     ax,[SelectorInc]
        mov     es,ax
        pop     ax
@Cont:  mov     ah,al
        and     ah,$C0
        cmp     ah,$C0
        jnz     @SingleByte
        mov     cl,al
        and     cl,$3F
        mov     al,es:[di]
        inc     dx
        inc     di
        jnz     @Loop
        push    ax
        mov     ax,es
        add     ax,SelectorInc
        mov     es,ax
        pop     ax
@Loop:  inc     bx
        loop    @Loop
        jmp     @NextByte
@SingleByte:
        inc     bx
        jmp     @NextByte
@Exit:  mov     ax,es
        mov     bx,di
        mov     Word ptr [Skip+2],ax
        mov     Word ptr [Skip],bx
        mov     ax,dx
 end;

 procedure ExtractLinePCX(Source,Dest: Pointer; _DX: Word); near; assembler;
      asm
        push    ds
        push    si
        mov     dx,ds
        cld
        les     di,[Dest]
        mov     bx,di
        add     bx,[_DX]
        lds     si,[Source]
        xor     cx,cx
@NextByte:
        cmp     bx,di
        jbe     @Exit
        mov     al,ds:[si]
        inc     si
        jnz     @Cont
        push    ax
        mov     ax,ds
        push    ds
        mov     ds,dx
        add     ax,SelectorInc
        pop     ds
        mov     ds,ax
        pop     ax
@Cont:  mov     ah,al
        and     ah,$C0
        cmp     ah,$C0
        jnz     @SingleByte
        mov     cl,al
        and     cl,$3F
        mov     al,ds:[si]
        inc     si
        jnz     @Loop
        push    ax
        mov     ax,ds
        push    ds
        mov     ds,dx
        add     ax,SelectorInc
        pop     ds
        mov     ds,ax
        pop     ax
@Loop:  mov     es:[di],al
        inc     di
        jnz     @Cont2
        push    ax
        mov     ax,es
        push    ds
        mov     ds,dx
        add     ax,SelectorInc
        pop     ds
        mov     es,ax
        pop     ax
@Cont2: loop    @Loop
        jmp     @NextByte
@SingleByte:
        mov     es:[di],al
        inc     di
        jnz     @Cont3
        push    ax
        mov     ax,es
        push    ds
        mov     ds,dx
        add     ax,SelectorInc
        pop     ds
        mov     es,ax
        pop     ax
@Cont3: jmp     @NextByte
@Exit:  mov     ax,ds
        mov     bx,si
        pop     si
        pop     ds
        mov     Word ptr [IPtr+2],ax
        mov     Word ptr [IPtr],bx
 end;

 procedure CodeDecodeTGIF(var Code: Word); near; assembler;
      asm
        les     di,[Code]
        mov     bx,Word ptr [es:di]
        mov     si,[IndiceSP]
        cmp     bx,[HighCode]
        jbe     @Quit
@Boucle:mov     al,[offset Word ptr Suffix+bx]
        mov     [Offset Word ptr DecodeStack+si],al
        inc     si
        shl     bx,1
        mov     bx,[Offset Word ptr Prefix+bx]
        cmp     bx,Word ptr HighCode
        ja      @Boucle
@Quit:  mov     [Offset Word ptr DecodeStack+si],bx
        inc     si
        mov     [IndiceSP],si
        mov     Word ptr [es:di],bx
 end;

 procedure ReadSubBlockTGIF; near;
 var i: Byte;
 begin
  ImageData.Size:=Byte(IPtr^);
  IncPtr(IPtr);
  if ImageData.Size=0 then begin GIFError:=false; exit; end;
  for i:=1 to ImageData.Size do begin
   ImageData.Data[i]:=Byte(IPtr^);
   IncPtr(IPtr);
  end;
  NextByte:=1;
  BytesLeft:=ImageData.Size;
 end;

 function NextCode: Word; near; assembler;
 const CodeMask: array[0..12] of LongInt=(0,1,3,7,$F,$1F,$3F,$7F,$FF,$1FF,$3FF,$7FF,$FFF);
      asm
        mov     ax,[BitsLeft]
        cmp     ax,0
        jg      @Pass1
        mov     ax,[BytesLeft]
        cmp     ax,0
        jg      @Pass2
        pusha
        push    di
        call    near ptr ReadSubBlockTGIF
        pop     di
        popa
@Pass2: mov     bx,[NextByte]
        mov     al,Byte ptr [offset ImageData+bx]
        mov     [CurrByte],al
        inc     bx
        mov     [NextByte],bx
        mov     [BitsLeft],8
        dec     [BytesLeft]
@Pass1: db      $66
        xor     ax,ax
        mov     al,[CurrByte]
        mov     cx,8
        mov     dx,[BitsLeft]
        sub     cx,dx
        db      $66
        shr     ax,cl
        mov     cx,dx
        db      $66
        mov     dx,ax
        mov     bx,[NextByte]
@While: cmp     [CurrCodeSize],cx
        jng     @Quit
        cmp     [BytesLeft],0
        jg      @Pass4
        pusha
        push    di
        call    near ptr ReadSubBlockTGIF
        pop     di
        popa
        mov     bx,[NextByte]
@Pass4: db      $66
        xor     ax,ax
        mov     al,Byte ptr [offset ImageData+bx]
        mov     [CurrByte],al
        inc     bx
        db      $66
        shl     ax,cl
        db      $66
        or      dx,ax
        add     cx,8
        dec     [BytesLeft]
        jmp     @While
@Quit:  mov     [NextByte],bx
        mov     bx,[CurrCodeSize]
        sub     cx,bx
        mov     [BitsLeft],cx
        shl     bx,2
        lea     di,[CodeMask]
        db      $66
        mov     ax,[di+bx]
        db      $66
        and     dx,ax
        mov     ax,dx
 end;

 function GetPCXWH(var Dx,Dy: Word; Addr: Pointer): Boolean;
 begin
  if (Byte(Addr^)<$0A) or (xGetByte(Addr,1)<>5) or
    (xGetByte(Addr,2)<>1) or (xGetByte(Addr,3)<>8) then begin
     GetPCXWH:=false;
     exit;
  end;
  Dx:=xGetWord(Addr,8)-xGetWord(Addr,4)+1;
  If Odd(DX) then Inc(DX);
  Dy:=xGetWord(Addr,10)-xGetWord(Addr,6)+1;
  GetPCXWH:=true;
 end;

 function GetPCXSize(Addr: Pointer): Longint;
 var i,Dx,Dy: Word;
     Len:     LongInt;
 begin
  Skip:=GetPtr(Addr,128);
  if not GetPCXWH(Dx,Dy,Addr) then begin
   GetPCXSize:=0;
   exit;
  end;
  Len:=896;
  for i:=1 to Dy do Len:=Len+SkipPCXLine(Skip,Dx);
  GetPCXSize:=Len;
 end;

 function PutPCX(X,Y: Integer; Addr: Pointer; Pal: Boolean): Boolean;
 var Dx,Dy:   Word;
     i:       Integer;
     PalVer:  Byte;
     LB:      Pointer;
 begin
  if not GetPCXWH(Dx,Dy,Addr) then begin
   PutPCX:=false;
   exit;
  end;
  IPtr:=GetPtr(Addr,128);
  if mgBitsPerPixel=8 then begin
   if Pal then begin
    Skip:=IPtr;
    for i:=1 to dy do SkipPCXLine(Skip,dx);
    PalVer:=Byte(Skip^);
    IncPtr(Skip);
    if PalVer=10 then SetVGAPalette(Skip,0,256);
    if PalVer=12 then begin
     for i:=0 to 255 do begin
      SetVGAPal(i,Byte(Skip^) shr 2,xGetByte(Skip,1) shr 2,xGetByte(Skip,2) shr 2);
      IncPointer(Skip,3);
     end;
    end;
   end;
   GetBuffer(LB,DX);
   for i:=0 to dy-1 do begin
    ExtractLinePCX(IPtr,LB,dx);
    PutLine(X,X+Dx-1,i+Y,LB);
   end;
   FreeBuffer(LB,DX);
  end else begin
   GfxPalAddr:=@LineBuffer;
   Skip:=IPtr;
   for i:=1 to dy do SkipPCXLine(Skip,dx);
   PalVer:=Byte(Skip^);
   IncPtr(Skip);
   if PalVer=10 then begin
    xMove(Skip,@LineBuffer,768);
    PAL6to8(@LineBuffer);
   end;
   if PalVer=12 then Move(Skip^,LineBuffer,768);
   GetBuffer(LB,DX);
   for i:=0 to dy-1 do begin
    ExtractLinePCX(IPtr,LB,dx);
    case mgBytesPerPixel of
     2: ConvertLine256to32K(LB,mgBufferPtr,Dx);
     3: ConvertLine256to16M(LB,mgBufferPtr,Dx);
     4: ConvertLine256to4G(LB,mgBufferPtr,Dx);
    end;
    PutLine(X,X+Dx-1,i+Y,mgBufferPtr);
   end;
   FreeBuffer(LB,DX);
  end;
  PutPCX:=true;
 end;

 function GetCELWH(var Dx,Dy: Word; Addr: Pointer): Boolean;
 begin
  if Word(Addr^)<>$9119 then begin
   GetCELWH:=false;
   exit;
  end;
  IncPointer(Addr,2);
  Dx:=GetWord(Addr); IncPointer(Addr,2);
  Dy:=GetWord(Addr); IncPointer(Addr,28);
  GetCELWH:=true;
 end;

 function GetCELSize(Addr: Pointer): Longint;
 var Dx,Dy: Word;
 begin
  if not GetCELWH(Dx,Dy,Addr) then begin
   GetCELSize:=0;
   exit;
  end;
  GetCELSize:=LongAdd(LongMul(Dx,Dy),1078);
 end;

 function PutCEL(X,Y: Integer; Addr: Pointer; Pal: Boolean): Boolean;
 var Dx,Dy:   Word;
 begin
  if not GetCELWH(Dx,Dy,Addr) then begin
   PutCEL:=false;
   exit;
  end;
  IncPointer(Addr,32);
  if mgBitsPerPixel=8 then begin
   if Pal then SetVGAPalette(Addr,0,256);
   IncPointer(Addr,768);
   PutSprite(X,Y,Dx+X-1,Dy+Y-1,false,Addr);
  end else begin
   GfxPalAddr:=@LineBuffer;
   xMove(Addr,@LineBuffer,768);
   PAL6to8(@LineBuffer);
   IncPointer(Addr,768);
   case mgBytesPerPixel of
    2: PutSprite256to32K(X,Y,Dx+X-1,Dy+Y-1,false,Addr);
    3: PutSprite256to16M(X,Y,Dx+X-1,Dy+Y-1,false,Addr);
    4: PutSprite256to4G(X,Y,Dx+X-1,Dy+Y-1,false,Addr);
   end;
  end;
  PutCEL:=true;
 end;

 procedure SetGIFPal; near;
 var i,j,Pt: Word;
 begin
  Pt:=TableSize*3;
  if mgBitsPerPixel=8 then begin
   if UseGIFPal then begin
    i:=0; j:=0;
    repeat
     SetVGAPal(j,xGetByte(IPtr,i) shr 2,xGetByte(IPtr,i+1) shr 2,xGetByte(IPtr,i+2) shr 2);
     inc(i,3); inc(j);
    until j=TableSize;
   end;
  end else GfxPalAddr:=IPtr;
  IncPointer(IPtr,Word(TableSize)*3);
 end;

 procedure InitTGIF; near;
 begin
  xMove(IPtr,@Header,SizeOf(THeader));
  IncPointer(IPtr,SizeOf(THeader));
  if Header.Signature<>'GIF' then begin GIFError:=false; exit; end;
  xMove(IPtr,@LogicalScreen,SizeOf(TLogicalScreenDescriptor));
  IncPointer(IPtr,SizeOf(TLogicalScreenDescriptor));
  if (LogicalScreen.PackedFields and $80)=$80 then begin
   TableSize:=trunc(ShlOne((LogicalScreen.PackedFields and $07)+1));
   SeTGIFPal;
  end else begin GIFError:=false; exit; end;
  xMove(IPtr,@ImageDescriptor,sizeof(ImageDescriptor));
  IncPointer(IPtr,sizeof(ImageDescriptor));
  if ImageDescriptor.Seperator<>$2C then begin GIFError:=false; exit; end;
  if (ImageDescriptor.PackedFields and $80)=$80 then begin
   TableSize:=trunc(ShlOne((ImageDescriptor.PackedFields and $07)+1));
   SeTGIFPal;
  end else if (ImageDescriptor.PackedFields and $40)=$40 then begin
   Interlaced:=true;
   InterlacePass:=0;
  end;
  GIFError:=true;
 end;

 procedure InitCompression; near;
 var i: Integer;
     n: Byte;
 begin
  LZWCodeSize:=Byte(IPtr^);
  IncPtr(IPtr);
  if not (LZWCodeSize in [2..9]) then begin GIFError:=false; exit; end;
  CurrCodeSize:=Succ(LZWCodeSize);
  ClearCode:=1 shl LZWCodeSize;
  EndingCode:=Succ(ClearCode);
  HighCode:=Pred(ClearCode);
  BytesLeft:=0;
  BitsLeft:=0;
 end;

 procedure PutLineTGIF; near;
 var I: Integer;
 begin
  if mgBitsPerPixel>8 then begin
   case mgBytesPerPixel of
    2: ConvertLine256to32K(@LineBuffer[0],mgBufferPtr,ImageDescriptor.ImageWidth);
    3: ConvertLine256to16M(@LineBuffer[0],mgBufferPtr,ImageDescriptor.ImageWidth);
    4: ConvertLine256to4G(@LineBuffer[0],mgBufferPtr,ImageDescriptor.ImageWidth);
   end;
   PutLine(CurX,CurX+ImageDescriptor.ImageWidth-1,CurY,mgBufferPtr);
  end else PutLine(CurX,CurX+ImageDescriptor.ImageWidth-1,CurY,@LineBuffer[0]);
  inc(CurY);
  if InterLaced then begin
   case InterlacePass of
    0: CurY:=CurY+7;
    1: CurY:=CurY+7;
    2: CurY:=CurY+3;
    3: CurY:=CurY+1;
   end;
   if CurY>=ImageDescriptor.ImageHeight then begin
    inc(InterLacePass);
    case InterLacePass of
     1: CurY:=4;
     2: CurY:=2;
     3: CurY:=1;
    end;
   end;
  end;
 end;

 procedure DecodeTGIF; near;
 var
  TempOldCode,OldCode: Word;
  BufCnt:              Word;
  Code,CI:             Word;
  CurrBuf:             Word;
 begin
  InitCompression;
  OldCode:=0;
  IndiceSP:=0;
  BufCnt:=ImageDescriptor.ImageWidth;
  CurrBuf:=0;
  CI:=NextCode;
  while CI<>EndingCode do begin
   if CI=ClearCode then begin
    CurrCodeSize:=LZWCodeSize+1;
    Slot:=EndingCode+1;
    TopSlot:=1 shl CurrCodeSize;
    while CI=ClearCode do CI:=NextCode;
    if CI=EndingCode then begin
     GIFError:=false; exit;
    end;
    if CI>=Slot then CI:=0;
    OldCode:=CI;
    DecodeStack[IndiceSP]:=CI;
    inc(IndiceSP);
   end else begin
    Code:=CI;
    if Code<Slot then begin
     CodeDecodeTGIF(Code);
     if Slot<=TopSlot then begin
      Suffix[Slot]:=Code;
      PreFix[Slot]:=OldCode;
      inc(Slot);
      OldCode:=CI;
     end;
     if Slot>=TopSlot then begin
      if CurrCodeSize<12 then begin
       TopSlot:=TopSlot shl 1;
       inc(CurrCodeSize)
      end
     end;
    end else begin
    if Code<>Slot then begin GIFError:=false; exit; end;
    TempOldCode:=OldCode;
    while OldCode>HighCode do begin
     DecodeStack[IndiceSP]:=Suffix[OldCode];
     OldCode:=Prefix[OldCode];
    end;
    DecodeStack[IndiceSP]:=OldCode;
    if Slot<=TopSlot then begin
     Suffix[Slot]:=OldCode;
     Prefix[Slot]:=TempOldCode;
     inc(Slot);
    end;
    if Slot>=TopSlot then begin
     if CurrCodeSize<12 then begin
      TopSlot:=TopSlot shl 1;
      inc(CurrCodeSize)
     end else begin GIFError:=false; exit; end;
    end;
    CodeDecodeTGIF(Code);
    OldCode:=CI;
   end;
  end;
      asm
        mov     cx,[BufCnt]
        mov     si,[CurrBuf]
        mov     bx,[IndiceSP]
        or      bx,0
        je      @Quit
@Boucle:dec     bx
        mov     al,[offset Byte ptr DecodeStack+bx]
        mov     [offset Byte ptr LineBuffer+si],al
        inc     si
        dec     cx
        jnz     @Pass
        pusha
        push    di
        call    PutLineTGIF
        pop     di
        popa
        xor     si,si
        mov     cx,[offset ImageDescriptor.ImageWidth]
@Pass:  or      bx,0
        ja      @Boucle
@Quit:  mov     [BufCnt],cx
        mov     [IndiceSP],bx
        mov     [CurrBuf],si
        call    near ptr NextCode
        mov     [CI],ax
   end;
  end;
 end;

 function GetGIFWH(var DX,DY: Word; Addr: Pointer): Boolean;
 begin
  UseGIFPal:=false; IPtr:=Addr;
  InitTGIF;
  DX:=ImageDescriptor.ImageWidth;
  DY:=ImageDescriptor.ImageHeight;
  GetGIFWH:=GIFError;
 end;

 function PutGIF(X,Y: Integer; Addr: Pointer; Pal: Boolean): Boolean;
 begin
  GIFError:=true; IPtr:=Addr; UseGIFPal:=Pal; CurY:=Y; CurX:=X;
  InitTGIF; if GIFError then DecodeTGIF;
  PutGIF:=GIFError;
 end;

 function GetBMPWH(var Dx,Dy: Word; Addr: Pointer): Boolean;
 begin
  if (GetWord(Addr)<>$4D42) or (xGetByte(Addr,$1E)<>0) then begin
   GetBMPWH:=false;
   exit;
  end;
  DX:=xGetWord(Addr,18);
  DY:=xGetWord(Addr,22);
  GetBMPWH:=true;
 end;

 function GetBMPSize(Addr: Pointer): Longint;
 var Dx,Dy: Word;
     BMpal: Byte;
 begin
  if not GetBMPWH(Dx,Dy,Addr) then begin
   GetBMPSize:=0;
   exit;
  end;
  BMpal:=XGetByte(Addr,$2E);
  if BMpal=0 then BMPpalNum:=256 else BMPpalNum:=BMpal;
  GetBMPSize:=LongMul(Dx,Dy)+54+BMPpalNum*4;
 end;

 procedure SetPalBMP(PalAddr: Pointer); near;
 var i,j: Word;
 begin
  i:=0;
  if mgBitsPerPixel=8 then begin
   repeat
    SetVGAPal(i,xGetByte(PalAddr,2) shr 2,xGetByte(PalAddr,1) shr 2,XGetByte(PalAddr,0) shr 2);
    inc(i);
    IncPointer(PalAddr,4);
   until (i=BMPpalNum);
  end else begin
   j:=0;
   repeat
    LineBuffer[j]:=xGetByte(PalAddr,2);
    LineBuffer[j+1]:=xGetByte(PalAddr,1);
    LineBuffer[j+2]:=Byte(PalAddr^);
    inc(i);
    inc(j,3);
    IncPointer(PalAddr,4);
   until (i=BMPpalNum);
   GfxPalAddr:=@LineBuffer;
  end;
 end;

 procedure BMP256(X1,Y1,X2,Y2: Integer; Addr: Pointer);
 var SizeX:  Word;
     i:      Integer;
     SizeAl: Word;
 begin
  SizeX:=X2-X1+1;
  SizeAl:=((SizeX+3) shr 2) shl 2;
  for i:=Y2 downto Y1 do begin
   PutLine(X1,X2,i,Addr);
   IncPointer(Addr,SizeAl);
  end;
 end;

 procedure BMP256to32K(X1,Y1,X2,Y2: Integer; Addr: Pointer);
 var SizeX:  Word;
     i:      Integer;
     SizeAl: Word;
 begin
  SizeX:=X2-X1+1;
  SizeAl:=((SizeX+3) shr 2) shl 2;
  for i:=Y2 downto Y1 do begin
   ConvertLine256to32K(Addr,mgBufferPtr,SizeX);
   PutLine(X1,X2,i,mgBufferPtr);
   IncPointer(Addr,SizeAl);
  end;
 end;

 procedure BMP256to16M(X1,Y1,X2,Y2: Integer; Addr: Pointer);
 var SizeX:  Word;
     i:      Integer;
     SizeAl: Word;
 begin
  SizeX:=X2-X1+1;
  SizeAl:=((SizeX+3) shr 2) shl 2;
  for i:=Y2 downto Y1 do begin
   ConvertLine256to16M(Addr,mgBufferPtr,SizeX);
   PutLine(X1,X2,i,mgBufferPtr);
   IncPointer(Addr,SizeAl);
  end;
 end;

 function PutBMP(X,Y: Integer; Addr: Pointer; Pal: Boolean): Boolean;
 var Dx,Dy,i: Word;
     XW:      Word;
     BMpal:   Byte;
     BMres:   Byte;
 begin
  if not GetBMPWH(Dx,Dy,Addr) then begin
   PutBMP:=false;
   exit;
  end;
  BMpal:=xGetByte(Addr,$2E);
  BMres:=xGetByte(Addr,$1C);
  if BMpal=0 then BMPpalNum:=256 else BMPpalNum:=BMpal;
  IncPointer(Addr,54);
  if BMres=8 then begin
   if (Pal) or (mgBitsPerPixel<>8) then SetPalBMP(Addr);
   IncPointer(Addr,BMPpalNum*4);
   case mgBytesPerPixel of
    1: BMP256(X,Y,X+Dx-1,Y+Dy-1,Addr);
    2: BMP256to32K(X,Y,X+Dx-1,Y+Dy-1,Addr);
    3: BMP256to16M(X,Y,X+Dx-1,Y+Dy-1,Addr);
    4: PutSprite(X,Y,X+Dx-1,Y+Dy-1,true,Addr);
   end;
   PutBMP:=true;
   exit;
  end;
  if BMres=24 then begin
   PutBMP:=true;
   case mgBytesPerPixel of
    2: PutSprite16Mto32K(X,Y,X+Dx-1,Y+Dy-1,true,Addr);
    3: PutSprite(X,Y,X+Dx-1,Y+Dy-1,true,Addr);
    4: PutSprite16Mto4G(X,Y,X+Dx-1,Y+Dy-1,true,Addr);
   else PutBMP:=false;
   end;
  end;
  PutBMP:=false;
 end;

 function GetTGAWH(var Dx,Dy: Word; Addr: Pointer): Boolean;
 begin
  if (xGetByte(Addr,1)>1) or (xGetByte(Addr,2)>2)  or
     not (xGetByte(Addr,16) in [8,16,24,32]) then begin GetTGAWH:=false; exit; end;
  Dx:=xGetWord(Addr,12);
  Dy:=xGetWord(Addr,14);
  GetTGAWH:=true;
 end;

 function GetTGASize(Buffer: Pointer): Longint;
 var Dx,Dy: Word;
 begin
  if not GetTGAWH(Dx,Dy,Buffer) then begin GetTGASize:=0; exit; end;
  GetTGASize:=LongMul(Dx,Dy)+786+Byte(Buffer^);
 end;

 procedure TGAPalConv(BPP: Byte; StartC,EndC: Word; Addr: Pointer); near;
 var C: Word;
 begin
  case BPP of
   16: repeat
        C:=GetWord(Addr);
        asm
        les     di,[mgBufferPtr]
        mov     ax,[StartC]
        shl     ax,1
        add     di,ax
        mov     ax,[C]
        xchg    al,ah
        mov     cl,5
        and     al,00011111b
        stosb
        shr     ax,cl
        and     al,00011111b
        stosb
        shr     ax,cl
        and     al,00011111b
        stosb
        end;
        IncPointer(Addr,2);
        inc(StartC);
       until StartC=EndC;
    24:repeat
        xPutByte(mgBufferPtr,StartC*3,xGetByte(Addr,2) shr 2);
        xPutByte(mgBufferPtr,StartC*3+1,xGetByte(Addr,1) shr 2);
        xPutByte(mgBufferPtr,StartC*3+2,Byte(Addr^) shr 2);
        IncPointer(Addr,3);
        inc(StartC);
       until StartC=EndC;
    32:repeat
        xPutByte(mgBufferPtr,StartC*3,xGetByte(Addr,2) shr 2);
        xPutByte(mgBufferPtr,StartC*3+1,xGetByte(Addr,1) shr 2);
        xPutByte(mgBufferPtr,StartC*3+2,Byte(Addr^) shr 2);
        IncPointer(Addr,4);
        inc(StartC);
       until StartC=EndC;
   end;
 end;

 function PutTGA(X,Y: Integer; Addr: Pointer; Pal: Boolean): Boolean;
 var Dx,Dy:   Word;
     Sp:      Byte;
     S,E:     Word;
     TGAPalB: Byte;
     BPP:     Byte;
     Dsc:     Byte;
 begin
  BPP:=xGetByte(Addr,16);
  if (not GetTGAWH(Dx,Dy,Addr)) or ((BPP shr 3)<>mgBytesPerPixel) then begin
   PutTGA:=false;
   exit;
  end;
  Sp:=Byte(Addr^);
  S:=xGetWord(Addr,3);
  E:=S+xGetWord(Addr,5);
  TGAPalB:=xGetByte(Addr,7);
  Dsc:=xGetByte(Addr,17);
  IncPointer(Addr,18+Sp);
  if (Pal) and (BPP=8) then begin
   TGAPalConv(TGAPalB,S,E,Addr);
   SetVGAPalette(mgBufferPtr,S,E-S);
  end;
  IncPointer(Addr,(TGAPalB shr 3)*(E-S));
  if (Dsc and $20)=0 then
   PutSprite(X,Y,X+Dx-1,Y+Dy-1,true,Addr) else
   PutSprite(X,Y,Dx+X-1,Dy+Y-1,false,Addr);
  PutTGA:=true;
 end;

 procedure SwapHL(var Wo: Word); near; assembler;
      asm
        les     di,Wo
        mov     ax,es:[di]
        xchg    al,ah
        mov     es:[di],ax
 end;

 function GetChunkSize: LongInt; near;
 var Hw,Lw: Word;
 begin
  Hw:=GetWord(IPtr);
  Lw:=xGetWord(IPtr,2);
  SwapHL(Hw); SwapHL(Lw);
  GetChunkSize:=LongAdd(LongShl(Hw,16),LongInt(Lw));
  IncPointer(IPtr,4);
 end;

 function GetLBMWH(var Dx,Dy: Word; Addr: Pointer): Boolean;
 begin
  IPtr:=Addr;
  if GetStr(IPtr,4)<>'FORM' then begin GetLBMWH:=false; exit; end;
  IncPointer(IPtr,4);
  LBMSize:=GetChunkSize+8;
  if GetStr(IPtr,4)<>'PBM ' then begin GetLBMWH:=false; exit; end;
  IncPointer(IPtr,4);
  Dx:=(xGetWord(Addr,20)); SwapHL(Dx);
  Dy:=(xGetWord(Addr,22)); SwapHL(Dy);
  IncPointer(IPtr,28);
  GetLBMWH:=true;
 end;

 function GetLBMSize(Addr: Pointer): Longint;
 var Dx,Dy: Word;
 begin
  if not GetLBMWH(Dx,Dy,Addr) then begin GetLBMSize:=0; exit; end;
  GetLBMSize:=LBMSize;
 end;

 procedure ExtractRLE(DX: Word; Src: Pointer); near; assembler;
      asm
        push    si
        push    ds
        mov     bx,SelectorInc
        les     di,[Src]
        lds     si,[IPtr]
        xor     dx,dx
        cld
@IFF_loop:
        xor     ah,ah
        mov     al,ds:[si]
        inc     si
        jnz     @Pass1
        push    ax
        mov     ax,ds
        add     ax,bx
        mov     ds,ax
        pop     ax
@Pass1: or      al,al
        js      @IFF_lower
        inc     ax
        add     dx,ax
        mov     cx,ax
@Loop:  mov     al,ds:[si]
        mov     es:[di],al
        inc     di
        jnz     @Pass3
        mov     ax,es
        add     ax,bx
        mov     es,ax
@Pass3: inc     si
        jnz     @Pass4
        mov     ax,ds
        add     ax,bx
        mov     ds,ax
@Pass4: loop    @Loop
        cmp     dx,[&DX]
        jl      @IFF_loop
        jmp     @IFF_done
@IFF_lower:
        neg     al
        inc     ax
        add     dx,ax
        mov     cx,ax
        mov     al,ds:[si]
        inc     si
        jnz     @Pass2
        push    ax
        mov     ax,ds
        add     ax,bx
        mov     ds,ax
        pop     ax
@Pass2: mov     es:[di],al
        inc     di
        jnz     @Pass5
        mov     ax,es
        add     ax,bx
        mov     es,ax
@Pass5: loop    @Pass2
        cmp     dx,[&DX]
        jl      @IFF_loop
@IFF_done:
        mov     ax,ds
        mov     bx,si
        pop     ds
        pop     si
        mov     word ptr [IPtr+2],ax
        mov     word ptr [IPtr],bx
 end;

 function PutLBM(X,Y: Integer; Addr: Pointer; Pal: Boolean): Boolean;
 var Pos,ChLen: LongInt;
     ChName:    String;
     i:         Integer;
     DX,DY:     Word;
     Src:       Pointer;
 begin
  if not GetLBMWH(DX,DY,Addr) then begin PutLBM:=false; exit; end;
  Pos:=40;
  Src:=@Prefix[0];
  repeat
   ChName:=GetStr(IPtr,4); IncPointer(IPtr,4);
   ChLen:=GetChunkSize;
   if Odd(ChLen) then inc(ChLen);
   if (ChName='CMAP') then begin
    if ((mgBytesPerPixel=1) and (Pal)) then begin
     GfxPalAddr:=@LineBuffer;
     xMove(IPtr,@LineBuffer,768);
     PAL8to6(@LineBuffer);
     SetVGAPalette(@LineBuffer,0,ChLen div 3);
    end else GfxPalAddr:=IPtr;
    IncPointer(IPtr,ChLen);
   end else
   if ChName='BODY' then begin
    if mgBytesPerPixel=1 then begin
     for i:=y to y+DY-1 do begin
      ExtractRLE(DX,Src);
      PutLine(X,X+Dx-1,i,Src);
     end;
    end else begin
     for i:=y to y+DY-1 do begin
      ExtractRLE(DX,Src);
      case mgBytesPerPixel of
       2: ConvertLine256to32K(Src,mgBufferPtr,Dx);
       3: ConvertLine256to16M(Src,mgBufferPtr,Dx);
       4: ConvertLine256to4G(Src,mgBufferPtr,Dx);
      end;
      PutLine(X,X+Dx-1,i,mgBufferPtr);
     end;
    end;
   end else IncPointer(IPtr,ChLen);
   Inc(Pos,ChLen+8);
  until Pos>=LBMSize;
  PutLBM:=true;
 end;

 end.

