{$g+,n-,d-,l-,b-,r-,o+,f+,s-,a+,e-,p-,q-,t+,v-,x+,i-}

(* ADVANCED KEYBOARD SUPPORT /I80386 AND HIGHER, REAL MODE, PROTECTED MODE *)
(*                                                                         *)
(*                  BEST GAME SDK FOR TURBO/BORLAND PASCAL                 *)
(*                ͻ         ͻ ͻ               *)
(*                ͼ    ͻ ͻ  ͻ   ͼ                  *)
(*                   ͼͼ  ͼ͹ ͼ  ͼ                  *)
(*                        ͻ   ͼ                                *)
(*                 :     ͹˻ ͻ  .Ĵ               *)
(*               | |  .    ͼ              *                   *)
(*               -+-    . ʼ       ʼ     ʼ   .  +                 *)
(*                |   .        version 2.0       .      :                 *)
(*                 BY VADIM BODROV, RUSSIA  (c) 1996-98   |               *)

{$IFDEF WINDOWS}
 THIS UNIT CAN NOT BE COMPILED FOR MS WINDOWS!!!
 ONLY DOS REAL MODE AND PROTECTED MODE SUPPORTED
{$ENDIF}

 unit Keyboard;

 interface

 const ESC_Scan:  Byte = $01;    Ent_Scan:  Byte = $1C;
       Pause_Scan:Byte = $C5;    Rsh_Scan:  Byte = $36;
       Back_Scan: Byte = $0E;    Prt_Scan:  Byte = $37;
       Ctrl_Scan: Byte = $1D;    Alt_Scan:  Byte = $38;
       Lsh_Scan:  Byte = $2A;    Home_Scan: Byte = $47;
       Caps_Scan: Byte = $3A;    Up_Scan:   Byte = $48;
       F1_Scan:   Byte = $3B;    PgUp_Scan: Byte = $49;
       F2_Scan:   Byte = $3C;    Min_Scan:  Byte = $4A;
       F3_Scan:   Byte = $3D;    Left_Scan: Byte = $4B;
       F4_Scan:   Byte = $3E;    Mid_Scan:  Byte = $4C;
       F5_Scan:   Byte = $3F;    Right_Scan:Byte = $4D;
       F6_Scan:   Byte = $40;    Plus_Scan: Byte = $4E;
       F7_Scan:   Byte = $41;    End_Scan:  Byte = $4F;
       F8_Scan:   Byte = $42;    Down_Scan: Byte = $50;
       F9_Scan:   Byte = $43;    PgDn_Scan: Byte = $51;
       F10_Scan:  Byte = $44;    Ins_Scan:  Byte = $52;
       F11_Scan:  Byte = $D9;    Del_Scan:  Byte = $53;
       F12_Scan:  Byte = $DA;    Num_Scan:  Byte = $45;
       Scrl_Scan: Byte = $46;    Space_Scan:Byte = $39;
       Tab_Scan:  Byte = $0F;

 var FlushKeys:    Boolean;
     DisablePause: Boolean;

 var TestPause:    Boolean;

 procedure FlushKeyboard;
 function  xKeyPressed: Boolean;
 function  xReadKey: Char;
 function  GetKey: Word;
 procedure ReadKeyScan (var Key: Char; var ScanCode: Byte);
 procedure StuffKey (Key: Word);
 procedure MultiKeysInit;
 procedure MultiKeysDone;
 function  TestKey (Ch: Byte): Boolean;
 function  ScanOfChar (Ch: Char): Byte;
 procedure SetCapsLock (Status: Boolean);
 procedure SetNumLock (Status: Boolean);
 procedure SetScrollLock (Status: Boolean);
 procedure SetInsert (Status: Boolean);
 function  TestCapsLock: Boolean;
 function  TestNumLock: Boolean;
 function  TestScrollLock: Boolean;
 function  TestInsert: Boolean;
 function  TestRShift: Boolean;
 function  TestLShift: Boolean;
 function  TestCtrl: Boolean;
 function  TestAlt: Boolean;

 implementation

{$IFDEF DPMI}
 uses WinApi,i80386,DOSUtil;
{$ELSE}
 uses i80386,DOSUtil;
{$ENDIF}

 var OldInt09:               Procedure;
 var Keys: Array [0..$80] of Boolean;

 procedure FlushKeyboard; assembler;
      asm
        mov     es,SEG0040
        mov     ax,es:[$001C]
        mov     es:[$1A],ax
 end;

 function  xKeyPressed: Boolean; assembler;
      asm
        mov     ah,$01
        int     $16
        mov     ax,$00
        jz      @Exit
        inc     ax
@Exit:
 end;

 function xReadKey: Char; assembler;
      asm
        xor     ax,ax
        int     $16
 end;

 function GetKey: Word; assembler;
      asm
        mov     ah,$10
        int     $16
        cmp     al,$E0
        jne     @Exit
        xor     al,al
@Exit:
 end;

 procedure ReadKeyScan(var Key: Char; var ScanCode: Byte); assembler;
      asm
        les     di,Key
        mov     ah,$10
        int     $16
        mov     es:[di],al
        les     di,ScanCode
        in      al,$60
        mov     es:[di],al
 end;

 procedure StuffKey (Key: Word); assembler;
      asm
        pushf
        cli
        mov     ax,SEG0040
        mov     es,ax
        mov     di,$001C
        mov     ax,[Key]
        xchg    ah,al
        mov     bx,[es:di]
        mov     [es:bx],ax
        add     byte ptr [es:di],2
        cmp     byte ptr [es:di],60
        jle     @Exit
        mov     byte ptr [es:di],30
@Exit:  popf
 end;

 procedure MultiKeys; Interrupt;
 var ScanCh: Byte;
 begin
  CLI;
  ScanCh:=Port[$60];
  if ScanCh>=$80 then Keys [ScanCh And $7F]:=false else Keys [ScanCh]:=true;
  if (ScanCh=197) and (DisablePause) then begin
   TestPause:=true;
   Port[$60]:=0;
  end else TestPause:=false;
  Inline($9C); OldInt09;
  if FlushKeys then FlushKeyboard;
 end;

 procedure MultiKeysInit;
 var i: Word;
 begin
  FillChar (Keys,127,0);
{$IFDEF MSDOS}
  GetRealIntVec($09,@OldInt09);
  SetRealIntVec($09,@MultiKeys);
{$ELSE}
  GetDPMIIntVec($09,@OldInt09);
  SetDPMIIntVec($09,@MultiKeys);
{$ENDIF}
 end;

 procedure MultiKeysDone;
 begin
{$IFDEF MSDOS}
  SetRealIntVec($09,Addr(OldInt09));
{$ELSE}
  SetDPMIIntVec($09,Addr(OldInt09));
{$ENDIF}
 end;

 function TestKey (Ch: Byte): Boolean;
 begin
  TestKey:=Keys[Ch];
 end;

 function ScanOfChar (Ch: Char): Byte;
 begin
  case UpCase(Ch) of
    '!', '1':  ScanOfChar:= $02;
    '@', '2':  ScanOfChar:= $03;
    '#', '3':  ScanOfChar:= $04;
    '$', '4':  ScanOfChar:= $05;
    '%', '5':  ScanOfChar:= $06;
    '^', '6':  ScanOfChar:= $07;
    '&', '7':  ScanOfChar:= $08;
    '*', '8':  ScanOfChar:= $09;
    '(', '9':  ScanOfChar:= $0a;
    ')', '0':  ScanOfChar:= $0b;
    '_', '-':  ScanOfChar:= $0c;
    '+', '=':  ScanOfChar:= $0d;
    'A':       ScanOfChar:= $1e;
    'S':       ScanOfChar:= $1f;
    'D':       ScanOfChar:= $20;
    'F':       ScanOfChar:= $21;
    'G':       ScanOfChar:= $22;
    'H':       ScanOfChar:= $23;
    'J':       ScanOfChar:= $24;
    'K':       ScanOfChar:= $25;
    'L':       ScanOfChar:= $26;
    ':', ';':  ScanOfChar:= $27;
    '"', '''': ScanOfChar:= $28;
    '~', '`':  ScanOfChar:= $29;
    ' ':       ScanOfChar:= $39;
    'Q':       ScanOfChar:= $10;
    'W':       ScanOfChar:= $11;
    'E':       ScanOfChar:= $12;
    'R':       ScanOfChar:= $13;
    'T':       ScanOfChar:= $14;
    'Y':       ScanOfChar:= $15;
    'U':       ScanOfChar:= $16;
    'I':       ScanOfChar:= $17;
    'O':       ScanOfChar:= $18;
    'P':       ScanOfChar:= $19;
    '{', '[':  ScanOfChar:= $1a;
    '}', ']':  ScanOfChar:= $1b;
    '|', '\':  ScanOfChar:= $2b;
    'Z':       ScanOfChar:= $2c;
    'X':       ScanOfChar:= $2d;
    'C':       ScanOfChar:= $2e;
    'V':       ScanOfChar:= $2f;
    'B':       ScanOfChar:= $30;
    'N':       ScanOfChar:= $31;
    'M':       ScanOfChar:= $32;
    '<', ',':  ScanOfChar:= $33;
    '>', '.':  ScanOfChar:= $34;
    '?', '/':  ScanOfChar:= $35
    end;
 end;

 procedure SetCapsLock (Status: Boolean); assembler;
      asm
        mov     es,SEG0040
        mov     al,es:[$0017]
        cmp     Status,0
        je      @Key_Off
        or      al,$40
        jmp     @MemWrite
@Key_Off:
        and     al,$bf
@MemWrite:
        mov     es:[di],al
 end;

 procedure SetNumLock (Status: Boolean); assembler;
      asm
        mov     es,SEG0040
        mov     al,es:[$0017]
        cmp     Status,0
        je      @Key_Off
        or      al,$20
        jmp     @MemWrite
@Key_Off:
        and     al,$DF
@MemWrite:
        mov     es:[di],al
 end;

 procedure SetScrollLock (Status: Boolean); assembler;
      asm
        mov     es,SEG0040
        mov     al,es:[$0017]
        cmp     Status,0
        je      @Key_Off
        or      al,$10
        jmp     @MemWrite
@Key_Off:
        and     al,$Ef
@MemWrite:
        mov     es:[di],al
 end;

 procedure SetInsert (Status: Boolean); assembler;
      asm
        mov     es,SEG0040
        mov     al,es:[$0017]
        cmp     Status,0
        je      @Key_Off
        or      al,$80
        jmp     @MemWrite
@Key_Off:
        and     al,$7F
@MemWrite:
        mov     es:[di],al
 end;

 function TestCapsLock: Boolean; assembler;
      asm
        mov     es,SEG0040
        xor     ax,ax
        mov     ah,es:[$0017]
        and     ah,$40
        jz      @Cont
        inc     al
@Cont:
 end;

 function TestNumLock: Boolean; assembler;
      asm
        mov     es,SEG0040
        xor     ax,ax
        mov     ah,es:[$0017]
        and     ah,$20
        jz      @Cont
        inc     al
@Cont:
 end;

 function TestScrollLock: Boolean; assembler;
      asm
        mov     es,SEG0040
        xor     ax,ax
        mov     ah,es:[$0017]
        and     ah,$10
        jz      @Cont
        inc     al
@Cont:
 end;

 function TestInsert: Boolean; assembler;
      asm
        mov     es,SEG0040
        xor     ax,ax
        mov     ah,es:[$0017]
        and     ah,$80
        jz      @Cont
        inc     al
@Cont:
 end;

 function TestRShift: Boolean; assembler;
      asm
        mov     es,SEG0040
        xor     ax,ax
        mov     ah,es:[$0017]
        and     ah,$01
        jz      @Cont
        inc     al
@Cont:
 end;

 function TestLShift: Boolean; assembler;
      asm
        mov     es,SEG0040
        xor     ax,ax
        mov     ah,es:[$0017]
        and     ah,$02
        jz      @Cont
        inc     al
@Cont:
 end;

 function TestCtrl: Boolean; assembler;
      asm
        mov     es,SEG0040
        xor     ax,ax
        mov     ah,es:[$0017]
        and     ah,$04
        jz      @Cont
        inc     al
@Cont:
 end;

 function TestAlt: Boolean; assembler;
      asm
        mov     es,SEG0040
        xor     ax,ax
        mov     ah,es:[$0017]
        and     ah,$08
        jz      @Cont
        inc     al
@Cont:
 end;



 end.
