{$g+,n-,d-,l-,b-,r-,o+,f+,s-,a+,e-,p-,q-,t+,v-,x+,i-}

(* ULTRA FAST GRAPH LIBRARY /I80386 AND HIGHER, REAL MODE & PROTECTED MODE *)
(*                                                                         *)
(*                  BEST GAME SDK FOR TURBO/BORLAND PASCAL                 *)
(*                ͻ         ͻ ͻ               *)
(*                ͼ    ͻ ͻ  ͻ   ͼ                  *)
(*                   ͼͼ  ͼ͹ ͼ  ͼ                  *)
(*                        ͻ   ͼ                                *)
(*                 :     ͹˻ ͻ  .Ĵ               *)
(*               | |  .    ͼ              *                   *)
(*               -+-    . ʼ       ʼ     ʼ   .  +                 *)
(*                |   .        version 2.0       .      :                 *)
(*                 BY VADIM BODROV, RUSSIA  (c) 1996-98   |               *)

(*----------------------- unit revision 2.20 (final) ----------------------*)

(* Used materials:
(* - SVGAKit v5.2 Copyright (C) 1992-95 SciTech Software                   *)
(* - 'Zen Of Graphic Programming', Copyright (C) 1995 by Michael Abrash    *)
(* - XLib by Themie Gouthas                                                *)
(* - VGAKit v 4.1 Copiright (C) 1991 by John Bridges                       *)

{$IFDEF WINDOWS}
 THIS UNIT CAN NOT BE COMPILED FOR MS WINDOWS!!!
 ONLY DOS REAL MODE AND PROTECTED MODE SUPPORTED
{$ENDIF}

 unit MegaGraf;

 interface

 (* VESA VBE info structure *)

 type
 TVBEInfoBlock = record
  VBESignature       : LongInt;
  VBEVersion         : Word;
  OemStringPtr       : Pointer;
  Capabilities       : LongInt;
  VideoModePtr       : Pointer;
  TotalMemory        : Word;
  OEMSoftwareRev     : Word;
  OEMVendorNamePtr   : Pointer;
  OEMProductNamePtr  : Pointer;
  OEMProductRevPtr   : Pointer;
  Reserved           : array[1..222] of Byte;
 end;

 (* VESA VBE mode info structure *)

 TVBEModeInfoBlock = record
  ModeAttributes     : Word;
  WinAAttributes     : Byte;
  WinBAttributes     : Byte;
  WinGranularity     : Word;
  WinSize            : Word;
  WinASegment        : Word;
  WinBSegment        : Word;
  WinFuncPtr         : Pointer;
  BytesPerScanLine   : Word;
  XResolution        : Word;
  YResolution        : Word;
  XCharSize          : Byte;
  YCharSize          : Byte;
  NumberOfPlanes     : Byte;
  BitsPerPixel       : Byte;
  NumberOfBanks      : Byte;
  MemoryModel        : Byte;
  BankSize           : Byte;
  NumberOfImagePages : Byte;
  Reserved           : Byte;
  RedMaskSize        : Byte;
  RedFieldPosition   : Byte;
  GreenMaskSize      : Byte;
  GreenFieldPosition : Byte;
  BlueMaskSize       : Byte;
  BlueFieldPosition  : Byte;
  RsvdMaskSize       : Byte;
  RsvdFieldPosition  : Byte;
  DirectColorModeInfo: Byte;
  Reserved2          : array[1..216] of Byte;
 end;

 (* SVGA/VBE mode structure for mgVBEModesList *)

 TVBEMode= record
  VideoMode: Word;
  ColorMode: Byte;
  XRes:      Word;
  YRes:      Word;
 end;

 (* 2D vertex structure *)

 Vertex= record
  X,Y: Integer;
 end;

 const

 (* Supported Mode X numbers *)

  ModeX320x200= 0;  ModeX376x282= 4;  ModeX360x480= 8;
  ModeX320x240= 1;  ModeX320x400= 5;  ModeX360x360= 9;
  ModeX360x200= 2;  ModeX320x480= 6;  ModeX376x308= 10;
  ModeX360x240= 3;  ModeX360x400= 7;  ModeX376x564= 11;

  (* Some standard VESA VBE modes *)

  SVGA320x200x256=  $163;  SVGA800x600x32K=  $113;  SVGA640x400x16M=  $122;
  SVGA320x240x256=  $164;  SVGA1024x768x32K= $116;  SVGA640x480x16M=  $112;
  SVGA640x400x256=  $100;  SVGA320x200x64K=  $10E;  SVGA800x600x16M=  $115;
  SVGA640x480x256=  $101;  SVGA320x240x64K=  $136;  SVGA1024x768x16M= $118;
  SVGA800x600x256=  $103;  SVGA640x400x64K=  $120;  SVGA320x200x4G=   $146;
  SVGA1024x768x256= $105;  SVGA640x480x64K=  $111;  SVGA320x240x4G=   $147;
  SVGA320x200x32K=  $10D;  SVGA800x600x64K=  $114;  SVGA640x400x4G=   $155;
  SVGA320x240x32K=  $12E;  SVGA1024x768x64K= $117;  SVGA640x480x4G=   $128;
  SVGA640x400x32K=  $11E;  SVGA320x200x16M=  $10F;  SVGA800x600x4G=   $129;
  SVGA640x480x32K=  $110;  SVGA320x240x16M=  $13E;  SVGA1024x768x4G=  $12A;

 (* First 16 standard VGA colors *)

  VGABlack=$00;  VGADarkGray  =$08;  VGARed      =$04;  VGALightRed    =$0C;
  VGABlue =$01;  VGALightBlue =$09;  VGAMagenta  =$05;  VGALightMagenta=$0D;
  VGAGreen=$02;  VGALightGreen=$0A;  VGABrown    =$06;  VGAYellow      =$0E;
  VGACyan =$03;  VGALightCyan =$0B;  VGALightGray=$07;  VGAWhite       =$0F;

 (* VGA ports *)

  GRAC_ADDR= $3CE;  CRTC_ADDR= $3D4;  MISC_ADDR= $3C2; VGAE_ADDR= $3C3;
  SEQU_ADDR= $3C4;  ATTR_ADDR= $3C0;  STAT_ADDR= $3DA;

 (* MegaGraf's video modes id *)

  grText= 0;  grModeX=  2;  grSVGA256= 4;  grSVGA64K= 6;  grSVGA4G= 8;
  grMCGA= 1;  grSVGA16= 3;  grSVGA32K= 5;  grSVGA16M= 7;

 (* Global variables *)

 var
  mgActivePage:     Word;        (* current active page *)
  mgVisualPage:     Word;        (* current visual page *)
  mgMaskColor:      LongInt;     (* transparent color *)
  mgAspectRatio:    Real;        (* vertical aspect ratio for circles *)
  mgBufferPtr:      Pointer;     (* graphic buffer pointer *)
  mgWorkMem:        LongInt;     (* accessible video memory in bytes *)
  mgLineStyle:      Word;        (* bit-style for DrawLine procedure *)
  mgThickLine:      Boolean;     (* line thickness for DrawLine procedure *)
  mgBorderColor:    LongInt;     (* border color for FilledCircle, FilledElipse,
                                    FilledRectangle and FilledTriangle *)
  mgUseBorderColor: Boolean;     (*                                    *)
  mgBkGrColor:      LongInt;     (* back ground color for ClearPage *)
  mgShadowX:        Integer;     (* shadow X-offset in pixels *)
  mgShadowY:        Integer;     (* shadow Y-offset in pixels *)
  mgUseMaxPages:    Boolean;     (* force to use max pages in SVGA modes *)

  mgVBEModesList:   array [0..99] of TVBEMode; (* availible VBE modes list *)
  mgVBEModes:       Word;        (* availible VBE modes number *)
  mgVBEMem:         Word;        (* total video memory in Kb *)
  mgVBEVersion:     Word;        (* VESA VBE version number *)
  mgCapabilities:   LongInt;     (* VESA VBE capabilities *)
  mgOemString:      String[80];  (* video card OEM info *)

  mgColorMode:      Byte;        (* current color model [grText..grSVGA4G] *)
  mgMaxColor:       LongInt;     (* max color value in current video mode *)
  mgMaxPages:       Byte;        (* number of availible video pages *)
  mgBytesPerLine:   Word;        (* bytes per scan line *)
  mgBytesPerPixel:  Byte;        (* bytes per pixel in current video mode *)
  mgBitsPerPixel:   Byte;        (* bits per pixel in current video mode *)
  mgXRes:           Word;        (* physical X-resolution *)
  mgYRes:           Word;        (* physical Y-resolution *)
  mgMaxY:           Word;        (* max logical Y-resolution *)
  mgBankOffset:     Word;        (* SVGA bank offset of current page *)
  mgPixOffset:      Word;        (* SVGA ogigin offset of current page *)
  mgCurBank:        Word;        (* current SVGA bank *)
  mgWinGran:        Word;        (* SVGA windows granulation *)
  mgBankAddr:       Pointer;     (* far address of bank-switch procedure *)
  mgRedMask:        Byte;        (* red field mask for direct color *)
  mgRedAjast:       Byte;        (* red field ajast for direct color *)
  mgRedPos:         Byte;        (* red field pos for direct color *)
  mgGreenMask:      Byte;        (* green field mask for direct color *)
  mgGreenAjast:     Byte;        (* green field ajast for direct color *)
  mgGreenPos:       Byte;        (* green field pos for direct color *)
  mgBlueMask:       Byte;        (* blue field mask for direct color *)
  mgBlusAjast:      Byte;        (* blue field ajast for direct color *)
  mgBlusPos:        Byte;        (* blue field pos for direct color *)

 (* ----------------------- LOW LEVEL SECTION ---------------------------- *)

 (* MCGA/VGA only graphic stuff *)

 procedure ClearPageMCGA;
 procedure PutPixelMCGA (X, Y: Word; Color: LongInt);
 procedure DrawLineMCGA (X1, Y1, X2, Y2: Integer; Color: Longint);
 function  GetPixelMCGA (X, Y: Word): LongInt;
 procedure HLineMCGA (X1, X2, Y: Integer; Color: LongInt);

 (* Modes X only graphic stuff *)

 procedure ClearPageModeX;
 procedure PutPixelModeX (X, Y: Word; Color: LongInt);
 procedure DrawLineModeX (X1, Y1, X2, Y2: Integer; Color: LongInt);
 function  GetPixelModeX (X, Y: Word): LongInt;
 procedure HLineModeX (X1, X2, Y: Integer; Color: LongInt);

 (* SVGA 256 only graphic stuff *)

 procedure ClearPageSVGA256;
 procedure PutPixelSVGA256 (X, Y: Word; Color: LongInt);
 procedure DrawLineSVGA256 (X1, Y1, X2, Y2: Integer; Color: LongInt);
 function  GetPixelSVGA256 (X, Y: Word): LongInt;
 procedure HLineSVGA256 (X1, X2, Y: Integer; Color: LongInt);

 (* SVGA 32K/64K only graphic stuff *)

 procedure ClearPageSVGA32K;
 procedure PutPixelSVGA32k (X, Y: Word; Color: LongInt);
 procedure DrawLineSVGA32K (X1, Y1, X2, Y2: Integer; Color: LongInt);
 function  GetPixelSVGA32K (X, Y: Word): LongInt;
 procedure HLineSVGA32K (X1, X2, Y: Integer; Color: LongInt);

 (* SVGA 16M only graphic stuff *)

 procedure ClearPageSVGA16M;
 procedure PutPixelSVGA16M (X, Y: Word; Color: LongInt);
 procedure DrawLineSVGA16M (X1, Y1, X2, Y2: Integer; Color: LongInt);
 function  GetPixelSVGA16M (X, Y: Word): LongInt;
 procedure HLineSVGA16M (X1, X2, Y: Integer; Color: LongInt);

 (* SVGA 16M+A only graphic stuff *)

 procedure ClearPageSVGA4G;
 procedure PutPixelSVGA4G (X, Y: Word; Color: LongInt);
 procedure DrawLineSVGA4G (X1, Y1, X2, Y2: Integer; Color: LongInt);
 function  GetPixelSVGA4G (X, Y: Word): LongInt;
 procedure HLineSVGA4G (X1, X2, Y: Integer; Color: LongInt);

 (* SVGA set bank function *)

 procedure VBESetBank (BankNo: Word);

 (* Graphic buffer operations *)

 function  GrBufferAlloc (Length: Word): Boolean;
 function  GrBufferReAlloc (NewLength: Word): Boolean;
 function  GrBufferFree: Boolean;
 function  GrBufferLength: Word;

 (* -------------------------- HIGH LEVEL SECTION ------------------------ *)

 (* Basic graphic stuff *)

 procedure SetTransp (Mode: Boolean);
 function  GetTransp: Boolean;
 function  GetVBEInfo (var VBEInfo: TVBEInfoBlock): Boolean;
 function  GetVBEModeInfo (Mode: Word; var ModeInfo: TVBEModeInfoBlock): Boolean;
 function  InitVBE: Boolean;
 procedure SetTextMode;
 procedure SetMCGAMode;
 function  SetModeX (Mode: Byte): Boolean;
 function  SetVBEMode (Mode: Word): Boolean;
 function  SetSVGAMode (XRes, YRes: Word; ColorMode: Byte): Boolean;
 function  SetVirtual: Boolean;
 function  SetNormal: Boolean;
 procedure StoreVirtual;
 procedure RestoreVirtual;
 procedure SwapVirtual;
 function  GetScreenAddr: Pointer;
 procedure SetActivePage (PageNo: Byte);
 procedure SetVisualPage (PageNo: Byte; WaitForRetrace: Boolean);
 function  SetScreenStart (X, Y: Word; WaitForRetrace: Boolean): Boolean;
 procedure SetWindow (X, Y, X1, Y1: Word);
 procedure GetWindow (var X, Y, X1, Y1: Word);
 function  SetScanLine (Pixels: Word): Word;
 function  SetLogicalSize (SX, SY: Word): Boolean;
 procedure GetLogicalSize (var SX, SY: Word);
 function  GetMaxX: Word;
 function  GetMaxY: Word;

 (* Main graphic stuff *)

 function  RGBColor (R, G, B: Byte): LongInt;
 procedure ClearVideoMem;
 procedure ClearPage;
 procedure PutPoint (X, Y: Integer; Color: LongInt);
 function  GetPoint (X, Y: Integer): LongInt;
 procedure DrawHLine (X1, X2, Y: Integer; Color: LongInt);
 function  ClipLine (var x1,y1, x2, y2: Integer;
           left, top, right, bottom: Integer): Boolean;
 procedure DrawLine (X1, Y1, X2, Y2: Integer; Color: LongInt);
 procedure DrawEllipse (X, Y: Integer; A,B: Integer; Color: LongInt);
 procedure FilledEllipse (X, Y: Integer; A,B: Integer; Color: LongInt);
 procedure DrawCircle (X, Y: Integer; Radius: Word; Color: LongInt);
 procedure FilledCircle (X, Y: Integer; Radius: Word; Color: LongInt);
 procedure DrawRectangle (X1, Y1, X2, Y2: Integer; Color: LongInt);
 procedure DrawTriangle (X0, Y0, X1, Y1, X2, Y2: Integer; Color: LongInt);
 procedure FilledRectangle (X1, Y1, X2, Y2: Integer; Color: LongInt);
 procedure FilledTriangle (X0, Y0, X1, Y1, X2, Y2: Integer; Color: LongInt);
 procedure FilledPolygon (var Vert; NumVert: Word; Color: LongInt);
 procedure FloodFill (X, Y: Integer; Color: LongInt);

 (* Sprites and graphic text stuff *)

 procedure PutLine (X1, X2, Y: Integer; Addr: Pointer);
 procedure GetLine (X1, X2, Y: Integer; Addr: Pointer);
 function  SpriteSize (SizeX, SizeY: Word): LongInt;
 function  ImageSize (SizeX, SizeY: Word): LongInt;
 procedure PutSprite (X, Y, X1, Y1: Integer; DirectY: Boolean; Buffer: Pointer);
 procedure GetSprite (X, Y, X1, Y1: Integer; DirectY: Boolean; Buffer: Pointer);
 procedure PutImage (X, Y: Integer; Buffer: Pointer);
 function  GetImage (X, Y, X1, Y1: Integer; var Buffer: Pointer): LongInt;
 function  GetVIMWH (var Dx, Dy: Word; Addr: Pointer): Boolean;
 procedure PutVIM (X, Y: Integer; Buffer: Pointer; UsePal: Boolean);
 function  GetVISSize (VISaddr: Pointer): LongInt;
 function  PutVIS (X, Y: Integer; Addr: Pointer; No: Word; UsePal: Boolean): Boolean;
 function  VIMSize (SizeX, SizeY,ColNum: Word): LongInt;
 function  GetVIM (X, Y, X1, Y1: Integer; FirstCol: Byte; ColNum: Word; var Buffer: Pointer): LongInt;
 procedure SetChars (AddrPtr: Pointer; Width, Hight, Start, Space:Byte);
 procedure PutCharXY (X, Y: Integer; C: Char; Color: LongInt);
 procedure ShadowCharXY (X, Y: Integer; C: Char; CharColor, ShadowColor: LongInt);
 procedure PutStringXY (X, Y: Integer; S: String; Color: LongInt);
 procedure ShadowStringXY (X, Y: Integer; S: String; CharColor, ShadowColor: LongInt);

 (* Palette stuff *)

 procedure SetVGAPalette (PalPtr: Pointer; Start: Word; Num: Word);
 procedure SetNormalPalette (PalPtr: Pointer; Start: Word; Num: Word);
 procedure SetVGAPal (Color, R, G, B: Byte);
 procedure SetNormalPal (Color, R, G, B: Byte);
 procedure GetVGAPalette (BufPtr: Pointer; Start,Num: Word);
 procedure GetVGAPal (Color: Byte; var R, G, B: Byte);
 function  FadePalette (PalBuf: Pointer; Start, Number: Word; Stop: Byte): Boolean;
 function  LightPalette (PalBuf: Pointer; Start, Number: Word; Stop: Byte): Boolean;
 function  EvenPalette (PalBuf, Addr: Pointer; Start, Number: Word): Boolean;
 function  EvenPaletteToColor (PalBuf: Pointer; Start, Number: Word; R, G, B: Byte): Boolean;
 procedure RotatePalette (PalBuf: Pointer; Start, Number: Word);

 (* Additional stuff *)

 procedure Stretch (Param: Byte);
 procedure Retrace;
 procedure CliRetrace;
 procedure HRetrace;
 procedure CliHRetrace;
 procedure SetSplitLine (Line: Word);

 implementation

{$IFDEF MSDOS}
 uses i80386,MemPlus,Version;
{$ELSE}
 uses i80386,WinApi,DOSUtil,MemPlus,Version;
{$ENDIF}

 const
  VBEStatusOk: Word= $004F;

  MaxScan: array[0..11] of Word =
  (1296,1064,1280,1064,904,640,528,640,528,704,824,448);

  PelPanMask: array[0..3] of Byte =(0,2,4,6);

  RightClipPlaneMask: array[0..3] of Byte =($0F,$01,$03,$07);
  LeftClipPlaneMask:  array[0..3] of Byte =($0F,$0E,$0C,$08);

  TweakValues: array[0..180] of Word =
  ($0200, $0014, $E317, 320, 200,
   $0AE3, $0D06, $3E07, $4109, $EA10, $AC11, $DF12, $0014, $E715, $0616,
   $E317, 320, 240,
   $08E7, $6B00, $5901, $5A02, $8E03, $5E04, $8A05, $0014, $E317, 360, 200,
   $11E7, $6b00, $5901, $5A02, $8E03, $5E04, $8A05, $0D06, $3E07, $4109,
   $EA10, $AC11, $DF12, $2D13, $0014, $E715, $0616, $E317, 360, 240,
   $12E7, $6E00, $5D01, $5E02, $9103, $06204, $8F05, $6206, $F007, $6109,
   $310F, $3710, $8911, $3312, $2F13, $0014, $3C15, $5C16, $E317, 376, 282,
   $03E3, $4009 ,$0014, $E317, 320, 400,
   $0AE3, $0D06, $3E07, $4009, $EA10, $AC11, $DF12, $0014, $E715, $0616,
   $E317, 320, 480,
   $09E7, $6B00, $5901, $5A02, $8E03, $5E04, $8A05, $4009, $0014, $E317,
   360, 400,
   $11E7, $6B00, $5901, $5A02, $8E03, $5E04, $8A05, $0D06, $3E07, $4009,
   $EA10, $AC11, $DF12, $2D13, $0014, $E715, $0616, $E317, 360, 480,
   $0FE7, $6b00, $5901, $5A02, $8E03, $5E04, $8A05, $4009, $8810, $8511,
   $6712, $2D13, $0014, $6D15, $BA16, $E317, 360, 360,
   $12E7, $6E00, $5D01, $5E02, $9103, $6204, $8F05, $6206, $0F07, $4009,
   $310F, $3710, $8911, $3312, $2F13, $0014, $3C15, $5C16, $E317, 376, 308,
   $12E7, $6E00, $5D01, $5E02, $9103, $6204, $8F05, $6206, $F007, $6009,
   $310F, $3710, $8911, $3312, $2F13, $0014, $3C15, $5C16, $E317, 376, 564);

  ModeTable: array[0..11] of Pointer =
  (@TweakValues[000], @TweakValues[005], @TweakValues[018],
   @TweakValues[029], @TweakValues[049], @TweakValues[070],
   @TweakValues[076], @TweakValues[089], @TweakValues[101],
   @TweakValues[121], @TweakValues[139], @TweakValues[160]);

 var ModeTablePtr: Pointer;

 var
  CharInit:      Boolean;
  CharStart:     Byte;
  CharSize:      Word;
  CharWidth:     Byte;
  CharHight:     Byte;
  CharAddr:      Pointer;
  CharSpace:     Byte;
 var
  Transparent:   Boolean;
 var
  MaxLine:       Word;
 var
  BankTable:     array [0..255] of Word;
  UseVBE:        Boolean;
  PageSize:      LongInt;
  BankFuncPtr:   Pointer;
 var
  BufferLen:     Word;
 var
  VideoSEG:      Word;
  ScrX:          Word;
  ScrY:          Word;
  PutPixAddr:    Pointer;
  PutPixelAddr:  Pointer;
  GetPixAddr:    Pointer;
  GetPixelAddr:  Pointer;
  GetLineAddr:   Word;
  MaskLineAddr:  Word;
  PutLineAddr:   Word;
  WriteLineAddr: Word;
  HLineAddr:     Pointer;
  ClearAddr:     Pointer;
  SetStartAddrWR:Word;
  SetStartAddrNW:Word;
 var
  PixListLen:    Word;
 var
  WX,WY,WX1,WY1: Word;
  WXb,WXb1:      Word;
 var
  Bshl:          Word;
  Badd:          Word;
 var
  VirAddr:       Pointer;
 var
  Tmp1,Tmp2:     Word;
 var
  MaxPages:      Byte;
 var
  Doub,Comp:     LongInt;
  Ost:           Word;

{$IFDEF DPMI}
 var RMRegs:     TRealRegs;
 var RMAddr:     Pointer;
 var PLS:        Word;
{$ENDIF}

 var MGExit:     Pointer;

 procedure Dummy1; far; assembler;
      asm
 end;

 procedure Dummy2; near; assembler;
      asm
 end;

 procedure Dummy3; far; assembler;
      asm
        leave
        retf    8
 end;

 procedure Dummy4; far; assembler;
      asm
        leave
        retf    4
 end;

 procedure ResetAddr; near; assembler;
      asm
        mov     ax,seg Dummy1
        db      $66
        shl     ax,16
        mov     ax,offset Dummy1
        db      $66
        mov     word ptr [HLineAddr],ax
        db      $66
        mov     word ptr [ClearAddr],ax
        db      $66
        mov     word ptr [mgBankAddr],ax
        db      $66
        mov     word ptr [PutPixAddr],ax
        db      $66
        mov     word ptr [GetPixAddr],ax
        mov     ax,seg Dummy2
        mov     word ptr [SetStartAddrWR],ax
        mov     word ptr [SetStartAddrNW],ax
        mov     ax,seg Dummy3
        db      $66
        shl     ax,16
        mov     ax,offset Dummy3
        db      $66
        mov     word ptr [PutPixelAddr],ax
        mov     ax,seg Dummy4
        db      $66
        shl     ax,16
        mov     ax,offset Dummy4
        db      $66
        mov     word ptr [GetPixelAddr],ax
        mov     ax,offset Dummy2
        mov     [GetLineAddr],ax
        mov     [PutLineAddr],ax
        mov     [MaskLineAddr],ax
        mov     [WriteLineAddr],ax
        db      $C3,$70,$73,$70,$32,$00,$00
 end;

 {
 ----------------------------------------------------------------------------
  PrepareBankTable
 ----------------------------------------------------------------------------
 }
 procedure PrepareBankTable; near; assembler;
      asm
        mov     di,offset BankTable
        xor     bx,bx
@BankLoop:
        mov     ax,bx
        mov     cx,64
        mul     cx
        mov     cx,[mgWinGran]
        jcxz    @be
        div     cx
@be:    mov     [di],ax
        inc     di
        inc     di
        inc     bx
        cmp     bx,256
        jb      @BankLoop
 end;

{
 ----------------------------------------------------------------------------
  SetBankA  - Sets Bank A uses 13h BIOS interrupt
 ----------------------------------------------------------------------------
 }
 procedure SetBankA; assembler;
      asm
        db      $66
        pusha
        and     ax,$00FF
        mov     [mgCurBank],ax
        mov     bx,offset BankTable
        add     ax,ax
        add     bx,ax
        mov     dx,ds:[bx]
        mov     ax,$4F05
        xor     bx,bx
        int     $10
        db      $66
        popa
 end;

 {
 ----------------------------------------------------------------------------
  SetBankA  - Fast sets Bank A uses BankFuncProc
 ----------------------------------------------------------------------------
 }
 procedure FSetBankA; assembler;
      asm
        db      $66
        pusha
        and     ax,$00FF
        mov     [mgCurBank],ax
        mov     bx,offset BankTable
        add     ax,ax
        add     bx,ax
        mov     dx,ds:[bx]
        xor     bx,bx
        call    dword ptr [BankFuncPtr]
        db      $66
        popa
 end;

 {
 ----------------------------------------------------------------------------
  SetBankAB  - Sets Banks A and B uses 13h BIOS interrupt
 ----------------------------------------------------------------------------
 }
 procedure SetBankAB; assembler;
      asm
        db      $66
        pusha
        and     ax,$00FF
        mov     [mgCurBank],ax
        mov     bx,offset BankTable
        add     ax,ax
        add     bx,ax
        mov     dx,ds:[bx]
        mov     ax,$4F05
        xor     bx,bx
        push    dx
        int     $10
        pop     dx
        mov     bx,1
        int     $10
        db      $66
        popa
 end;

 {
 ----------------------------------------------------------------------------
  FSetBankAB - Fast sets Banks A and B uses BankFuncProc
 ----------------------------------------------------------------------------
 }
 procedure FSetBankAB; assembler;
      asm
        db      $66
        pusha
        and     ax,$00FF
        mov     [mgCurBank],ax
        mov     bx,offset BankTable
        add     ax,ax
        add     bx,ax
        mov     dx,ds:[bx]
        xor     bx,bx
        push    dx
        call    dword ptr [BankFuncPtr]
        pop     dx
        mov     bx,1
        call    dword ptr [BankFuncPtr]
        db      $66
        popa
 end;

 procedure ClearPageMCGA; assembler;
      asm
        cld
        mov     al,byte ptr [mgBkGrColor]
        mov     ah,al
        push    ax
        db      $66
        shl     ax,16
        pop     ax
        mov     es,[VideoSEG]
        xor     di,di
        mov     cx,16000
        db      $66
        rep     stosw
 end;

 procedure ClearPageModeX; assembler;
      asm
        db      $66
        mov     ax,word ptr [PageSize]
        db      $66
        shr     ax,4
        mov     cx,ax
        mov     dx,SEQU_ADDR
        mov     es,[VideoSEG]
        mov     bl,byte ptr [mgBkGrColor]
        mov     bh,bl
        push    bx
        db      $66
        shl     bx,16
        pop     bx
        pushf
        cld
        mov     ax,$0F02
@Loop:  push    ax
        out     dx,ax
        push    cx
        mov     di,[mgPixOffset]
        db      $66
        mov     ax,bx
        db      $66
        rep     stosw
        pop     cx
        pop     ax
        shr     ah,1
        jnc     @Loop
        popf
 end;

 procedure ClearBanked; near; assembler;
 var Color: LongInt;
      asm
        db      $66
        mov     word ptr [Color],ax
        cld
        mov     ax,[mgBankOffset]
        cmp     ax,[mgCurBank]
        jz      @Next1
        call    dword ptr [mgBankAddr]
@Next1: mov     es,SSEG
        db      $66
        xor     bx,bx
        mov     di,[mgPixOffset]
        or      di,di
        jz      @Skip1
        mov     cx,di
        xor     cx,$FFFF
        mov     bx,cx
        push    cx
        and     cx,3
        inc     cx
        db      $66
        mov     ax,word ptr [Color]
        rep     stosb
        pop     cx
        shr     cx,2
        db      $66
        rep     stosw
        mov     ax,[mgCurBank]
        inc     ax
        call    dword ptr mgBankAddr
@Skip1: db      $66
        mov     cx,word ptr [PageSize]
        db      $66
        sub     cx,bx
        db      $66
        sub     cx,1
        push    cx
        db      $66
        shr     cx,16
        cmp     cx,0
        je      @Skip2
@Loop:  push    cx
        mov     cx,16384
        db      $66
        mov     ax,word ptr [Color]
        db      $66
        rep     stosw
        mov     ax,[mgCurBank]
        inc     ax
        call    dword ptr [mgBankAddr]
        pop     cx
        loop    @Loop
@Skip2: pop     cx
        db      $66
        mov     ax,word ptr [Color]
        shr     cx,2
        inc     cx
        db      $66
        rep     stosw
 end;

{
----------------------------------------------------------------------------
 Clear256
----------------------------------------------------------------------------
 Routine to clear the screen. Assumes pages begin on bank boundaries
 for simplicity of coding.
----------------------------------------------------------------------------
}
 procedure ClearPageSVGA256; assembler;
      asm
        mov     al,byte ptr [mgBkGrColor]
        mov     ah,al
        push    ax
        db      $66
        shl     ax,16
        pop     ax
        call    near ptr ClearBanked
 end;

{
----------------------------------------------------------------------------
 Clear32K
----------------------------------------------------------------------------
 Routine to clear the screen. Assumes pages begin on bank boundaries
 for simplicity of coding.
----------------------------------------------------------------------------
}
 procedure ClearPageSVGA32K; assembler;
      asm
        mov     ax,word ptr [mgBkGrColor]
        push    ax
        db      $66
        shl     ax,16
        pop     ax
        call    near ptr ClearBanked
 end;

{
----------------------------------------------------------------------------
 Clear16M
----------------------------------------------------------------------------
 Routine to clear the screen.
----------------------------------------------------------------------------
}
 procedure ClearPageSVGA16M; assembler;
 var ScanLineAdjast: Word;
      asm
        db      $66
        mov     ax,word ptr [mgBkGrColor]
        db      $66
        or      ax,ax
        jnz     @SlowClear
        call    near ptr ClearBanked
        jmp     @Quit
@SlowClear:
        mov     es,SSEG
        mov     bx,[mgPixOffset]
        mov     di,[ScrX]
        mov     si,[ScrY]
        mov     dx,di
        shl     dx,1
        add     dx,di
        sub     dx,[mgBytesPerline]
        neg     dx
        mov     [ScanLineAdjast],dx
        mov     dx,[mgBankOffset]
        cmp     dx,[mgCurBank]
        jz      @NoChange
        push    ax
        mov     ax,dx
        call    dword ptr mgBankAddr
        pop     ax
@NoChange:
        mov     dh,byte ptr [mgBkGrColor+2]
@NextScanLine:
        mov     cx,di
@LoopSolid:
        cmp     bx,$FFFD
        jae     @BankSwitch
        mov     es:[bx],ax
        mov     es:[bx+2],dh
        add     bx,3
        loop    @LoopSolid
@AfterPlot:
        add     bx,[ScanLineAdjast]
        jc      @BankSwitch2
        dec     si
        jnz     @NextScanLine
        jmp     @Quit
@BankSwitch:
        jne     @Next5
        mov     es:[bx],ax
        mov     es:[bx+2],dh
        xor     bx,bx
        inc     dl
        push    ax
        mov     ax,dx
        call    dword ptr mgBankAddr
        pop     ax
        loop    @LoopSolid
        jmp     @AfterPlot
@Next5:
        cmp     bx,$FFFE
        jne     @Next4
        mov     es:[bx],ax
        inc     dl
        push    ax
        mov     ax,dx
        call    dword ptr mgBankAddr
        pop     ax
        xor     bx,bx
        mov     es:[bx],dh
        inc     bx
        loop    @LoopSolid
        jmp     @AfterPlot
@Next4:
        mov     es:[bx],al
        inc     dl
        push    ax
        mov     ax,dx
        call    dword ptr mgBankAddr
        pop     ax
        xor     bx,bx
        mov     es:[bx],ah
        mov     es:[bx+1],dh
        mov     bx,2
        loop    @LoopSolid
        jmp     @AfterPlot
@BankSwitch2:
        inc     dl
        push    ax
        mov     ax,dx
        call    dword ptr mgBankAddr
        pop     ax
        dec     si
        jnz     @NextScanLine
@Quit:
 end;

{
----------------------------------------------------------------------------
 Clear4G
----------------------------------------------------------------------------
 Routine to clear the screen. Assumes pages begin on bank boundaries
 for simplicity of coding.
----------------------------------------------------------------------------
}
 procedure ClearPageSVGA4G; assembler;
      asm
        db      $66
        mov     ax,word ptr [mgBkGrColor]
        call    near ptr ClearBanked
 end;

 procedure PutPixelMCGA(X,Y: Word; Color: LongInt); assembler;
     asm
        mov     es,[VideoSEG]
        mov     ax,Y
        shl     ax,6
        mov     di,X
        add     di,ax
        shl     ax,2
        add     di,ax
        mov     al,byte ptr [Color]
        mov     es:[di],al
 end;

 {
 ----------------------------------------------------------------------------
  DrawLineMCGAFast(X1,Y1,X2,Y2: Integer; Color: LongInt);
 ----------------------------------------------------------------------------
 Original code:
 'Zen Of Graphic Programming', Copyright (C) 1995 by Michael Abrash
 ---------------------------------------------------------------------------
 }
 procedure DrawLineMCGA(X1,Y1,X2,Y2: Integer; Color: Longint); assembler;
 var AdjUp,AdjDown,WholeStep,XAdvance: Integer;
    asm
      mov       [AdjUp],-2
      mov       [AdjDown],-4
      mov       [WholeStep],-6
      mov       [XAdvance],-8
      cld
      mov       ax,[Y1]
      cmp       ax,[Y2]
      jle       @TopBottom
      xchg      [Y2],ax
      mov       [Y1],ax
      mov       bx,[X1]
      xchg      [X2],bx
      mov       [X1],bx
@TopBottom:
      mov       dx,320
      mul       dx
      mov       si,[X1]
      mov       di,si
      add       di,ax
      mov       cx,[Y2]
      sub       cx,[Y1]
      mov       dx,[X2]
      sub       dx,si
      jnz       @NotVertical
      mov       al,byte ptr [Color]
      mov       es,[VideoSeg]
@VLoop:
      mov       es:[di],al
      add       di,320
      dec       cx
      jns       @VLoop
      jmp       @Done
@Horizontal:
      mov       al,byte ptr [Color]
      mov       ah,al
      and       bx,bx
      jns       @DirSet
      sub       di,dx
@DirSet:
      mov       cx,dx
      inc       cx
      shr       cx,1
      mov       es,[VideoSEG]
      rep       stosw
      adc       cx,cx
      rep       stosb
      jmp       @Done
@Diagonal:
      mov       al,byte ptr [Color]
      add       bx,320
      mov       es,[VideoSEG]
@DLoop:
      mov       es:[di],al
      add       di,bx
      dec       cx
      jns       @DLoop
      jmp       @Done
@NotVertical:
      mov       bx,1
      jns       @LeftToRight
      neg       bx
      neg       dx
@LeftToRight:
      and       cx,cx
      jz        @Horizontal
      cmp       cx,dx
      jz        @Diagonal
      cmp       dx,cx
      jae       @XMajor
      jmp       @YMAjor
@XMajor:
      and       bx,bx
      jns       @DFSet
      std
@DFSet:
      mov       ax,dx
      sub       dx,dx
      div       cx
      mov       bx,dx
      add       bx,bx
      mov       [AdjUp],bx
      mov       si,cx
      add       si,si
      mov       [AdjDown],si
      sub       dx,si
      mov       si,cx
      mov       cx,ax
      shr       cx,1
      inc       cx
      push      cx
      add       dx,si
      test      al,1
      jnz       @XMajorDone
      sub       dx,si
      and       bx,bx
      jnz       @XMajorDone
      dec       cx
@XMajorDone:
      mov       [WholeStep],ax
      mov       al,byte ptr [Color]
      mov       es,[VideoSeg]
      rep       stosb
      add       di,320
      cmp       si,1
      jna       @XMajorDraw
      dec       dx
      shr       si,1
      jnc       @XMajorFullOdd
@XMajorFullLoop:
      mov       cx,[WholeStep]
      add       dx,bx
      jnc       @XMajorNoExtra
      inc       cx
      sub       dx,[AdjDown]
@XMajorNoExtra:
      rep       stosb
      add       di,320
@XMajorFullOdd:
      mov       cx,[WholeStep]
      add       dx,bx
      jnc       @XMajorNoExtra2
      inc       cx
      sub       dx,[AdjDown]
@XMajorNoExtra2:
      rep       stosb
      add       di,320
      dec       si
      jnz       @XMajorFullLoop
@XMajorDraw:
      pop       cx
      rep       stosb
      cld
      jmp       @Done
@YMajor:
      mov       [XAdvance],bx
      mov       ax,cx
      mov       cx,dx
      sub       dx,dx
      div       cx
      mov       bx,dx
      add       bx,bx
      mov       [AdjUp],bx
      mov       si,cx
      add       si,si
      mov       [AdjDown],si
      sub       dx,si
      mov       si,cx
      mov       cx,ax
      shr       cx,1
      inc       cx
      push      cx
      add       dx,si
      test      al,1
      jnz       @YMajorDone
      sub       dx,si
      and       bx,bx
      jnz       @YMajorDone
      dec       cx
@YMajorDone:
      mov       es,[VideoSEG]
      mov       [WholeStep],ax
      mov       al,byte ptr [Color]
      mov       bx,[XAdvance]
      inc       cx
@YMajorFirstLoop:
      mov       es:[di],al
      add       di,320
      dec       cx
      jnz       @YMajorFirstLoop
      add       di,bx
      cmp       si,1
      jna       @YMajorDraw
      dec       dx
      shr       si,1
      jnc       @YMajorFullOdd
@YMajorFullLoop:
      mov       cx,[WholeStep]
      add       dx,[AdjUp]
      jnc       @YMajorNoExtra
      inc       cx
      sub       dx,[AdjDown]
@YMajorNoExtra:
@YMajorRunLoop:
      mov       es:[di],al
      add       di,320
      dec       cx
      jnz       @YMajorRunLoop
      add       di,bx
@YMajorFullOdd:
      mov       cx,[WholeStep]
      add       dx,[AdjUp]
      jnc       @YMajorNoExtra2
      inc       cx
      sub       dx,[AdjDown]
@YMajorNoExtra2:
@YMajorRunLoop2:
      mov       es:[di],al
      add       di,320
      dec       cx
      jnz       @YMajorRunLoop2
      add       di,bx
      dec       si
      jnz       @YMajorFullLoop
@YMajorDraw:
      pop       cx
@YMajorLastLoop:
      mov       es:[di],al
      add       di,320
      dec       cx
      jnz       @YMajorLastLoop
@Done:
 end;

 function GetPixelMCGA(X,Y: Word): LongInt; assembler;
     asm
        mov     es,[VideoSEG]
        mov     ax,Y
        shl     ax,6
        mov     di,X
        add     di,ax
        shl     ax,2
        add     di,ax
        xor     dx,dx
        xor     ax,ax
        mov     al,es:[di]
 end;

 {
 ----------------------------------------------------------------------------
  PutPixelModeX(X,Y: Word; Color: LongInt)
 ----------------------------------------------------------------------------
  楤 ⠥ ᥫ  ० X
  室 :        X       -   न X ᥫ
                Y       -   न Y ᥫ
                Color   -   梥 ᥫ
  :     ax,dx,di,es,cx
  ਬ砭:   ஢ઠ  室 ᥫ  । ࠭  !
 ----------------------------------------------------------------------------
 }

 procedure PutPixelModeX(X,Y: Word; Color: LongInt); assembler;
      asm
        mov     ax,[mgBytesPerLine]
        mul     Y
        mov     di,X
        shr     di,2
        add     di,ax
        add     di,[mgPixOffset]
        mov     es,SSEG
        mov     cl,byte ptr [X]
        and     cl,3
        mov     ax,$102
        shl     ah,cl
        mov     dx,SEQU_ADDR
        out     dx,ax
        mov     al,byte ptr [Color]
        mov     es:[di],al
 end;

{----------------------------------------------------------------------------
 Original Code:
 XLib by Themie Gouthas
----------------------------------------------------------------------------}
 procedure DrawLineModeX(X1,Y1,X2,Y2: Integer; Color: LongInt); assembler;
 var Vertincr, Incr1, Incr2, Routine: Word;
      asm
        mov     es,[VideoSEG]
        mov     dx,SEQU_ADDR
        mov     si,[mgBytesPerLine]
        mov     cx,[X2]
        sub     cx,[X1]
        jz      @VertLine
        jns     @L01
        neg     cx
        mov     bx,[X2]
        xchg    bx,[X1]
        mov     [X2],bx
        mov     bx,[Y2]
        xchg    bx,[Y1]
        mov     [Y2],bx
@L01:   mov     bx,[Y2]
        sub     bx,[Y1]
        jnz     @Skip
        jmp     @HorizLine
@Skip:  jns     @L03
        neg     bx
        neg     si
@L03:   mov     [Vertincr],si
        mov     [Routine],offset @LoSlopeLine
        cmp     bx,cx
        jle     @L04
        mov     [Routine],offset @HiSlopeLine
        xchg    bx,cx
@L04:   shl     bx,1
        mov     [Incr1],bx
        sub     bx,cx
        mov     si,bx
        sub     bx,cx
        mov     [Incr2],bx
        push    cx
        mov     ax,[Y1]
        mov     bx,[X1]
        mov     cl,bl
        push    dx
        mov     dx,[mgBytesPerLine]
        mul     dx
        pop     dx
        shr     bx,2
        add     bx,ax
        add     bx,[mgPixOffset]
        and     cl,3
        mov     di,bx
        mov     al,1
        shl     al,cl
        mov     ah,al
        shl     al,4
        add     ah,al
        mov     bl,ah
        pop     cx
        inc     cx
        jmp     word ptr [Routine]
@VertLine:
        mov     ax,[Y1]
        mov     bx,[Y2]
        mov     cx,bx
        sub     cx,ax
        jge     @L31
        neg     cx
        mov     ax,bx
@L31:   inc     cx
        mov     bx,[X1]
        push    cx
        mov     cl,bl
        push    dx
        mov     dx,[mgBytesPerLine]
        mul     dx
        pop     dx
        shr     bx,2
        add     bx,ax
        add     bx,[mgPixOffset]
        and     cl,3
        mov     ah,1
        shl     ah,cl
        mov     al,2
        out     dx,ax
        pop     cx
        mov     ax,word ptr [Color]
@L32:   mov     es:[bx],al
        add     bx,si
        loop    @L32
        leave
        retf    12
@HorizLine:
        mov     ax,[Y1]
        mov     bx,[X1]
        mov     cl,bl
        push    dx
        mov     dx,[mgBytesPerLine]
        mul     dx
        pop     dx
        shr     bx,2
        add     bx,ax
        add     bx,[mgPixOffset]
        and     cl,3
        mov     di,bx
        mov     dl,$0F
        shl     dl,cl
        mov     cx,[X2]
        and     cl,3
        mov     dh,[$0E]
        shl     dh,cl
        not     dh
        mov     ax,[X2]
        mov     bx,[X1]
        shr     ax,2
        shr     bx,2
        mov     cx,ax
        sub     cx,bx
        mov     ax,dx
        mov     dx,SEQU_ADDR
        mov     bx,word ptr [Color]
        or      cx,cx
        jnz     @L42
        and     ah,al
        jmp     @L44
@L42:   push    ax
        mov     ah,al
        mov     al,2
        out     dx,ax
        mov     al,bl
        stosb
        dec     cx
        mov     ah,$0F
        mov     al,2
        out     dx,ax
        mov     al,bl
        rep     stosb
        pop     ax
@L44:   mov     al,2
        out     dx,ax
        mov     byte ptr es:[di],bl
        leave
        retf    12
@LoSlopeLine:
        mov     al,2
        mov     bh,byte ptr [Color]
@L10:   mov     ah,bl
@L11:   or      ah,bl
        rol     bl,1
        jc      @L14
        or      si,si
        jns     @L12
        add     si,[Incr1]
        loop    @L11
        out     dx,ax
        mov     es:[di],bh
        leave
        retf    12
@L12:   add     si,[Incr2]
        out     dx,ax
        mov     es:[di],bh
        add     di,[Vertincr]
        loop    @L10
        leave
        retf    12
@L14:   out     dx,ax
        mov     es:[di],bh
        inc     di
        or      si,si
        jns     @L15
        add     si,[Incr1]
        loop    @L10
        leave
        retf    12
@L15:   add     si,[Incr2]
        add     di,[Vertincr]
        loop    @L10
        leave
        retf    12
@HiSlopeLine:
        mov     bx,[Vertincr]
        mov     al,2
@L21:   out     dx,ax
        push    ax
        mov     ax,word ptr [Color]
        mov     es:[di],al
        pop     ax
        add     di,bx
@L22:   or      si,si
        jns     @L23
        add     si,[Incr1]
        loop    @L21
        leave
        retf    12
@L23:   add     si,[Incr2]
        rol     ah,1
        adc     di,0
@lx21:  loop    @L21
 end;

 {
 ----------------------------------------------------------------------------
  GetPixelModeX(X,Y: Word: LongInt;
 ----------------------------------------------------------------------------
 }

 function GetPixelModeX(X,Y: Word): LongInt; assembler;
      asm
        mov     cx,X
        mov     dx,Y
        mov     es,SSEG
        mov     ax,[mgBytesPerLine]
        mul     dx
        push    cx
        shr     cx,1
        shr     cx,1
        add     ax,cx
        add     ax,[mgPixOffset]
        mov     di,ax
        pop     ax
        and     al,3
        mov     ah,al
        mov     al,4
        mov     dx,GRAC_ADDR
        out     dx,ax
        xor     dx,dx
        xor     ax,ax
        mov     al,es:[di]
 end;

 {
 ----------------------------------------------------------------------------
  PutPixel256(X,Y: Word; Color: LongInt)
 ----------------------------------------------------------------------------
 }
 procedure PutPixelSVGA256(X,Y: Word; Color: LongInt); assembler;
      asm
        mov     ax,[Y]
        mul     [mgBytesPerLine]
        add     ax,[X]
        adc     dx,word ptr [mgBankOffset]
        mov     es,[VideoSEG]
        mov     di,ax
        add     di,[mgPixOffset]
        adc     dx,0
        cmp     dx,word ptr [mgCurBank]
        je      @NoChange
        mov     ax,dx
        call    dword ptr [mgBankAddr]
@NoChange:
        mov     al,byte ptr [Color]
        mov     es:[di],al
 end;

 {
 ----------------------------------------------------------------------------
  DrawLine256Fast(X1,Y1,X2,Y2: Integer; Color: LongInt);
 ----------------------------------------------------------------------------
  Original Code:
  SVGAKit v5.2 by Kendall Bennett, Copyright (C) 1992-95 SciTech Software
 ----------------------------------------------------------------------------
 }
 procedure DrawLineSVGA256(X1,Y1,X2,Y2: Integer; Color: LongInt); assembler;
 var Routine: Word;
     EIncr,NEIncr: Word;
     VertInc: LongInt;
      asm
        cld
        mov     si,[mgBytesPerLine]
        mov     word ptr [VertInc+2],0
        mov     ax,[X2]
        sub     ax,[X1]
        jns     @X2Greater
        neg     ax
        mov     bx,[X2]
        xchg    bx,[X1]
        mov     [X2],bx
        mov     bx,[Y2]
        xchg    bx,[Y1]
        mov     [Y2],bx
@X2Greater:
        mov     bx,[Y2]
        sub     bx,[Y1]
        jns     @Y2Greater
        neg     bx
        neg     si
        mov     word ptr [VertInc+2],$FFFF
@Y2Greater:
        mov     word ptr [VertInc],si
        mov     [Routine],offset @LoSlopeLine
        cmp     bx,ax
        jle     @LoSlope
        mov     [Routine],offset @HiSlopeLine
        xchg    bx,ax
@LoSlope:
        shl     bx,1
        mov     [EIncr],bx
        sub     bx,ax
        mov     di,bx
        sub     bx,ax
        mov     [NEIncr],bx
        push    ax
        mov     ax,[Y1]
        mul     [mgBytesPerLine]
        add     ax,[X1]
        adc     dx,word ptr [mgBankOffset]
        mov     es,[VideoSEG]
        mov     bx,ax
        add     bx,[mgPixOffset]
        adc     dx,0
        pop     cx
        inc     cx
        jmp     [Routine]
@LoSlopeLine:
        mov     al,byte ptr [Color]
        mov     dh,byte ptr [mgCurBank]
@LoopLo:
        cmp     dl,dh
        je      @SetLo
        mov     dh,al
        mov     al,dl
        call    dword ptr [mgBankAddr]
        mov     al,dh
        mov     dh,dl
@SetLo:
        mov     [es:bx],al
        add     bx,1
        adc     dl,0
        or      di,di
        jns     @LoPosDi
        add     di,[EIncr]
        loop    @LoopLo
        leave
        retf    12
@LoPosDi:
        add     di,[NEIncr]
        add     bx,word ptr [VertInc]
        adc     dl,byte ptr [VertInc+2]
        loop    @LoopLo
        leave
        retf    12
@HiSlopeLine:
        mov     al,byte ptr [Color]
        mov     dh,byte ptr [mgCurBank]
@LoopHi:
        cmp     dh,dl
        je      @SetHi
        mov     dh,al
        mov     al,dl
        call    dword ptr [mgBankAddr]
        mov     al,dh
        mov     dh,dl
@SetHi:
        mov     [es:bx],al
        add     bx,word ptr [VertInc]
        adc     dl,byte ptr [VertInc+2]
        or      di,di
        jns     @HiPosDi
        add     di,[EIncr]
        loop    @LoopHi
        leave
        retf    12
@HiPosDi:
        add     di,[NEIncr]
        add     bx,1
        adc     dl,0
        loop    @LoopHi
 end;

 {
 ----------------------------------------------------------------------------
  GetPixel256(X,Y: Word): LongInt
 ----------------------------------------------------------------------------
 }
 function GetPixelSVGA256(X,Y: Word): LongInt; assembler;
      asm
        mov     ax,[Y]
        mul     [mgBytesPerLine]
        add     ax,[X]
        adc     dx,word ptr [mgBankOffset]
        mov     es,[VideoSEG]
        mov     di,ax
        add     di,[mgPixOffset]
        adc     dx,0
        cmp     dx,word ptr [mgCurBank]
        je      @NoChange
        mov     ax,dx
        call    dword ptr [mgBankAddr]
@NoChange:
        xor     dx,dx
        xor     ax,ax
        mov     al,es:[di]
 end;

 {
 ----------------------------------------------------------------------------
  PutPixel32K(X,Y: Word; Color: LongInt)
 ----------------------------------------------------------------------------
 }
 procedure PutPixelSVGA32K(X,Y: Word; Color: LongInt); assembler;
      asm
        mov     ax,[Y]
        mul     [mgBytesPerLine]
        mov     di,[X]
        shl     di,1
        add     ax,di
        adc     dx,word ptr [mgBankOffset]
        mov     es,[VideoSEG]
        mov     di,ax
        add     di,[mgPixOffset]
        adc     dx,0
        cmp     dx,word ptr [mgCurBank]
        je      @NoChange
        mov     ax,dx
        call    dword ptr [mgBankAddr]
@NoChange:
        mov     ax,word ptr [Color]
        mov     es:[di],ax
 end;

{
 ----------------------------------------------------------------------------
  DrawLine32KFast(X1,Y1,X2,Y2: Integer; Color: LongInt);
 ----------------------------------------------------------------------------
  Original Code:
  SVGAKit v5.2 by Kendall Bennett, Copyright (C) 1992-95 SciTech Software
 ----------------------------------------------------------------------------
 }
 procedure DrawLineSVGA32K(X1,Y1,X2,Y2: Integer; Color: LongInt); assembler;
 var Routine: Word;
     EIncr,NEIncr: Word;
     VertInc: LongInt;
      asm
        cld
        mov     si,[mgBytesPerLine]
        mov     word ptr [VertInc+2],0
        mov     ax,[X2]
        sub     ax,[X1]
        jns     @X2Greater
        neg     ax
        mov     bx,[X2]
        xchg    bx,[X1]
        mov     [X2],bx
        mov     bx,[Y2]
        xchg    bx,[Y1]
        mov     [Y2],bx
@X2Greater:
        mov     bx,[Y2]
        sub     bx,[Y1]
        jns     @Y2Greater
        neg     bx
        neg     si
        mov     word ptr [VertInc+2],$FFFF
@Y2Greater:
        mov     word ptr [VertInc],si
        mov     [Routine],offset @LoSlopeLine
        cmp     bx,ax
        jle     @LoSlope
        mov     [Routine],offset @HiSlopeLine
        xchg    bx,ax
@LoSlope:
        shl     bx,1
        mov     [EIncr],bx
        sub     bx,ax
        mov     di,bx
        sub     bx,ax
        mov     [NEIncr],bx
        push    ax
        mov     ax,[Y1]
        mul     [mgBytesPerLine]
        mov     bx,[X1]
        shl     bx,1
        add     bx,ax
        adc     dx,word ptr [mgBankOffset]
        mov     es,[VideoSEG]
        add     bx,[mgPixOffset]
        adc     dx,0
        pop     cx
        inc     cx
        jmp     [Routine]
@LoSlopeLine:
        mov     ax,word ptr [Color]
        mov     dh,byte ptr [mgCurBank]
@LoopLo:
        cmp     dl,dh
        je      @SetLo
        push    ax
        mov     al,dl
        call    dword ptr [mgBankAddr]
        mov     dh,dl
        pop     ax
@SetLo:
        mov     [es:bx],ax
        add     bx,2
        adc     dl,0
        or      di,di
        jns     @LoPosDi
        add     di,[EIncr]
        loop    @LoopLo
        leave
        retf    12
@LoPosDi:
        add     di,[NEIncr]
        add     bx,word ptr [VertInc]
        adc     dl,byte ptr [VertInc+2]
        loop    @LoopLo
        leave
        retf    12
@HiSlopeLine:
        mov     ax,word ptr [Color]
        mov     dh,byte ptr [mgCurBank]
@LoopHi:
        cmp     dh,dl
        je      @SetHi
        push    ax
        mov     al,dl
        call    dword ptr [mgBankAddr]
        mov     dh,dl
        pop     ax
@SetHi:
        mov     [es:bx],ax
        add     bx,word ptr [VertInc]
        adc     dl,byte ptr [VertInc+2]
        or      di,di
        jns     @HiPosDi
        add     di,[EIncr]
        loop    @LoopHi
        leave
        retf    12
@HiPosDi:
        add     di,[NEIncr]
        add     bx,2
        adc     dl,0
        loop    @LoopHi
end;

 {
 ----------------------------------------------------------------------------
  GetPixel32K(X,Y: Word): LongInt
 ----------------------------------------------------------------------------
 }
 function GetPixelSVGA32K(X,Y: Word): LongInt; assembler;
      asm
        mov     ax,[Y]
        mul     [mgBytesPerLine]
        mov     di,[X]
        shl     di,1
        add     ax,di
        adc     dx,word ptr [mgBankOffset]
        mov     es,[VideoSEG]
        mov     di,ax
        add     di,[mgPixOffset]
        adc     dx,0
        cmp     dx,word ptr [mgCurBank]
        je      @NoChange
        mov     ax,dx
        call    dword ptr [mgBankAddr]
@NoChange:
        xor     dx,dx
        mov     ax,es:[di]
 end;

 {
 ----------------------------------------------------------------------------
  PutPixel16M(X,Y: Word; Color: LongInt)
 ----------------------------------------------------------------------------
 }
 procedure PutPixelSVGA16M(X,Y: Word; Color: LongInt); assembler;
      asm
        mov     ax,[Y]
        mul     [mgBytesPerLine]
        mov     di,[X]
        add     ax,di
        adc     dx,0
        shl     di,1
        add     ax,di
        adc     dx,[mgBankOffset]
        add     ax,[mgPixOffset]
        adc     dx,0
        mov     es,[VideoSEG]
        mov     di,ax
        cmp     dx,word ptr [mgCurBank]
        je      @NoChange
        mov     ax,dx
        call    dword ptr [mgBankAddr]
@NoChange:
        mov     ax,word ptr [Color]
        mov     dl,byte ptr [Color+2]
        cmp     di,0FFFEh
        jae     @Next2
        stosw
        mov     es:[di],dl
        leave
        ret     8
@Next2: jne     @Next1
        mov     es:[di],ax
        mov     ax,[mgCurBank]
        inc     ax
        call    dword ptr [mgBankAddr]
        mov     es:[0],dl
        leave
        ret     $0008
@Next1: mov     es:[di],al
        push    ax
        mov     ax,[mgCurBank]
        inc     ax
        call    dword ptr [mgBankAddr]
        pop     ax
        mov     es:[0],ah
        mov     es:[1],dl
 end;

 {
 ----------------------------------------------------------------------------
  DrawLine16MFast(X1,Y1,X2,Y2: Integer; Color: LongInt);
 ----------------------------------------------------------------------------
  Original Code:
  SVGAKit v5.2 by Kendall Bennett, Copyright (C) 1992-95 SciTech Software
 ----------------------------------------------------------------------------
 }
 procedure DrawLineSVGA16M(X1,Y1,X2,Y2: Integer; Color: LongInt); assembler;
 var Routine: Word;
     EIncr,NEIncr: Word;
     VertInc: LongInt;
      asm
        cld
        mov     si,[mgBytesPerLine]
        mov     word ptr [VertInc+2],0
        mov     ax,[X2]
        sub     ax,[X1]
        jns     @X2Greater
        neg     ax
        mov     bx,[X2]
        xchg    bx,[X1]
        mov     [X2],bx
        mov     bx,[Y2]
        xchg    bx,[Y1]
        mov     [Y2],bx
@X2Greater:
        mov     bx,[Y2]
        sub     bx,[Y1]
        jns     @Y2Greater
        neg     bx
        neg     si
        mov     word ptr [VertInc+2],$FFFF
@Y2Greater:
        mov     word ptr [VertInc],si
        mov     [Routine],offset @LoSlopeLine
        cmp     bx,ax
        jle     @LoSlope
        mov     [Routine],offset @HiSlopeLine
        xchg    bx,ax
@LoSlope:
        shl     bx,1
        mov     [EIncr],bx
        sub     bx,ax
        mov     di,bx
        sub     bx,ax
        mov     [NEIncr],bx
        push    ax
        mov     ax,[Y1]
        mov     bx,[X1]
        mul     [mgBytesPerLine]
        add     ax,bx
        adc     dx,0
        shl     bx,1
        add     bx,ax
        adc     dx,[mgBankOffset]
        add     bx,[mgPixOffset]
        adc     dx,0
        mov     es,[VideoSEG]
        pop     cx
        inc     cx
        jmp     [Routine]
@LoSlopeLine:
        mov     ax,word ptr [Color]
        mov     dh,byte ptr [Color+2]
@LoopLo:
        cmp     dl,byte ptr [mgCurBank]
        je      @SetPixelLo
        push    ax
        mov     al,dl
        call    dword ptr [mgBankAddr]
        pop     ax
@SetPixelLo:
        cmp     bx,$FFFE
        jae     @BankSwitchLo
@SetLo:
        mov     [es:bx],ax
        mov     [es:bx+2],dh
        add     bx,3
        adc     dl,0
@DonePixelLo:
        or      di,di
        jns     @LoPosDi
        add     di,[EIncr]
        loop    @LoopLo
        leave
        retf    12
@LoPosDi:
        add     di,[NEIncr]
        add     bx,word ptr [VertInc]
        adc     dl,byte ptr [VertInc+2]
        loop    @LoopLo
        leave
        retf    12
@BankSwitchLo:
        call    near ptr @SlowPixel
        inc     dl
        jmp     @DonePixelLo
@HiSlopeLine:
        mov     ax,word ptr [Color]
        mov     dh,byte ptr [Color+2]
@LoopHi:
        cmp     dl,byte ptr [mgCurBank]
        je      @SetPixelHi
        push    ax
        mov     al,dl
        call    dword ptr [mgBankAddr]
        pop     ax
@SetPixelHi:
        cmp     bx,$FFFE
        jae     @BankSwitchHi
@SetHi:
        mov     [es:bx],ax
        mov     [es:bx+2],dh
@DonePixelHi:
        add     bx,word ptr [VertInc]
        adc     dl,byte ptr [VertInc+2]
        or      di,di
        jns     @HiPosDi
        add     di,[EIncr]
        loop    @LoopHi
        leave
        retf    12
@HiPosDi:
        add     di,[NEIncr]
        add     bx,3
        adc     dl,0
        loop    @LoopHi
        leave
        retf    12
@BankSwitchHi:
        call    near ptr @SlowPixel
        sub     bx,3
        jmp     @DonePixelHi
@SlowPixel:
        jne     @Next1
        mov     es:[bx],ax
        push    ax
        mov     ax,[mgCurBank]
        inc     ax
        call    dword ptr [mgBankAddr]
        pop     ax
        mov     es:[0],dh
        mov     bx,1
        retn
@Next1: mov     es:[bx],al
        push    ax
        mov     ax,[mgCurBank]
        inc     ax
        call    dword ptr [mgBankAddr]
        pop     ax
        mov     es:[0],ah
        mov     es:[1],dh
        mov     bx,2
        retn
end;

 {
 ----------------------------------------------------------------------------
  GetPixel16M(X,Y: Word): LongInt
 ----------------------------------------------------------------------------
 }
 function GetPixelSVGA16M(X,Y: Word): LongInt; assembler;
      asm
        mov     ax,[Y]
        mul     [mgBytesPerLine]
        mov     di,[X]
        add     ax,di
        adc     dx,0
        shl     di,1
        add     ax,di
        adc     dx,[mgBankOffset]
        add     ax,[mgPixOffset]
        adc     dx,0
        mov     es,[VideoSEG]
        mov     di,ax
        cmp     dx,word ptr [mgCurBank]
        je      @NoChange
        mov     ax,dx
        call    dword ptr [mgBankAddr]
@NoChange:
        xor     dx,dx
        cmp     di,0FFFEh
        jae     @Next2
        mov     ax,es:[di]
        mov     dl,es:[di+2]
        leave
        ret     4
@Next2: jne     @Next1
        mov     ax,es:[di]
        push    ax
        mov     ax,[mgCurBank]
        inc     ax
        call    dword ptr [mgBankAddr]
        pop     ax
        mov     dl,es:[0]
        leave
        ret     $0004
@Next1: mov     al,es:[di]
        push    ax
        mov     ax,[mgCurBank]
        inc     ax
        call    dword ptr [mgBankAddr]
        pop     ax
        xor     dx,dx
        mov     ah,es:[0]
        mov     dl,es:[1]
 end;

 {
 ----------------------------------------------------------------------------
  PutPixel4G(X,Y: Word; Color: LongInt)
 ----------------------------------------------------------------------------
 }
 procedure PutPixelSVGA4G(X,Y: Word; Color: LongInt); assembler;
      asm
        mov     ax,[Y]
        mul     [mgBytesPerLine]
        mov     di,[X]
        shl     di,2
        add     di,ax
        adc     dx,word ptr [mgBankOffset]
        mov     es,[VideoSEG]
        add     di,[mgPixOffset]
        adc     dx,0
        cmp     dx,word ptr [mgCurBank]
        je      @NoChange
        mov     ax,dx
        call    dword ptr [mgBankAddr]
@NoChange:
        db      $66
        mov     ax,word ptr [Color]
        db      $66
        mov     es:[di],ax
 end;

{
 ----------------------------------------------------------------------------
  DrawLine4GFast(X1,Y1,X2,Y2: Integer; Color: LongInt);
 ----------------------------------------------------------------------------
  Original Code:
  SVGAKit v5.2 by Kendall Bennett, Copyright (C) 1992-95 SciTech Software
 ----------------------------------------------------------------------------
 }
 procedure DrawLineSVGA4G(X1,Y1,X2,Y2: Integer; Color: LongInt); assembler;
 var Routine: Word;
     EIncr,NEIncr: Word;
     VertInc: LongInt;
      asm
        cld
        mov     si,[mgBytesPerLine]
        mov     word ptr word ptr [VertInc+2],0
        mov     ax,[x2]
        sub     ax,[x1]
        jns     @X2Greater
        neg     ax
        mov     bx,[x2]
        xchg    bx,[x1]
        mov     [x2],bx
        mov     bx,[y2]
        xchg    bx,[y1]
        mov     [y2],bx
@X2Greater:
        mov     bx,[y2]
        sub     bx,[y1]
        jns     @Y2Greater
        neg     bx
        neg     si
        mov     word ptr [VertInc+2],$FFFF
@Y2Greater:
        mov     word ptr [VertInc],si
        mov     [Routine],offset @LoSlopeLine
        cmp     bx,ax
        jle     @LoSlope
        mov     [Routine],offset @HiSlopeLine
        xchg    bx,ax
@LoSlope:
        shl     bx,1
        mov     [EIncr],bx
        sub     bx,ax
        mov     di,bx
        sub     bx,ax
        mov     [NEIncr],bx
        push    ax
        mov     ax,[Y1]
        mul     [mgBytesPerLine]
        mov     bx,[X1]
        shl     bx,2
        add     bx,ax
        adc     dx,word ptr [mgBankOffset]
        mov     es,[VideoSEG]
        add     bx,[mgPixOffset]
        adc     dx,0
        pop     cx
        inc     cx
        jmp     [Routine]
@LoSlopeLine:
        db      $66
        mov     ax,word ptr [Color]
        mov     dh,byte ptr [mgCurBank]
@LoopLo:
        cmp     dl,dh
        je      @SetLo
        push    ax
        mov     al,dl
        call    dword ptr [mgBankAddr]
        mov     dh,dl
        pop     ax
@SetLo:
        db      $66
        mov     [es:bx],ax
        add     bx,4
        adc     dl,0
        or      di,di
        jns     @LoPosDi
        add     di,[EIncr]
        loop    @LoopLo
        leave
        retf    12
@LoPosDi:
        add     di,[NEIncr]
        add     bx,word ptr [VertInc]
        adc     dl,byte ptr [VertInc+2]
        loop    @LoopLo
        leave
        retf    12
@HiSlopeLine:
        db      $66
        mov     ax,word ptr [Color]
        mov     dh,byte ptr [mgCurBank]
@LoopHi:
        cmp     dh,dl
        je      @SetHi
        push    ax
        mov     al,dl
        call    dword ptr [mgBankAddr]
        mov     dh,dl
        pop     ax
@SetHi:
        db      $66
        mov     [es:bx],ax
        add     bx,word ptr [VertInc]
        adc     dl,byte ptr [VertInc+2]
        or      di,di
        jns     @HiPosDi
        add     di,[EIncr]
        loop    @LoopHi
        leave
        retf    12
@HiPosDi:
        add     di,[NEIncr]
        add     bx,4
        adc     dl,0
        loop    @LoopHi
 end;

 {
 ----------------------------------------------------------------------------
  GetPixel4G(X,Y: Integer): LongInt
 ----------------------------------------------------------------------------
 }
 function GetPixelSVGA4G(X,Y: Word): LongInt; assembler;
      asm
        mov     ax,[Y]
        mul     [mgBytesPerLine]
        mov     di,[X]
        shl     di,2
        add     ax,di
        adc     dx,word ptr [mgBankOffset]
        mov     es,[VideoSEG]
        mov     di,ax
        add     di,[mgPixOffset]
        add     dx,0
        cmp     dx,word ptr [mgCurBank]
        je      @NoChange
        mov     ax,dx
        call    dword ptr [mgBankAddr]
@NoChange:
        db      $66
        mov     ax,es:[di]
        db      $66
        mov     dx,ax
        db      $66
        shr     dx,16
 end;

 procedure HLineMCGA(X1,X2,Y: Integer; Color: LongInt); assembler;
      asm
        mov     cx,X2
        mov     bx,X1
        mov     dx,Y
        cmp     dx,[WY]
        jl      @Quit
        cmp     dx,[WY1]
        jg      @Quit
        cmp     cx,[WX]
        jl      @Quit
        cmp     bx,[WX1]
        jg      @Quit
        cmp     bx,[WX]
        jge     @Next1
        mov     bx,[WX]
@Next1: cmp     cx,[WX1]
        jle     @Next2
        mov     cx,[WX1]
@Next2: push    cx
        shl     dx,6
        mov     di,bx
        add     di,dx
        shl     dx,2
        add     di,dx
        cld
        pop     cx
        mov     al,byte ptr [Color]
        mov     ah,al
        push    ax
        db      $66
        shl     ax,16
        pop     ax
        mov     es,[VideoSEG]
        sub     cx,bx
        inc     cx
        push    cx
        and     cx,3
        rep     stosb
        pop     cx
        shr     cx,2
        db      $66
        rep     stosw
@Quit:
 end;

 procedure HLineModeX(X1,X2,Y: Integer; Color: LongInt); assembler;
      asm
        mov     es,[VideoSEG]
        mov     dx,SEQU_ADDR
        mov     al,$02
        out     dx,al
        mov     ax,[X1]
        mov     dx,[X2]
        inc     dx
        mov     cx,[Y]
        cmp     dx,ax
        jl      @Quit
        cmp     cx,[WY]
        jl      @Quit
        cmp     cx,[WY1]
        jg      @Quit
        mov     di,[WX1]
        cmp     ax,di
        jg      @Quit
        inc     di
        cmp     dx,di
        jl      @ClipLeft
        mov     dx,di
@ClipLeft:
        mov     di,[WX]
        cmp     dx,di
        jl      @Quit
        cmp     ax,di
        jge     @DoLine
        mov     ax,di
@DoLine:
        xchg    cx,ax
        mov     si,dx
        mul     mgBytesPerLine
        mov     dx,si
        add     ax,[mgPixOffset]
        mov     di,cx
        sar     di,2
        add     di,ax
        and     si,03h
        mov     ah,byte ptr RightClipPlaneMask[si]
        mov     si,cx
        and     si,03h
        mov     al,byte ptr LeftClipPlaneMask[si]
        cmp     dx,cx
        jle     @Quit
        xchg    cx,dx
        dec     cx
        and     dx,not 03h
        sub     cx,dx
        js      @Quit
        shr     cx,2
        jnz     @MasksSet
        and     al,ah
@MasksSet:
        mov     dl,byte ptr [Color]
        mov     bx,ax
        mov     ah,dl
        mov     dx,$3C5
        mov     al,bl
        out     dx,al
        mov     al,ah
        stosb
        dec     cx
        js      @Quit
        jz      @RightEnd
        mov     al,0fh
        out     dx,al
        mov     al,ah
        shr     cx,1
        rep     stosw
        adc     cx,cx
        rep     stosb
@RightEnd:
        mov     al,bh
        out     dx,al
        mov     al,ah
        stosb
@Quit:
 end;

 procedure HLineSVGA256(X1,X2,Y: Integer; Color: LongInt); assembler;
      asm
        mov     dx,[Y]
        mov     bx,[X1]
        mov     cx,[X2]
        cmp     dx,[WY]
        jl      @Quit
        cmp     dx,[WY1]
        jg      @Quit
        cmp     cx,[WX]
        jl      @Quit
        cmp     bx,[WX1]
        jg      @Quit
        cmp     bx,[WX]
        jge     @Next1
        mov     bx,[WX]
@Next1: cmp     cx,[WX1]
        jle     @Next2
        mov     cx,[WX1]
@Next2: sub     cx,bx
        inc     cx
        mov     ax,dx
        mul     [mgBytesPerLine]
        add     bx,ax
        adc     dx,[mgBankOffset]
        add     bx,[mgPixOffset]
        adc     dx,0
        mov     ax,dx
        cmp     ax,[mgCurBank]
        je      @Pass
        call    dword ptr [mgBankAddr]
@Pass:  mov     al,byte ptr Color
        cld
        mov     ah,al
        push    ax
        db      $66
        shl     ax,16
        pop     ax
        mov     es,[VideoSEG]
        mov     di,bx
        add     bx,cx
        jnc     @Novf
        push    cx
        mov     cx,di
        not     cx
        inc     cx
        mov     bx,cx
        push    cx
        and     cx,3
        rep     stosb
        pop     cx
        shr     cx,2
        db      $66
        rep     stosw
        pop     cx
        sub     cx,bx
        push    ax
        mov     ax,[mgCurBank]
        inc     ax
        call    dword ptr [mgBankAddr]
        xor     di,di
        pop     ax
        push    cx
        and     cx,3
        rep     stosb
        pop     cx
        shr     cx,2
        db      $66
        rep     stosw
        leave
        retf    10
@Novf:  push    cx
        and     cx,3
        rep     stosb
        pop     cx
        shr     cx,2
        db      $66
        rep     stosw
@Quit:
 end;

 procedure HLineSVGA32K(X1,X2,Y: Integer; Color: LongInt); assembler;
      asm
        mov     dx,[Y]
        mov     bx,[X1]
        mov     cx,[X2]
        cmp     dx,[WY]
        jl      @Quit
        cmp     dx,[WY1]
        jg      @Quit
        cmp     cx,[WX]
        jl      @Quit
        cmp     bx,[WX1]
        jg      @Quit
        cmp     bx,[WX]
        jge     @Next1
        mov     bx,[WX]
@Next1: cmp     cx,[WX1]
        jle     @Next2
        mov     cx,[WX1]
@Next2: sub     cx,bx
        inc     cx
        shl     cx,1
        mov     ax,dx
        mul     [mgBytesPerLine]
        shl     bx,1
        add     bx,ax
        adc     dx,[mgBankOffset]
        add     bx,[mgPixOffset]
        adc     dx,0
        mov     ax,dx
        cmp     ax,[mgCurBank]
        je      @Pass
        call    dword ptr [mgBankAddr]
@Pass:  mov     ax,word ptr Color
        cld
        push    ax
        db      $66
        shl     ax,16
        pop     ax
        mov     es,[VideoSEG]
        mov     di,bx
        add     bx,cx
        jnc     @Novf
        push    cx
        mov     cx,di
        not     cx
        inc     cx
        mov     bx,cx
        push    cx
        and     cx,3
        shr     cx,1
        rep     stosw
        pop     cx
        shr     cx,2
        db      $66
        rep     stosw
        pop     cx
        sub     cx,bx
        push    ax
        mov     ax,[mgCurBank]
        inc     ax
        call    dword ptr [mgBankAddr]
        pop     ax
        push    cx
        and     cx,3
        shr     cx,1
        rep     stosw
        pop     cx
        shr     cx,2
        db      $66
        rep     stosw
        leave
        retf    10
@Novf:  push    cx
        and     cx,3
        shr     cx,1
        rep     stosw
        pop     cx
        shr     cx,2
        db      $66
        rep     stosw
@Quit:
 end;

 procedure HLineSVGA16M(X1,X2,Y: Integer; Color: LongInt); assembler;
      asm
        mov     dx,[Y]
        mov     bx,[X1]
        mov     cx,[X2]
        cmp     dx,[WY]
        jl      @Quit
        cmp     dx,[WY1]
        jg      @Quit
        cmp     cx,[WX]
        jl      @Quit
        cmp     bx,[WX1]
        jg      @Quit
        cmp     bx,[WX]
        jge     @Next1
        mov     bx,[WX]
@Next1: cmp     cx,[WX1]
        jle     @Next2
        mov     cx,[WX1]
@Next2: sub     cx,bx
        inc     cx
        mov     ax,dx
        mul     [mgBytesPerLine]
        add     ax,bx
        adc     dx,0
        shl     bx,1
        add     ax,bx
        adc     dx,[mgBankOffset]
        add     ax,[mgPixOffset]
        adc     dx,0
        mov     es,[VideoSEG]
        mov     di,ax
        cmp     dx,word ptr [mgCurBank]
        je      @NoChange
        mov     ax,dx
        call    dword ptr [mgBankAddr]
@NoChange:
        mov     ax,word ptr [Color]
        mov     dl,byte ptr [Color+2]
@Loop:  cmp     di,$FFFD
        jae     @Next3
        mov     es:[di],ax
        mov     es:[di+2],dl
        add     di,3
@NextPix:
        loop    @Loop
        leave
        retf    10
@Next3: jne     @Next5
        mov     es:[di],ax
        mov     es:[di+2],dl
        xor     di,di
        push    ax
        mov     ax,[mgCurBank]
        inc     ax
        call    mgBankAddr
        pop     ax
        jmp     @NextPix
@Next5: cmp     di,$FFFE
        jne     @Next4
        mov     es:[di],ax
        push    ax
        mov     ax,[mgCurBank]
        inc     ax
        call    dword ptr [mgBankAddr]
        pop     ax
        mov     es:[0],dl
        mov     di,1
        jmp     @NextPix
@Next4: mov     es:[di],al
        push    ax
        mov     ax,[mgCurBank]
        inc     ax
        call    dword ptr [mgBankAddr]
        pop     ax
        mov     es:[0],ah
        mov     es:[1],dl
        mov     di,2
        jmp     @NextPix
@Quit:
 end;

 procedure HLineSVGA4G(X1,X2,Y: Integer; Color: LongInt); assembler;
      asm
        mov     dx,[Y]
        mov     bx,[X1]
        mov     cx,[X2]
        cmp     dx,[WY]
        jl      @Quit
        cmp     dx,[WY1]
        jg      @Quit
        cmp     cx,[WX]
        jl      @Quit
        cmp     bx,[WX1]
        jg      @Quit
        cmp     bx,[WX]
        jge     @Next1
        mov     bx,[WX]
@Next1: cmp     cx,[WX1]
        jle     @Next2
        mov     cx,[WX1]
@Next2: sub     cx,bx
        inc     cx
        shl     cx,2
        mov     ax,dx
        mul     [mgBytesPerLine]
        shl     bx,2
        add     bx,ax
        adc     dx,[mgBankOffset]
        add     bx,[mgPixOffset]
        adc     dx,0
        mov     ax,dx
        cmp     ax,[mgCurBank]
        je      @Pass
        call    dword ptr [mgBankAddr]
@Pass:  db      $66
        mov     ax,word ptr Color
        cld
        mov     es,[VideoSEG]
        mov     di,bx
        add     bx,cx
        jnc     @Novf
        push    cx
        mov     cx,di
        not     cx
        inc     cx
        mov     bx,cx
        shr     cx,2
        db      $66
        rep     stosw
        pop     cx
        sub     cx,bx
        push    ax
        mov     ax,[mgCurBank]
        inc     ax
        call    dword ptr [mgBankAddr]
        pop     ax
        shr     cx,2
        db      $66
        rep     stosw
        leave
        retf    10
@Novf:  shr     cx,2
        db      $66
        rep     stosw
@Quit:
 end;

 procedure MCGAPutLine; near; assembler;
      asm
        pusha
        mov     es,[VideoSEG]
        push    cx
        push    cx
        shl     dx,6
        mov     di,bx
        add     di,dx
        shl     dx,2
        add     di,dx
        pop     cx
        and     cx,3
        db      $64
        rep     movsb
        pop     cx
        shr     cx,2
        db      $64
        db      $66
        rep     movsw
@Quit:  popa
 end;

 procedure MCGAMaskLine; near; assembler;
      asm
        pusha
        mov     es,[VideoSEG]
        push    cx
        shl     dx,6
        mov     di,bx
        add     di,dx
        shl     dx,2
        add     di,dx
        pop     cx
@Loop:  db      $64
        lodsb
        cmp     al,byte ptr [mgMaskColor]
        jz      @Pass
        mov     es:[di],al
@Pass:  inc     di
        loop    @Loop
@Quit:  popa
 end;

 procedure MCGAGetLine; near; assembler;
      asm
        pusha
        mov     ax,[VideoSEG]
        dw      $E08E        {<- mov FS,AX}
        push    cx
        push    cx
        shl     dx,6
        mov     si,bx
        add     si,dx
        shl     dx,2
        add     si,dx
        pop     cx
        and     cx,3
        db      $64
        rep     movsb
        pop     cx
        shr     cx,2
        db      $64
        db      $66
        rep     movsw
@Quit:  popa
 end;

 procedure ModeXPutLine; near; assembler;
      asm
        mov     ax,[mgBytesPerLine]
        mul     dx
        mov     di,bx
        shr     di,2
        add     di,ax
        add     di,[mgPixOffset]
        mov     es,SSEG
        push    cx
        mov     cx,bx
        and     cx,3
        mov     ax,$1102
        rol     ah,cl
        mov     dx,SEQU_ADDR
        out     dx,ax
        pop     cx
        dec     cx
        jz      @Quit
        mov     bx,4
@Next:  push    bx
        push    cx
        mov     bx,si
        push    di
@Loop:  db      $64
        movsb
        add     si,3
        sub     cx,4
        jnc     @Loop
        pop     di
        mov     si,bx
        inc     si
        rol     ah,1
        out     dx,ax
        mov     bx,ax
        shr     bx,8
        and     bx,1
        add     di,bx
        pop     cx
        pop     bx
        dec     cx
        jz      @Quit
        dec     bx
        jnz     @Next
@Quit:
 end;

 procedure ModeXGetLine; near; assembler;
      asm
        mov     ax,[VideoSEG]
        dw      $E08E        {<- mov FS,AX}
        mov     ax,[mgBytesPerLine]
        mul     dx
        mov     si,bx
        shr     si,2
        add     si,ax
        add     si,[mgPixOffset]
        mov     ah,bl
        and     ah,3
        mov     al,$04
        mov     dx,$3CE
        out     dx,ax
        dec     cx
        jz      @Quit
        mov     bx,4
@Next:  push    cx
        push    di
        push    si
@Loop:  db      $64
        movsb
        add     di,3
        sub     cx,4
        jnc     @Loop
        pop     si
        pop     di
        inc     di
        inc     ah
        and     ah,3
        jne     @Next1
        inc     si
@Next1:
        out     dx,ax
        pop     cx
        dec     cx
        jz      @Quit
        dec     bx
        jnz     @Next
@Quit:
 end;

 procedure ModeXMaskLine; near; assembler;
      asm
        mov     ax,[mgBytesPerLine]
        mul     dx
        mov     di,bx
        shr     di,2
        add     di,ax
        add     di,[mgPixOffset]
        mov     es,SSEG
        push    cx
        mov     cx,bx
        and     cx,3
        mov     ax,$1102
        rol     ah,cl
        mov     dx,SEQU_ADDR
        out     dx,ax
        pop     cx
        dec     cx
        jz      @Quit
        mov     bx,4
@Next:  push    bx
        push    cx
        push    si
        push    di
@Loop:  db      $64
        mov     bl,[si]
        cmp     bl,byte ptr [mgMaskColor]
        jz      @Pass
        mov     es:[di],bl
@Pass:  add     si,4
        inc     di
        sub     cx,4
        jnc     @Loop
        pop     di
        pop     si
        inc     si
        rol     ah,1
        out     dx,ax
        mov     bx,ax
        shr     bx,8
        and     bx,1
        add     di,bx
        pop     cx
        pop     bx
        dec     cx
        jz      @Quit
        dec     bx
        jnz     @Next
@Quit:
 end;

 procedure SVGAPutLine; near; assembler;
      asm
        pusha
        mov     ax,[mgBytesPerLine]
        mul     dx
        add     bx,ax
        adc     dx,[mgBankOffset]
        add     bx,[mgPixOffset]
        adc     dx,0
        cmp     dx,[mgCurBank]
        jz      @Pass
        mov     ax,dx
        call    dword ptr mgBankAddr
@Pass:  cld
        mov     es,[VideoSEG]
        mov     di,bx
        add     bx,cx
        jnc     @Novf
        push    cx
        mov     cx,di
        not     cx
        inc     cx
        mov     bx,cx
        push    cx
        and     cx,3
        db      $64
        rep     movsb
        pop     cx
        shr     cx,2
        db      $66
        db      $64
        rep     movsw
        pop     cx
        sub     cx,bx
        mov     ax,[mgCurBank]
        inc     ax
        call    dword ptr mgBankAddr
        push    cx
        and     cx,3
        db      $64
        rep     movsb
        pop     cx
        shr     cx,2
        db      $66
        db      $64
        rep     movsw
        popa
        ret
@Novf:  push    cx
        and     cx,3
        db      $64
        rep     movsb
        pop     cx
        shr     cx,2
        db      $64
        db      $66
        rep     movsw
@Quit:  popa
 end;

 procedure SVGA256MaskLine; near; assembler;
      asm
        pusha
        mov     ax,[mgBytesPerLine]
        mul     dx
        add     bx,ax
        adc     dx,[mgBankOffset]
        add     bx,[mgPixOffset]
        adc     dx,0
        cmp     dx,[mgCurBank]
        jz      @Pass
        mov     ax,dx
        call    dword ptr mgBankAddr
@Pass:  cld
        mov     es,[VideoSEG]
        mov     di,bx
        add     bx,cx
        jnc     @Loop3
        push    cx
        mov     cx,di
        not     cx
        inc     cx
        mov     bx,cx
        cmp     cx,0
        jz      @Next
@Loop1: db      $64
        lodsb
        cmp     al,byte ptr [mgMaskColor]
        jz      @Pass1
        mov     es:[di],al
@Pass1: inc     di
        loop    @Loop1
@Next:  pop     cx
        sub     cx,bx
        mov     ax,[mgCurBank]
        inc     ax
        call    dword ptr mgBankAddr
        cmp     cx,0
        jz      @Quit
@Loop2: db      $64
        lodsb
        cmp     al,byte ptr [mgMaskColor]
        jz      @Pass2
        mov     es:[di],al
@Pass2: inc     di
        loop    @Loop2
        popa
        ret
@Loop3: db      $64
        lodsb
        cmp     al,byte ptr [mgMaskColor]
        jz      @Pass3
        mov     es:[di],al
@Pass3: inc     di
        loop    @Loop3
@Quit:  popa
 end;

 procedure SVGA32KMaskLine; near; assembler;
      asm
        pusha
        mov     ax,[mgBytesPerLine]
        mul     dx
        add     bx,ax
        adc     dx,[mgBankOffset]
        add     bx,[mgPixOffset]
        adc     dx,0
        cmp     dx,[mgCurBank]
        jz      @Pass
        mov     ax,dx
        call    dword ptr mgBankAddr
@Pass:  cld
        mov     es,[VideoSEG]
        mov     di,bx
        add     bx,cx
        jnc     @Novf
        push    cx
        mov     cx,di
        not     cx
        inc     cx
        mov     bx,cx
        cmp     cx,0
        jz      @Next
        shr     cx,1
@Loop1: db      $64
        lodsw
        cmp     ax,word ptr [mgMaskColor]
        jz      @Pass1
        mov     es:[di],ax
@Pass1: inc     di
        inc     di
        loop    @Loop1
@Next:  pop     cx
        sub     cx,bx
        mov     ax,[mgCurBank]
        inc     ax
        call    dword ptr mgBankAddr
        cmp     cx,0
        jz      @Quit
        shr     cx,1
@Loop2: db      $64
        lodsw
        cmp     ax,word ptr [mgMaskColor]
        jz      @Pass2
        mov     es:[di],ax
@Pass2: inc     di
        inc     di
        loop    @Loop2
        popa
        ret
@Novf:  shr     cx,1
@Loop3: db      $64
        lodsw
        cmp     ax,word ptr [mgMaskColor]
        jz      @Pass3
        mov     es:[di],ax
@Pass3: inc     di
        inc     di
        loop    @Loop3
@Quit:  popa
 end;

 procedure SVGA16MMaskLine; near; assembler;
      asm
        pusha
        mov     ax,[mgBytesPerLine]
        mul     dx
        add     bx,ax
        adc     dx,[mgBankOffset]
        add     bx,[mgPixOffset]
        adc     dx,0
        mov     es,[VideoSEG]
        mov     di,bx
        cmp     dx,[mgCurBank]
        jz      @NoChange
        mov     ax,dx
        call    dword ptr [mgBankAddr]
@NoChange:
        mov     ax,cx
        mov     dx,3
        div     dl
        mov     cx,ax
        db      $66
        mov     dx,word ptr [mgMaskColor]
@Loop:  db      $66
        xor     ax,ax
        db      $64
        mov     al,[si+2]
        db      $66
        shl     ax,16
        db      $64
        mov     ax,[si]
        add     si,3
        db      $66
        cmp     ax,dx
        jz      @Skip
        cmp     di,$FFFD
        jae     @Next3
        mov     es:[di],ax
        inc     di
        inc     di
        db      $66
        shr     ax,16
        mov     es:[di],al
        inc     di
@NextPix:
        loop    @Loop
        popa
        retn
@Next3: jne     @Next5
        mov     es:[di],ax
        db      $66
        shr     ax,16
        mov     es:[di+2],al
        xor     di,di
        mov     ax,[mgCurBank]
        inc     ax
        call    dword ptr [mgBankAddr]
        jmp     @NextPix
@Next5: cmp     di,$FFFE
        jne     @Next4
        mov     es:[di],ax
        mov     ax,[mgCurBank]
        inc     ax
        call    dword ptr [mgBankAddr]
        db      $66
        shr     ax,16
        mov     es:[0],al
        mov     di,1
        jmp     @NextPix
@Next4: mov     es:[di],al
        push    ax
        mov     ax,[mgCurBank]
        inc     ax
        call    dword ptr [mgBankAddr]
        pop     ax
        db      $66
        shr     ax,8
        mov     es:[0],ax
        mov     di,2
        db      $66
        xor     ax,ax
        jmp     @NextPix
@Skip:  add     di,3
        jnc     @NextPix
        mov     ax,[mgCurBank]
        inc     ax
        call    dword ptr [mgBankAddr]
        jmp     @NextPix
@Quit:  popa
 end;

 procedure SVGA4GMaskLine; near; assembler;
      asm
        pusha
        mov     ax,[mgBytesPerLine]
        mul     dx
        add     bx,ax
        adc     dx,[mgBankOffset]
        add     bx,[mgPixOffset]
        adc     dx,0
        cmp     dx,[mgCurBank]
        jz      @Pass
        mov     ax,dx
        call    dword ptr mgBankAddr
@Pass:  cld
        mov     es,[VideoSEG]
        mov     di,bx
        add     bx,cx
        jnc     @Novf
        push    cx
        mov     cx,di
        not     cx
        inc     cx
        mov     bx,cx
        cmp     cx,0
        jz      @Next
        shr     cx,2
@Loop1: db      $66
        db      $64
        lodsw
        db      $66
        cmp     ax,word ptr [mgMaskColor]
        jz      @Pass1
        db      $66
        mov     es:[di],ax
@Pass1: add     di,4
        loop    @Loop1
@Next:  pop     cx
        sub     cx,bx
        mov     ax,[mgCurBank]
        inc     ax
        call    dword ptr mgBankAddr
        cmp     cx,0
        jz      @Quit
        shr     cx,2
@Loop2: db      $66
        db      $64
        lodsw
        db      $66
        cmp     ax,word ptr [mgMaskColor]
        jz      @Pass2
        db      $66
        mov     es:[di],ax
@Pass2: add     di,4
        loop    @Loop2
        popa
        ret
@Novf:  shr     cx,2
@Loop3: db      $66
        db      $64
        lodsw
        db      $66
        cmp     ax,word ptr [mgMaskColor]
        jz      @Pass3
        db      $66
        mov     es:[di],ax
@Pass3: add     di,4
        loop    @Loop3
@Quit:  popa
 end;

 procedure SVGAGetLine; near; assembler;
      asm
        pusha
        mov     ax,[mgBytesPerLine]
        mul     dx
        add     bx,ax
        adc     dx,[mgBankOffset]
        add     bx,[mgPixOffset]
        adc     dx,0
        cmp     dx,[mgCurBank]
        jz      @Pass
        mov     ax,dx
        call    dword ptr mgBankAddr
@Pass:  cld
        mov     ax,[VideoSEG]
        dw      $E08E        {<- mov FS,AX}
        mov     si,bx
        add     bx,cx
        jnc     @Novf
        push    cx
        mov     cx,si
        not     cx
        inc     cx
        mov     bx,cx
        push    cx
        and     cx,3
        db      $64
        rep     movsb
        pop     cx
        shr     cx,2
        db      $66
        db      $64
        rep     movsw
        pop     cx
        sub     cx,bx
        mov     ax,[mgCurBank]
        inc     ax
        call    dword ptr mgBankAddr
        push    cx
        and     cx,3
        db      $64
        rep     movsb
        pop     cx
        shr     cx,2
        db      $66
        db      $64
        rep     movsw
        popa
        ret
@Novf:  push    cx
        and     cx,3
        db      $64
        rep     movsb
        pop     cx
        shr     cx,2
        db      $64
        db      $66
        rep     movsw
@Quit:  popa
 end;

 {
 ----------------------------------------------------------------------------
  VBEFunc00 - Gets VBE info
 ----------------------------------------------------------------------------
 }
 function VBEFunc00 (var BuffAddr): Word; near; assembler;
      asm
        les     di,[BuffAddr]
        mov     ax,$4F00
        xor     si,si
        inc     si
        int     $10
 end;

 {
 ----------------------------------------------------------------------------
  VBEFunc05 - Sets bank Addr
 ----------------------------------------------------------------------------
 }
 procedure VBESetBank(BankNo: Word); assembler;
      asm
        mov     ax,BankNo
        call    dword ptr [mgBankAddr]
 end;

 {
 ----------------------------------------------------------------------------
  VBEFunc07 - Sets Screen Start on VESA 1.2/2.0, WaitForRetrace=FALSE
 ----------------------------------------------------------------------------
 }
 procedure VBEFunc07NW; near; assembler;
      asm
        mov     ax,$4F07
        xor     bx,bx
        int     $10
        xor     ax,[VBEStatusOk]
        jnz     @Failed
        inc     ax
        retn
@Failed:xor     ax,ax
 end;

 {
 ----------------------------------------------------------------------------
  VBEFunc07 - Sets Screen Start on VESA 1.2, WaitForRetrace=TRUE
 ----------------------------------------------------------------------------
 }
 procedure VBEFunc07W1; near; assembler;
      asm
        push    dx
        mov     dx,STAT_ADDR
@WaitDE:
        in      al,dx
        test    al,1
        jnz     @WaitDE
        pop     dx

        mov     ax,$4F07
        xor     bx,bx
        int     $10

        push    ax
        mov     dx,STAT_ADDR
@WaitVS:
        in      al,dx
        test    al,8
        jz      @WaitVS
        pop     ax
        xor     ax,[VBEStatusOk]
        jnz     @Failed
        inc     ax
        retn
@Failed:xor     ax,ax
 end;

 {
 ----------------------------------------------------------------------------
  VBEFunc07 - Sets Screen Start on VESA 2.0, WaitForRetrace=TRUE
 ----------------------------------------------------------------------------
 }
 procedure VBEFunc07W2; near; assembler;
      asm
        mov     ax,$4F07
        mov     bx,$80
        int     $10
        xor     ax,[VBEStatusOk]
        jnz     @Failed
        inc     ax
        retn
@Failed:xor     ax,ax
 end;

 {
 ----------------------------------------------------------------------------
  VBEFunc07 - Sets Screen Start in X Mode, WaitForRetrace=FALSE
 ----------------------------------------------------------------------------
 }
 procedure ModeXSetStartNW; near; assembler;
      asm
        mov     si,cx
        mov     ax,[mgBytesPerLine]
        mov     cx,dx
        mul     cx
        mov     cx,si
        shr     cx,2
        add     ax,cx
        mov     bh,al
        mov     ch,ah
        mov     bl,$0D
        mov     cl,$0C
        and     si,0003h
        mov     ah,byte ptr PelPanMask[si]
        mov     al,33h
        mov     si,ax
        mov     dx,CRTC_ADDR
        mov     ax,bx
        out     dx,ax
        mov     ax,cx
        out     dx,ax
        mov     dx,ATTR_ADDR
        mov     ax,si
        out     dx,al
        mov     al,ah
        out     dx,al
        mov     ax,1
 end;

 {
 ----------------------------------------------------------------------------
  VBEFunc07 - Sets Screen Start in X Mode, WaitForRetrace=TRUE
 ----------------------------------------------------------------------------
 }
 procedure ModeXSetStartW0; near; assembler;
      asm
        push    dx
        mov     dx,STAT_ADDR
@WaitDE:
        in      al,dx
        test    al,1
        jnz     @WaitDE
        pop     dx

        mov     si,cx
        mov     ax,[mgBytesPerLine]
        mov     cx,dx
        mul     cx
        mov     cx,si
        shr     cx,2
        add     ax,cx
        mov     bh,al
        mov     ch,ah
        mov     bl,$0D
        mov     cl,$0C
        and     si,0003h
        mov     ah,byte ptr PelPanMask[si]
        mov     al,33h
        mov     si,ax
        mov     dx,CRTC_ADDR
        mov     ax,bx
        out     dx,ax
        mov     ax,cx
        out     dx,ax
        mov     dx,ATTR_ADDR
        mov     ax,si
        out     dx,al
        mov     al,ah
        out     dx,al

        mov     dx,STAT_ADDR
@WaitVR:
        in      al,dx
        test    al,8
        jz      @WaitVR
        mov     ax,1
 end;

 {
 ----------------------------------------------------------------------------
  VBESetMode - Sets VBE mode
 ----------------------------------------------------------------------------
  Entry:                BX     -       desired VBE mode
  Exit:                 AX     -       return VBE ststus
  Registers:            None
 ----------------------------------------------------------------------------
 }
 function VBESetMode(Mode: Word): Boolean; near; assembler;
      asm
        mov     ax,$4F02
        mov     bx,[Mode]
        and     bx,0011111111111111b
        int     $10
        cmp     ax,VBEStatusOk
        jz      @Ok
        xor     ax,ax
        jmp     @End
@Ok:    mov     ax,1
@End:
 end;

 function  GrBufferAlloc(Length: Word): Boolean;
 begin
  if (BufferLen>0) or (Length>32767) then begin
   GrBufferAlloc:=false;
   exit;
  end;
  GetBuffer(mgBufferPtr,Length);
  if mgBufferPtr<>nil then begin
   GrBufferAlloc:=true;
{$IFDEF DPMI}
   PLS:=SEG(mgBufferPtr^);
{$ENDIF}
   BufferLen:=Length;
  end;
 end;

 function  GrBufferReAlloc(NewLength: Word): Boolean;
 begin
  GrBufferReAlloc:=false;
  if (BufferLen=0) or (NewLength>32767) then exit;
  FreeBuffer(mgBufferPtr,BufferLen);
  GetBuffer(mgBufferPtr,NewLength);
  if mgBufferPtr<>nil then begin
   GrBufferReAlloc:=true;
{$IFDEF DPMI}
   PLS:=SEG(mgBufferPtr^);
{$ENDIF}
   BufferLen:=NewLength;
  end;
 end;

 function  GrBufferFree: Boolean;
 begin
  if BufferLen=0 then begin
   GrBufferFree:=false;
   exit;
  end;
  FreeBuffer(mgBufferPtr,BufferLen);
  GrBufferFree:=true;
{$IFDEF DPMI}
  PLS:=0;
{$ENDIF}
  BufferLen:=0;
 end;

 function  GrBufferLength: Word; assembler;
      asm
        mov     ax,[BufferLen]
 end;

 procedure SetTransp(Mode: Boolean); assembler;
      asm
        or      [Mode],0
        jz      @NoTransp
        mov     ax,[MaskLineAddr]
        mov     [Transparent],1
        jmp     @Quit
@NoTransp:
        mov     ax,[PutLineAddr]
        mov     [Transparent],0
@Quit:  mov     [WriteLineAddr],ax
 end;

 function  GetTransp: Boolean; assembler;
      asm
        mov     al,[Transparent]
 end;

 function  GetVBEInfo(var VBEInfo: TVBEInfoBlock): Boolean;
{$IFDEF DPMI}
 var
     Reg:   TRealRegs;
     RealPtr: Pointer;
{$ENDIF}
 begin
{$IFDEF DPMI}
  FillChar(Reg,SizeOf(Reg),0);
  Reg.ES:=xGlobalDOSAlloc(RealPtr,256);
  Reg.SI:=1;
  Reg.AX:=$4F00;
  RealModeInt($10,Reg);
  if Reg.AX<>VBEStatusOK then GetVBEInfo:=false
{$ELSE}
  if VBEFunc00(VBEInfo)<>VBEStatusOK then GetVBEInfo:=false
{$ENDIF}
  else begin
{$IFDEF DPMI}
   Move(RealPtr^,VBEInfo,256);
{$ENDIF}
   GetVBEInfo:=true;
  end;
{$IFDEF DPMI}
   GlobalDOSFree(SEG(RealPtr^));
{$ENDIF}
 end;

 function GetVBEModeInfo(Mode: Word; var ModeInfo: TVBEModeInfoBlock): Boolean;
 var
{$IFDEF DPMI}
     Reg:   TRealRegs;
     RealPtr: Pointer;
{$ELSE}
     VBEStatus: Word;
{$ENDIF}
 begin
{$IFDEF DPMI}
  ClearRegs(Reg);
  Reg.ES:=xGlobalDOSAlloc(RealPtr,256);
  Reg.AX:=$4F01;
  Reg.CX:=Mode;
  RealModeInt($10,Reg);
  if (Reg.AX<>VBEStatusOK) then GetVBEModeInfo:=false
{$ELSE}
      asm
        les     di,ModeInfo
        mov     cx,[Mode]
        mov     ax,$4F01
        int     $10
        mov     [VBEStatus],ax
      end;
  if (VBEStatus<>VBEStatusOK) then GetVBEModeInfo:=false
{$ENDIF}
  else begin
{$IFDEF DPMI}
   Move(RealPtr^,ModeInfo,256);
{$ENDIF}
   GetVBEModeInfo:=true;
  end;
{$IFDEF DPMI}
   GlobalDOSFree(SEG(RealPtr^));
{$ENDIF}
  if (ModeInfo.BitsPerPixel=16) and (ModeInfo.RsvdMaskSize=1) then
     ModeInfo.BitsPerPixel:=15;
 end;

 procedure CreateModeTable(VideoModePtr: Pointer); near;
 var VMode,I: Word;
     ModeInfo: TVBEModeInfoBlock;
     Colors: Byte;
 begin
  i:=0;
  repeat
   VMode:=GetWord(VideoModePtr);
   if (VMode>$FF) and (VMode<>$FFFF) then begin
    if GetVBEModeInfo(VMode,ModeInfo) then begin
     case ModeInfo.BitsPerPixel of
          08: Colors:=grSVGA256;
          15: Colors:=grSVGA32K;
          16: Colors:=grSVGA64K;
          24: Colors:=grSVGA16M;
          32: Colors:=grSVGA4G;
     else Colors:=0;
     end;
     if (Colors>0) and (ModeInfo.XResolution>0) and
        (ModeInfo.YResolution>0) and
        (LongShl(mgVBEMem,10)>LongMul((ModeInfo.BitsPerPixel+1) shr 3,
         LongMul(ModeInfo.XResolution,ModeInfo.YResolution))) and
        ((ModeInfo.ModeAttributes and $10)<>0) then begin
      mgVBEModesList[i].VideoMode:=VMode;
      mgVBEModesList[i].ColorMode:=Colors;
      mgVBEModesList[i].XRes:=ModeInfo.XResolution;
      mgVBEModesList[i].YRes:=ModeInfo.YResolution;
      inc(i);
     end;
    end;
   end;
   IncPointer(VideoModePtr,2);
  until VMode=$FFFF;
  mgVBEModes:=i;
 end;

 function  InitVBE: Boolean;
 var VBEInfo: TVBEInfoBlock;
     i,j:     Word;
     PMSeg,PMOfs:  Word;
     ModesList  :  array [0..99] of word;
 begin
  if (not GetVBEInfo(VBEInfo)) or (VBEInfo.VBEVersion<258) or
  (VBEInfo.VBESignature<>$41534556) then begin
   InitVBE:=false; UseVBE:=false; exit;
  end;
  UseVBE:=true;
  InitVBE:=true;
  mgVBEMem:=VBEInfo.TotalMemory shl 6;
  mgVBEVersion:=VBEInfo.VBEVersion;
  mgCapabilities:=VBEInfo.Capabilities;
  mgOemString:='';
{$IFDEF DPMI}
  PMSEG:=HiWord(LongInt(VBEInfo.OEMStringPtr));
  PMOFS:=LongInt(VBEInfo.OEMStringPtr);
  PMSEG:=NewSelector(LongAdd(LongShl(PMSEG,4),PMOFS),81);
  I:=0;
  repeat
   mgOemString:=mgOemString+chr(GetByte(ptr(PMSEG,I)));
   inc(I);
  until (I=80) or (xGetByte(ptr(PMSEG,0),I)=0);
  if (VBEInfo.VBEVersion=$202) and (mgOEMString='VORTEX')
   then VBEInfo.VBEVersion:=$102;
  FreeSelector(PMSEG);
  PMSEG:=HiWord(LongInt(VBEInfo.VideoModePtr));
  PMOFS:=LongInt(VBEInfo.VideoModePtr);
  PMSEG:=NewSelector(LongAdd(LongShl(PMSEG,4),PMOFS),256);
  i:=0; j:=0;
  repeat
   if GetWord(ptr(PMSEG,j*2))>=$100 then begin
    ModesList[i]:=GetWord(ptr(PMSEG,j*2));
    inc(i);
   end;
   inc(j);
  until (i=99) or (GetWord(ptr(PMSEG,j*2))=$FFFF);
  ModesList[i]:=$FFFF;
  FreeSelector(PMSEG);
  CreateModeTable(@ModesList);
{$ELSE}
  I:=0;
  repeat
   mgOemString:=mgOemString+chr(xGetByte(VBEInfo.OEMStringPtr,I));
   inc(I);
  until (I=80) or (xGetByte(VBEInfo.OEMStringPtr,I)=0);
  i:=0; j:=0;
  repeat
   if GetWord(GetPtr(VBEInfo.VideoModePtr,j*2))>=$100 then begin
    ModesList[i]:=GetWord(GetPtr(VBEInfo.VideoModePtr,j*2));
    inc(i);
   end;
   inc(j);
  until (i=99) or (GetWord(GetPtr(VBEInfo.VideoModePtr,j*2))=$FFFF);
  ModesList[i]:=$FFFF;
  CreateModeTable(@ModesList);
{$ENDIF}
  VideoSEG:=SSEG;
 end;

 procedure SetTextMode; assembler;
      asm
        call    near ptr ResetAddr
        mov     ax,$3
        int     $10
 end;

 procedure SetModeVariables; near;
 begin
  mgActivePage:=0;
  mgVisualPage:=0;
  ScrX:=mgXRes;
  ScrY:=mgYRes;
  if (mgXRes>0) and (mgYRes>0) then mgAspectRatio:=(mgYRes/mgXRes)*1.344;
  SetWindow(0,0,mgXRes-1,mgYRes-1);
 end;

 function SetVBEMode(Mode: Word): Boolean;
 var ModeInfo: TVBEModeInfoBlock;
 begin
  ResetAddr;
  if not UseVBE then begin
   SetVBEMode:=false; exit;
  end;
  if (not GetVBEModeInfo(Mode,ModeInfo)) or (Mode<$100) then begin
   SetVBEMode:=false; exit;
  end;
  if not VBESetMode(Mode) then begin
   SetVBEMode:=false; exit;
  end;
  case Mode of
   $100: begin ModeInfo.XResolution:=640;  ModeInfo.YResolution:=400; end;
   $101: begin ModeInfo.XResolution:=640;  ModeInfo.YResolution:=480; end;
   $103: begin ModeInfo.XResolution:=800;  ModeInfo.YResolution:=600; end;
   $105: begin ModeInfo.XResolution:=1024; ModeInfo.YResolution:=768; end;
  end;
  if (ModeInfo.BitsPerPixel<=4) or (ModeInfo.XResolution=0) or
     (ModeInfo.BytesPerScanLine=0) or (ModeInfo.YResolution=0) or
     ((ModeInfo.ModeAttributes and $1B)<>$1B) then begin
     SetVBEMode:=false; exit;
  end;
  mgWinGran:=ModeInfo.WinGranularity;
  mgBitsPerPixel:=ModeInfo.BitsPerPixel;
  mgBytesPerLine:=ModeInfo.BytesPerScanLine;
  mgXRes:=ModeInfo.XResolution;
  mgYRes:=ModeInfo.YResolution;
  case mgBitsPerPixel of
   4 : begin
        ResetAddr;
        mgColorMode:=grSVGA16;
        mgBytesPerPixel:=0;
        mgMaxColor:=15;
        Badd:=0; BShl:=0;
       end;
   8 : begin
        HLineAddr:=@HLineSVGA256;
        mgColorMode:=grSVGA256;
        mgBytesPerPixel:=1;
        PutLineAddr:=Ofs(SVGAPutLine);
        MaskLineAddr:=Ofs(SVGA256MaskLine);
        WriteLineAddr:=Ofs(SVGAPutLine);
        GetLineAddr:=Ofs(SVGAGetLine);
        PutPixAddr:=@PutPixelSVGA256;
        PutPixelAddr:=PutPixAddr;
        IncPointer(PutPixelAddr,3);
        GetPixAddr:=@GetPixelSVGA256;
        GetPixelAddr:=GetPixAddr;
        IncPointer(GetPixelAddr,3);
        ClearAddr:=@ClearPageSVGA256;
        mgMaxColor:=255;
        Badd:=0; Bshl:=0;
       end;
   15: begin
        HLineAddr:=@HLineSVGA32K;
        mgColorMode:=grSVGA32K;
        mgBytesPerPixel:=2;
        PutLineAddr:=Ofs(SVGAPutLine);
        MaskLineAddr:=Ofs(SVGA32KMaskLine);
        WriteLineAddr:=Ofs(SVGAPutLine);
        GetLineAddr:=Ofs(SVGAGetLine);
        PutPixAddr:=@PutPixelSVGA32K;
        PutPixelAddr:=PutPixAddr;
        IncPointer(PutPixelAddr,3);
        GetPixAddr:=@GetPixelSVGA32K;
        GetPixelAddr:=GetPixAddr;
        IncPointer(GetPixelAddr,3);
        ClearAddr:=@ClearPageSVGA32K;
        mgMaxColor:=32767;
        Badd:=0; BShl:=1;
       end;
   16: begin
        HLineAddr:=@HLineSVGA32K;
        mgColorMode:=grSVGA64K;
        mgBytesPerPixel:=2;
        PutLineAddr:=Ofs(SVGAPutLine);
        MaskLineAddr:=Ofs(SVGA32KMaskLine);
        WriteLineAddr:=Ofs(SVGAPutLine);
        GetLineAddr:=Ofs(SVGAGetLine);
        PutPixAddr:=@PutPixelSVGA32K;
        PutPixelAddr:=PutPixAddr;
        IncPointer(PutPixelAddr,3);
        GetPixAddr:=@GetPixelSVGA32K;
        GetPixelAddr:=GetPixAddr;
        IncPointer(GetPixelAddr,3);
        ClearAddr:=@ClearPageSVGA32K;
        mgMaxColor:=65535;
        Badd:=0; BShl:=1;
       end;
   24: begin
        HLineAddr:=@HLineSVGA16m;
        mgColorMode:=grSVGA16M;
        mgBytesPerPixel:=3;
        PutLineAddr:=Ofs(SVGAPutLine);
        MaskLineAddr:=Ofs(SVGA16MMaskLine);;
        WriteLineAddr:=Ofs(SVGAPutLine);
        GetLineAddr:=Ofs(SVGAGetLine);
        PutPixAddr:=@PutPixelSVGA16M;
        PutPixelAddr:=PutPixAddr;
        IncPointer(PutPixelAddr,3);
        GetPixAddr:=@GetPixelSVGA16M;
        GetPixelAddr:=GetPixAddr;
        IncPointer(GetPixelAddr,3);
        ClearAddr:=@ClearPageSVGA16M;
        mgMaxColor:=16777215;
        Badd:=$FFFF; Bshl:=1;
       end;
   32: begin
        HLineAddr:=@HLineSVGA4G;
        mgColorMode:=grSVGA4G;
        mgBytesPerPixel:=4;
        PutLineAddr:=Ofs(SVGAPutLine);
        MaskLineAddr:=Ofs(SVGA4GMaskLine);
        WriteLineAddr:=Ofs(SVGAPutLine);
        GetLineAddr:=Ofs(SVGAGetLine);
        PutPixAddr:=@PutPixelSVGA4G;
        PutPixelAddr:=PutPixAddr;
        IncPointer(PutPixelAddr,3);
        GetPixAddr:=@GetPixelSVGA4G;
        GetPixelAddr:=GetPixAddr;
        IncPointer(GetPixelAddr,3);
        ClearAddr:=@ClearPageSVGA4G;
        mgMaxColor:=16777215;
        Badd:=0; BShl:=2;
       end;
  end;
  {if mgVBEVersion>=$200 then begin}
  { SetStartAddrWR:=Ofs(VBEFunc07W2);}
  { SetStartAddrNW:=Ofs(VBEFunc07NW);}
  {end else begin}
   SetStartAddrWR:=Ofs(VBEFunc07W1);
   SetStartAddrNW:=Ofs(VBEFunc07NW);
  {end;}
  mgWorkMem:=LongShl(mgVBEMem,10);
  mgMaxY:=LongDiv(mgWorkMem,mgBytesPerLine);
  MaxPages:=ModeInfo.NumberOfImagePages+1;
  PageSize:=LongMul(mgBytesPerLine,mgYRes);
  if not mgUseMaxPages then mgMaxPages:=MaxPages
   else mgMaxPages:=LongDiv(mgWorkMem,PageSize);
  mgRedAjast:=8-ModeInfo.RedMaskSize;
  mgRedMask:=$FF shr mgRedAjast;
  mgRedPos:=ModeInfo.RedFieldPosition;
  mgGreenAjast:=8-ModeInfo.GreenMaskSize;
  mgGreenMask:=$FF shr mgGreenAjast;
  mgGreenPos:=ModeInfo.GreenFieldPosition;
  mgBlusAjast:=8-ModeInfo.BlueMaskSize;
  mgBlueMask:=$FF shr mgBlusAjast;
  mgBlusPos:=ModeInfo.BlueFieldPosition;
  mgCurBank:=$FFFF;
  if (ModeInfo.WinAAttributes and $07)<>$07 then begin
{$IFDEF MSDOS}
   BankFuncPtr:=ModeInfo.WinFuncPtr;
   if BankFuncPtr<>nil then mgBankAddr:=@FSetBankAB else mgBankAddr:=@SetBankAB;
{$ELSE}
   mgBankAddr:=@SetBankAB;
{$ENDIF}
  end else begin
{$IFDEF MSDOS}
   BankFuncPtr:=ModeInfo.WinFuncPtr;
   if BankFuncPtr<>nil then mgBankAddr:=@FSetBankA else mgBankAddr:=@SetBankA;
{$ELSE}
   mgBankAddr:=@SetBankA;
{$ENDIF}
  end;
  PrepareBankTable;
  SetScreenStart(0,0,false);
  SetModeVariables;
  SetVBEMode:=true;
 end;

 function  SetSVGAMode(XRes,YRes: Word; ColorMode: Byte): Boolean;
 var i,VMode: Word;
 begin
  i:=0; VMode:=0;
  repeat
   if (mgVBEModesList[i].XRes=XRes) and (mgVBEModesList[i].YRes=YRes) and
      (mgVBEModesList[i].ColorMode=ColorMode) then VMode:=mgVBEModesList[i].VideoMode;
   inc(i);
  until i>=mgVBEModes;
  if VMode>0 then SetSVGAMode:=SetVBEMode(VMode) else SetSVGAMode:=false;
 end;
{----------------------------------------------------------------------------
 Original Code:
 XLib by Themie Gouthas
----------------------------------------------------------------------------}
 procedure DoModeX(Mode: Byte); near; assembler;
      asm
        xor     cx,cx
        mov     cl,[Mode]
        push    cx
        mov     ax,13h
        int     10h
        pop     cx
        mov     dx,SEQU_ADDR
        mov     ax,0604h
        out     dx,ax
        mov     ax,0100h
        out     dx,ax
        les     bx,ModeTablePtr
        shl     cx,2
        add     bx,cx
        mov     si,word ptr [bx]
        mov     ax,word ptr [bx+2]
        dw      $E08E
        cld
        db      $64
        lodsb
        or      al,al
        jz      @DontSetDot
        mov     dx,MISC_ADDR
        out     dx,al
@DontSetDot:
        mov     dx,SEQU_ADDR
        mov     ax,0300h
        out     dx,ax
        mov     dx,CRTC_ADDR
        mov     al,11h
        out     dx,al
        inc     dx
        in      al,dx
        and     al,07Fh
        out     dx,al
        dec     dx
        xor     cx,cx
        db      $64
        lodsb
        mov     cl,al
@ParmsLoop:
        db      $64
        lodsw
        out     dx,ax
        loop    @ParmsLoop
        mov     dx,SEQU_ADDR
        mov     ax,0F02h
        out     dx,ax
        mov     es,[VideoSEG]
        xor     di,di
        xor     ax,ax
        mov     cx,8000h
        rep     stosw
        db      $64
        lodsw
        mov     [mgXRes],ax
        mov     bx,ax
        shr     ax,2
        mov     [mgBytesPerLine],ax
        db      $64
        lodsw
        mov     [mgYRes],ax
        mov     dx,CRTC_ADDR
        mov     al,$13
        out     dx,al
        inc     dx
        mov     ax,bx
        shr     ax,3
        out     dx,al
 end;

 function  VGAPresent: Boolean; near; assembler;
      asm
        mov     ax,$1A00
        int     $10
        cmp     al,$1A
        jne     @NonVGA
        cmp     bl,$07
        je      @ItVGA
        cmp     bl,$08
        je      @ItVGA
@NonVGA:
        xor     ax,ax
        retn
@ItVGA: mov     ax,1
 end;

 procedure SetMCGA; near; assembler;
      asm
        mov     ax,$13
        int     $10
 end;

 function  SetModeX(Mode: Byte): Boolean;
 begin
  if (not VGAPresent) or (Mode>ModeX376x564) then SetModeX:=false else begin
   VideoSEG:=SSEG;
   ModeTablePtr:=@ModeTable;
   mgWorkMem:=262144;
   DoModeX(Mode);
   mgBytesPerPixel:=1;
   mgBitsPerPixel:=8;
   PutPixAddr:=@PutPixelModeX;
   PutPixelAddr:=PutPixAddr;
   IncPointer(PutPixelAddr,3);
   ClearAddr:=@ClearPageModeX;
   GetPixAddr:=@GetPixelModeX;
   GetPixelAddr:=GetPixAddr;
   IncPointer(GetPixelAddr,3);
   SetStartAddrNW:=Ofs(ModeXSetStartNW);
   SetStartAddrWR:=Ofs(ModeXSetStartW0);
   HLineAddr:=@HLineModeX;
   PutLineAddr:=Ofs(ModeXPutLine);
   MaskLineAddr:=Ofs(ModeXMaskLine);
   WriteLineAddr:=Ofs(ModeXPutLine);
   GetLineAddr:=Ofs(ModeXGetLine);
   mgMaxColor:=255;
   PageSize:=LongMul(mgXRes,mgYRes);
   MaxPages:=LongDiv(mgWorkMem,PageSize);
   mgMaxPages:=MaxPages;
   mgColorMode:=grModeX;
   SetModeVariables;
   MaxLine:=MaxScan[Mode];
   SetModeX:=true;
   Badd:=0; Bshl:=0;
  end;
 end;

 procedure SetMCGAMode;
 begin
  SetMCGA;
  VideoSEG:=SSEG;
  mgXRes:=320;
  mgYRes:=200;
  mgWorkMem:=64000;
  mgBytesPerLine:=mgXRes;
  mgBytesPerPixel:=1;
  mgBitsPerPixel:=8;
  PutPixAddr:=@PutPixelMCGA;
  PutPixelAddr:=PutPixAddr;
  IncPointer(PutPixelAddr,3);
  ClearAddr:=@ClearPageMCGA;
  GetPixAddr:=@GetPixelMCGA;
  GetPixelAddr:=GetPixAddr;
  IncPointer(GetPixelAddr,3);
  PutLineAddr:=Ofs(MCGAPutLine);
  WriteLineAddr:=Ofs(MCGAPutLine);
  MaskLineAddr:=Ofs(MCGAMaskLine);
  GetLineAddr:=Ofs(MCGAGetLine);
  SetStartAddrNW:=Ofs(Dummy2);
  SetStartAddrWR:=Ofs(Dummy2);
  HLineAddr:=@HLineMCGA;
  mgMaxColor:=255;
  mgMaxPages:=1;
  PageSize:=64000;
  mgColorMode:=grMCGA;
  SetModeVariables;
  Badd:=0; Bshl:=0;
 end;

 function SetVirtual: Boolean;
 begin
  if (VirAddr<>nil) or (mgColorMode<>grMCGA) then begin
   SetVirtual:=false;
   exit;
  end;
{$IFDEF DPMI}
  GetBuffer(VirAddr,64321);
  FillChar(VirAddr^,64321,0);
{$ELSE}
  GetMem(VirAddr,64336);
  FillChar(VirAddr^,64336,0);
{$ENDIF}
  if VirAddr=nil then begin
   SetVirtual:=false;
   exit;
  end;
{$IFDEF MSDOS}
  VideoSEG:=SEG(VirAddr^)+1;
{$ELSE}
  VideoSEG:=SEG(VirAddr^);
{$ENDIF}
  SetVirtual:=true;
 end;

 function SetNormal: Boolean;
 begin
  if (VirAddr=nil) or (mgColorMode<>grMCGA) then begin
   SetNormal:=false;
   exit;
  end;
{$IFDEF DPMI}
  FreeBuffer(VirAddr,64321);
{$ELSE}
  FreeMem(VirAddr,64336);
{$ENDIF}
  VideoSEG:=SSEG;
  VirAddr:=nil;
  SetNormal:=true;
 end;

 procedure StoreVirtual; assembler;
      asm
        cmp     [mgColorMode],grMCGA
        jnz     @Quit
        push    ds
        cld
        mov     es,[VideoSEG]
        mov     ds,SSEG
        xor     di,di
        xor     si,si
        mov     cx,16000
        db      $66
        rep     movsw
        pop     ds
@Quit:
 end;

 procedure RestoreVirtual; assembler;
      asm
        cmp     [mgColorMode],grMCGA
        jnz     @Quit
        push    ds
        cld
        mov     es,SSEG
        mov     ds,[VideoSEG]
        xor     di,di
        xor     si,si
        mov     cx,16000
        db      $66
        rep     movsw
        pop     ds
@Quit:
 end;

 procedure SwapVirtual; assembler;
      asm
        cmp     [mgColorMode],grMCGA
        jnz     @Quit
        push    ds
        cld
        mov     es,SSEG
        mov     ds,[VideoSEG]
        xor     di,di
        xor     si,si
        mov     cx,16000
@Loop1: db      $66
        mov     bx,es:[di]
        db      $66
        mov     ax,ds:[si]
        db      $66
        mov     ds:[si],bx
        db      $66
        stosw
        add     si,4
        loop    @Loop1
        pop     ds
@Quit:
 end;

 function GetScreenAddr: Pointer; assembler;
      asm
        mov     dx,[VideoSEG]
        xor     ax,ax
 end;

 procedure SetActivePage(PageNo: Byte);
 begin
  if mgColorMode>=grSVGA256 then begin
   if mgMaxPages>PageNo then begin
    mgBankOffset:=LongShr(LongMul(LongMul(mgBytesPerLine,ScrY),PageNo),16);
    mgPixOffset:=Word(LongMul(LongMul(mgBytesPerLine,ScrY),PageNo));
    mgActivePage:=PageNo;
   end;
  end;
  if mgColorMode=grModeX then begin
   if mgMaxPages>PageNo then begin
    mgPixOffset:=LongMul(PageNo,mgBytesPerLine*ScrY);
    mgActivePage:=PageNo;
   end;
  end;
 end;

 procedure SetVisualPage(PageNo: Byte; WaitForRetrace: Boolean); assembler;
      asm
        mov     bx,[ScrY]
        xor     ax,ax
        mov     al,[PageNo]
        mov     [mgVisualPage],ax
        mul     bx
        mov     dx,ax
        xor     cx,cx
        cmp     [WaitForRetrace],0
        jz      @DoNotWait
        call    word ptr [SetStartAddrWR]
        leave
        retf    4
@DoNotWait:
        call    word ptr [SetStartAddrNW]
 end;

 function SetScreenStart(X,Y: Word; WaitForRetrace: Boolean): Boolean; assembler;
      asm
        mov     cx,[X]
        mov     dx,[Y]
        cmp     [WaitForRetrace],0
        jz      @DoNotWait
        call    word ptr [SetStartAddrWR]
        leave
        retf    6
@DoNotWait:
        call    word ptr [SetStartAddrNW]
 end;

 procedure SetWindow(X,Y,X1,Y1: Word);
 var MaxX,mgMaxY: Word;
 begin
  MaxX:=mgBytesPerLine;
  if (X1<=X) or (Y1<=Y) or (X1>=ScrX) or (Y1>=ScrY) then exit;
  WX:=X; WY:=Y; WX1:=X1; WY1:=Y1;
  WXb:=WX*Word(mgBytesPerPixel);
  WXb1:=WX1*Word(mgBytesPerPixel);
 end;

 var ScStatus: Boolean;

 function SetScanLine (Pixels: Word): Word; assembler;
      asm
        cmp     [mgColorMode],grMCGA
        jg      @Cont
@Cont:  cmp     [mgColorMode],grModeX
        jnz     @SVGA
@ModeX: mov     ax,[Pixels]
        and     ax,$FFF8
        cmp     ax,[mgXRes]
        jge     @Pass
        mov     ax,[mgXRes]
@Pass:  mov     dx,CRTC_ADDR
        mov     al,$13
        out     dx,al
        inc     dx
        mov     ax,[Pixels]
        push    ax
        shr     ax,3
        out     dx,al
        pop     ax
        push    ax
        shr     ax,2
        mov     [mgBytesPerLine],ax
        pop     ax
        jmp     @Ok
@SVGA:  mov     cx,[Pixels]
        cmp     cx,[mgXRes]
        jge     @DoIt
        mov     cx,[mgXRes]
@DoIt:  mov     ax,$4F06
        xor     bx,bx
        int     $10
        cmp     ax,VBEStatusOk
        jnz     @Fail
        mov     ax,cx
        mov     [mgBytesPerLine],bx
        mov     [mgMaxY],dx
        jmp     @Ok
@Fail:  xor     ax,ax
@Ok:
 end;

 function SetLogicalSize(SX,SY: Word): Boolean;
 var LB,LX,LY: Word;
 begin
  if (mgColorMode=grModeX) and (SX>MaxLine) then SX:=MaxLine;
  LX:=ScrX;
  LY:=mgMaxY;
  LB:=mgBytesPerLine;
  ScrX:=SetScanLine(SX);
  if (ScrX<mgXRes) or ((mgMaxY<mgYRes) and (mgColorMode>grModeX)) or (mgBytesPerLine=0) then begin
   ScrX:=LX;
   mgMaxY:=LY;
   mgBytesPerLine:=LB;
   SetLogicalSize:=false;
   exit;
  end else SetLogicalSize:=true;
  if mgColorMode=grModeX then mgMaxY:=LongDiv(mgWorkMem,ScrX);
  if SY<=mgMaxY then ScrY:=SY else ScrY:=mgMaxY;
  case mgColorMode of
   grText,grMCGA:  mgMaxPages:=1;
   grModeX: mgMaxPages:=LongDiv(mgWorkMem,LongMul(ScrX,ScrY))
   else begin
    mgMaxPages:=LongDiv(mgWorkMem,LongMul(mgBytesPerLine,ScrY));
    if (mgMaxPages>MaxPages) and (not mgUseMaxPages) then mgMaxPages:=MaxPages;
   end;
  end;
  if mgColorMode=grModeX then PageSize:=LongMul(ScrX,ScrY)
  else PageSize:=LongMul(mgBytesPerLine,ScrY);
  SetWindow(0,0,SX-1,SY-1);
 end;

 procedure GetLogicalSize(var SX,SY: Word);
 begin
  SX:=ScrX; SY:=ScrY;
 end;

 function  GetMaxX: Word; assembler;
      asm
        mov     ax,[ScrX]
        dec     ax
 end;

 function  GetMaxY: Word; assembler;
      asm
        mov     ax,[ScrY]
        dec     ax
 end;

 procedure GetWindow(var X,Y,X1,Y1: Word);
 begin
  X:=WX; Y:=WY; X1:=WX1; Y1:=WY1;
 end;

 function  RGBColor(R,G,B: Byte): LongInt; assembler;
      asm
        db      $66
        xor     ax,ax
        db      $66
        xor     bx,bx
        db      $66
        xor     dx,dx
        mov     al,[R]
        and     al,[mgRedMask]
        mov     cl,[mgRedPos]
        db      $66
        shl     ax,cl
        mov     bl,[G]
        and     bl,[mgGreenMask]
        mov     cl,[mgGreenPos]
        db      $66
        shl     bx,cl
        mov     dl,[B]
        and     dl,[mgBlueMask]
        mov     cl,[mgBlusPos]
        db      $66
        shl     dx,cl
        db      $66
        or      ax,bx
        db      $66
        or      ax,dx
        db      $66
        push    ax
        pop     ax
        pop     dx
 end;

 procedure ClearVideoMem; assembler;
      asm
        cld
        cmp     [mgColorMode],grSVGA256
        jl      @ModeX
@SVGA:  cmp     [mgCurBank],0
        je      @Next1
        xor     ax,ax
        call    dword ptr [mgBankAddr]
@Next1: mov     es,SSEG
        xor     di,di
        mov     cx,[mgVBEMem]
        shr     cx,6
@Loop:  push    cx
        db      $66
        xor     ax,ax
        mov     cx,16384
        db      $66
        rep     stosw
        mov     ax,[mgCurBank]
        inc     ax
        call    dword ptr [mgBankAddr]
        pop     cx
        loop    @Loop
        retf
@ModeX: cmp     [mgColorMode],grModeX
        jnz     @MCGA
        mov     cx,16384
        mov     dx,SEQU_ADDR
        mov     es,SSEG
        db      $66
        xor     bx,bx
        pushf
        mov     ax,$0F02
@LoopX: push    ax
        out     dx,ax
        push    cx
        xor     di,di
        db      $66
        mov     ax,bx
        db      $66
        rep     stosw
        pop     cx
        pop     ax
        shr     ah,1
        jnc     @LoopX
        popf
@MCGA:
 end;

 procedure ClearPage; assembler;
      asm
        jmp     dword ptr [ClearAddr]
 end;

 procedure PutPoint(X,Y: Integer; Color: LongInt); assembler;
      asm
        mov     bx,X
        mov     dx,Y
        cmp     bx,[WX]
        jl      @Failed
        cmp     dx,[WY]
        jl      @Failed
        cmp     bx,[WX1]
        jg      @Failed
        cmp     dx,[WY1]
        jg      @Failed
        jmp     dword ptr [PutPixelAddr]
@Failed:
 end;

 function  GetPoint(X,Y: Integer): LongInt; assembler;
      asm
        mov     bx,X
        mov     dx,Y
        cmp     bx,[WX]
        jl      @Failed
        cmp     dx,[WY]
        jl      @Failed
        cmp     bx,[WX1]
        jg      @Failed
        cmp     dx,[WY1]
        jg      @Failed
        jmp     dword ptr [GetPixelAddr]
@Failed:
 end;


 procedure DrawHLine(X1,X2,Y: Integer; Color: LongInt); assembler;
      asm
        mov     ax,X1
        cmp     ax,[X2]
        jg      @Quit
        push    X1
        push    X2
        push    Y
        db      $66
        push    word ptr Color
        call    dword ptr [HLineAddr]
@Quit:
 end;

{----------------------------------------------------------------------------
 Original code:
 VGAKit v 4.1 Copiright (C) 1991 by John Bridges
----------------------------------------------------------------------------}
 procedure xDrawLine(X1,Y1,X2,Y2: Integer; Color: LongInt); assembler;
 var Cnt, Acc, xLineStyle: Integer;
     DeltaX, DeltaY, DirX, DirY, NwX, NwX1, NwY, NwY1: Integer;
      asm
        mov     ax,[mgLineStyle]
        mov     [xLineStyle],ax
        db      $66
        mov     bx,word ptr Color
        mov     si,X1
        mov     di,Y1
        xor     ax,ax
        mov     [acc],ax
        mov     ax,X2
        sub     ax,si
        mov     dx,1
        jns     @nosx
        neg     ax
        mov     dx,-1
@nosx:  mov     [dirx],dx
        mov     [deltax],ax
        mov     ax,Y2
        sub     ax,di
        mov     dx,1
        jns     @nosy
        neg     ax
        mov     dx,-1
@nosy:  mov     [diry],dx
        mov     [deltay],ax
        cmp     ax,[deltax]
        jge     @ylp
        push    di
        push    si
        ror     word ptr [xLineStyle],1
        jnc     @a10
        push    si
        push    di
        db      $66
        push    bx
        call    dword ptr [PutPixAddr]
@a10:   pop     si
        pop     di
        mov     ax,[deltax]
        mov     [cnt],ax
@lp1:   dec     [cnt]
        js      @done
        add     si,[dirx]
        mov     ax,[deltay]
        add     [acc],ax
        mov     ax,[acc]
        cmp     ax,[deltax]
        jb      @noincy
        mov     ax,[deltax]
        sub     [acc],ax
        add     di,[diry]
@noincy:
        push    di
        push    si
        ror     word ptr [xLineStyle],1
        jnc     @b10
        push    si
        push    di
        db      $66
        push    bx
        call    dword ptr [PutPixAddr]
@b10:   pop     si
        pop     di
        jmp     @lp1
@ylp:   push    di
        push    si
        ror     word ptr [xLineStyle],1
        jnc     @c10
        push    si
        push    di
        db      $66
        push    bx
        call    dword ptr [PutPixAddr]
@c10:   pop     si
        pop     di
        mov     ax,[deltay]
        mov     [cnt],ax
@lp2:   dec     [cnt]
        js      @done
        add     di,[diry]
        mov     ax,[deltax]
        add     [acc],ax
        mov     ax,[acc]
        cmp     ax,[deltay]
        jb      @noincx
        mov     ax,[deltay]
        sub     [acc],ax
        add     si,[dirx]
@noincx:
        push    di
        push    si
        ror     word ptr [xLineStyle],1
        jnc     @d10
        push    si
        push    di
        db      $66
        push    bx
        call    dword ptr [PutPixAddr]
@d10:   pop     si
        pop     di
        jmp     @lp2
@done:
 end;

 function ClipLine (var x1, y1, x2, y2: Integer;
  left, top, right, bottom: Integer): Boolean;
 var
  outcode1,outcode2: Integer;     { Outcodes for the two endpoints  }
  outcodeOut: Integer;            { Outcode of endpoint outside     }
  x,y,dx,dy: Real;

 function MulDiv (A,B,C: Real): Real;
 begin
  MulDiv:=A*B/C;
 end;

 procedure SETOUTCODES(var outcode: Integer; x,y: Real);
 begin
  outcode:= 0;
  if (y > bottom) then outcode:= outcode or 1;
  if (y < top) then outcode:= outcode or 2;
  if (x > right) then outcode:= outcode or 4;
  if (x < left) then outcode:= outcode or 8;
 end;

 begin
 { Set up the initial 4 bit outcodes }
  outcode1:=0;
  outcode2:=0;
  outcodeOut:=0;
  SETOUTCODES(outcode1,x1,y1);
  SETOUTCODES(outcode2,x2,y2);
  if (outcode1 and outcode2)<>0 then begin
   ClipLine:=false;
   exit;
  end;
  if ((outcode1 or outcode2))=0 then begin
   ClipLine:=true;
   exit;
  end;
  dx:= x2 - x1;  { Compute dx and dy once only }
  dy:= y2 - y1;

  repeat
   (* Determine which endpoint is currently outside of clip rectangle *)
   (* and pick it to be clipped.                                      *)

   if (outcode2)<>0 then outcodeOut:= outcode2 else outcodeOut:= outcode1;

   (* Clip the endpoint to                    *)
   (* one of the appropriate boundaries...    *)

   if (outcodeOut and 1)<>0 then begin
    x:= x1 + MulDiv(dx,bottom-1-y1,dy);
    y:= bottom-1;
   end
   else if (outcodeOut and 2)<>0 then begin
    x:= x1 + MulDiv(dx,top-y1,dy);
    y:= top;
   end
   else if (outcodeOut and 4)<>0 then begin
    y:= y1 + MulDiv(dy,right-1-x1,dx);
    x:= right-1;
   end
   else begin
    y:= y1 + MulDiv(dy,left-x1,dx);
    x:= left;
   end;

   if (outcodeOut = outcode1) then begin
    x1:=Round(x); y1:=Round(y);
    SETOUTCODES(outcode1,x,y);
   end
   else begin
    x2:=Round(x); y2:=Round(y);
    SETOUTCODES(outcode2,x,y);
   end;

   if (outcode1 and outcode2)<>0 then begin
    ClipLine:=false;
    exit;
   end;
   if ((outcode1 or outcode2))=0 then begin
    ClipLine:=true;
    exit;
   end;
  until false;
 end;

 procedure DrawLine(X1,Y1,X2,Y2: Integer; Color: LongInt);
 begin
  if ClipLine(X1,Y1,X2,Y2,WX,WY,WX1,WY1) then xDrawLine(X1,Y1,X2,Y2,Color);
  if not mgThickLine then exit;

  if Abs(X2-X1)>Abs(Y2-Y1) then begin
   Y1:=Y1+1;
   Y2:=Y2+1;
   if ClipLine(X1,Y1,X2,Y2,WX,WY,WX1,WY1) then xDrawLine(X1,Y1,X2,Y2,Color);
   Y1:=Y1-2;
   Y2:=Y2-2;
   if ClipLine(X1,Y1,X2,Y2,WX,WY,WX1,WY1) then xDrawLine(X1,Y1,X2,Y2,Color);
  end else begin
   X1:=X1+1;
   X2:=X2+1;
   if ClipLine(X1,Y1,X2,Y2,WX,WY,WX1,WY1) then xDrawLine(X1,Y1,X2,Y2,Color);
   X1:=X1-2;
   X2:=X2-2;
   if ClipLine(X1,Y1,X2,Y2,WX,WY,WX1,WY1) then xDrawLine(X1,Y1,X2,Y2,Color);
  end;
 end;

 procedure DrawRectangle(X1,Y1,X2,Y2: Integer; Color: LongInt); assembler;
      asm
        push    mgLineStyle
        mov     [mgLineStyle],$FFFF
        push    X1
        push    X2
        push    Y1
        db      $66
        push    word ptr Color
        call    far ptr DrawHLine
        push    X1
        push    Y1
        push    X1
        push    Y2
        db      $66
        push    word ptr Color
        call    far ptr DrawLine
        push    X2
        push    Y1
        push    X2
        push    Y2
        db      $66
        push    word ptr Color
        call    far ptr DrawLine
        push    X1
        push    X2
        push    Y2
        db      $66
        push    word ptr Color
        call    far ptr DrawHLine
        pop     mgLineStyle
 end;

 procedure GenerateEOctant(MinorAjast,Threshold,MajorSquared,MinorSquared:
                           LongInt); near; assembler;
      asm
        mov     word ptr [PixListLen],0
        db      $66
        mov     ax,word ptr [MajorSquared]
        db      $66
        shl     ax,1
        db      $66
        mov     dx,ax                           {EDX=MajorSquaredTimes2}
        db      $66
        mov     ax,word ptr [MinorSquared]
        db      $66
        shl     ax,1
        db      $66
        mov     si,ax                           {ESI=MinorSquaredTimes2}
        les     di,mgBufferPtr
        db      $66
        xor     cx,cx                           {ECX=MajorAjast}
        db      $66
        mov     bx,word ptr [Threshold]         {EBX=Threshold}
@GenLoop:
        db      $66
        add     bx,cx
        mov     byte ptr es:[di],0
        db      $66
        add     bx,word ptr [MinorSquared]
        js      @MoveMajor
        db      $66
        mov     ax,dx
        db      $66
        sub     word ptr [MinorAjast],ax
        db      $66
        sub     bx,word ptr [MinorAjast]
        mov     byte ptr es:[di],1
@MoveMajor:
        inc     di
        inc     word ptr [PixListLen]
        db      $66
        add     cx,si
        db      $66
        cmp     cx,word ptr [MinorAjast]
        jb      @GenLoop
 end;

{--------------------------------------------------------------------------
 Original code:
 'Zen Of Graphic Programming', Copyright (C) 1995 by Michael Abrash
---------------------------------------------------------------------------}
 procedure DrawEllipse(X,Y: Integer; A,B: Integer; Color: LongInt);
 var ASquared,BSquared: LongInt;
 procedure DrawVOctant(X,Y: Integer; DrawLen: Word; YDir,
                       HMoveDir: Integer; mgBufferPtr: Pointer); near;
 var CX,CY,I: Integer; DrawList: Pointer;
 begin
  DrawList:=mgBufferPtr;
  CX:=X; CY:=Y;
  for I:=1 to DrawLen do begin
   PutPoint(CX,CY,Color);
   if Byte(DrawList^)=1 then inc(CX,HMoveDir);
   inc(CY,YDir);
   IncPtr(DrawList);
  end;
 end;
 procedure DrawHOctant(X,Y: Integer; DrawLen: Word; YDir,
                       HMoveDir: Integer; mgBufferPtr: Pointer); near;
 var CX,CY,I: Integer; DrawList: Pointer;
 begin
  DrawList:=mgBufferPtr;
  CX:=X; CY:=Y;
  for I:=1 to DrawLen do begin
   PutPoint(CX,CY,Color);
   if Byte(DrawList^)=1 then inc(CY,YDir);
   inc(CX,HMoveDir);
   IncPtr(DrawList);
  end;
 end;
 begin
  if (A=0) or (B=0) then exit;
  ASquared:=LongMul(A,A);
  BSquared:=LongMul(B,B);
  GenerateEOctant(LongMul(ASquared,2*B),
   LongSub(LongDiv(ASquared,4),LongMul(ASquared,B)),ASquared,BSquared);
  DrawHOctant(X,Y-B,PixListLen,1,-1,mgBufferPtr);
  DrawHOctant(X+1,Y-B+Byte(mgBufferPtr^),PixListLen-1,1,1,GetPtr(mgBufferPtr,1));
  DrawHOctant(X,Y+B,PixListLen,-1,-1,mgBufferPtr);
  DrawHOctant(X+1,Y+B-Byte(mgBufferPtr^),PixListLen-1,-1,1,GetPtr(mgBufferPtr,1));
  GenerateEOctant(LongMul(BSquared,2*A),
   LongSub(LongDiv(BSquared,4),LongMul(BSquared,A)),BSquared,ASquared);
  DrawVOctant(X-A,Y,PixListLen,-1,1,mgBufferPtr);
  DrawVOctant(X-A+Byte(mgBufferPtr^),Y+1,PixListLen-1,1,1,GetPtr(mgBufferPtr,1));
  DrawVOctant(X+A,Y,PixListLen,-1,-1,mgBufferPtr);
  DrawVOctant(X+A-Byte(mgBufferPtr^),Y+1,PixListLen-1,1,-1,GetPtr(mgBufferPtr,1));
 end;

{--------------------------------------------------------------------------
 Original code:
 'Zen Of Graphic Programming', Copyright (C) 1995 by Michael Abrash
---------------------------------------------------------------------------}
 procedure FilledEllipse(X,Y: Integer; A,B: Integer; Color: LongInt);
 var ASquared,BSquared: LongInt;
 procedure FilledVOctant(X,Y: Integer; DrawLen: Word; YDir,
                       HMoveDir: Integer; mgBufferPtr: Pointer); near;
 var CX,CL,CY,I: Integer; DrawList: Pointer;
 begin
  DrawList:=mgBufferPtr;
  CX:=X; CY:=Y; CL:=CX+A shl 1;
  for I:=1 to DrawLen do begin
   DrawHLine(CX,CL,CY,Color);
   if Byte(DrawList^)=1 then begin inc(CX,HMoveDir); dec(CL,1); end;
   inc(CY,YDir);
   IncPtr(DrawList);
  end;
 end;

 procedure FilledHOctant(X,Y: Integer; DrawLen: Word; YDir,
                       HMoveDir: Integer; mgBufferPtr: Pointer); near;
 var CX,CY,CL,I: Integer; DrawList: Pointer;
 begin
  DrawList:=mgBufferPtr;
  CX:=X; CY:=Y; CL:=CX;
  DrawHLine(CX,CL,CY,Color);
  for I:=1 to DrawLen do begin
   if Byte(DrawList^)=1 then begin
    inc(CY,YDir); DrawHLine(CX,CL,CY,Color);
   end;
   inc(CX,HMoveDir);
   inc(CL,1);
   IncPtr(DrawList);
  end;
 end;

 begin
  if (A=0) or (B=0) then exit;
  ASquared:=LongMul(A,A);
  BSquared:=LongMul(B,B);
  GenerateEOctant(LongMul(ASquared,2*B),
   LongSub(LongDiv(ASquared,4),LongMul(ASquared,B)),ASquared,BSquared);
  FilledHOctant(X,Y+B,PixListLen,-1,-1,mgBufferPtr);
  FilledHOctant(X,Y-B,PixListLen,1,-1,mgBufferPtr);
  GenerateEOctant(LongMul(BSquared,2*A),
   LongSub(LongDiv(BSquared,4),LongMul(BSquared,A)),BSquared,ASquared);
  FilledVOctant(X-A,Y,PixListLen,-1,1,mgBufferPtr);
  FilledVOctant(X-A+Byte(mgBufferPtr^),Y+1,PixListLen-1,1,1,GetPtr(mgBufferPtr,1));

  if mgUseBorderColor then DrawEllipse(X,Y,A,B,mgBorderColor);
 end;

 procedure DrawCircle(X,Y: Integer; Radius: Word; Color: LongInt);
 begin
  DrawEllipse(X,Y,Radius,Round(Radius*mgAspectRatio),Color);
 end;

 procedure FilledCircle(X,Y: Integer; Radius: Word; Color: LongInt);
 begin
  FilledEllipse(X,Y,Radius,Round(Radius*mgAspectRatio),Color);
  if mgUseBorderColor then DrawCircle(X,Y,Radius,mgBorderColor);
 end;

 procedure DrawTriangle(X0,Y0,X1,Y1,X2,Y2: Integer; Color: LongInt); assembler;
      asm
        push    mgLineStyle
        mov     [mgLineStyle],$FFFF
        push    X0
        push    Y0
        push    X1
        push    Y1
        db      $66
        push    word ptr Color
        call    far ptr DrawLine
        push    X1
        push    Y1
        push    X2
        push    Y2
        db      $66
        push    word ptr Color
        call    far ptr DrawLine
        push    X2
        push    Y2
        push    X0
        push    Y0
        db      $66
        push    word ptr Color
        call    far ptr DrawLine
        pop     mgLineStyle
 end;

 procedure FilledRectangle(X1,Y1,X2,Y2: Integer; Color: LongInt); assembler;
      asm
        mov     cx,[Y1]
@Loop:  push    cx
        push    X1
        push    X2
        push    cx
        db      $66
        push    word ptr Color
        call    far ptr DrawHLine
        pop     cx
        inc     cx
        cmp     cx,Y2
        jbe     @Loop
        cmp     [mgUseBorderColor],1
        jnz     @Quit
        push    X1
        push    Y1
        push    X2
        push    Y2
        db      $66
        push    word ptr [mgBorderColor]
        call    far ptr DrawRectangle
@Quit:
 end;

{----------------------------------------------------------------------------
 Original Code:
 XLib by Themie Gouthas
----------------------------------------------------------------------------}
 procedure xFilledTriangle (X0,Y0,X1,Y1,X2,Y2: Integer; Color: LongInt); assembler;
 var DX01,DY01,DX02,DY02,DX12,DY12,DP01,DP02,DP12,XA01,XA02,XA12: Word;
      asm
        mov     ax,X0
        mov     bx,Y0
        mov     cx,X1
        mov     dx,Y1
        cmp     bx,dx
        jl      @Y0lY1
        je      @Y0eY1
        xchg    ax,cx
        xchg    bx,dx
@Y0lY1: cmp     dx,Y2
        jg      @Skip1
        jmp     @sorted
@Skip1: xchg    cx,X2
        xchg    dx,Y2
        cmp     bx,dx
        jge     @Skip2
        jmp     @sorted
@Skip2: je      @bot
        xchg    ax,cx
        xchg    bx,dx
        jmp     @sorted
@Y0eY1: cmp     bx,Y2
        jl      @bot
        jg      @Next
        leave
        ret     16
@Next:  xchg    ax,X2
        xchg    bx,Y2
        jmp     @sorted
@bot:   cmp     ax,cx
        jl      @botsorted
        jg      @bota
        leave
        ret     16
@bota:  xchg    ax,cx
@botsorted:
        cmp     bx,WY1
        jle     @boty0ok
        leave
        ret     16
@boty0ok:
        mov     si,Y2
        cmp     si,WY
        jge     @boty2ok
        leave
        ret     16
@boty2ok:
        mov     X0,ax
        mov     Y0,bx
        mov     X1,cx
        mov     Y1,dx
        mov     bx,Y2
        sub     bx,Y0
        mov     DY02,bx
        mov     ax,X2
        sub     ax,X0
        mov     DX02,ax
        mov     cx,ax
        cwd
        idiv    bx
        cmp     cx,0
        jge     @bot02
        dec     ax
@bot02: mov     XA02,ax
        imul    bx
        sub     cx,ax
        mov     DP02,cx
        mov     bx,Y2
        sub     bx,Y1
        mov     DY12,bx
        mov     ax,X2
        sub     ax,X1
        mov     DX12,ax
        mov     cx,ax
        cwd
        idiv    bx
        cmp     cx,0
        jge     @bot12
        dec     ax
@bot12: mov     XA12,ax
        imul    bx
        sub     cx,ax
        mov     DP12,cx
        xor     ax,ax
        xor     bx,bx
        mov     cx,Y0
        mov     si,X0
        mov     di,X1
        dec     di
@botloop:
        inc     cx
        add     ax,DP02
        jle     @botshortl
        sub     ax,DY02
        inc     si
@botshortl:
        add     si,XA02
        add     bx,DP12
        jle     @botshortr
        sub     bx,DY12
        inc     di
@botshortr:
        add     di,XA12
        push    di
        push    si
        cmp     cx,Y2
        jl      @botloop
        jmp     @lineloop
@sorted:
        cmp     bx,WY1
        jle     @y0ok
        leave
        ret     16
@y0ok:  mov     si,Y2
        cmp     si,WY
        jge     @y2ok
        leave
        ret     16
@y2ok:  mov     X0,ax
        mov     Y0,bx
        mov     X1,cx
        mov     Y1,dx
        mov     bx,dx
        sub     bx,Y0
        mov     DY01,bx
        mov     ax,X1
        sub     ax,X0
        mov     DX01,ax
        mov     cx,ax
        cwd
        idiv    bx
        cmp     cx,0
        jge     @psl01
        dec     ax
@psl01: mov     XA01,ax
        imul    bx
        sub     cx,ax
        mov     DP01,cx
        mov     bx,Y2
        sub     bx,Y0
        mov     DY02,bx
        mov     ax,X2
        sub     ax,X0
        mov     DX02,ax
        mov     cx,ax
        cwd
        idiv    bx
        cmp     cx,0
        jge     @psl02
        dec     ax
@psl02: mov     XA02,ax
        imul    bx
        sub     cx,ax
        mov     DP02,cx
        mov     bx,Y2
        sub     bx,Y1
        jle     @constcomputed
        mov     DY12,bx
        mov     ax,X2
        sub     ax,X1
        mov     DX12,ax
        mov     cx,ax
        cwd
        idiv    bx
        cmp     cx,0
        jge     @psl12
        dec     ax
@psl12: mov     XA12,ax
        imul    bx
        sub     cx,ax
        mov     DP12,cx
@ConstComputed:
        mov     ax,DX01
        imul    word ptr DY02
        mov     bx,ax
        mov     cx,dx
        mov     ax,DX02
        imul    word ptr DY01
        cmp     cx,dx
        jg      @pt1rt
        jl      @pt1lt
        cmp     bx,ax
        ja      @pt1rt
        jb      @pt1lt
        leave
        ret     16
@pt1lt: xor     ax,ax
        xor     bx,bx
        mov     cx,Y0
        mov     si,X0
        mov     di,si
        dec     si
@ltloop:
        inc     cx
        add     ax,DP02
        jle     @ltshortl
        sub     ax,DY02
        inc     si
@ltshortl:
        add     si,XA02
        add     bx,DP01
        jle     @ltshortr
        sub     bx,DY01
        inc     di
@ltshortr:
        add     di,XA01
        push    si
        push    di
        cmp     cx,Y1
        jl      @ltloop
        jmp     @lbstart
@lbloop:
        inc     cx
        add     ax,DP02
        jle     @lbshortl
        sub     ax,DY02
        inc     si
@lbshortl:
        add     si,XA02
        add     bx,DP12
        jle     @lbshortr
        sub     bx,DY12
        inc     di
@lbshortr:
        add     di,XA12
        push    si
        push    di
@lbstart:
        cmp     cx,Y2
        jl      @lbloop
        jmp     @lineloop
@pt1rt: xor     ax,ax
        xor     bx,bx
        mov     cx,Y0
        mov     si,X0
        mov     di,si
        dec     di
@rtloop:
        inc     cx
        add     ax,DP02
        jle     @rtshortl
        sub     ax,DY02
        inc     si
@rtshortl:
        add     si,XA02
        add     bx,DP01
        jle     @rtshortr
        sub     bx,DY01
        inc     di
@rtshortr:
        add     di,XA01
        push    di
        push    si
        cmp     cx,Y1
        jl      @rtloop
        jmp     @rbstart
@rbloop:
        inc     cx
        add     ax,DP02
        jle     @rbshortl
        sub     ax,DY02
        inc     si
@rbshortl:
        add     si,XA02
        add     bx,DP12
        jle     @rbshorts
        sub     bx,DY12
        inc     di
@rbshorts:
        add     di,XA12
        push    di
        push    si
@rbstart:
        cmp     cx,Y2
        jl      @rbloop
@lineloop:
        pop     ax
        pop     dx
        cmp     ax,dx
        jg      @drawnext
        {inc     dx}
        push    ax
        push    dx
        push    Y2
        db      $66
        push    word ptr Color
        call    dword ptr [HLineAddr]
@drawnext:
        dec     word ptr Y2
        dec     word ptr DY02
        jnz     @lineloop
 end;

 procedure FilledTriangle (X0,Y0,X1,Y1,X2,Y2: Integer; Color: LongInt);
 begin
  xFilledTriangle(X0,Y0,X1,Y1,X2,Y2,Color);
  if mgUseBorderColor then DrawTriangle(X0,Y0,X1,Y1,X2,Y2,mgBorderColor);
 end;

{----------------------------------------------------------------------------
 Original Code:
 XLib by Themie Gouthas
----------------------------------------------------------------------------}
 procedure FilledPolygon( var Vert; NumVert: Word; Color: LongInt); assembler;
 var X,Y,Count: Integer;
      asm
        mov     ax,[NumVert]
        cmp     ax,3
        jl      @Done
        sub     ax,3
        mov     [Count],ax
        mov     ax,word ptr [Vert+2]
        dw      $E88E                           {<- mov gs,ax}
        mov     di,word ptr [Vert]
        db      $65
        mov     ax,[di]
        mov     [X],ax
        db      $65
        mov     ax,[di+2]
        mov     [Y],ax
@Next:  add     di,4
        push    di
        push    [X]
        push    [Y]
        db      $65
        push    word ptr [di+4]
        db      $65
        push    word ptr [di+6]
        db      $65
        push    word ptr [di]
        db      $65
        push    word ptr [di+2]
        db      $66
        push    word ptr [Color]
        call    far ptr FilledTriangle
        pop     di
        dec     [Count]
        jns     @Next
@Done:
 end;

 procedure FloodFill(X,Y: Integer; Color: LongInt);
 var C2: LongInt;

 procedure PredLine(L,R,Y:Integer; UpDown:Byte); near;
 var X,X2:Integer;
 begin
  if GetPoint(L,Y)=C2 then
   while (L>0) and  (GetPoint(L-1,Y)=C2) DO
    Dec(L);
    X:=L;
    if GetPoint(R,Y)=C2 then
     while (R<ScrX) and  (GetPoint(R+1,Y)=C2) DO
      Inc(R);
      while X<=R do begin
       X2:=X;
       if GetPoint(X,Y)=C2 then begin
        while (GetPoint(X+1,Y)=C2) and  (X<ScrX) DO
         Inc(X);
         DrawHLine(X2,X,Y,Color);
         if UpDown=2 then begin
          if Y>0 then PredLine(X2,X,Y-1,2);
          if Y<ScrY then if (L>X2) and  (R<X) then begin
           PredLine(X2,L-1,Y+1,1);
           PredLine(R+1,X,Y+1,1);
          end else
           if (L<=X2) and  (R<X) then PredLine(R+1,X,Y+1,1) else
            if (L>X2) and  (R>=X) then PredLine(X2,L-1,Y+1,1);
          end;
          if UpDown=1 then begin
           if Y<ScrY then PredLine(X2,X,Y+1,1);
           if Y>0 then
            if (L>X2) and  (R<X) then begin
             PredLine(X2,L-1,Y-1,2);
             PredLine(R+1,X,Y-1,2);
            end          else
            if (L<=X2) and  (R<X) then PredLine(R+1,X,Y-1,2) else
             if (L>X2) and  (R>=X) then PredLine(X2,L-1,Y-1,2);
           end;
          end;
          Inc(X);
         end;
        end;
 begin
  C2:=GetPoint(X,Y);
  if Y<>0 then Dec(Y);
  PredLine(X,X,Y,2);
  PredLine(X,X,Y+1,1);
 end;

 procedure PutLine(X1,X2,Y: Integer; Addr: Pointer); assembler;
      asm
        mov     ax,word ptr [Addr+2]
        dw      $E08E                           {<- mov fs,ax}
        mov     si,word ptr [Addr]
        mov     cx,[Bshl]
        mov     ax,[BAdd]
        mov     bx,X1
        and     ax,bx
        shl     bx,cl
        add     bx,ax
        mov     ax,[BAdd]
        mov     dx,X2
        and     ax,dx
        shl     dx,cl
        add     dx,ax
        mov     cx,dx
        push    cx
        sub     cx,bx
        xor     ax,ax
        mov     al,[mgBytesPerPixel]
        push    ax
        add     cx,ax
        push    si
        add     si,cx
        pop     si
        jnc     @Next
@DoIt:  push    bx
        call    far ptr NormalizeFSSI
        pop     bx
@Next:  pop     ax
        pop     cx
        mov     dx,Y
        cmp     dx,[WY]
        jl      @Quit
        cmp     dx,[WY1]
        jg      @Quit
        cmp     cx,[WXb]
        jl      @Quit
        cmp     bx,[WXb1]
        jg      @Quit
        cmp     bx,[WXb]
        jge     @Next1
        sub     si,bx
        mov     bx,[WXb]
        add     si,bx
@Next1: cmp     cx,[WXb1]
        jle     @Next2
        mov     cx,[WXb1]
@Next2: sub     cx,bx
        add     cx,ax
        call    word ptr [WriteLineAddr]
@Quit:
 end;

 procedure GetLine(X1,X2,Y: Integer; Addr: Pointer); assembler;
      asm
        les     di,Addr
        mov     cx,[Bshl]
        mov     ax,[Badd]
        mov     bx,X1
        and     ax,bx
        shl     bx,cl
        add     bx,ax
        mov     ax,[BAdd]
        mov     dx,X2
        and     ax,dx
        shl     dx,cl
        add     dx,ax
        mov     cx,dx
        push    cx
        sub     cx,bx
        xor     ax,ax
        mov     al,[mgBytesPerPixel]
        push    ax
        add     cx,ax
        push    di
        add     di,cx
        pop     di
        jnc     @Next
@DoIt:  push    bx
        call    far ptr NormalizeESDI
        pop     bx
@Next:  pop     ax
        pop     cx
        mov     dx,Y
        cmp     dx,[WY]
        jl      @Quit
        cmp     dx,[WY1]
        jg      @Quit
        cmp     cx,[WXb]
        jl      @Quit
        cmp     bx,[WXb1]
        jg      @Quit
        cmp     bx,[WXb]
        jge     @Next1
        sub     di,bx
        mov     bx,[WXb]
        add     di,bx
@Next1: cmp     cx,[WXb1]
        jle     @Next2
        mov     cx,[WXb1]
@Next2: sub     cx,bx
        add     cx,ax
        call    word ptr [GetLineAddr]
@Quit:
 end;

 function  SpriteSize(SizeX,SizeY: Word): LongInt;
 begin
  SpriteSize:=LongMul(LongMul(SizeX,SizeY),mgBytesPerPixel);
 end;

 function  ImageSize(SizeX,SizeY: Word): LongInt;
 begin
  ImageSize:=6+LongMul(LongMul(SizeX,SizeY),mgBytesPerPixel);
 end;

 procedure PutSprite(X,Y,X1,Y1: Integer; DirectY: Boolean; Buffer: Pointer); assembler;
      asm
        mov     ax,[Y1]
        cmp     ax,[Y]
        jge     @Cont1
        leave
        retf    14
@Cont1: mov     bx,[X1]
        cmp     bx,[X]
        jge     @Cont2
        leave
        retf    14
@Cont2: sub     bx,[X]
        inc     bx
        mov     ax,[Badd]
        and     ax,bx
        mov     cx,[Bshl]
        shl     bx,cl
        add     bx,ax
        les     di,[Buffer]
        cmp     [DirectY],1
        mov     ax,[X]
        mov     si,[X1]
        jnz     @Norm
        mov     dx,[Y]
        mov     cx,[Y1]
@Loop1: pusha
        push    es
        push    ax
        push    si
        push    cx
        push    es
        push    di
        call    far ptr PutLine
        pop     es
        popa
        add     di,bx
        jnc     @Next1
        push    ax
        mov     ax,es
        add     ax,SelectorInc
        mov     es,ax
        pop     ax
@Next1: dec     cx
        cmp     cx,dx
        jge     @Loop1
        leave
        retf    14
@Norm:  mov     dx,[Y1]
        mov     cx,[Y]
@Loop2: pusha
        push    es
        push    ax
        push    si
        push    cx
        push    es
        push    di
        call    far ptr PutLine
        pop     es
        popa
        add     di,bx
        jnc     @Next2
        push    ax
        mov     ax,es
        add     ax,SelectorInc
        mov     es,ax
        pop     ax
@Next2: inc     cx
        cmp     cx,dx
        jle     @Loop2
 end;

 procedure GetSprite(X,Y,X1,Y1: Integer; DirectY: Boolean; Buffer: Pointer); assembler;
      asm
        mov     ax,[Y1]
        cmp     ax,[Y]
        jge     @Cont1
        leave
        retf    14
@Cont1: mov     bx,[X1]
        cmp     bx,[X]
        jge     @Cont2
        leave
        retf    14
@Cont2: sub     bx,[X]
        inc     bx
        mov     ax,[Badd]
        and     ax,bx
        mov     cx,[Bshl]
        shl     bx,cl
        add     bx,ax
        les     di,[Buffer]
        mov     ax,[X]
        mov     si,[X1]
        cmp     [DirectY],1
        jnz     @Norm
        mov     dx,[Y]
        mov     cx,[Y1]
@Loop1: pusha
        push    es
        push    ax
        push    si
        push    cx
        push    es
        push    di
        call    far ptr GetLine
        pop     es
        popa
        add     di,bx
        jnc     @Next1
        push    ax
        mov     ax,es
        add     ax,SelectorInc
        mov     es,ax
        pop     ax
@Next1: dec     cx
        cmp     cx,dx
        jge     @Loop1
        leave
        retf    14
@Norm:  mov     dx,[Y1]
        mov     cx,[Y]
@Loop2: pusha
        push    es
        push    ax
        push    si
        push    cx
        push    es
        push    di
        call    far ptr GetLine
        pop     es
        popa
        add     di,bx
        jnc     @Next2
        push    ax
        mov     ax,es
        add     ax,SelectorInc
        mov     es,ax
        pop     ax
@Next2: inc     cx
        cmp     cx,dx
        jle     @Loop2
 end;

 procedure PutImage(X,Y: Integer; Buffer: Pointer);
 var Len,Y1,X1: Integer;
 begin
  Y1:=Y+xGetWord(Buffer,2);
  Len:=GetWord(Buffer)+1;
  IncPointer(Buffer,6);
  X1:=X+Len-1;
  Len:=(Badd and Len)+(Len Shl Byte(Bshl));
  repeat
   PutLine(X,X1,Y,Buffer);
   IncPointer(Buffer,Len);
   inc(Y);
  until Y>Y1;
 end;

 function GetImage(X,Y,X1,Y1: Integer; var Buffer: Pointer): LongInt;
 var Len:  Integer;
     Size: LongInt;
     tBuf: Pointer;
 begin
  if Buffer=nil then begin
   GetBuffer(Buffer,ImageSize(X1-X+1,Y1-Y+1));
   if Buffer=nil then begin
    GetImage:=0;
    exit;
   end;
  end;
  tBuf:=Buffer;
  Size:=ImageSize(X1-X+1,Y1-Y+1);
  if (X1<X) or (Y1<Y) then exit;
  Len:=X1-X;
  PutWord(tBuf,Len);
  xPutWord(tBuf,2,Y1-Y);
  Inc(Len);
  IncPointer(tBuf,6);
  repeat
   GetLine(X,X1,Y,tBuf);
   IncPointer(tBuf,Len);
   inc(Y);
  until Y>Y1;
  GetImage:=Size;
 end;

 function ExtractLine256(Buffer: Pointer; Len: Word): Pointer; near; assembler;
      asm
        mov     ax,word ptr [Buffer+2]
        dw      $E08E                           {<- mov fs,ax}
        mov     si,word ptr [Buffer]
@Ok:    les     di,[mgBufferPtr]
        mov     cx,[Len]
        cmp     [Ost],0
        jz      @Loop
        mov     bx,[Ost]
        mov     al,byte ptr [Doub]
        jmp     @Go
@Loop:  db      $64
        db      $64
        mov     al,[si]
        inc     si
        jnz     @1
        dw      $E28C   {<- Mov dx,fs}
        add     dx,[SelectorInc]
        dw      $E28E   {<- Mov fs,dx}
@1:     cmp     al,byte ptr [Comp]
        jz      @SolidLine
        stosb
        loop    @Loop
@Pass:  mov     [Ost],0
        dw      $E28C   {<- Mov dx,fs}
        mov     ax,si
        leave
        retn    6
@SolidLine:
        xor     bx,bx
        db      $64
        mov     bl,[si]
        inc     si
        jnz     @2
        dw      $E28C   {<- Mov dx,fs}
        add     dx,[SelectorInc]
        dw      $E28E   {<- Mov fs,dx}
@2:     db      $64
        mov     al,[si]
        inc     si
        jnz     @3
        dw      $E28C   {<- Mov dx,fs}
        add     dx,[SelectorInc]
        dw      $E28E   {<- Mov fs,dx}
@3:     mov     byte ptr [Doub],al
@Go:    mov     dx,bx
        push    cx
        sub     cx,bx
        jg      @Next
        neg     cx
        mov     [Ost],cx
        pop     bx
        push    bx
@Next:  mov     cx,bx
        rep     stosb
        pop     cx
        sub     cx,bx
        jnz     @Loop
@Pass2: dw      $E28C   {<- Mov dx,fs}
        mov     ax,si
 end;

 function GetVIMWH(var Dx,Dy: Word; Addr: Pointer): Boolean;
 var DDX,DDY,X1,Y1:     Integer;
     Pl:                Word;
     InfoByte:          Byte;
 begin
  if GetStr(Addr,3)<>'VIM' then begin
   GetVIMWH:=false;
   exit;
  end;
  IncPointer(Addr,3);
  InfoByte:=Byte(Addr^) and 1;
  IncPointer(Addr,2+InfoByte);
  Pl:=GetWord(Addr);
  IncPointer(Addr,2+Pl*3);
  Dx:=GetWord(Addr);
  Dy:=xGetWord(Addr,2);
  GetVIMWH:=true;
 end;

 procedure PutVIM(X,Y: Integer; Buffer: Pointer; UsePal: Boolean);
 var X1,Y1,i:           Integer;
     Pl:                Word;
     PalStart,InfoByte: Byte;
     Tmp:               Word;
 begin
  if GetStr(Buffer,3)<>'VIM' then exit;
  IncPointer(Buffer,3);
  InfoByte:=Byte(Buffer^);
  IncPtr(Buffer);
  Comp:=0;
  PalStart:=GetByte(Buffer);
  IncPtr(Buffer);
  if InfoByte=1 then begin
   Comp:=GetByte(Buffer); IncPtr(Buffer);
  end;
  Pl:=GetWord(Buffer); IncPointer(Buffer,2);
  if UsePal then SetVGAPalette(Buffer,PalStart,Pl);
  IncPointer(Buffer,(Pl*3));
  X1:=GetWord(Buffer)+X-1; IncPointer(Buffer,2);
  Y1:=GetWord(Buffer)+Y-1; IncPointer(Buffer,2);
  if InfoByte<>1 then PutSprite(X,Y,X1,Y1,false,Buffer)
  else begin
   Ost:=0; Tmp:=X1-X+1;
   for i:=Y to Y1 do begin
    Buffer:=ExtractLine256(Buffer,Tmp);
    PutLine(X,X1,i,mgBufferPtr);
   end;
  end;
 end;

 function ChunkSize(ChunkAddr: Pointer): LongInt; near; assembler;
      asm
        cmp     di,$FFFC
        jbe     @Pass
        call    far ptr NormalizeESDI
@Pass:  les     di,[ChunkAddr]
        mov     ax,es:[di]
        add     di,2
        mov     dx,es:[di]
  end;

 function GetVISSize(VISaddr: Pointer): LongInt;
 var Chunks,i:    Word;
     Size,Tmp: LongInt;
 begin
  if GetStr(VISaddr,3)='VIS' then begin
   IncPointer(VISaddr,5+xGetByte(VISaddr,3));
   Chunks:=GetWord(VISaddr);
   IncPointer(VISaddr,2);
   Size:=7;
   for i:=1 to Chunks do begin
    Tmp:=ChunkSize(VISaddr);
    Size:=LongAdd(Size,Tmp);
    IncPointer(VISaddr,Tmp);
   end;
   GetVISSize:=Size
  end else GetVISSize:=0;
 end;

 function PutVIS(X,Y: Integer; Addr: Pointer; No: Word; UsePal: Boolean): Boolean;
 var Chunks,i,PalNum: Word;
     Bps:             Byte;
     Dsc:             Byte;
     Y1,X1,Tmp:       Integer;
 begin
  if GetStr(Addr,3)<>'VIS' then begin PutVIS:=false; exit; end;
  IncPointer(Addr,3);
  Dsc:=1+Byte(Addr^);
  IncPointer(Addr,Dsc);
  Bps:=Byte(Addr^);
  Chunks:=xGetWord(Addr,1);
  IncPointer(Addr,3);
  if (Chunks<=No) or (Bps<>mgBytesPerPixel) then begin PutVIS:=false; exit; end;
  for i:=1 to No do IncPointer(Addr,ChunkSize(Addr));
  PalNum:=xGetWord(Addr,10);
  if (Bps=1) and (UsePal) then SetVGAPalette(GetPtr(Addr,13),xGetByte(Addr,12),PalNum);
  if xGetByte(Addr,8)=0 then
   PutSprite(X,Y,X+xGetWord(Addr,4)-1,Y+xGetWord(Addr,6)-1,false,GetPtr(Addr,13+PalNum*3))
  else begin
   Comp:=xGetByte(Addr,9);
   Ost:=0;
   Tmp:=xGetWord(Addr,4);
   Y1:=Y+xGetWord(Addr,6)-1;
   X1:=X+Tmp-1;
   Addr:=GetPtr(Addr,13+PalNum*3);
   for i:=Y to Y1 do begin
    Addr:=ExtractLine256(Addr,Tmp);
    PutLine(X,X1,i,mgBufferPtr);
   end;
  end;
  PutVIS:=true;
 end;

 function  VIMSize(SizeX,SizeY,ColNum: Word): LongInt;
 begin
  VIMSize:=11+LongMul(ColNum,3)+LongMul(LongMul(SizeX,SizeY),mgBytesPerPixel);
 end;

 function GetVIM(X,Y,X1,Y1: Integer; FirstCol: Byte; ColNum: Word; var Buffer: Pointer): LongInt;
 var Size:    LongInt;
     DX,DY:   Word;
     xBuffer: Pointer;
 begin
  DX:=X1-X+1; DY:=Y1-Y+1;
  Size:=VIMSize(DX,DY,ColNum);
  if Buffer=nil then begin
   GetBuffer(Buffer,Size);
   if Buffer=nil then begin
    GetVIM:=0; exit;
   end;
  end;
  xBuffer:=Buffer;
  xPutWord(xBuffer,3,((mgBytesPerPixel)-1) shl 5);
  if ((mgBitsPerPixel=8) and (ColNum>0)) or (ColNum+FirstCol>256) then begin
   ColNum:=0;
   FirstCol:=0;
  end;
  PutStr(xBuffer,'VIM');
  xPutByte(xBuffer,4,FirstCol);
  xPutWord(xBuffer,5,ColNum);
  IncPointer(xBuffer,7);
  if ColNum>0 then begin
   GetVGAPalette(xBuffer,0,ColNum);
   IncPointer(xBuffer,(ColNum*3));
  end;
  PutWord(xBuffer,DX); IncPointer(xBuffer,2);
  PutWord(xBuffer,DY); IncPointer(xBuffer,2);
  GetSprite(X,Y,X1,Y1,false,xBuffer);
  GetVIM:=Size;
 end;

 procedure SetChars(AddrPtr: Pointer; Width,Hight,Start,Space: Byte); assembler;
      asm
        mov     ax,word ptr [AddrPtr+2]
        db      $66
        shl     ax,16
        mov     ax,word ptr [AddrPtr+0]
        db      $66
        mov     word ptr [CharAddr],ax
        mov     al,[Space]
        mov     [CharSpace],al
        mov     al,[Start]
        mov     [CharStart],al
        xor     ax,ax
        xor     bx,bx
        mov     [CharInit],1
        mov     al,[Width]
        cmp     al,0
        jnz     @Ok
        inc     ax
@Ok:    mov     [CharWidth],al
        mov     bl,[Hight]
        mov     [CharHight],bl
        mul     bx
        mov     [CharSize],ax
 end;

 procedure PutCharXY(X,Y: Integer; C: Char; Color: LongInt); assembler;
      asm
        cmp     [CharInit],1
        jz      @Cont
        leave
        retf    10
@Cont:  xor     ax,ax
        mov     al,[C]
        sub     al,[CharStart]
        mul     word ptr [CharSize]
        les     di,CharAddr
        add     di,ax
        jnc     @Next1
        mov     ax,es
        add     ax,[SelectorInc]
        mov     es,ax
@Next1: mov     dx,[X]
        add     dx,7
        xor     cx,cx
        mov     cl,[CharHight]
@Loop1: push    cx
        xor     bx,bx
        mov     cx,1
@Loop2: push    cx
        mov     al,es:[di]
        mov     cx,[X]
@Loop3: pusha
        push    es
        and     al,128
        or      al,0
        jz      @Skip
        add     cx,bx
        push    cx
        push    [Y]
        db      $66
        push    word ptr [Color]
        call    far ptr PutPoint
@Skip:  pop     es
        popa
        shl     al,1
        inc     cx
        cmp     cx,dx
        jle     @Loop3
        inc     di
        jnz     @Next2
        mov     ax,es
        add     ax,SelectorInc
        mov     es,ax
@Next2: add     bx,8
        pop     cx
        inc     cx
        cmp     cl,[CharWidth]
        jle     @Loop2
        inc     [Y]
        pop     cx
        loop    @Loop1
 end;

 procedure ShadowCharXY(X,Y: Integer; C:Char; CharColor,ShadowColor: LongInt); assembler;
      asm
        cmp     [CharInit],1
        jz      @Cont
        leave
        retf    14
@Cont:  xor     ax,ax
        mov     al,[C]
        sub     al,[CharStart]
        mul     word ptr [CharSize]
        les     di,CharAddr
        add     di,ax
        jnc     @Next1
        mov     ax,es
        add     ax,[SelectorInc]
        mov     es,ax
@Next1: mov     dx,[X]
        add     dx,7
        xor     cx,cx
        mov     cl,[CharHight]
@Loop1: push    cx
        xor     bx,bx
        mov     cx,1
@Loop2: push    cx
        mov     al,es:[di]
        mov     cx,[X]
@Loop3: pusha
        push    es
        and     al,128
        or      al,0
        jz      @Skip
        push    cx
        push    bx
        add     cx,bx
        add     cx,[mgShadowX]
        push    cx
        mov     cx,[Y]
        add     cx,[mgShadowY]
        push    cx
        db      $66
        push    word ptr [ShadowColor]
        call    far ptr PutPoint
        pop     bx
        pop     cx
        add     cx,bx
        push    cx
        push    [Y]
        db      $66
        push    word ptr [CharColor]
        call    far ptr PutPoint
@Skip:  pop     es
        popa
        shl     al,1
        inc     cx
        cmp     cx,dx
        jle     @Loop3
        inc     di
        jnz     @Next2
        mov     ax,es
        add     ax,SelectorInc
        mov     es,ax
@Next2: add     bx,8
        pop     cx
        inc     cx
        cmp     cl,[CharWidth]
        jle     @Loop2
        inc     [Y]
        pop     cx
        loop    @Loop1
 end;

 procedure PutStringXY(X,Y: Integer; S: String; Color: LongInt);
 var I,J: Integer;
 begin
  J:=X;
  for I:=1 to Length(S) do begin
   PutCharXY(J,Y,S[I],Color);
   J:=J+(CharWidth shl 3)+CharSpace;
  end;
 end;

 procedure ShadowStringXY(X,Y: Integer; S: String; CharColor,ShadowColor: LongInt);
 var I,J: Integer;
 begin
  J:=X;
  for I:=1 to Length(S) do begin
   ShadowCharXY(J,Y,S[I],CharColor,ShadowColor);
   J:=J+(CharWidth shl 3)+CharSpace;
  end;
 end;

 procedure SetVGAPalette(PalPtr: Pointer; Start: Word; Num: Word); assembler;
    asm
        mov     ax,word ptr [PalPtr+2]
        dw      $E08E                           {<- mov fs,ax}
        mov     si,word ptr [PalPtr]
        call    far ptr NormalizeFSSI
        mov     bx,[Start]
        mov     cx,[Num]
        mov     ax,[Num]
        cmp     ax,0
        je      @Quit
        cld
@DAC6:  mov     dx,$3C8
        mov     al,bl
        out     dx,al
        inc     bl
        inc     dx
        db      $64
        lodsb
        out     dx,al
        db      $64
        lodsb
        out     dx,al
        db      $64
        lodsb
        out     dx,al
        loop    @DAC6
@Quit:
 end;

 procedure SetNormalPalette(PalPtr: Pointer; Start: Word; Num: Word); assembler;
      asm
        mov     ax,word ptr [PalPtr+2]
        dw      $E08E                           {<- mov fs,ax}
        mov     si,word ptr [PalPtr]
        call    far ptr NormalizeFSSI
        mov     ax,[Num]
        cmp     ax,0
        je      @Quit
        mov     bx,[Start]
        mov     cx,[Num]
        cld
@DAC6:  mov     dx,$3C8
        mov     al,bl
        out     dx,al
        inc     bl
        inc     dx
        db      $64
        lodsb
        shr     al,2
        out     dx,al
        db      $64
        lodsb
        shr     al,2
        out     dx,al
        db      $64
        lodsb
        shr     al,2
        out     dx,al
        loop    @DAC6
@Quit:
 end;

 procedure SetVGAPal(Color,R,G,B: Byte); assembler;
      asm
        mov     dx,$3C8
        mov     al,[Color]
        out     dx,al
        inc     dx
        mov     al,[R]
        out     dx,al
        mov     al,[G]
        out     dx,al
        mov     al,[B]
        out     dx,al
 end;

 procedure SetNormalPal(Color,R,G,B: Byte); assembler;
      asm
        mov     dx,$3C8
        mov     al,[Color]
        out     dx,al
        inc     dx
        mov     al,[R]
        out     dx,al
        mov     al,[G]
        out     dx,al
        mov     al,[B]
        out     dx,al
 end;

 procedure GetVGAPalette(BufPtr: Pointer; Start,Num: Word); assembler;
     asm
        cld
        les     di,BufPtr
        call    far ptr NormalizeESDI
        mov     ax,[Num]
        mov     cx,3
        mul     cx
        mov     cx,ax
        mov     dx,$3C7
        mov     ax,[Start]
        out     dx,al
        mov     dx,$3C9
@PalLp: in      al,dx
        mov     es:[di],al
        inc     di
        loop    @PalLp
 end;

 procedure GetVGAPal(Color: Byte; var R,G,B: Byte); assembler;
      asm
        mov     al,[Color]
        mov     dx,$3C7
        out     dx,al
        inc     dx
        inc     dx
        in      al,dx
        les     di,R
        mov     es:[di],al
        in      al,dx
        les     di,G
        mov     es:[di],al
        in      al,dx
        les     di,B
        mov     es:[di],al
 end;

 function FadePalette(PalBuf: Pointer; Start,Number: Word; Stop: Byte): Boolean;
 var R,G,B:   Byte;
     Counter: Word;
     EndCntr: Word;
     C:       Boolean;
 begin
  C:=false;
  Counter:=Start*3;
  EndCntr:=Start+Number*3;
  repeat
   R:=xGetByte(PalBuf,Counter);
   G:=xGetByte(PalBuf,Counter+1);
   B:=xGetByte(PalBuf,Counter+2);
   if R>Stop then begin dec(R); C:=true; end;
   if G>Stop then begin dec(G); C:=true; end;
   if B>Stop then begin dec(B); C:=true; end;
   xPutByte(PalBuf,Counter,R);
   inc(Counter);
   xPutByte(PalBuf,Counter,G);
   inc(Counter);
   xPutByte(PalBuf,Counter,B);
   inc(Counter);
  until Counter>=EndCntr;
  SetVGAPalette(GetPtr(PalBuf,Start*3),Start,Number);
  FadePalette:=C;
 end;

 function LightPalette(PalBuf: Pointer; Start,Number: Word; Stop: Byte): Boolean;
 var R,G,B:   Byte;
     Counter: Word;
     EndCntr: Word;
     C:       Boolean;
 begin
  C:=false;
  Counter:=Start*3;
  EndCntr:=Start+Number*3;
  repeat
   R:=xGetByte(PalBuf,Counter);
   G:=xGetByte(PalBuf,Counter+1);
   B:=xGetByte(PalBuf,Counter+2);
   if R<Stop then begin inc(R); C:=true; end;
   if G<Stop then begin inc(G); C:=true; end;
   if B<Stop then begin inc(B); C:=true; end;
   xPutByte(PalBuf,Counter,R);
   inc(Counter);
   xPutByte(PalBuf,Counter,G);
   inc(Counter);
   xPutByte(PalBuf,Counter,B);
   inc(Counter);
  until Counter>=EndCntr;
  SetVGAPalette(GetPtr(PalBuf,Start*3),Start,Number);
  LightPalette:=C;
 end;

 function EvenPalette(PalBuf,Addr: Pointer; Start,Number: Word): Boolean;
 var R,G,B,A: Byte;
     Counter: Word;
     EndCntr: Word;
     C:       Boolean;
 begin
  C:=false;
  Counter:=Start*3;
  EndCntr:=Start+Number*3;
  repeat
   R:=xGetByte(PalBuf,Counter);
   G:=xGetByte(PalBuf,Counter+1);
   B:=xGetByte(PalBuf,Counter+2);
   A:=Byte(Addr^); IncPtr(Addr);
   if R<A then begin inc(R); C:=true; end;
   if R>A then begin dec(R); C:=true; end;
   A:=Byte(Addr^); IncPtr(Addr);
   if G<A then begin inc(G); C:=true; end;
   if G>A then begin dec(G); C:=true; end;
   A:=Byte(Addr^); IncPtr(Addr);
   if B<A then begin inc(B); C:=true; end;
   if B>A then begin dec(B); C:=true; end;
   xPutByte(PalBuf,Counter,R);
   xPutByte(PalBuf,Counter+1,G);
   xPutByte(PalBuf,Counter+2,B);
   inc(Counter,3);
  until Counter>=EndCntr;
  SetVGAPalette(GetPtr(PalBuf,Start*3),Start,Number);
  EvenPalette:=C;
 end;

 function  EvenPaletteToColor(PalBuf: Pointer; Start,Number: Word; R,G,B: Byte): Boolean;
 var R1,G1,B1: Byte;
     Counter: Word;
     EndCntr: Word;
     C:       Boolean;
 begin
  C:=false;
  Counter:=Start*3;
  EndCntr:=Start+Number*3;
  repeat
   R1:=xGetByte(PalBuf,Counter);
   G1:=xGetByte(PalBuf,Counter+1);
   B1:=xGetByte(PalBuf,Counter+2);
   if R1<R then begin inc(R1); C:=true; end;
   if R1>R then begin dec(R1); C:=true; end;
   if G1<G then begin inc(G1); C:=true; end;
   if G1>G then begin dec(G1); C:=true; end;
   if B1<B then begin inc(B1); C:=true; end;
   if B1>B then begin dec(B1); C:=true; end;
   xPutByte(PalBuf,Counter,R1);
   xPutByte(PalBuf,Counter+1,G1);
   xPutByte(PalBuf,Counter+2,B1);
   inc(Counter,3);
  until Counter>=EndCntr;
  SetVGAPalette(GetPtr(PalBuf,Start*3),Start,Number);
  EvenPaletteToColor:=C;
 end;

 procedure RotatePalette(PalBuf: Pointer; Start,Number: Word);
 var R,G,B: Byte;
     LastCol: Word;
 begin
  LastCol:=Start+Number-1;
  if (Number<2) or (LastCol>255) then exit;
  R:=xGetByte(PalBuf,LastCol*3);
  G:=xGetByte(PalBuf,LastCol*3+1);
  B:=xGetByte(PalBuf,LastCol*3+2);
  Move(GetPtr(PalBuf,Start*3)^,GetPtr(PalBuf,Start*3+3)^,(Number-1)*3);
  xPutByte(PalBuf,Start*3,R);
  xPutByte(PalBuf,Start*3+1,G);
  xPutByte(PalBuf,Start*3+2,B);
  SetVGAPalette(GetPtr(PalBuf,Start*3),Start,Number);
 end;

 procedure Stretch(Param: Byte); assembler;
      asm
        mov     al,$09
        mov     dx,CRTC_ADDR
        out     dx,al
        inc     dx
        in      al,dx
        and     al,$E0
        add     al,[Param]
        out     dx,al
 end;

 procedure Retrace; assembler;
      asm
        mov     dx,STAT_ADDR
@VSync: in      al,dx
        test    al,8
        jz      @VSync
@NoVSync:
        in      al,dx
        test    al,8
        jnz     @NoVSync
 end;

 procedure CliRetrace; assembler;
      asm
        pushf
        cli
        mov     dx,STAT_ADDR
@VSync: in      al,dx
        test    al,8
        jz      @VSync
@NoVSync:
        in      al,dx
        test    al,8
        jnz     @NoVSync
        popf
 end;

 procedure HRetrace; assembler;
      asm
        mov     dx,STAT_ADDR
@HSync: in      al,dx
        test    al,1
        jz      @HSync
        mov     dx,STAT_ADDR
@NoHSync:
        in      al,dx
        test    al,1
        jnz     @NoHSync
 end;

 procedure CliHRetrace; assembler;
      asm
        pushf
        cli
        mov     dx,STAT_ADDR
@HSync: in      al,dx
        test    al,1
        jz      @HSync
        mov     dx,STAT_ADDR
@NoHSync:
        in      al,dx
        test    al,1
        jnz     @NoHSync
        popf
 end;

 procedure SetSplitLine(Line: Word); assembler;
      asm
        cmp     [mgYRes],300
        jg      @Next
        shl     [Line],1
@Next:  call    far ptr Retrace
        mov     dx,CRTC_ADDR
        mov     ah,byte ptr [Line]
        mov     al,$18
        out     dx,ax
        mov     ah,byte ptr [Line+1]
        and     ah,1
        mov     cl,4
        shl     ah,cl
        mov     al,7
        out     dx,al
        inc     dx
        in      al,dx
        and     al,not $10
        or      al,ah
        out     dx,al
        dec     dx
        mov     ah,byte ptr [Line+1]
        and     ah,2
        mov     cl,3
        ror     ah,cl
        mov     al,9
        out     dx,al
        inc     dx
        in      al,dx
        and     al,not $40
        or      al,ah
        out     dx,al
 end;

 procedure MegaGrafExit;
 begin
  ExitProc:=MGExit;
  FreeBuffer(mgBufferPtr,BufferLen);
 end;

 begin
  mgShadowX:=1;
  mgShadowY:=1;
  MGExit:=ExitProc;
  ExitProc:=@MegaGrafExit;
{$IFDEF DPMI}
  RMAddr:=@RMRegs;
  ClearRegs(RMRegs);
  BufferLen:=4096;
{$ELSE}
  BufferLen:=2048;
{$ENDIF}
  GetBuffer(mgBufferPtr,BufferLen);
{$IFDEF DPMI}
  PLS:=Seg(mgBufferPtr^);
{$ENDIF}
  mgLineStyle:=$FFFF;
  ResetAddr;
 end.

 {MegaGraf rev 2.20 / Total: 6370 lines}