{$g+,n-,d-,l-,b-,r-,o+,f+,s-,a+,e-,p-,q-,t+,v-,x+,i-}

(*      MIDPAK SUPPORT /I80386 AND HIGHER, REAL MODE, PROTECTED MODE       *)
(*                                                                         *)
(*                  BEST GAME SDK FOR TURBO/BORLAND PASCAL                 *)
(*                ͻ         ͻ ͻ               *)
(*                ͼ    ͻ ͻ  ͻ   ͼ                  *)
(*                   ͼͼ  ͼ͹ ͼ  ͼ                  *)
(*                        ͻ   ͼ                                *)
(*                 :     ͹˻ ͻ  .Ĵ               *)
(*               | |  .    ͼ              *                   *)
(*               -+-    . ʼ       ʼ     ʼ   .  +                 *)
(*                |   .        version 2.0       .      :                 *)
(*                 BY VADIM BODROV, RUSSIA  (c) 1996-98   |               *)

{---------------------------------------------------------------------------
 Used materials:
 'TRICKS OF THE GAME-PROGRAMMING GURUS' by Andre LaMothe, John Ratcliff,
 Mark Seminatore, Denise Tyler, Copyright (C) 1994 Sams Publishing
---------------------------------------------------------------------------}

{$IFDEF WINDOWS}
 THIS UNIT CAN NOT BE COMPILED FOR MS WINDOWS!!!
 ONLY DOS REAL MODE AND PROTECTED MODE SUPPORTED
{$ENDIF}

{****************************************************************************
    A  $500  per  product  license  fee  applies  to  all commercial software
 products  distributed  with  ANY DIGPAK and another $500 for MIDPAK drivers.
 That's  a  total  of  $1,000  if  your  product  uses BOTH DIGPAK and MIDPAK
 drivers.  If  you  distribute any commercial title with DIGPAK and/or MIDPAK
 drivers  resident  then  this  license fee applies. To pay a license, simply
 write  a  check for $500 for just DIGPAK $500 for just MIDPAK, or $1,000 for
 both  DIGPAK  and MIDPAK single product distribution license payable to: The
 Audio  Solution,  747  Napa  Lane, St. Charles, MO 63304 with a copy of your
 commerical  product.  You  will  receive a signed license agreement from The
 Audio  Solution shortly thereafter. This license fee applies specifically to
 the  inclusion  with  your distribution disk any of the DIGPAK and/or MIDPAK
 drivers.  These drivers are copyrighted works, created by me, to enhance the
 use  of  sound  and music in DOS based commercial software. The license fees
 collected  are  used  to  maintain  the  drivers  and  keep the BBS running.

 WARNING!!!!!!  You  would  be ill-advised to distribute a commercial product
 containing  either  DIGPAK  and/or  MIDPAK  drivers  without having paid the
 distribution  license  fee.  Since  your  product  would  contain unlicensed
 copyrighted software from The Audio Solution, your product could be required
 to be immediately removed from retail distribution. I doubt this is going to
 be  a  problem.  Clearly  if  your  product  is enhanced by the use of these
 drivers,  your  company can easily afford a nominal license fee of $1,000 in
 exchange  for  getting  the use of several man-years of software engineering
 resources.
*****************************************************************************}

 unit MidPak;

 interface

 type TMidiStruct = record
  Addr:    Pointer;
  Size:    LongInt;
  Para:    Word;
 end;

 function  LoadMidPak(MidPak,Adv,Ad: String): Boolean;
 function  UnLoadMidPak: Boolean;
 function  InitMidPak: Boolean;
 function  DeInitMidPak: Boolean;
 function  MidiLoad (Name: String; var MidiFile: TMidiStruct): Boolean;
 procedure MidiFree (var MidiFile: TMidiStruct);
 function  RegisterXMidi (MidiFile: TMidiStruct): Byte;
 function  ReportTriggerCount (var ID: Word): Word;
 procedure ResetTriggerCount;
 function  DigPakAvailable: Boolean;
 function  MidPakClock: LongInt;
 function  MidPakClockAddress: Pointer;
 procedure RemapChannel (Sequence: Word; Physical: Word);
 procedure ResetCallbackCounter;
 procedure MidiSleep;
 procedure MidiAwake;
 procedure PollMidPak;
 function  TriggerCountAddress: Pointer;
 function  EventIDAddress: Pointer;
 function  ReportSequenceNumber: Word;
 function  PlaySequence (SEQ: Word): Boolean;
 procedure ResumePlaying;
 function  SequenceStatus: Word;
 function  RelativeVolume: Word;
 procedure SetRelativeVolume (Volume: Word);
 procedure SegueSequence (SEQ: Word; ACT: Integer);
 procedure StopMidi;

 implementation

{$IFDEF MSDOS}
 uses MemPlus,DOSUtil,i80386;
{$ELSE}
 uses MemPlus,DOSUtil,i80386,WinAPI;
{$ENDIF}

 var HaveMidPak: Boolean;
     MidPakOn:   Boolean;

     MidPakLoad: Pointer;
     MidPakSize: LongInt;
     MidPakPara: Word;
     AdLoad:     Pointer;
     AdSize:     LongInt;
     AdPara:     Word;
     AdvLoad:    Pointer;
     AdvSize:    LongInt;
     AdvPara:    Word;

{$IFDEF DPMI}
 var Clock:      Word;
     Trigger:    Word;
     EventID:    Word;
     MidPakExit: Pointer;
{$ENDIF}

 procedure MPInit; near;
{$IFDEF MSDOS}
 assembler;
      asm
        mov     bx,[AdvPara]
        xor     cx,cx
        mov     dx,word ptr [AdLoad+2]
        mov     si,word ptr [AdLoad]
        mov     ax,$710
        int     $66
 end;
{$ELSE}
 var Regs: TRealRegs;
 begin
  ClearRegs(Regs);
  Regs.BX:=AdvPara;
  Regs.CX:=0;
  Regs.DX:=AdPara;
  Regs.SI:=0;
  Regs.AX:=$710;
  RealModeInt($66,Regs);
 end;
{$ENDIF}

{$IFDEF MSDOS}
 function Int704(Addr: Pointer; Size: LongInt): Byte; near; assembler;
      asm
        mov     bx,word ptr [Addr]
        mov     cx,word ptr [Addr+2]
        mov     si,word ptr [Size]
        mov     di,word ptr [Size+2]
        mov     ax,$704
        int     $66
 end;
{$ENDIF}

 function LoadMidPak(MidPak,Adv,Ad: String): Boolean;
 begin
  if HaveMidPak then begin
   LoadMidPak:=false; exit;
  end;
  MidPakSize:=SizeOfFile(MidPak);
  AdvSize:=SizeOfFile(Adv);
  AdSize:=SizeOfFile(Ad);
{$IFDEF MSDOS}
  GetBuffer(MidPakLoad,MidPakSize+$110);
  if MidPakLoad=nil then begin
   LoadMidPak:=false; exit;
  end;
  MidPakPara:=Seg(MidPakLoad^)+1;
  GetBuffer(AdvLoad,AdvSize+16);
  if AdvLoad=nil then begin
   FreeBuffer(MidPakLoad,MidPakSize+$110);
   LoadMidPak:=false; exit;
  end;
  AdvPara:=Seg(AdvLoad^)+1;
  GetBuffer(AdLoad,AdSize);
  if AdLoad=nil then begin
   FreeBuffer(MidPakLoad,MidPakSize+$110);
   FreeBuffer(AdvLoad,AdvSize+16);
   LoadMidPak:=false; exit;
  end;
  AdPara:=Seg(AdLoad^);
{$ELSE}
  MidPakPara:=xGlobalDosAlloc(MidPakLoad,MidPakSize+$100);
  if MidPakLoad=nil then begin
   LoadMidPak:=false; exit;
  end;
  AdvPara:=xGlobalDosAlloc(AdvLoad,AdvSize);
  if AdvLoad=nil then begin
   xGlobalDosFree(MidPakLoad);
   LoadMidPak:=false; exit;
  end;
  AdPara:=xGlobalDosAlloc(AdLoad,AdSize);
  if AdLoad=nil then begin
   xGlobalDosFree(MidPakLoad);
   xGlobalDOSFree(AdvLoad);
   LoadMidPak:=false; exit;
  end;
{$ENDIF}
{$IFDEF MSDOS}
  if not (ReadFromFile(MidPak,Ptr(MidPakPara,$100),0,MidPakSize) and
   ReadFromFile(Adv,Ptr(AdvPara,0),0,AdvSize) and
   ReadFromFile(Ad,AdLoad,0,AdSize)) then begin
    FreeBuffer(AdLoad,AdSize);
    FreeBuffer(AdvLoad,AdvSize+16);
    FreeBuffer(MidPakLoad,MidPakSize+$110);
{$ELSE}
  if not (ReadFromFile(MidPak,GetPtr(MidPakLoad,$100),0,MidPakSize) and
   ReadFromFile(Adv,AdvLoad,0,AdvSize) and
   ReadFromFile(Ad,AdLoad,0,AdSize)) then begin
    xGlobalDosFree(AdLoad);
    xGlobalDOSFree(AdvLoad);
    xGlobalDosFree(MidPakLoad);
{$ENDIF}
    LoadMidPak:=false;
  end else HaveMidPak:=true;
  LoadMidPak:=HaveMidPak;
 end;

 function UnLoadMidPak: Boolean;
 begin
  if HaveMidPak then begin
   if MidPakOn then DeInitMidPak;
   if MidPakLoad<>nil then begin
{$IFDEF MSDOS}
    FreeBuffer(AdLoad,AdSize);
    FreeBuffer(AdvLoad,AdvSize+16);
    FreeBuffer(MidPakLoad,MidPakSize+$110);
{$ELSE}
    xGlobalDosFree(AdLoad);
    xGlobalDosFree(AdvLoad);
    xGlobalDosFree(MidPakLoad);
{$ENDIF}
    MidPakLoad:=nil;
    AdvLoad:=nil;
    AdLoad:=nil;
    MidPakSize:=0;
    AdvSize:=0;
    AdSize:=0;
    HaveMidPak:=false;
   end;
   UnLoadMidPak:=true;
  end else UnLoadMidPak:=false;
 end;

 function InitMidpak: Boolean;
{$IFDEF DPMI}
 var Regs: TRealRegs;
 begin
  if (HaveMidPak) and (xGetStr(MidPakLoad,$103,6)='MIDPAK') then begin
   ClearRegs(Regs);
   Regs.CS:=MidPakPara;
   Regs.IP:=$200;
   RealCallF(Regs);
   MidPakOn:=Regs.AX=0;
  end;
{$ELSE}
 begin
  if (HaveMidPak) and (xGetStr(Ptr(MidPakPara,0),$103,6)='MIDPAK') then begin
   MidPakOn:=Word(FarCall(Ptr(MidPakPara,$200)))=0;
  end;
{$ENDIF}
  InitMidPak:=MidPakOn;
  if MidPakOn then MPInit;
 end;

 function DeInitMidPak: Boolean;
{$IFDEF DPMI}
 var Regs: TRealRegs;
{$ENDIF}
 begin
  if MidPakOn then begin
   StopMidi;
{$IFDEF DPMI}
   ClearRegs(Regs);
   Regs.CS:=MidPakPara;
   Regs.IP:=$203;
   RealCallF(Regs);
{$ELSE}
   FarCall(Ptr(MidPakPara,$203));
{$ENDIF}
   MidPakOn:=false;
   DeInitMidPak:=true;
  end else DeInitMidPak:=false;
 end;

 function MidiLoad(Name: String; var MidiFile: TMidiStruct): Boolean;
 begin
  MidiFile.Addr:=nil;
  if TestFile(Name) then begin
   MidiFile.Size:=SizeOfFile(Name);
{$IFDEF MSDOS}
   GetBuffer(MidiFile.Addr,MidiFile.Size);
   MidiFile.Para:=Seg(MidiFile.Addr^);
{$ELSE}
   MidiFile.Para:=xGlobalDosAlloc(MidiFile.Addr,MidiFile.Size);
{$ENDIF}
   if MidiFile.Addr=nil then begin
    MidiLoad:=false;
    exit;
   end;
   if not ReadFromFile(Name,MidiFile.Addr,0,MidiFile.Size) then begin
{$IFDEF MSDOS}
    FreeBuffer(MidiFile.Addr,MidiFile.Size);
{$ELSE}
    xGlobalDOSFree(MidiFile.Addr);
{$ENDIF}
    MidiFile.Addr:=nil;
   end;
  end;
  MidiLoad:=MidiFile.Addr<>nil;
 end;

 procedure MidiFree(var MidiFile: TMidiStruct);
 begin
  if MidiFile.Addr<>nil then begin
{$IFDEF MSDOS}
   FreeBuffer(MidiFile.Addr,MidiFile.Size);
{$ELSE}
   xGlobalDOSFree(MidiFile.Addr);
{$ENDIF}
   MidiFile.Size:=0;
   MidiFile.Addr:=nil;
   MidiFile.Para:=0;
  end;
 end;

 function RegisterXMidi(MidiFile: TMidiStruct): Byte;
{$IFDEF MSDOS}
 begin
  RegisterXMidi:=Int704(MidiFile.Addr,MidiFile.Size);
 end;
{$ELSE}
 var Regs: TRealRegs;
 begin
  ClearRegs(Regs);
  Regs.BX:=0;
  Regs.CX:=MidiFile.Para;
  Regs.SI:=Word(MidiFile.Size);
  Regs.DI:=HiWord(MidiFile.Size);
  Regs.AX:=$704;
  RealModeInt($66,Regs);
  RegisterXMidi:=Regs.AX;
 end;
{$ENDIF}

 function  ReportTriggerCount (var ID: Word): Word; assembler;
      asm
        mov     ax,$707
        int     $66
        les     di,ID
        mov     es:[di],dx
 end;

 procedure ResetTriggerCount; assembler;
      asm
        mov     ax,$708
        int     $66
 end;

 function  DigPakAvailable: Boolean; assembler;
      asm
        mov     ax,$701
        int     $66
 end;

 function MidPakClock: LongInt; assembler;
      asm
        mov     ax,$712
        int     $66
 end;

 function MidPakClockAddress: Pointer;
{$IFDEF MSDOS}
 assembler;
      asm
        mov     ax,$712
        int     $66
        mov     ax,bx
        mov     dx,cx
 end;
{$ELSE}
 var Regs: TRealRegs;
 begin
  if Clock=0 then begin
   ClearRegs(Regs);
   Regs.AX:=$712;
   RealModeInt($66,Regs);
   AllocSelector(Clock);
   Clock:=SetSelectorBase(Clock,LongAdd(LongMul(Regs.CX,16),Regs.BX));
   SetSelectorLimit(Clock,4);
  end;
  MidPakClockAddress:=Ptr(Clock,0);
 end;
{$ENDIF}

 procedure RemapChannel(Sequence: Word; Physical: Word); assembler;
      asm
        mov     ax,$706
        mov     bx,[Sequence]
        mov     cx,[Physical]
        int     $66
 end;

 procedure ResetCallbackCounter; assembler;
      asm
        mov     ax,$708
        int     $66
 end;

 procedure MidiSleep; assembler;
      asm
        mov     ax,$709
        int     $66
 end;

 procedure MidiAwake; assembler;
      asm
        mov     ax,$70A
        int     $66
 end;

 procedure PollMidPak; assembler;
      asm
        mov     ax,$711
        int     $66
 end;

 function TriggerCountAddress: Pointer;
{$IFDEF MSDOS}
 assembler;
      asm
        mov     ax,$713
        int     $66
 end;
{$ELSE}
 var Regs: TRealRegs;
 begin
  if Trigger=0 then begin
   ClearRegs(Regs);
   Regs.AX:=$713;
   RealModeInt($66,Regs);
   AllocSelector(Trigger);
   Clock:=SetSelectorBase(Trigger,LongAdd(LongMul(Regs.DX,16),Regs.AX));
   SetSelectorLimit(Trigger,4);
  end;
  TriggerCountAddress:=Ptr(Trigger,0);
 end;
{$ENDIF}

 function EventIDAddress: Pointer;
{$IFDEF MSDOS}
 assembler;
      asm
        mov     ax,$714
        int     $66
 end;
{$ELSE}
 var Regs: TRealRegs;
 begin
  if EventID=0 then begin
   ClearRegs(Regs);
   Regs.AX:=$714;
   RealModeInt($66,Regs);
   AllocSelector(EventID);
   Clock:=SetSelectorBase(EventID,LongAdd(LongMul(Regs.DX,16),Regs.AX));
   SetSelectorLimit(EventID,4);
  end;
  EventIDAddress:=Ptr(EventID,0);
 end;
{$ENDIF}

 function ReportSequenceNumber: Word; assembler;
      asm
        mov     ax,$716
        int     $66
 end;

 function  PlaySequence(SEQ: Word): Boolean; assembler;
      asm
        cmp     [MidPakOn],1
        jnz     @Exit
        mov     ax,$702
        mov     bx,[SEQ]
        int     $66
@Exit:
 end;

 procedure ResumePlaying; assembler;
      asm
        mov     ax,$70B
        int     $66
 end;

 function  SequenceStatus: Word; assembler;
      asm
        mov     ax,$70C
        int     $66
 end;

 function  RelativeVolume: Word; assembler;
      asm
        mov     ax,$70E
        int     $66
 end;

 procedure SetRelativeVolume(Volume: Word); assembler;
      asm
        mov     ax,$70F
        mov     bx,[Volume]
        int     $66
  end;

 procedure SegueSequence(SEQ: Word; ACT: Integer); assembler;
      asm
        mov     ax,$703
        mov     bx,[SEQ]
        mov     cx,[ACT]
        int     $66
 end;

 procedure StopMidi; assembler;
      asm
        mov     ax,$705
        int     $66
 end;

{$IFDEF DPMI}
 procedure ExitMidPak;
 begin
  if Clock<>0 then FreeSelector(Clock);
  if Trigger<>0 then FreeSelector(Trigger);
  if EventID<>0 then FreeSelector(EventID);
 end;
{$ENDIF}

 begin
{$IFDEF DPMI}
  MidPakExit:=ExitProc;
  ExitProc:=@ExitMidPak;
{$ENDIF}
 end.