{$g+,n-,d-,l-,b-,r-,o+,f+,s-,a+,e-,p-,q-,t+,v-,x+,i-}

(*    SERIAL LINK SUPPORT /I80386 AND HIGHER, REAL MODE, PROTECTED MODE    *)
(*                                                                         *)
(*                  BEST GAME SDK FOR TURBO/BORLAND PASCAL                 *)
(*                ͻ         ͻ ͻ               *)
(*                ͼ    ͻ ͻ  ͻ   ͼ                  *)
(*                   ͼͼ  ͼ͹ ͼ  ͼ                  *)
(*                        ͻ   ͼ                                *)
(*                 :     ͹˻ ͻ  .Ĵ               *)
(*               | |  .    ͼ              *                   *)
(*               -+-    . ʼ       ʼ     ʼ   .  +                 *)
(*                |   .        version 2.0       .      :                 *)
(*                 BY VADIM BODROV, RUSSIA  (c) 1996-98   |               *)

(* Used materials:
(*  - TRICKS OF THE GAME-PROGRAMMING GURUS by Andre LaMothe, John Ratcliff,*)
(*    Mark Seminatore, Denise Tyler, Copyright (C) 1994 Sams Publishing    *)

{$IFDEF WINDOWS}
 THIS UNIT CAN NOT BE COMPILED FOR MS WINDOWS!!!
 ONLY DOS REAL MODE AND PROTECTED MODE SUPPORTED
{$ENDIF}

 unit SerLink;

 interface

 const
  Bound_1200      = 96;
  Bound_2400      = 48;
  Bound_9600      = 12;
  Bound_19200     = 6;
  COM_1           = $38F;
  COM_2           = $2F8;
  COM_3           = $3E8;
  COM_4           = $2E8;
  SER_STOP_1      = 0;
  SER_STOP_2      = 4;
  SER_BITS_5      = 0;
  SER_BITS_6      = 1;
  SER_BITS_7      = 2;
  SER_BITS_8      = 3;

  SER_PARITY_NONE = 0;
  SER_PARITY_ODD  = 8;
  SER_PARITY_EVEN = 24;

 var BufferIsClear: Boolean;

 procedure OpenSerial (BasePort, Baund, Config: Word);
 procedure CloseSerial (BasePort: Word);
 function  SerialRead: Byte;
 procedure SerialWrite (Ch: Byte);

 implementation

 uses i80386,DOSUtil;

 const
  SER_RBF=0;
  SER_THR=0;
  SER_IER=1;
  SER_IIR=2;
  SER_LCR=3;
  SER_MCR=4;
  SER_LSR=5;
  SER_MSR=6;
  SER_DLL=0;
  SER_DLH=1;

  SER_GP02=8;

  SER_DIV_LATCH_ON=128;

  PIC_IMR=$21;
  PIC_ICR=$20;

  INT_SER_PORT_0=$0C;
  INT_SER_PORT_1=$0B;

  SERIAL_BUFF_SIZE=128;

  var Old_Isr: Pointer;
      ser_buffer: array [0..SERIAL_BUFF_SIZE] of Byte;
      ser_end:            Integer;
      ser_start:          Integer;
      ser_ch:             Byte;
      char_ready:         Integer;
      old_int_mask:       Word;
      open_port:          Word;
      serial_lock:        Boolean;

 procedure SerialIsr; interrupt;
 begin
  serial_lock:=true;
  ser_ch:=port[open_port+SER_RBF];
  inc(ser_end);
  if ser_end>SERIAL_BUFF_SIZE-1 then ser_end:=0;
  ser_buffer[ser_end]:=ser_ch;
  inc(char_ready);
  port[PIC_ICR]:=$20;
  serial_lock:=false;
 end;

 function SerialRead: Byte;
 var ch: Byte;
 begin
  repeat until not serial_lock;
  if ser_end<>ser_start then begin
   inc(ser_start);
   if ser_start>SERIAL_BUFF_SIZE-1 then ser_start:=0;
   ch:=ser_buffer[ser_start];
   if char_ready>0 then dec(char_ready);
   SerialRead:=ch;
   BufferIsClear:=false;
  end else begin
   SerialRead:=0;
   BufferIsClear:=true;
  end;
 end;

 procedure SerialWrite(ch: Byte);
 begin
  repeat
  until (port[open_port+SER_LSR] and $20)=$20;
  Cli;
  port[open_port+SER_THR]:=ch;
  Sti;
 end;

 procedure OpenSerial(BasePort, Baund, Config: Word);
 begin
  open_port:=BasePort;
  port[BasePort+SER_LCR]:=SER_DIV_LATCH_ON;
  port[BasePort+SER_DLL]:=Baund;
  port[BasePort+SER_DLH]:=0;
  port[BasePort+SER_LCR]:=Config;
  port[BasePort+SER_MCR]:=SER_GP02;
  port[BAsePort+SER_IER]:=1;
  if (BasePort=COM_1) or (BasePort=COM_3) then begin
{$IFDEF MSDOS}
   GetRealIntVec(INT_SER_PORT_0,Old_Isr);
   SetRealIntVec(INT_SER_PORT_0,@SerialIsr);
{$ELSE}
   GetDPMIIntVec(INT_SER_PORT_0,Old_Isr);
   SetDPMIIntVec(INT_SER_PORT_0,@SerialIsr);
{$ENDIF}
  end else begin
{$IFDEF MSDOS}
   GetRealIntVec(INT_SER_PORT_1,Old_Isr);
   SetRealIntVec(INT_SER_PORT_1,@SerialIsr);
{$ELSE}
   GetDPMIIntVec(INT_SER_PORT_1,Old_Isr);
   SetDPMIIntVec(INT_SER_PORT_1,@SerialIsr);
{$ENDIF}
  end;
  old_int_mask:=port[PIC_IMR];
  if (BasePort=COM_1) or (BasePort=COM_3) then
   port[PIC_IMR]:=(old_int_mask and $EF)
  else
   port[PIC_IMR]:=(old_int_mask and $F7);
 end;

 procedure CloseSerial(BasePort: Word);
 begin
  port[BasePort+SER_MCR]:=0;
  port[BasePort+SER_IER]:=0;
  port[PIC_IMR]:=old_int_mask;
  if (BasePort=COM_1) or (BasePort=COM_3) then
{$IFDEF MSDOS}
   SetRealIntVec(INT_SER_PORT_0,Old_Isr)
{$ELSE}
   SetDPMIIntVec(INT_SER_PORT_0,Old_Isr)
{$ENDIF}
  else
{$IFDEF MSDOS}
   SetRealIntVec(INT_SER_PORT_1,Old_Isr);
{$ELSE}
   SetDPMIIntVec(INT_SER_PORT_1,Old_Isr);
{$ENDIF}
 end;

 begin
  ser_end:=-1;
  ser_start:=-1;
  serial_lock:=false;
 end.