{$g+,n-,d-,l-,b-,r-,o+,f+,s-,a+,e-,p-,q-,t+,v-,x+,i-}

(*                           IMAGE VIEWER UTILITY                          *)
(*                                                                         *)
(*                  BEST GAME SDK FOR TURBO/BORLAND PASCAL                 *)
(*                ͻ         ͻ ͻ               *)
(*                ͼ    ͻ ͻ  ͻ   ͼ                  *)
(*                   ͼͼ  ͼ͹ ͼ  ͼ                  *)
(*                        ͻ   ͼ                                *)
(*                 :     ͹˻ ͻ  .Ĵ               *)
(*               | |  .    ͼ              *                   *)
(*               -+-    . ʼ       ʼ     ʼ   .  +                 *)
(*                |   .        version 2.0       .      :                 *)
(*                 BY VADIM BODROV, RUSSIA  (c) 1996-98   |               *)

{$IFDEF WINDOWS}
 THIS PROGRAM CAN`T BE COMPILED FOR MS WINDOWS
{$ENDIF}

uses MemPlus,MegaGraf,DOSUtil,Keyboard,i80386,Images,FLI;

const
    VIM          = 1;
    CEL          = 2;
    PCX          = 3;
    BMP          = 4;
    GIF          = 5;
    LBM          = 6;
    TGA          = 7;
    FLIC         = 8;

var Name, iType:       String;
    ImageAddr:         Pointer;
    N:                 LongInt;
    PalFlag:           Boolean;
    Dx,Dy,Dtep:        Word;
    X,Y:               Integer;
    XRes,YRes:         Word;
    grMode:            Byte;
    Step:              Byte;
    Show:              Boolean;
    ImageType:         Byte;

begin
 Write('IMAGE VIEWER v1.0');
{$IFDEF DPMI}
 Writeln(' // Protected Mode');
{$ELSE}
 Writeln(' // Real Mode');
{$ENDIF}
 Writeln('Copyright (c) 1996-98 by Vadim Bodrov (falkoris@hotmail.com)');
 Writeln('This program is a part of PLUS SYSTEM PRO 2.0 GDK FOR BORLAND PASCAL');
 Writeln('Usage: IMGVIEW [[drive:][path]filename.vim] [ResX] [ResY]');
 Writeln('Hint: use arrow keys to scroll screen and "Esc" to exit');
 if ParamCount=0 then begin
  Writeln('Supported formats:');
  Writeln('------------------');
  Writeln('VIM: 256-, 64K-, 16M- and 4G-colored (VGA image format)');
  Writeln('CEL: 256-colored original (Autodesk Animator format)');
  Writeln('PCX: standard 256-colored (ZSoft Corp. and Genus Microprogramming formats)');
  Writeln('BMP: uncompressed 256-colored and True Color (Microsoft Windows BitMap format)');
  Writeln('GIF: 2-, 4-, 16- and 256-colored (GIF`87 and GIF`89 formats)');
  Writeln('LBM: 256-colored Amiga`s image (PBM format)');
  Writeln('TGA: uncompressed 256-, 32K- and 16M-colored TARGA (tagged image format)');
  Writeln('FLI: original Autodesk animation format');
  Halt(0);
 end;
 Name:=ParamStr(1);
 XRes:=StrToInt(ParamStr(2));
 YRes:=StrToInt(ParamStr(3));
 N:=SizeOfFile(Name);
 if N=0 then begin
  Writeln('Can`t read file');
  exit;
 end;
 if FLIInit(Name) then begin
  ImageType:=FLIC;
  grMode:=grSVGA256;
  dx:=320;
  dy:=200;
 end else begin
  GetBuffer(ImageAddr,N);
  if ImageAddr=nil then begin
   Writeln('Out of memory!');
   exit;
  end;
  ReadFromFile(Name,ImageAddr,0,n);

  if GetVIMWH(dx,dy,ImageAddr) then begin
   ImageType:=VIM;
   grMode:=(xGetByte(ImageAddr,3) shr 5)+grSVGA256
  end else
   if GetCELWH(dx,dy,ImageAddr) then begin
    ImageType:=CEL;
    grMode:=grSVGA256
   end else
    if GetPCXWH(dx,dy,ImageAddr) then begin
     ImageType:=PCX;
     grMode:=grSVGA256
    end else
     if GetBMPWH(dx,dy,ImageAddr) then begin
      ImageType:=BMP;
      grMode:=grSVGA16+(xGetByte(ImageAddr,$1C) shr 3)
     end else
      if GetGIFWH(dx,dy,ImageAddr) then begin
       ImageType:=GIF;
       grMode:=grSVGA256
      end else
       if GetLBMWH(dx,dy,ImageAddr) then begin
        ImageType:=LBM;
        grMode:=grSVGA256
       end else
        if GetTGAWH(dx,dy,ImageAddr) then begin
         ImageType:=TGA;
         grMode:=grSVGA16+(xGetByte(ImageAddr,16) shr 3)
        end else begin
          Writeln(Name,' is not supported');
          Halt(0);
  end;
 end;

 if grMode>grSVGA256 then inc(grMode);
 if (XRes=0) or (YRes=0) then begin
  if (dx<=320) and (dy<=200) and (grMode=grSVGA256) then begin
   XRes:=320;
   YRes:=200;
  end else begin
   XRes:=640;
   YRes:=480;
  end;
 end;
 if (XRes=320) and (xRes=200) and (grMode=grSVGA256) then
  SetMCGAMode
 else begin
  if not InitVBE then begin
   Writeln('VESA VBE 1.2 required. VESA VBE 2.0/3.0 recomended.');
   Halt(0);
  end;
  if not SetSVGAMode(XRes,YRes,grMode) then
   if (ImageType=BMP) and (grMode=grSVGA16M) then
    if not SetSVGAMode(XRes,YRes,grSVGA32K) then
     if not SetSVGAMode(XRes,YRes,grSVGA64K) then
      if not SetSVGAMode(XRes,YRes,grSVGA4G) then
       SetTextMode
 end;
 if (mgColorMode=grText) and (grMode=grSVGA256) then
  SetMCGAMode
 else begin
  if mgColorMode=grText then begin
   SetTextMode;
   Writeln('Can`t initialize required video mode');
   Halt(0);
  end;
 end;
 X:=0;
 Y:=0;
 if x>360 then Step:=4 else Step:=2;
 if dy<mgYRes then y:=y+trunc((mgYRes-dy)/2);
 if dx<mgXRes then x:=x+trunc((mgXRes-dx)/2);
 if ImageType=FLIC then begin
  FLIPlay(x,y,0);
  FLIDone;
 end else begin
  MultiKeysInit;
  FlushKeys:=true;
  Show:=true;
  repeat
   if Show then begin
    case ImageType of
     VIM: if not PalFlag then PutVIM(X,Y,ImageAddr,true) else PutVIM(X,Y,ImageAddr,false);
     CEL: if not PalFlag then PutCEL(X,Y,ImageAddr,true) else PutCEL(X,Y,ImageAddr,false);
     PCX: if not PalFlag then PutPCX(X,Y,ImageAddr,true) else PutPCX(X,Y,ImageAddr,false);
     BMP: if not PalFlag then PutBMP(X,Y,ImageAddr,true) else PutBMP(X,Y,ImageAddr,false);
     GIF: if not PalFlag then PutGIF(X,Y,ImageAddr,true) else PutGIF(X,Y,ImageAddr,false);
     LBM: if not PalFlag then PutLBM(X,Y,ImageAddr,true) else PutLBM(X,Y,ImageAddr,false);
     TGA: if not PalFlag then PutTGA(X,Y,ImageAddr,true) else PutTGA(X,Y,ImageAddr,false);
    end;
    PalFlag:=true;
    Show:=false;
   end;
   if (TestKey($50)) and (y+dy-step-1>mgYRes) then begin dec(y,step); Show:=true; end;
   if (TestKey($48)) and (y+step<0) then begin inc(y,step); Show:=true; end;
   if (TestKey($50)) and (y+dy-1>mgYRes) then begin dec(y,1); Show:=true; end;
   if (TestKey($48)) and (y<0) then begin inc(y,1); Show:=true; end;
   if (TestKey($4d)) and (x+dx-step-1>mgXRes) then begin dec(x,step); Show:=true; end;
   if (TestKey($4b)) and (x+step<0) then begin inc(x,step); Show:=true; end;
   if (TestKey($4d)) and (x+dx-1>mgXRes) then begin dec(x,1); Show:=true; end;
   if (TestKey($4b)) and (x<0) then begin inc(x,1); Show:=true; end;
  until TestKey(1);
  MultiKeysDone;
  FreeBuffer(ImageAddr,n);
 end;
 SetTextMode;
 Writeln;
 case ImageType of
  VIM:  iType:='VGA image (VIM)';
  CEL:  iType:='Autodesk image CEL';
  PCX:  iType:='standard 256-colored PCX';
  BMP:  iType:='Microsoft Windows BitMap (BMP)';
  GIF:  iType:='standard GIF';
  LBM:  iType:='Amiga`s LBM image (PBM format)';
  TGA:  iType:='tagged image (TARGA)';
  FLIC: iType:='Autodesk animation file (FLI)';
 end;
 Writeln('File ',name,' is a ',iType,': ',Dx,'x',Dy,', ',(grMode-grSVGA16)*8,' bps');
 Writeln;
 FlushKeyboard;
end.
