{$g+,n-,d-,l-,b-,r-,o-,f-,s-,a+,e-,p-,q-,t+,v-,x+,i-}

(*            VGA Image (VIM) to VGA Images Set (VIS) Convertor            *)
(*                                                                         *)
(*                  BEST GAME SDK FOR TURBO/BORLAND PASCAL                 *)
(*                ͻ         ͻ ͻ               *)
(*                ͼ    ͻ ͻ  ͻ   ͼ                  *)
(*                   ͼͼ  ͼ͹ ͼ  ͼ                  *)
(*                        ͻ   ͼ                                *)
(*                 :     ͹˻ ͻ  .Ĵ               *)
(*               | |  .    ͼ              *                   *)
(*               -+-    . ʼ       ʼ     ʼ   .  +                 *)
(*                |   .        version 2.0       .      :                 *)
(*                 BY VADIM BODROV, RUSSIA  (c) 1996-98   |               *)

program vim2vis;

uses DOSUtil,MemPlus,MegaGraf,i80386;

var  Name,Ext,RName:  String;
     Tmp:             String;
     Mode:            Byte;
     CompSts:         Byte;
     Count:           Word;
     CompNum:         Byte;
     f:               File;
     f1:              Text;
     Offs,FullSize:   LongInt;
     SizeX,SizeY:     Word;
     j,n:             Word;
     PalLen,Pc:       Word;
     Flag:            Boolean;
     Ml:              Byte;
     BPS:             Byte;
     Descript:        String;

 procedure ShowHelp;
 begin
  Writeln('Usage: VIM2VIS filename [description]');
  Writeln('       filename     - VIM or IFL file');
 end;

 procedure NextVIM;
 var i: Word;
     b: Byte;
     Size: LongInt;
 begin
  Offs:=0;
  if not ReadFromFile(RName,mgBufferPtr,0,8) then begin
   Writeln('Can`t read file ',RName);
   Halt(0);
  end;
  if GetStr(mgBufferPtr,3)<>'VIM' then begin
   Writeln(RName,' is not a VIM (VGA Image file)');
   Halt(0);
  end;
  if BPS=$FF then BPS:=xGetByte(mgBufferPtr,3);
  if (xGetByte(mgBufferPtr,3) and $E0)<>(BPS and $E0) then begin
   Writeln('All VIM files must be in same color model!');
   Halt(0);
  end;
  Pc:=xGetByte(mgBufferPtr,4);
  if xGetByte(mgBufferPtr,3)=1 then begin
   CompSts:=1;
   CompNum:=xGetByte(mgBufferPtr,5);
   PalLen:=xGetWord(mgBufferPtr,6);
   Offs:=LongAdd(Offs,8);
  end else begin
   CompSts:=0;
   PalLen:=xGetWord(mgBufferPtr,5);
   Offs:=LongAdd(Offs,7);
  end;
  ReadFromFile(RName,mgBufferPtr,Offs,PalLen*3);
  Offs:=LongAdd(Offs,3*PalLen);
  ReadFromFile(RName,@SizeX,Offs,2);
  ReadFromFile(RName,@SizeY,Offs+2,2);
  inc(Offs,4);
  if not Flag then begin
{$i-}
   Assign(f,Name+'.VIS');
   Rewrite(f,1);
   Tmp:='VIS';
   BlockWrite(f,Tmp[1],3);
   BlockWrite(f,Descript[0],1);
   if Byte(Descript[0])>0 then BlockWrite(f,Descript[1],Byte(Descript[0]));
   case (BPS shr 5) of
        0: b:=1;
        1: b:=2;
        2: b:=2;
        3: b:=3;
        4: b:=4;
   end;
   Mode:=b;
   BlockWrite(f,b,1);
   BlockWrite(f,Count,2);
{$i+}
   if IOResult<>0 then begin
    Writeln('Can`t create .VIS file)');
    Halt(0);
   end;
{$i-}
  end; {if not Flag}
  FullSize:=SizeOfFile(RName);
  Size:=FullSize-Offs+PalLen*3+4+2+2+1+1+2+1;
  BlockWrite(f,Size,4);
  BlockWrite(f,SizeX,2);
  BlockWrite(f,SizeY,2);
  BlockWrite(f,CompSts,1);
  BlockWrite(f,CompNum,1);
  BlockWrite(f,PalLen,2);
  BlockWrite(f,pc,1);
  if PalLen>0 then BlockWrite(f,mgBufferPtr^,PalLen*3);
  repeat
   if (FullSize-Offs)>1024 then i:=1024 else i:=FullSize-Offs;
   ReadFromFile(RName,mgBufferPtr,Offs,i);
   Offs:=LongAdd(Offs,i);
   BlockWrite(f,mgBufferPtr^,i);
  until Offs=FullSize;
  Flag:=true;
 end;

begin
 Writeln;
 Writeln('VGA Image (VIM) to VGA Images Set (VIS) Convertor');
{$IFDEF DPMI}
 Writeln(' // Protected Mode');
{$ELSE}
 Writeln(' // Real Mode');
{$ENDIF}
 Writeln('Copyright (c) 1996-98 by Vadim Bodrov (falkoris@hotmail.com)');
 Writeln('This program is a part of PLUS SYSTEM PRO 2.0 GDK FOR BORLAND PASCAL');
  if ParamCount=0 then begin
   ShowHelp;
   exit;
  end;
  Ext:='.VIM';
  Name:=ParamStr(1);
  if Name[Length(Name)-3]='.' then begin
   Ext:=Copy(Name,Length(Name)-3,4);
   Name:=Copy(Name,1,Length(Name)-4);
  end;
  for Count:=1 to Length(Ext) do Ext[Count]:=UpCase(Ext[Count]);
  Descript:='';
  if Ext='.IFL' then begin
   Count:=0;
{$i-}
   Assign(f1,Name+Ext);
   Reset(f1);
{$i+}
   if IOResult<>0 then begin Writeln('Can`t find file!'); Halt(0); exit; end;
   repeat
    Readln(f1,Tmp);
    Inc(Count);
   until EOF(f1);
  end else Count:=1;
  if ParamCount>1 then
   for j:=2 to ParamCount do Descript:=Descript+' '+ParamStr(j);
  BPS:=$FF;
  if Ext='.IFL' then begin
   Reset(f1);
   for j:=1 to Count do begin
    Readln(f1,RName);
    NextVIM;
   end;
  end else begin RName:=Name+'.VIM'; NextVIM; end;
  if Ext='.IFL' then Close(f1);
  Close(f);
  Writeln(Name,'.vim info:');
  Writeln('Bits per pixel:   ',Mode);
  Writeln('Number of images: ',Count);
end.

