unit BIOSTime;
(* BIOS timer resolution is 0.06 sec *)

interface

procedure TimerReset;
function TimerRead:single;
procedure TimerWait(Seconds:single);


implementation
{$S-,Q-,R-}
var Ticks:longint;

procedure TimerReset;
begin
{$IFNDEF __TMT__}
 Ticks:=MemL[Seg0040:$006C];
{$ELSE}
 Ticks:=MemD[$46C];
{$ENDIF}
end;

function TimerRead:single;
var TickDelta:longint;
begin
{$IFNDEF __TMT__}
 TickDelta:=MemL[Seg0040:$006C]-Ticks;
{$ELSE}
 TickDelta:=MemD[$46C]-Ticks;
{$ENDIF}
 if TickDelta<0 then Inc(TickDelta,$FFFFFFFF);
 TimerRead:=TickDelta/18.2;
end;

procedure TimerWait(Seconds:single);
begin
 TimerReset;
 while TimerRead<Seconds do;
end;

end.
