(********************************************)
(* Gamma correction demonstration           *)
(********************************************)
(* Example program for VRG SuperVGA library *)
(* Copyleft (C) 1998-1999 Virtual Research  *)
(********************************************)

uses LFB256,CRT;
var Pal,NewPal:TPalette;
    i:byte;
    Gamma:single;
    c:char;

function SinglToStr(v:single):string;
begin
 str(v:4:2,Result);
end;

{$i font.inc}

var BrightestColor,DarkestColor:byte;

procedure GetBrightestColor(var palette:TPalette);
        (* Gets darkest and brightest colors from palette *)
var i,R,G,B:byte;
    Brightness,Darkness:word;
begin
 R:=palette[0].R;
 G:=palette[0].G;
 B:=palette[0].B;
 Brightness:=R+G+B;
 Darkness:=Brightness;
 BrightestColor:=0;
 DarkestColor:=0;
 for i:=1 to 255 do begin
  R:=palette[i].R;
  G:=palette[i].G;
  B:=palette[i].B;
  if (R+G+B)>Brightness then begin
   Brightness:=R+G+B;
   BrightestColor:=i;
  end;
  if (R+G+B)<Darkness then begin
   Darkness:=R+G+B;
   DarkestColor:=i;
  end;
 end;
end;

begin
 if (ParamCount=0) or (Pos('?',ParamStr(1))<>0) then begin
  WriteLn('Usage: gammatst <pcx file>');
  Halt;
 end;
 _Get_PCX_Palette(ParamStr(1),Pal);
 GetBrightestColor(Pal);
 _VBE2_Init;
 _SetMode(_640x480);
 _SetPalette(pal);
 _PCX_Display(ParamStr(1),0,0,0);
 _SetFont(@Font);
 Gamma:=1;
 _WriteOverlappedText(0,0,'Gamma = '+SinglToStr(gamma),
                      BrightestColor,DarkestColor);
 _WriteTransparentText(0,16,'Use <+> and <-> keys to change Gamma value, <esc> to quit',
                      BrightestColor);
 repeat
  c:=ReadKey;
  if c='+' then begin
   if Gamma<2 then gamma+:=0.01;
   _WriteOverlappedText(0,0,'Gamma = '+singltostr(gamma),
                        BrightestColor,DarkestColor);
   Move(Pal,Newpal,768);
(* _GammaCorrect(Newpal,Gamma); *)
   _GammaCorrectRGB(Newpal,Gamma);
   _SetPalette(newpal);
  end;
  if c='-' then begin
   if gamma>0.5 then gamma-:=0.01;
   _WriteOverlappedText(0,0,'Gamma = '+SinglToStr(gamma),
                        BrightestColor,DarkestColor);
   move(pal,newpal,768);
(* _GammaCorrect(Newpal,Gamma); *)
   _GammaCorrectRGB(Newpal,Gamma);
   _SetPalette(Newpal);
  end;
 until c=#27;
end.
