(*************************************)
(* VGA 320x200x256 graphics routines *)
(* v. 4.02  16.Jul.1999              *)
(* System: DOS/DPMI16                *)
(* (C)oded by Asp / VR group         *)
(*************************************)

unit VGA256;
{$X+,N+,E+,G+,S-,R-,Q-,V-,B-,O-}

interface

 const Version='4.02';

 var vgaTransparentColor:byte;
     vgaMinClipX,vgaMinClipY,
     vgaMaxClipX,vgaMaxClipY:word;      (* Clipwindow *)

 type TRGB=record
  R,G,B:byte;
 end;

      TPalette=array[0..255] of TRGB;

 function  vgaSetMode:boolean;

 procedure vgaPutPixel(x,y:word;color:byte);
 procedure vgaPutTransparentPixel(x,y:word;color:byte);
 procedure vgaGetPixel(x,y:word;var color:byte);
 procedure vgaLine(x1,y1,x2,y2:word;color:byte);
 procedure vgaMaskedLine(x1,y1,x2,y2:word;color:byte;mask:word);
 procedure vgaEllipse(xc,yc,rx,ry:word;color:byte);
 procedure vgaFilledEllipse(xc,yc,rx,ry:word;color:byte);
 procedure vgaBox(x1,y1,x2,y2:word;color,fill:byte);
 procedure vgaHLine(x1,x2,y:word;color:byte);
 procedure vgaVLine(x,y1,y2:word;color:byte);
 procedure vgaTriangle(x1,y1,x2,y2,x3,y3:word;color:byte);
 procedure vgaFilledTriangle(x1,y1,x2,y2,x3,y3:integer;color:byte);
 procedure vgaFilledPolygon(var VertexArray;NumOfVertexes,color:byte);

 procedure _vgaPutPixel(x,y:integer;color:byte);
 procedure _vgaPutTransparentPixel(x,y:integer;color:byte);
 procedure _vgaGetPixel(x,y:integer;var color:byte);
 procedure _vgaLine(x1,y1,x2,y2:integer;color:byte);
 procedure _vgaMaskedLine(x1,y1,x2,y2:integer;color:byte;mask:word);
 procedure _vgaEllipse(xc,yc:integer;rx,ry:word;color:byte);
 procedure _vgaFilledEllipse(xc,yc:integer;rx,ry:word;color:byte);
 procedure _vgaBox(x1,y1,x2,y2:integer;color,fill:byte);
 procedure _vgaHLine(x1,x2,y:integer;color:byte);
 procedure _vgaVLine(x,y1,y2:integer;color:byte);
 procedure _vgaTriangle(x1,y1,x2,y2,x3,y3:integer;color:byte);
 procedure _vgaFilledTriangle(x1,y1,x2,y2,x3,y3:integer;color:byte);
 procedure _vgaFilledPolygon(var VertexArray;NumOfVertexes,color:byte);

 procedure vgaSetPalette(var pal);
 procedure vgaFixedPalette(var pal);
 procedure vgaGetPalette(var pal);
 procedure vgaSetColor(clr,r,g,b:byte);
 procedure vgaGetColor(clr:byte;var r,g,b:byte);
 procedure vgaFadeIn(pal:array of byte;speed:single);
 procedure vgaFadeOut(pal:array of byte;speed:single);

 procedure vgaFill(color:byte);
 procedure vgaSetTextMode;
 procedure vgaWaitVSync;
 procedure vgaRestoreDisplayBounds;

 procedure vgaLoadPCX(filename:string;fileoffset:longint;x,y:word);
 procedure vgaGetPCXPalette(filename:string;var palette);
 procedure vgaSavePCX(filename:string;x1,y1,x2,y2:word);
 procedure vgaGetPCXSize(filename:string;fileoffset:longint;var x,y:word);

 procedure vgaGetImage(x1,y1,x2,y2:word;clip:pointer);
 procedure vgaPutImage(x1,y1:integer;width,height:word;clip:pointer);
 procedure vgaPutTransparentImage(x1,y1:integer;width,height:word;clip:pointer);
 procedure vgaXORImage(x1,y1:integer;width,height:word;clip:pointer);
{$IFNDEF DPMI}
 procedure vgaPutLargeImage(x1,y1:integer;width,height:word;handle:word);
{$ELSE}
 procedure vgaPutLargeImage(x1,y1:integer;width,height:word;image:pointer);
{$ENDIF}

 procedure vgaWriteStr(x,y:word;S:string;color:byte);
 procedure vgaSetFont(p:pointer);

 function  vgaAllocVirtualScreen:pointer;
 procedure vgaFreeVirtualScreen(segment:pointer);
 procedure vgaSetVirtualOutput(segment:pointer);
 procedure vgaSetNormalOutput;
 procedure vgaFlushVirtualScreen(segment:pointer);
 procedure vgaMoveToVirtualScreen(segment:pointer);

 function Copyleft_Id:string;

implementation
uses memory, Mem32 {$IFNDEF DPMI}, XManager {$ENDIF};

var {$IFNDEF DPMI} XMDescriptor:TxmmMoveStruc; {$ENDIF}
    FontPtr:pointer;
    Copyleft:string;
    VideoSeg:word;

function vgaSetMode:boolean;assembler;
        (* Set VGA $13 videomode *)
asm
 mov ax,$13
 int $10
 mov ax,$0F00
 int $10
 and ax,$00FF
 cmp ax,$13
 je @@2
 xor ax,ax
 jmp @@exit
@@2:
 mov vgaTransparentColor,0
 mov vgaMinClipX,0
 mov vgaMinClipY,0
 mov vgaMaxClipX,319
 mov vgaMaxClipY,199
 mov ax,1
@@exit:
end;

(***************************************************************************

                        PutPixel and GetPixel ones

****************************************************************************)

procedure vgaPutPixel(x,y:word;color:byte);assembler;
asm
 mov es,VideoSeg
 mov bx,y
 mov di,x
 shl bx,6
 add di,bx
 shl bx,2
 add di,bx
 mov al,color
 mov es:[di],al
end;

procedure vgaPutTransparentPixel(x,y:word;color:byte);assembler;
 (* This version of PutPixel will not display
    color, if it's equal to vgaTransparentColor *)
asm
 mov al,vgaTransparentColor
 cmp al,color
 je @exit
 mov es,VideoSeg
 mov bx,y
 mov di,x
 shl bx,6
 add di,bx
 shl bx,2
 add di,bx
 mov al,color
 mov es:[di],al
@exit:
end;

procedure vgaGetPixel(x,y:word;var color:byte);assembler;
asm
 mov es,VideoSeg
 mov bx,y
 mov si,x
 shl bx,6
 add si,bx
 shl bx,2
 add si,bx
 mov al,es:[si]
 les di,color
 mov es:[di],al
end;

(***************************************************************************

                       PutPixel and GetPixel w/ clipping

****************************************************************************)

procedure _vgaPutPixel(x,y:integer;color:byte);
begin
 if (x>=vgaMinClipX) and (x<=vgaMaxClipX) and
    (y>=vgaMinClipY) and (y<=vgaMaxClipY) then
  vgaPutPixel(x,y,color);
end;

procedure _vgaPutTransparentPixel(x,y:integer;color:byte);
begin
 if (x>=vgaMinClipX) and (x<=vgaMaxClipX) and
    (y>=vgaMinClipY) and (y<=vgaMaxClipY) then
  vgaPutTransparentPixel(x,y,Color);
end;

procedure _vgaGetPixel(x,y:integer;var color:byte);
begin
 if (x>=vgaMinClipX) and (x<=vgaMaxClipX) and
    (y>=vgaMinClipY) and (y<=vgaMaxClipY) then
  vgaGetPixel(x,y,color);
end;

(***************************************************************************

                         Palette routines

****************************************************************************)

procedure vgaSetPalette(var pal); assembler;
        (* Set palette from pal *)
asm
 mov dx,$3C8
 xor al,al
 out dx,al
 push ds
 lds si,pal
 cld
 inc dx
 mov cx,768
 rep outsb
 pop ds
end;

procedure vgaSetColor(clr,r,g,b:byte);assembler;
asm
 mov dx,$3C8
 mov al,clr
 out dx,al
 mov dx,$3C9
 mov al,r
 out dx,al
 mov al,g
 out dx,al
 mov al,b
 out dx,al
end;

procedure vgaGetColor(clr:byte;var r,g,b:byte);assembler;
asm
 mov dx,$3C7
 mov al,clr
 out dx,al
 mov dx,$3C9
 les di,r
 in al,dx
 mov es:[di],al
 les di,g
 in al,dx
 mov es:[di],al
 les di,b
 in al,dx
 mov es:[di],al
end;

procedure vgaFixedPalette(var pal);assembler;
asm
 mov dx,$3DA
@@1:
 in al,dx
 test al,8
 jz @@1
 mov dx,$3C8
 xor al,al
 out dx,al
 push ds
 lds si,pal
 cld
 inc dx
 mov cx,768
 rep outsb
 pop ds
end;

procedure vgaGetPalette(var pal); assembler;
asm
 mov dx,$3C7
 xor al,al
 out dx,al
 les di,pal
 cld
 inc dx
 inc dx
 mov cx,768
 rep insb
end;

procedure vgaFadeIn(pal:array of byte;speed:single);
        (* Fade in to pal *)
var delta:array [0..767] of single;
    realpal:array [0..767] of single;
    i,j:word;
begin
 for i:=0 to 767 do begin
  realpal[i]:=pal[i];
  delta[i]:=realpal[i]/speed;
  realpal[i]:=0;
 end;
 for i:=1 to trunc(speed) do begin
  for j:=0 to 767 do begin
   realpal[j]:=realpal[j]+delta[j];
   pal[j]:=round(realpal[j]);
  end;
  vgaFixedPalette(pal[0]);
 end;
end;

procedure vgaFadeOut(pal:array of byte;speed:single);
        (* Fade out of pal *)
var delta:array [0..767] of real;
    realpal:array [0..767] of real;
    i,j:word;
begin
 for i:=0 to 767 do begin
  realpal[i]:=pal[i];
  delta[i]:=realpal[i]/speed;
 end;
 for i:=1 to trunc(speed) do begin
  for j:=0 to 767 do begin
   realpal[j]:=realpal[j]-delta[j];
   pal[j]:=trunc(realpal[j]);
  end;
  vgaFixedPalette(pal[0]);
 end;
end;

(***************************************************************************

                         Drawing routines

****************************************************************************)

procedure vgaHLine(x1,x2,y:word;color:byte);assembler;
        (* Fast horizontal line *)
asm
 cld
 mov es,VideoSeg
 mov bx,y
 mov ax,y
 shl bx,8
 shl ax,6
 add ax,bx
 add ax,x1
 mov di,ax
 mov cx,x2
 sub cx,x1
 inc cx
 mov al,color
 mov ah,al
 mov bx,ax
 db $66; shl ax,16     (* shl eax,16 *)
 mov ax,bx
 mov bx,cx
 shr cx,2
 db 66h; rep stosw     (* rep stosd *)
 and bx,3
 mov cx,bx
 rep stosb
end;

procedure vgaVLine(x,y1,y2:word;color:byte);assembler;
        (* Fast vertical line *)
asm
 mov es,VideoSeg
 mov bx,y1
 mov ax,y1
 shl bx,8
 shl ax,6
 add ax,bx
 add ax,x
 mov di,ax
 mov al,color
 mov cx,y2
 sub cx,y1
 inc cx
@@1:
 stosb
 add di,319
loop @@1
end;

procedure vgaLine(x1,y1,x2,y2:word;color:byte);assembler;
        (* This is Bresenham's line *)
var d,_dx,_dy,aincr,bincr,yincr:integer;
asm
 mov ax,x1
 cmp ax,x2
 je @@Vertical
 jbe @@1                (* if x1>x2 *)
 mov bx,x2
 mov x1,bx
 mov x2,ax              (* swap x1,x2 *)
 mov ax,y1
 mov bx,y2
 mov y1,bx
 mov y2,ax              (* swap y1,y2 *)
@@1:
 mov cx,320
 mov ax,y1
 mov bx,y2
 cmp bx,ax
 ja @@2                 (* if y2>y1 *)
 neg cx                 (* yincr=-320 *)
@@2:
 mov yincr,cx           (* else yincr=320 *)
 sub bx,ax              (* bx <- (y2-y1) *)
 jns @@3
 neg bx
@@3:
 mov _dy,bx             (* _dy=abs(y2-y1) *)
 mov ax,x2
 sub ax,x1
 mov _dx,ax             (* _dx=x2-x1 *)
 cmp ax,bx
 jb @@45                (* if _dx>=_dy *)
 shl bx,1
 mov bincr,bx           (* bincr=2*_dy *)
 sub bx,ax
 mov d,bx               (* d=2*_dy-_dx *)
 mov ax,_dy
 sub ax,_dx
 jmp @@Continue
@@45:                   (* else *)
 shl ax,1
 mov bincr,ax           (* bincr=2*_dx *)
 sub ax,bx
 mov d,ax               (* d=2*_dx-_dy *)
 mov ax,_dx
 sub ax,_dy
@@Continue:
 sal ax,1
 mov aincr,ax           (* aincr=2*(_dx-_dy) or aincr=2*(_dy-_dx) *)

 mov es,VideoSeg
 mov bx,y1
 mov di,x1
 shl bx,6
 add di,bx
 shl bx,2
 add di,bx
 mov bl,color
 mov es:[di],bl         (* PutPixel(x,y) *)

 mov dx,yincr
 mov ax,_dx
 cmp ax,_dy
 jb @@LessThen45

@@6:
 inc di                 (* x+=1 *)
 inc x1
 mov ax,d
 cmp ax,0
 js @@4                 (* if d>=0 *)
 add di,dx              (* y+=yincr *)
 add ax,aincr           (* d+=aincr *)
 jmp @@5
@@4:                    (* else *)
 add ax,bincr           (* d+=bincr *)
@@5:
 mov d,ax
 mov es:[di],bl         (* PutPixel(x,y) *)

 mov ax,x2
 cmp ax,x1
 ja @@6                 (* if x<x2 then loop *)
 jmp @@Exit

@@LessThen45:
 xor dx,0
 jns @@Positive
 mov cx,-1
 jmp @@6_
@@Positive:
 mov cx,1
@@6_:
 add di,dx              (* y+=yinc *)
 add y1,cx
 mov ax,d
 cmp ax,0
 js @@4_                (* if d>=0 *)
 inc di                 (* x+=1 *)
 add ax,aincr           (* d+=aincr *)
 jmp @@5_
@@4_:                   (* else *)
 add ax,bincr           (* d+=bincr *)
@@5_:
 mov d,ax
 mov es:[di],bl         (* PutPixel(x,y) *)

 mov ax,y2
 cmp ax,y1
 jne @@6_               (* if y<y2 then loop *)
 jmp @@Exit

@@Vertical:             (* draw vertical line *)
 mov ax,y1
 cmp ax,y2
 jbe @@7                (* if y1>y2 *)
 mov bx,y2
 mov y1,bx
 mov y2,ax              (* swap y1,y2 *)
@@7:
 mov es,VideoSeg
 mov di,x1
 mov bx,y1
 shl bx,6
 add di,bx
 shl bx,2
 add di,bx
 mov al,color           (* al <- color *)
 mov cx,y2
 sub cx,y1
 inc cx                 (* cx <- number of pixels *)
 mov dx,320
@@8:
 mov es:[di],al         (* fill line *)
 add di,dx
 loop @@8

@@Exit:
end;

procedure vgaMaskedLine(x1,y1,x2,y2:word;color:byte;mask:word);assembler;
var d,_dx,_dy,aincr,bincr,yincr:integer;
asm
 mov ax,x1
 cmp ax,x2
 je @@Vertical
 jbe @@1                (* if x1>x2 *)
 mov bx,x2
 mov x1,bx
 mov x2,ax              (* swap x1,x2 *)
 mov ax,y1
 mov bx,y2
 mov y1,bx
 mov y2,ax              (* swap y1,y2 *)
@@1:
 mov cx,320
 mov ax,y1
 mov bx,y2
 cmp bx,ax
 ja @@2                 (* if y2>y1 *)
 neg cx                 (* yincr=-320 *)
@@2:
 mov yincr,cx           (* else yincr=320 *)
 sub bx,ax              (* bx <- (y2-y1) *)
 jns @@3
 neg bx
@@3:
 mov _dy,bx             (* _dy=abs(y2-y1) *)
 mov ax,x2
 sub ax,x1
 mov _dx,ax             (* _dx=x2-x1 *)
 cmp ax,bx
 jb @@45                (* if _dx>=_dy *)
 shl bx,1
 mov bincr,bx           (* bincr=2*_dy *)
 sub bx,ax
 mov d,bx               (* d=2*_dy-_dx *)
 mov ax,_dy
 sub ax,_dx
 jmp @@Continue
@@45:                   (* else *)
 shl ax,1
 mov bincr,ax           (* bincr=2*_dx *)
 sub ax,bx
 mov d,ax               (* d=2*_dx-_dy *)
 mov ax,_dx
 sub ax,_dy
@@Continue:
 sal ax,1
 mov aincr,ax           (* aincr=2*(_dx-_dy) or aincr=2*(_dy-_dx) *)

 mov es,VideoSeg
 mov bx,y1
 mov di,x1
 shl bx,6
 add di,bx
 shl bx,2
 add di,bx
 mov bl,color
 rol mask,1
 jnc @@Skip1stPix
 mov es:[di],bl         (* PutPixel(x,y) *)
@@Skip1stPix:

 mov dx,yincr
 mov ax,_dx
 cmp ax,_dy
 jb @@LessThen45

@@6:
 inc di                 (* x+=1 *)
 inc x1
 mov ax,d
 cmp ax,0
 js @@4                 (* if d>=0 *)
 add di,dx              (* y+=yincr *)
 add ax,aincr           (* d+=aincr *)
 jmp @@5
@@4:                    (* else *)
 add ax,bincr           (* d+=bincr *)
@@5:
 mov d,ax
 rol mask,1
 jnc @@SkipPix
 mov es:[di],bl         (* PutPixel(x,y) *)
@@SkipPix:

 mov ax,x2
 cmp ax,x1
 ja @@6                 (* if x<x2 then loop *)
 jmp @@Exit

@@LessThen45:
 xor dx,0
 jns @@Positive
 mov cx,-1
 jmp @@6_
@@Positive:
 mov cx,1
@@6_:
 add di,dx              (* y+=yinc *)
 add y1,cx
 mov ax,d
 cmp ax,0
 js @@4_                (* if d>=0 *)
 inc di                 (* x+=1 *)
 add ax,aincr           (* d+=aincr *)
 jmp @@5_
@@4_:                   (* else *)
 add ax,bincr           (* d+=bincr *)
@@5_:
 mov d,ax
 rol mask,1
 jnc @@SkipPix_
 mov es:[di],bl         (* PutPixel(x,y) *)
@@SkipPix_:

 mov ax,y2
 cmp ax,y1
 jne @@6_               (* if y<y2 then loop *)
 jmp @@Exit

@@Vertical:             (* draw vertical line *)
 mov ax,y1
 cmp ax,y2
 jbe @@7                (* if y1>y2 *)
 mov bx,y2
 mov y1,bx
 mov y2,ax              (* swap y1,y2 *)
@@7:
 mov es,VideoSeg
 mov bx,y1
 mov di,x1
 shl bx,6
 add di,bx
 shl bx,2
 add di,bx
 mov al,color           (* al <- color *)
 mov cx,y2
 sub cx,y1
 inc cx                 (* cx <- number of pixels *)
 mov dx,320
@@8:
 rol mask,1
 jnc @@SkipPix__
 mov es:[di],al         (* fill line *)
@@SkipPix__:
 add di,dx
 loop @@8

@@Exit:
end;

procedure vgaBox(x1,y1,x2,y2:word;color,fill:byte);assembler;
var count,ofset:word;
asm
 push x1                (* Draw left and right sides *)
 push y1
 push y2
 push word ptr color
 call vgaVLine
 push x2
 push y1
 push y2
 push word ptr color
 call vgaVLine
 push x1                     (* Draw top line of box *)
 push x2
 push y1
 push word ptr color
 call vgaHLine

 cld
 mov es,VideoSeg
 mov ax,x2      (* Check if zero-width box *)
 sub ax,x1
 jz @@exit
 dec ax
 jz @@exit
 mov count,ax
 inc x1
 mov ax,y2      (* Check if zero-height box *)
 sub ax,y1
 jz @@exit
 dec ax
 jz @@4
 inc y1

 mov al,vgaTransparentColor
 cmp al,fill                    (* filled rectangle? *)
 je @@4                         (* if no, go to bottom line drawing *)

 mov bx,y1
 mov ax,y1
 shl bx,8
 shl ax,6
 add ax,bx
 add ax,x1
 mov ofset,ax

@@7:
 mov di,ofset
 mov cx,count
 mov al,fill
 mov ah,al
 mov bx,ax
 db $66; shl ax,16     (* shl eax,16 *)
 mov ax,bx
 mov bx,cx
 shr cx,2
 db 66h; rep stosw     (* rep stosd *)
 and bx,3
 mov cx,bx
 rep stosb
 add ofset,320
 inc y1
 mov ax,y2
 cmp ax,y1              (* while y<y2 *)
 jne @@7

@@4:                    (* Draw bottom line *)
 dec x1
 push x1
 push x2
 push y2
 push word ptr color
 call vgaHline
@@exit:         (* Voila! *)
end;

procedure vgaFill(color:byte);assembler;
        (* fill entire screen with color *)
asm
 mov es,VideoSeg
 xor di,di
 mov cx,16000
 mov al,color
 mov ah,al
 mov bx,ax
 db $66; shl ax,16
 mov ax,bx
 db $66; rep stosw
end;

procedure vgaEllipse(xc,yc,rx,ry:word;color:byte);
var x,y:word;
    a,b,as,tas,bs,tbs:longint;
    d,dx,dy:longint;
begin
 if rx=0 then begin
  vgaVLine(xc,yc-ry,yc+ry,color); exit;
 end;
 if ry=0 then begin
  vgaHLine(xc-rx,xc+rx,yc,color); exit;
 end;
 x:=0; y:=ry; a:=rx; b:=ry; as:=a*a;
 tas:=as shl 1; bs:=b*b; tbs:=bs shl 1;
 d:=bs-as*b+(as shr 2); dx:=0; dy:=tas*b;
 while dx<dy do begin
  vgaPutPixel(xc+x,yc+y,color);
  vgaPutPixel(xc-x,yc+y,color);
  vgaPutPixel(xc+x,yc-y,color);
  vgaPutPixel(xc-x,yc-y,color);
  if d>0 then begin y:=y-1; dy:=dy-tas; d:=d-dy; end;
  x:=x+1; dx:=dx+tbs; d:=d+bs+dx;
 end;
 d:=d+((3*(as-bs)div 2-(dx+dy))div 2);
 while y>0 do begin
  vgaPutPixel(xc+x,yc+y,color);
  vgaPutPixel(xc-x,yc+y,color);
  vgaPutPixel(xc+x,yc-y,color);
  vgaPutPixel(xc-x,yc-y,color);
  if d<0 then begin x:=x+1; dx:=dx+tbs; d:=d+dx; end;
  y:=y-1; dy:=dy-tas; d:=d+as-dy;
 end;
 vgaPutPixel(xc+x,yc,color);
 vgaPutPixel(xc-x,yc,color);
end;

procedure vgaFilledEllipse(xc,yc,rx,ry:word;color:byte);
        (* Filled ellipse *)
var x,y:word;
    a,b,as,tas,bs,tbs:longint;
    d,dx,dy:longint;
begin
 if rx=0 then begin
  vgaVLine(xc,yc-ry,yc+ry,color); exit;
 end;
 if ry=0 then begin
  vgaHLine(xc-rx,xc+rx,yc,color); exit;
 end;
 x:=0; y:=ry; a:=rx; b:=ry; as:=a*a;
 tas:=as shl 1; bs:=b*b; tbs:=bs shl 1;
 d:=bs-as*b+(as shr 2); dx:=0; dy:=tas*b;
 while dx<dy do begin
  vgaHLine(xc-x,xc+x,yc+y,color);
  vgaHLine(xc-x,xc+x,yc-y,color);
  if d>0 then begin y:=y-1; dy:=dy-tas; d:=d-dy; end;
  x:=x+1; dx:=dx+tbs; d:=d+bs+dx;
 end;
 d:=d+((3*(as-bs)div 2-(dx+dy))div 2);
 while y>0 do begin
  vgaHLine(xc-x,xc+x,yc+y,color);
  vgaHLine(xc-x,xc+x,yc-y,color);
  if d<0 then begin x:=x+1; dx:=dx+tbs; d:=d+dx; end;
  y:=y-1; dy:=dy-tas; d:=d+as-dy;
 end;
 vgaHLine(xc-x,xc+x,yc,color);
end;

procedure vgaTriangle(x1,y1,x2,y2,x3,y3:word;color:byte);
begin
 vgaLine(x1,y1,x2,y2,color);
 vgaLine(x2,y2,x3,y3,color);
 vgaLine(x3,y3,x1,y1,color);
end;

procedure vgaFilledTriangle(x1,y1,x2,y2,x3,y3:integer;color:byte);external;
{$L TRIANGLE.OBJ}

procedure vgaFilledPolygon(var VertexArray;NumOfVertexes,color:byte);
        (* Vertexes must be ordered, and polygon must be convex *)
type TVertex=record
      x,y:integer;
     end;
     TVertexArray=array[1..256] of TVertex;
begin
 if NumOfVertexes=1 then begin
  vgaPutPixel(TVertexArray(VertexArray)[1].x,TVertexArray(VertexArray)[1].y,color);
  Exit;
 end;
 if NumOfVertexes=2 then begin
  vgaLine(TVertexArray(VertexArray)[1].x,TVertexArray(VertexArray)[1].y,
           TVertexArray(VertexArray)[2].x,TVertexArray(VertexArray)[2].y,
           color);
  Exit;
 end;
 repeat
  vgaFilledTriangle(TVertexArray(VertexArray)[1].x,TVertexArray(VertexArray)[1].y,
               TVertexArray(VertexArray)[NumOfVertexes-1].x,TVertexArray(VertexArray)[NumOfVertexes-1].y,
               TVertexArray(VertexArray)[NumOfVertexes].x,TVertexArray(VertexArray)[NumOfVertexes].y,
               color);
  Dec(NumOfVertexes);
 until NumOfVertexes=2;
end;

(***************************************************************************

                         Drawing routines w/ clipping

****************************************************************************)

procedure xchange(var a,b:integer);
var c:integer;
begin
 c:=a;a:=b;b:=c;
end;

function OutCode(x,y:integer):integer;
var code:integer;
begin
 code:=0;
 if x<vgaMinClipX then code:=(code or 1);
 if y<vgaMinClipY then code:=(code or 2);
 if x>vgaMaxClipX then code:=(code or 4);
 if y>vgaMaxClipY then code:=(code or 8);
 OutCode:=code;
end;

function ClipLine(var x1,y1,x2,y2:integer):boolean;

(* This is Sutherland - Cohen clipping algorithm *)

var code1,code2:integer;
    inside,outside:boolean;
begin
 code1:=OutCode(x1,y1);
 code2:=OutCode(x2,y2);
 inside:=(code1 or code2)=0;
 outside:=(code1 and code2)<>0;
 while (not inside) and (not outside) do begin
  if code1=0 then begin
   xchange(x1,x2);
   xchange(y1,y2);
   xchange(code1,code2);
  end;
  if (code1 and 1)<>0 then begin
   y1:=y1+longint(y2-y1)*(vgaMinClipX-x1) div (x2-x1);
   x1:=vgaMinClipX;
  end else
  if (code1 and 2)<>0 then begin
   x1:=x1+longint(x2-x1)*(vgaMinClipY-y1) div (y2-y1);
   y1:=vgaMinClipY;
  end else
  if (code1 and 4)<>0 then begin
   y1:=y1+longint(y2-y1)*(vgaMaxClipX-x1) div (x2-x1);
   x1:=vgaMaxClipX;
  end else
  if (code1 and 8)<>0 then begin
   x1:=x1+longint(x2-x1)*(vgaMaxClipY-y1) div (y2-y1);
   y1:=vgaMaxClipY;
  end;
  code1:=OutCode(x1,y1);
  code2:=OutCode(x2,y2);
  inside:=(code1 or code2)=0;
  outside:=(code1 and code2)<>0;
 end;
 ClipLine:=(not outside);
end;

procedure _vgaLine(x1,y1,x2,y2:integer;color:byte);
begin
 if ClipLine(x1,y1,x2,y2) then vgaLine(x1,y1,x2,y2,color);
end;

procedure _vgaMaskedLine(x1,y1,x2,y2:integer;color:byte;Mask:word);
var MaskShift:word;
begin
 if x1<vgaMinClipX then MaskShift:=(vgaMinClipX-x1) mod 16 else MaskShift:=0;
 if ClipLine(x1,y1,x2,y2) then vgaMaskedLine(x1,y1,x2,y2,color,Mask shl MaskShift);
end;

procedure _vgaHLine(x1,x2,y:integer;color:byte);
begin
 if (y<vgaMinClipY) or (y>vgaMaxClipY) or
    (x1>vgaMaxClipX) or (x2<vgaMinClipX) then Exit;
 if x1<vgaMinClipX then x1:=vgaMinClipX;
 if x2>vgaMaxClipX then x2:=vgaMaxClipX;
 vgaHLine(x1,x2,y,color);
end;

procedure _vgaVLine(x,y1,y2:integer;color:byte);
begin
 if (x<vgaMinClipX) or (x>vgaMaxClipX) or
    (y1>vgaMaxClipY) or (y2<vgaMinClipY) then Exit;
 if y1<vgaMinClipY then y1:=vgaMinClipY;
 if y2>vgaMaxClipY then y2:=vgaMaxClipY;
 vgaVLine(x,y1,y2,color);
end;

procedure _vgaBox(x1,y1,x2,y2:integer;color,fill:byte);
begin
 _vgaHLine(x1,x2,y1,color);
 _vgaVLine(x1,y1,y2,color);
 _vgaVLine(x2,y1,y2,color);
 _vgaHLine(x1,x2,y2,color);
 if fill<>vgaTransparentColor then begin
  if (x1>vgaMaxClipX) or (y1>vgaMaxClipY) or
     (x2<vgaMinClipX) or (y2<vgaMinClipY) then Exit;
  if x1<vgaMinClipX then x1:=vgaMinClipX;
  if y1<vgaMinClipY then y1:=vgaMinClipY;
  if x2>vgaMaxClipX then x2:=vgaMaxClipX;
  if y2>vgaMaxClipY then Y2:=vgaMaxClipY;
  vgaBox(x1+1,y1+1,x2-1,y2-1,fill,fill);
 end;
end;

procedure _vgaEllipse(xc,yc:integer;rx,ry:word;color:byte);
var x,y:word;
    a,b,as,tas,bs,tbs:longint;
    d,dx,dy:longint;
begin
 if rx=0 then begin
  _vgaVLine(xc,yc-ry,yc+ry,Color); Exit;
 end;
 if ry=0 then begin
  _vgaHLine(xc-rx,xc+rx,yc,Color); Exit;
 end;
 x:=0; y:=ry; a:=rx; b:=ry; as:=a*a;
 tas:=as shl 1; bs:=b*b; tbs:=bs shl 1;
 d:=bs-as*b+(as shr 2); dx:=0; dy:=tas*b;
 while dx<dy do begin
  _vgaPutPixel(xc+x,yc+y,Color);
  _vgaPutPixel(xc-x,yc+y,Color);
  _vgaPutPixel(xc+x,yc-y,Color);
  _vgaPutPixel(xc-x,yc-y,Color);
  if d>0 then begin y:=y-1; dy:=dy-tas; d:=d-dy; end;
  x:=x+1; dx:=dx+tbs; d:=d+bs+dx;
 end;
 d:=d+((3*(as-bs)div 2-(dx+dy))div 2);
 while y>0 do begin
  _vgaPutPixel(xc+x,yc+y,Color);
  _vgaPutPixel(xc-x,yc+y,Color);
  _vgaPutPixel(xc+x,yc-y,Color);
  _vgaPutPixel(xc-x,yc-y,Color);
  if d<0 then begin x:=x+1; dx:=dx+tbs; d:=d+dx; end;
  y:=y-1; dy:=dy-tas; d:=d+as-dy;
 end;
 _vgaPutPixel(xc+x,yc,Color);
 _vgaPutPixel(xc-x,yc,Color);
end;

procedure _vgaFilledEllipse(xc,yc:integer;rx,ry:word;Color:byte);
var x,y:word;
    a,b,as,tas,bs,tbs:longint;
    d,dx,dy:longint;
begin
 if rx=0 then begin
  _vgaVLine(xc,yc-ry,yc+ry,Color); Exit;
 end;
 if ry=0 then begin
  _vgaHLine(xc-rx,xc+rx,yc,Color); Exit;
 end;
 x:=0; y:=ry; a:=rx; b:=ry; as:=a*a;
 tas:=as shl 1; bs:=b*b; tbs:=bs shl 1;
 d:=bs-as*b+(as shr 2); dx:=0; dy:=tas*b;
 while dx<dy do begin
  _vgaHLine(xc-x,xc+x,yc+y,Color);
  _vgaHLine(xc-x,xc+x,yc-y,Color);
  if d>0 then begin y:=y-1; dy:=dy-tas; d:=d-dy; end;
  x:=x+1; dx:=dx+tbs; d:=d+bs+dx;
 end;
 d:=d+((3*(as-bs)div 2-(dx+dy))div 2);
 while y>0 do begin
  _vgaHLine(xc-x,xc+x,yc+y,Color);
  _vgaHLine(xc-x,xc+x,yc-y,Color);
  if d<0 then begin x:=x+1; dx:=dx+tbs; d:=d+dx; end;
  y:=y-1; dy:=dy-tas; d:=d+as-dy;
 end;
 _vgaHLine(xc-x,xc+x,yc,Color);
end;

procedure _vgaTriangle(x1,y1,x2,y2,x3,y3:integer;color:byte);
begin
 _vgaLine(x1,y1,x2,y2,color);
 _vgaLine(x2,y2,x3,y3,color);
 _vgaLine(x3,y3,x1,y1,color);
end;

procedure _vgaFilledTriangle(x1,y1,x2,y2,x3,y3:integer;color:byte);external;

procedure _vgaFilledPolygon(var VertexArray;NumOfVertexes,color:byte);
        (* Vertexes must be ordered, and polygon must be convex *)
type TVertex=record
      x,y:integer;
     end;
     TVertexArray=array[1..256] of TVertex;
begin
 if NumOfVertexes=1 then begin
  _vgaPutPixel(TVertexArray(VertexArray)[1].x,TVertexArray(VertexArray)[1].y,color);
  Exit;
 end;
 if NumOfVertexes=2 then begin
  _vgaLine(TVertexArray(VertexArray)[1].x,TVertexArray(VertexArray)[1].y,
           TVertexArray(VertexArray)[2].x,TVertexArray(VertexArray)[2].y,
           color);
  Exit;
 end;
 repeat
  _vgaFilledTriangle(TVertexArray(VertexArray)[1].x,TVertexArray(VertexArray)[1].y,
               TVertexArray(VertexArray)[NumOfVertexes-1].x,TVertexArray(VertexArray)[NumOfVertexes-1].y,
               TVertexArray(VertexArray)[NumOfVertexes].x,TVertexArray(VertexArray)[NumOfVertexes].y,
               color);
  Dec(NumOfVertexes);
 until NumOfVertexes=2;
end;

(***************************************************************************

                        Image manipulation procedures

****************************************************************************)

procedure vgaGetImage(x1,y1,x2,y2:word;clip:pointer);assembler;
        (* Copies image part to buffer *)
var _Width,_Height:word;
asm
 mov ax,x2
 sub ax,x1
 inc ax
 cmp ax,0
 jle @@exit
 mov _Width,ax
 mov ax,y2
 sub ax,y1
 inc ax
 cmp ax,0
 jle @@exit
 mov _Height,ax

 push ds
 mov ds,VideoSeg
 mov bx,y1
 mov si,x1
 shl bx,6
 add si,bx
 shl bx,2
 add si,bx

 mov dx,320
 sub dx,_Width
 les di,clip

 mov bx,_Width
@@1:
 mov cx,bx
 shr cx,2
 db $66; rep movsw
 mov cx,bx
 and cx,3
 rep movsb      (* moved one line *)
 add si,dx      (* set to next line begin *)
 dec _Height    (* all lines already? *)
 jnz @@1
@@exit:
 pop ds
end;

procedure vgaPutImage(x1,y1:integer;width,height:word;clip:pointer);assembler;
        (* Puts previously copied image *)
var TopCut,LeftCut,RightCut,OldWidth:word;
asm
 mov TopCut,0
 mov LeftCut,0
 mov RightCut,0
 mov ax,width
 mov OldWidth,ax

 mov ax,y1
 cmp ax,vgaMaxClipY
 jg @@Exit
 cmp ax,vgaMinClipY
 jge @@1
                (* if cut at top *)
 mov bx,vgaMinClipY
 mov y1,bx
 sub bx,ax
 mov TopCut,bx
 sub height,bx
@@1:
 mov ax,y1
 add ax,height
 dec ax
 cmp ax,vgaMinClipY
 jl @@Exit
 cmp ax,vgaMaxClipY
 jle @@2
                (* if cut at bottom *)
 mov bx,vgaMaxClipY
 sub bx,y1
 inc bx
 mov height,bx
@@2:
 mov ax,x1
 cmp ax,vgaMaxClipX
 jg @@Exit
 cmp ax,vgaMinClipX
 jge @@3
                (* if cut at left *)
 mov bx,vgaMinClipX
 mov x1,bx
 sub bx,ax
 mov LeftCut,bx
 sub width,bx
@@3:
 mov ax,x1
 add ax,width
 dec ax
 cmp ax,vgaMinClipX
 jl @@Exit
 cmp ax,vgaMaxClipX
 jle @@4
                (* if cut at right *)
 mov bx,vgaMaxClipX
 sub bx,x1
 inc bx
 mov width,bx
 sub ax,vgaMaxClipX
 mov RightCut,ax
@@4:

 mov es,VideoSeg
 mov bx,y1
 mov di,x1
 shl bx,6
 add di,bx
 shl bx,2
 add di,bx

 push ds
 lds si,clip
 mov ax,TopCut
 mul OldWidth
 add si,ax
 add si,LeftCut
 mov ax,LeftCut
 add ax,RightCut
 mov dx,320
 sub dx,width

 mov bx,width
@@5:
 mov cx,bx
 shr cx,2
 db $66; rep movsw
 mov cx,bx
 and cx,3
 rep movsb      (* moved one line *)
 add di,dx      (* set to next line begin *)
 add si,ax
 dec height     (* all lines already? *)
 jnz @@5

 pop ds
@@Exit:
end;

procedure vgaPutTransparentImage(x1,y1:integer;width,height:word;clip:pointer);assembler;
        (* Puts everything except transparent pixels.
           This one is quite slow. *)
var TopCut,LeftCut,RightCut,OldWidth:word;
asm
 mov TopCut,0
 mov LeftCut,0
 mov RightCut,0
 mov ax,width
 mov OldWidth,ax

 mov ax,y1
 cmp ax,vgaMaxClipY
 jg @@Exit
 cmp ax,vgaMinClipY
 jge @@1
                (* if cut at top *)
 mov bx,vgaMinClipY
 mov y1,bx
 sub bx,ax
 mov TopCut,bx
 sub height,bx
@@1:
 mov ax,y1
 add ax,height
 dec ax
 cmp ax,vgaMinClipY
 jl @@Exit
 cmp ax,vgaMaxClipY
 jle @@2
                (* if cut at bottom *)
 mov bx,vgaMaxClipY
 sub bx,y1
 inc bx
 mov height,bx
@@2:
 mov ax,x1
 cmp ax,vgaMaxClipX
 jg @@Exit
 cmp ax,vgaMinClipX
 jge @@3
                (* if cut at left *)
 mov bx,vgaMinClipX
 mov x1,bx
 sub bx,ax
 mov LeftCut,bx
 sub width,bx
@@3:
 mov ax,x1
 add ax,width
 dec ax
 cmp ax,vgaMinClipX
 jl @@Exit
 cmp ax,vgaMaxClipX
 jle @@4
                (* if cut at right *)
 mov bx,vgaMaxClipX
 sub bx,x1
 inc bx
 mov width,bx
 sub ax,vgaMaxClipX
 mov RightCut,ax
@@4:

 mov es,VideoSeg
 mov bx,y1
 mov di,x1
 shl bx,6
 add di,bx
 shl bx,2
 add di,bx

 mov bh,vgaTransparentColor
 push ds
 lds si,clip
 mov ax,TopCut
 mul OldWidth
 add si,ax
 add si,LeftCut
 mov ax,LeftCut
 add ax,RightCut
 mov dx,320
 sub dx,width

@@5:
 mov cx,width
@@7:
 mov bl,ds:[si]
 inc si
 cmp bl,bh
 jz @@6
 mov es:[di],bl
@@6:
 inc di
 loop @@7
 add di,dx              (* set to next line begin *)
 add si,ax
 dec height     (* all lines already? *)
 jnz @@5

 pop ds
@@Exit:
end;

procedure vgaXORImage(x1,y1:integer;width,height:word;clip:pointer);assembler;
var TopCut,LeftCut,RightCut,OldWidth:word;
asm
 mov TopCut,0
 mov LeftCut,0
 mov RightCut,0
 mov ax,width
 mov OldWidth,ax

 mov ax,y1
 cmp ax,vgaMaxClipY
 jg @@Exit
 cmp ax,vgaMinClipY
 jge @@1
                (* if cut at top *)
 mov bx,vgaMinClipY
 mov y1,bx
 sub bx,ax
 mov TopCut,bx
 sub height,bx
@@1:
 mov ax,y1
 add ax,height
 dec ax
 cmp ax,vgaMinClipY
 jl @@Exit
 cmp ax,vgaMaxClipY
 jle @@2
                (* if cut at bottom *)
 mov bx,vgaMaxClipY
 sub bx,y1
 inc bx
 mov height,bx
@@2:
 mov ax,x1
 cmp ax,vgaMaxClipX
 jg @@Exit
 cmp ax,vgaMinClipX
 jge @@3
                (* if cut at left *)
 mov bx,vgaMinClipX
 mov x1,bx
 sub bx,ax
 mov LeftCut,bx
 sub width,bx
@@3:
 mov ax,x1
 add ax,width
 dec ax
 cmp ax,vgaMinClipX
 jl @@Exit
 cmp ax,vgaMaxClipX
 jle @@4
                (* if cut at right *)
 mov bx,vgaMaxClipX
 sub bx,x1
 inc bx
 mov width,bx
 sub ax,vgaMaxClipX
 mov RightCut,ax
@@4:

 mov es,VideoSeg
 mov bx,y1
 mov di,x1
 shl bx,6
 add di,bx
 shl bx,2
 add di,bx

 push ds
 lds si,clip
 mov ax,TopCut
 mul OldWidth
 add si,ax
 add si,LeftCut
 mov ax,LeftCut
 add ax,RightCut
 mov dx,320
 sub dx,width

@@5:
 mov cx,width
@@7:
 mov bl,ds:[si]
 inc si
 xor byte ptr es:[di],bl
 inc di
 loop @@7
 add di,dx              (* set to next line begin *)
 add si,ax
 dec height             (* all lines already? *)
 jnz @@5

 pop ds
@@Exit:
end;


{$IFNDEF DPMI}
procedure vgaPutLargeImage(x1,y1:integer;width,height:word;handle:word);
        (* Puts large image from XMS buffer *)
var blocks,tail,h,i,size:word;
    y:integer;
    p:pointer;
begin
 h:=64000 div width;
 size:=h*width;
 blocks:=height div h;
 tail:=height mod h;
 y:=y1;
 GetMem(p,64000);
 with XMDescriptor do begin
  Length:=size;
  if Odd(Length) then inc(Length);
  SourceHandle:=handle;
  SourceOffset:=0;
  DestHandle:=0;
  DestOffset:=seg(p^)*65536+ofs(p^);
 end;
 for i:=1 to blocks do begin
  if y>199 then begin
   FreeMem(p,64000);
   exit;
  end;
  if y>=-height then begin
   xmmMoveEMB(XMDescriptor);
   vgaPutImage(x1,y,width,h,p);
  end;
  inc(XMDescriptor.SourceOffset,size);
  inc(y,h);
 end;
 XMDescriptor.Length:=tail*width;
 if odd(XMDescriptor.Length) then inc(XMDescriptor.Length);
 xmmMoveEMB(XMDescriptor);
 vgaPutImage(x1,y,width,tail,p);
 FreeMem(p,64000);
end;
{$ELSE}

procedure vgaPutLargeImage(x1,y1:integer;width,height:word;image:pointer);
        (* Puts large image from large memory block. Image is pointer
           returned by GlobalAllocPtr procedure. *)
var blocks,tail,h,i,size:word;
    y:integer;
    buffer:pointer;
    offset:longint;

 function GetPtr(P:pointer;Offset:longint):pointer;
 type TLong=record
  Lo,Hi:word;
 end;
 begin
  GetPtr:=Ptr(TLong(P).Hi+TLong(Offset).Hi*SelectorInc,
              TLong(P).Lo+TLong(Offset).Lo);
 end;

begin
 h:=64000 div width;
 size:=h*width;
 blocks:=height div h;
 tail:=height mod h;
 y:=y1;
 buffer:=image; offset:=0;
 for i:=1 to blocks do begin
  if y>199 then Exit;
  if y>=-height then vgaPutImage(x1,y,width,h,buffer);
  inc(offset,size);
  buffer:=GetPtr(image,offset);
  inc(y,h);
 end;
 vgaPutImage(x1,y,width,tail,buffer);
end;
{$ENDIF}

(***************************************************************************

                Image files manipulation routines

****************************************************************************)

{$I PCXHEADR.INC}

procedure vgaLoadPCX(FileName:string;FileOffset:longint;x,y:word);
var InCounter,OutCounter:word;
    i,LineCounter:word;
    Header:T_PCX_Header;
    Dummy:word;
    Count,Data:byte;
    f:file;
    _IO_Buffer:array[1..8192] of byte;
begin
 Assign(f,FileName);
 Reset(f,1);
 Seek(f,FileOffset);
 BlockRead(f,Header,128);
 with Header do
  if (Signature<>$0A) or (BPP<>8) or (Planes<>1) or
     ((XMax-XMin+1)>4096) then begin;
   Close(f);
   Exit;
  end;
 InCounter:=1;OutCounter:=1;LineCounter:=0;
 BlockRead(f,_IO_Buffer,4096,Dummy);
 repeat
  if (_IO_Buffer[InCounter] and $C0)=$C0 then begin
   Count:=(_IO_Buffer[InCounter]) and $3F;
   Inc(InCounter);
   if InCounter=4097 then begin
    InCounter:=1;
    BlockRead(f,_IO_Buffer,4096,Dummy);
   end;
   Data:=_IO_Buffer[InCounter];
   Inc(InCounter);
   if InCounter=4097 then begin
    InCounter:=1;
    BlockRead(f,_IO_Buffer,4096,Dummy);
   end;
  end
  else begin
   Count:=1;
   Data:=_IO_Buffer[InCounter];
   Inc(InCounter);
   if InCounter=4097 then begin
    InCounter:=1;
    BlockRead(f,_IO_Buffer,4096,Dummy);
   end;
  end;
  for i:=1 to Count do begin
   _IO_Buffer[OutCounter+4096]:=Data;
   Inc(OutCounter);
   if OutCounter=Header.BPL+1 then begin
    OutCounter:=1;
    Inc(LineCounter);
    vgaPutImage(x,y,Header.XMax-Header.XMin+1,1,@_IO_Buffer[4097]);
    Inc(y);
   end;
  end;
 until LineCounter=Header.YMax-Header.YMin+1;
 Close(f);
end;

procedure vgaGetPCXSize(filename:string;fileoffset:longint;var x,y:word);
var Header:T_PCX_Header;
    f:file;
begin
 x:=0; y:=0;
 Assign(f,FileName);
 Reset(f,1);
 Seek(f,FileOffset);
 BlockRead(f,Header,128);
 with Header do
  if (Signature<>$0A) or (BPP<>8) or (Planes<>1) then begin
   Close(f);
   Exit;
  end;
 x:=Header.XMax-Header.XMin+1;
 y:=Header.YMax-Header.YMin+1;
 Close(f);
end;

procedure vgaSavePCX(FileName:string;x1,y1,x2,y2:word);
var Header:T_PCX_Header;
    Palette256:array[-1..767] of byte;
    f:file;
    Len,i,InPos,OutPos:word;
    Data,Count:byte;
    _IO_Buffer:array[1..8192] of byte;
begin
 Len:=x2-x1+1;
 if Len>4096 then Exit;
 vgaGetPalette(Palette256[0]);
 for i:=0 to 767 do Palette256[i]:=round(Palette256[i]*255/63);
 Palette256[-1]:=$0C;
 with Header do begin
  Signature:=$0A;
  Version:=5;
  Encoding:=1;
  BPP:=8;
  XMin:=x1;
  YMin:=y1;
  XMax:=x2;
  YMax:=y2;
  PPIx:=Round(320/11);
  PPIy:=Round(200/8.5);
  for i:=0 to 47 do Palette[i]:=Palette256[i];
  Reserved1:=0;
  Planes:=1;
  BPL:=Len; if Odd(BPL) then Inc(BPL);
  PaletteDescriptor:=1;
  XResolution:=320;
  YResolution:=200;
  for i:=0 to 53 do Reserved2[i]:=0;
 end;
 Assign(f,FileName);
 Rewrite(f,1);
 BlockWrite(f,Header,128);
 OutPos:=1;
 for i:=y1 to y2 do begin
  vgaGetImage(x1,i,x1+Len-1,i,@_IO_Buffer);
  InPos:=1;
  repeat
   Data:=_IO_Buffer[InPos];Count:=1;
   Inc(InPos);
   repeat
    if InPos=Header.BPL+1 then break;
    if _IO_Buffer[InPos]=Data then begin
     Inc(Count);
     Inc(InPos);
    end
    else break;
   until Count=63;
   if (Count>1) or ((Data and $C0)=$C0) then begin
    _IO_Buffer[OutPos+4096]:=($C0 or Count); Inc(OutPos);
    if OutPos=4097 then begin OutPos:=1; BlockWrite(f,_IO_Buffer[4097],4096); end;
   end;
   _IO_Buffer[OutPos+4096]:=Data; Inc(OutPos);
   if OutPos=4097 then begin OutPos:=1; BlockWrite(f,_IO_Buffer[4097],4096); end;
   if InPos=Header.BPL+1 then break;
  until false;
 end;
 if OutPos>1 then BlockWrite(f,_IO_Buffer[4097],OutPos-1);
 BlockWrite(f,Palette256[-1],769);
 Close(f);
end;

procedure vgaGetPCXPalette(FileName:string;var Palette);
var f:file;
    Test:byte;
    i:word;
type TPalette=array[0..767] of byte;
begin
 Assign(f,FileName);
 Reset(f,1);
 Seek(f,FileSize(f)-769);
 BlockRead(f,Test,1);
 if Test<>$0C then begin
  Close(f);
  Exit;
 end;
 BlockRead(f,Palette,768);
 for i:=0 to 767 do TPalette(Palette)[i]:=round(TPalette(Palette)[i]*63/255);
 Close(f);
end;

(***************************************************************************

                        Fonts and text strings handling

****************************************************************************)

type TFont=array[0..255,0..15] of byte;

procedure vgaWriteStr(x,y:word;S:string;color:byte);
var j:word;
    i,k:byte;
begin
 if FontPtr=nil then exit;
 for i:=1 to Length(S) do begin
  for j:=0 to 15 do begin
   k:=TFont(FontPtr^)[Ord(S[i]),j];
   asm
    mov cx,8
@@2:
    rol k,1
    jnc @@1
    mov bx,x
    add bx,8
    sub bx,cx
    push bx
    mov bx,y
    add bx,j
    push bx
    push word ptr color
    call vgaPutPixel
@@1:
    loop @@2
   end;
  end;
  inc(x,8);
 end;
end;

procedure vgaSetFont(p:pointer);
begin
  FontPtr:=p;
end;

(***************************************************************************

                        Services

****************************************************************************)

procedure vgaWaitVSync;assembler;
        (* Waits for vertical retrace *)
asm
 mov dx,$3DA
@@1:
 in al,dx
 test al,8
 jz @@1
end;

procedure vgaSetTextMode;assembler;
        (* Set 80x25 color text *)
asm
 mov ax,3
 int $10
end;

function Copyleft_Id:string;
begin
 Copyleft_Id:=Copyleft;
end;

procedure vgaRestoreDisplayBounds;assembler;
asm
 mov vgaMinClipX,0
 mov vgaMinClipY,0
 mov vgaMaxClipX,319
 mov vgaMaxClipY,199
end;

(***************************************************************************

                        Virtual screen support

****************************************************************************)

function vgaAllocVirtualScreen:pointer;
var segment:pointer;
begin
 segment:=MemAllocSeg(64000);
 FillChar(segment^,64000,vgaTransparentColor);
 vgaAllocVirtualScreen:=segment;
end;

procedure vgaFreeVirtualScreen(segment:pointer);
begin
 if segment<>nil then FreeMem(segment,64000);
end;

procedure vgaSetVirtualOutput(segment:pointer);
begin
 VideoSeg:=Seg(segment^);
end;

procedure vgaSetNormalOutput;
begin
 VideoSeg:=segA000;
end;

procedure vgaFlushVirtualScreen(segment:pointer);
begin
 Move(segment^,Ptr(segA000,0)^,64000);
end;

procedure vgaMoveToVirtualScreen(segment:pointer);
begin
 Move(Ptr(segA000,0)^,segment^,64000);
end;

(***************************************************************************

                        Initialization

****************************************************************************)

begin
 FontPtr:=nil;
 VideoSeg:=segA000;
 Copyleft:=#13+#10+' SuperVGA library (320x200) Version '+Version
{$IFNDEF DPMI}
 +'.DOS'+
{$ELSE}
 +'.DPMI16'+
{$ENDIF}
 #13+#10+' Virtual Research independent group production (C) 1998-1999'+#13+#10;
end.

